#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "rtv.h"
#include "rtv_ops.h"

static int     rtv_shmid;
RTV_OBJECT handle_list[5];

RTV_OBJECT *RtvConnect(char *hostname)
{
	RTV_OBJECT *hndl;
	char iobuf[80];

	if(hostname == NULL)
	{
	    printf("Error - No hostname supplied !\n");
	    return(NULL);
	}
/*
 *	Create handle for Client object.
	hndl= (RTV_OBJECT *)malloc(sizeof(RTV_OBJECT));
 */
	rtv_shmid= shmget(IPC_PRIVATE,sizeof(RTV_OBJECT), IPC_CREAT|0777);
	if(rtv_shmid<0)
	{
		perror("shmget");
		return(NULL);
	}
	hndl= (RTV_OBJECT *)shmat(rtv_shmid,0,0);
	hndl->shmid=rtv_shmid;
	hndl->local_host= (char *)malloc(25);
/*
 *	Add local hostname to handle.
 */
	gethostname(hndl->local_host,20);
	hndl->remote_host= (char *)malloc(strlen(hostname));
	strcat(hndl->remote_host,hostname);
/*
 *	Connect to local host rtv deamon process.
 */
	hndl->loc_msgsock=init_client_socket(hndl->local_host,XmitServerPort);
        sprintf(iobuf,"shmatt:%d:",rtv_shmid);
        send_msg(hndl,iobuf,strlen(iobuf));
        recv_msg(hndl,iobuf,80);

	return(hndl);
}
RtvDisconnect(RTV_OBJECT *handle)
{
int shmid;
	shmid= handle->shmid;
	shmdt((void *)handle);
	shmctl(shmid,IPC_RMID,0);
}
RtvOpenStream(RTV_OBJECT *handle,char *fname)
{
char iobuf[80];
int nbytes;
/*
 * Just open video stream.
 */
   memset(iobuf,NULL,80);
   sprintf(iobuf,"open:%s:",fname);
   send_msg(handle,iobuf,strlen(iobuf));
   memset(iobuf,NULL,80);
   nbytes=recv_msg(handle,iobuf,80);
}
RtvCloseStream(RTV_OBJECT *handle)
{
char iobuf[80];
/*
 * Close video stream.
 */
      memset(iobuf,NULL,80);
      sprintf(iobuf,"close:");
      send_msg(handle,iobuf,strlen(iobuf));
      memset(iobuf,NULL,80);
      recv_msg(handle,iobuf,80);
}
RtvSetup(RTV_OBJECT *handle,int request,RTV_ATTRIBUTES *attrs)
{
char iobuf[80];
int msgleng;
	memset(iobuf,NULL,80);
	handle->request=request;
	switch(handle->request)
	{
	case SET_RTV_ATTRIBUTES:
	     sprintf(iobuf,"set_attrs:interlace:%d:qfact:%d:rate:%d:fps:%d:",
		     attrs->interlace,attrs->qfactor,attrs->rate,attrs->fps);
             send_msg(handle,iobuf,strlen(iobuf));
	     memset(iobuf,NULL,80);
             recv_msg(handle,iobuf,80);
	     break;
	case SET_RTV_PLAY_ATTRIBUTES:
	     sprintf(iobuf,"play:set_play_attrs:first:%d:last:%d:",
		     attrs->first_valid_frame, attrs->last_valid_frame);
             send_msg(handle,iobuf,strlen(iobuf));
	     memset(iobuf,NULL,80);
             recv_msg(handle,iobuf,80);
	     break;
	case RTV_SET_RECORD_ORIGIN:
	     sprintf(iobuf,"record:set_origin:win_x:%d:win_y:%d:",
		 attrs->win_x,attrs->win_y);
             send_msg(handle,iobuf,strlen(iobuf));
	     memset(iobuf,NULL,80);
             recv_msg(handle,iobuf,80);
	     break;
	case RTV_SET_PLAY_ORIGIN:
	     sprintf(iobuf,"play:set_origin:win_x:%d:win_y:%d:",
		 attrs->win_x,attrs->win_y);
             send_msg(handle,iobuf,strlen(iobuf));
	     memset(iobuf,NULL,80);
             recv_msg(handle,iobuf,80);
	     break;
	case RTV_SET_PLAY_WINDOW:
	     sprintf(iobuf,"play:set_window:win_x:%d:win_y:%d:win_h:%d:win_w:%d:",
		 attrs->win_x,attrs->win_y,attrs->win_h,attrs->win_w);
             send_msg(handle,iobuf,strlen(iobuf));
	     memset(iobuf,NULL,80);
             recv_msg(handle,iobuf,80);
	     break;
	case RTV_SET_RECORD_WINDOW:
	     sprintf(iobuf,"record:set_window:win_x:%d:win_y:%d:win_h:%d:win_w:%d:",
		 attrs->win_x,attrs->win_y,attrs->win_h,attrs->win_w);
             send_msg(handle,iobuf,strlen(iobuf));
	     memset(iobuf,NULL,80);
             recv_msg(handle,iobuf,80);
	     break;
	case GET_RTV_ATTRIBUTES:
	     attrs->qfactor= handle->attrs.qfactor;
	     attrs->rate= handle->attrs.rate;
	     attrs->fps= handle->attrs.fps;
	     attrs->interlace= handle->attrs.interlace;
	     break;
	case GET_RTV_PLAY_ATTRIBUTES:
	     sprintf(iobuf,"play:get_play_attrs:");
	     send_msg(handle,iobuf,strlen(iobuf));
	     msgleng=recv_msg(handle,iobuf,80);
	     sscanf(iobuf,"%d:%d", &attrs->first_valid_frame, &attrs->last_valid_frame);
	     break;
	case GET_RTV_WINDOW:
	     attrs->win_x= handle->attrs.win_x;
	     attrs->win_y= handle->attrs.win_y;
	     attrs->win_h= handle->attrs.win_h;
	     attrs->win_w= handle->attrs.win_w;
	     break;
	default:
		  fprintf(stderr,"Invalid Request = %d\n",handle->request);
		  return(1);
		  break;

	}
	return(0);
}
RtvRequest(RTV_OBJECT *handle,int request)
{
int rec_size;
int msgleng;
int frame,field;
char iobuf[80];
	handle->request=request;
	memset(iobuf,NULL,80);
	switch(handle->request)
	{
	     case RTV_SELECT_FRAME:
	     case RTV_PLAY_SINGLE:
		  frame= handle->next_frame;
	          sprintf(iobuf,"play:select_frm:%d:",frame);
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
		  break;
	     case RTV_SELECT_FIELD:
		  frame= handle->next_frame;
		  field= handle->next_field;
	          sprintf(iobuf,"play:select_fld:%d:%d:",frame,field);
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
		  break;
	     case RTV_SHUTTLE:
		  frame= handle->next_frame;
		  sprintf(iobuf,"play:shuttle:%d:",frame);
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
		  break;
	     case RTV_GET_STATUS:
		  printf("GET_STATUS: handle->next_frame=%d\n",
			handle->next_frame);
		  break;
	     case RTV_GET_FRAME_COUNT:
		  sprintf(iobuf,"framecnt:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
		  handle->frame_count= atoi(iobuf);
		  break;
	     case RTV_GET_CURRENT_FRAME:
		  break;
	     case RTV_REWIND:
		  sprintf(iobuf,"rewind:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
		  break;
	     case START_RTV_RECORD:
	          sprintf(iobuf,"record:start:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case INIT_RTV_RECORD:
	          sprintf(iobuf,"record:init:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case STOP_RTV_RECORD:
	          sprintf(iobuf,"record:stop:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case START_RTV_PLAY:
	          sprintf(iobuf,"play:start:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case INIT_RTV_PLAY:
	          sprintf(iobuf,"play:init:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case STOP_RTV_PLAY:
	          sprintf(iobuf,"play:stop:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case PAUSE_RTV_RECORD:
	          sprintf(iobuf,"record:pause:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case RESUME_RTV_RECORD:
	          sprintf(iobuf,"record:resume:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case RTV_PAUSE_PLAY_WINDOW:
	          sprintf(iobuf,"play:pause_win:");
		      send_msg(handle,iobuf,strlen(iobuf));
   		      msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case RTV_RESUME_PLAY_WINDOW:
	          sprintf(iobuf,"play:resume_win:");
		      send_msg(handle,iobuf,strlen(iobuf));
   		      msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case PAUSE_RTV_PLAY:
	          sprintf(iobuf,"play:pause:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case RESUME_RTV_PLAY:
	          sprintf(iobuf,"play:resume:");
		  send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
	          break;
	     case CLIENT_EXIT:
		  sprintf(iobuf,"disconnect:");
	          send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
		  close(handle->loc_msgsock);
		  return;
		  break;
	     case RTV_AUDIO_MODE:
		  sprintf(iobuf,"audio_mode:%d",handle->audio_mode);
	          send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
		  break;
	     case RTV_AUDIO_STATUS:
		  sprintf(iobuf,"audio_status:");
	          send_msg(handle,iobuf,strlen(iobuf));
   		  msgleng=recv_msg(handle,iobuf,80);
		  handle->audio_status=atoi(iobuf);
		  break;
	     default:
		  fprintf(stderr,"Invalid Request = %d\n",handle->request);
		  return(1);
		  break;
	}
	return(0);
}
