
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stropts.h>
#include <sys/ioctl.h>
#include <multimedia/libaudio.h>
#include <multimedia/audio_device.h>
#include <multimedia/audio_device.h>
#ifdef SVR4
#include <multimedia/audio_encode.h>
#else
#include <multimedia/ulaw2linear.h>
#endif
#include "rtv.h"


unsigned
scale_gain( unsigned        g)
{
	return (AUDIO_MIN_GAIN + 
	       (int)(((double) (AUDIO_MAX_GAIN - AUDIO_MIN_GAIN)) *
		((double)g / (double)AUDIO_MAX_GAIN)));
}


/*
#define STAND_ALONE
*/


extern int errno;

rtv_audio_init()
{
Audio_info	audioInfo;
  int		audioFD;
  int		soundFileFD = 0;
  int		result;
  int		gain;
  int		istat;
#ifdef SVR4
  audio_device_t	deviceType;
#else  
  int			deviceType;
#endif
  char*		AudioFile = NULL;
  
  audioFD = open("/dev/audio", (O_RDWR));			    /* Try to open the audio device for reading (record) only */
  if (audioFD == -1)						    /* Did the open fail? */
  {								    /* Yes, report the error and exit immediately */
    printf("Sorry, could not open the audio device for recording.  Exiting.\n");
    return(-1);
  }
  result = ioctl(audioFD, AUDIO_GETINFO, &audioInfo);
  if (result == -1)
  {
    printf("Could not get information about the audio device.  Exiting.\n");
    printf("errno was set to %d.\n", errno);
    exit(-1);
  }
  result = ioctl(audioFD, AUDIO_GETDEV, &deviceType);
  if (result == -1)
  {
    printf("Could not enquire about the audio device.  Exiting.\n");
    return(result);
  }
  audioInfo.record.sample_rate = 48000;
  audioInfo.record.channels = 2;
  audioInfo.record.precision = 16;
  audioInfo.record.encoding = AUDIO_ENCODING_LINEAR;
  audioInfo.play.sample_rate = 48000;
  audioInfo.play.channels = 2;
  audioInfo.play.precision = 16;
  audioInfo.record.buffer_size= 4096;
  audioInfo.play.encoding = AUDIO_ENCODING_LINEAR;
#ifdef STAND_ALONE
  audioInfo.record.port = AUDIO_LINE_IN;
  audioInfo.record.gain=scale_gain(75);
  audioInfo.play.port = AUDIO_SPEAKER;
  /*
  audioInfo.play.port = AUDIO_HEADPHONE;
  */
  audioInfo.play.gain=scale_gain(100);
#endif
  result = ioctl(audioFD, AUDIO_SETINFO, &audioInfo);
  if (result == -1)/* Did the query fail? */
  {
    printf("Could not reconfigure the audio device for recording high-quality audio; exiting.\n");
    close(audioFD);
    return(-1);
  }
  ioctl(audioFD,I_PUSH,"rtaudio");
  ioctl(audioFD,I_FLUSH,FLUSHRW);
  return(audioFD);
}
resume_audio(int fd)
{
   audio_resume_record(fd);
}
flush_audio(int fd)
{
  ioctl(fd,I_FLUSH,FLUSHRW);
  ioctl(fd,I_POP,"rtaudio");
}

