#include <stdio.h>
#include <fcntl.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/mman.h>
#include <sys/signal.h>
#include <sys/asynch.h>
#include <sys/stat.h>
#include <errno.h>
/*
 ***** TO DO: 
****  Review Eor and Eof detection after audio recrods are
****  working.
******/

#include "rtv.h"
#include "rtv_ops.h"
#include "rtvdiskio.h"

static RTV_AIO aio_res_tbl[MAX_AIO_QUEUE];
static int PanicStop;



rtv_aio_hndlr()
{
RTV_AIO *res;
FIELD_INFO *field;
SERVER_OBJECT *obj;
static    struct timeval wrt_time_out;
/*
 * Poll wait for (AIO_INPROGRESS == 0).
 */
   wrt_time_out.tv_sec = 0;
   wrt_time_out.tv_usec = 0;
   do {
            res= (RTV_AIO *)aiowait(&wrt_time_out);
        }while(res->aio_result.aio_return==AIO_INPROGRESS);
	if(res!= (RTV_AIO *)NULL)
	{
	    obj= (SERVER_OBJECT *) res->obj;
	    if(res->aio_result.aio_errno== 28)
	    {
		obj->errno=obj->client->errno= RTV_ENOSPC;
		obj->action=STOP_RTV;
		sleep(1);
		return;
	    }
	    if(res->action==RTV_PLAY)
	        obj->que_level++;
	    else
	        obj->que_level--;
	    res->inuse=0;
	    res->aio_result.aio_return=0;
	    res->action=0;
	    res->obj=0;
	}
	signal(SIGIO,rtv_aio_hndlr);
}
static int res_cnt=0;

static int ForEver=1;
RTV_AIO *alloc_res(SERVER_OBJECT *obj,int mode)
{
RTV_AIO *res;

	do
	{
	    res=(RTV_AIO *)&aio_res_tbl[res_cnt];
	    if(!res->inuse)break;
	    if(++res_cnt>=MAX_AIO_QUEUE)res_cnt=0;
	}while(ForEver);
        res->aio_result.aio_return= AIO_INPROGRESS;
        res->action= mode;
	res->obj= (int *)obj;
	res->inuse=1;
	return(res);
}
rtv_reset_que(SERVER_OBJECT *rtvobj)
{
   rtvobj->que_level=0;
   rtvobj->bufno=0;
   rtvobj->buf_inuse=0;
}
check_ioque_level(SERVER_OBJECT *rtvobj,int sync)
{
caddr_t buffer;
int status;

	if(rtvobj->bufno<MaxBuffers)
	{
		buffer= rtvobj->fbufr[rtvobj->bufno];
#ifndef BETA1
	        PutNextBuf(rtvobj,buffer);
#endif
	        if(rtvobj->bufno==1) rtvobj->seek_ahead=1;
	        if(rtv_diskio(rtvobj,buffer,sync)==0)
	        {
	            rtvobj->end_of_file=1;
	            fprintf(stderr,"EndofFile dectected!\n");
	            return(-1);
	        }
		rtvobj->bufno++;
		return(0);
	}
	return(1);
}
rtv_diskio(SERVER_OBJECT *rtvobj,caddr_t buf,int sync )
{
RTV_AIO *res;
register int nbytes,newaddr;
RTV_FRAME_TOC *frmptr;
FIELD_INFO *field;
	if(rtvobj->mode == RTV_RECORD)
	{
	    rtvobj->que_level++;
	    res= alloc_res(rtvobj,RTV_RECORD);
#ifdef BETA1
	    if(aiowrite(rtvobj->disk_fd,buf,IoBufSize,
	        rtvobj->seek_offset,SEEK_SET,(aio_result_t *)res)== -1)
#else
            if(aiowrite(rtvobj->disk_fd,buf,IoBufSize,
                0,SEEK_CUR,(aio_result_t *)res)== -1)
#endif
	    {
		perror("rtv-AIOWRITE: \n");
		rtv_shutdown(rtvobj,99);
		return(0);
	    }
	    if(sync)
	    {
            	res= (RTV_AIO *)aiowait(NULL);
		if(res!=NULL)
		{
	    	    res->inuse=0;
	    	    res->action=0;
	    	    res->aio_result.aio_return=0;
	        }
	    }
#ifdef BETA1
	    rtvobj->seek_offset += IoBufSize;
#else
	    lseek(rtvobj->disk_fd,IoBufSize,SEEK_CUR);
	    rtvobj->seek_offset += IoBufSize;
	    rtvobj->blkno++;
            rtvobj->record_count++;

	    if((rtvobj->blkno % MAX_BLOCKS)==0)
	    {
	        rtvobj->seek_offset = 0;
	        rtvobj->Gbytes++;
	    }
#endif
	    rtvobj->frame_offset=0;
	}
	else
	{
	    if(sync)
		signal(SIGIO,SIG_IGN);
            res= alloc_res(rtvobj,RTV_PLAY);
#ifdef BETA1
            if(aioread(rtvobj->disk_fd,buf,IoBufSize,
                rtvobj->seek_offset,SEEK_SET,(aio_result_t *)res)== -1)
#else
	    if(rtvobj->seek_ahead)
		lseek(rtvobj->disk_fd,IoBufSize,SEEK_CUR);
            if(aioread(rtvobj->disk_fd,buf,IoBufSize,
                0,SEEK_CUR,(aio_result_t *)res)== -1)
#endif
            {
	        perror("rtv-AIOREAD: \n");
		rtv_shutdown(rtvobj,99);
		return(0);
            }
	    if(sync)
	    {
		res= (RTV_AIO *)aiowait(NULL);
		if(res!=NULL)
		{
	    	    res->inuse=0;
	    	    res->action=0;
	    	    res->aio_result.aio_return=0;
	        }
	        rtvobj->que_level++;
		signal(SIGIO,rtv_aio_hndlr);
	    }
#ifdef BETA1
	    rtvobj->seek_offset += IoBufSize;
#else
#ifdef TRACE_DISKIO
	field= (FIELD_INFO *)(buf+8192);
	printf("diskio: seek_offset=%d field->frame_no=%d\n",
		rtvobj->seek_offset,field->frame_no);
#endif
	    if(!rtvobj->seek_ahead)
	        lseek(rtvobj->disk_fd,IoBufSize,SEEK_CUR);
	    rtvobj->seek_offset += IoBufSize;
	    rtvobj->blkno++;
	    if((rtvobj->blkno % MAX_BLOCKS)==0)
	    {
	        rtvobj->seek_offset = 0;
	        rtvobj->Gbytes++;
	    }
#endif
	}
	return(1);
}
rtv_fill_queue( SERVER_OBJECT *rtvobj)
{
caddr_t buffer;
int status;
        while(rtvobj->bufno<MaxBuffers)
	{
	    buffer= rtvobj->fbufr[rtvobj->bufno];
#ifndef BETA1
	    PutNextBuf(rtvobj,buffer);
#endif
	    if(rtv_diskio(rtvobj,buffer,SYNC_IO)==0)
	    {
	        rtvobj->end_of_file=1;
	        fprintf(stderr,"EndofFile dectected!\n");
	        return(0);
	    }
	    rtvobj->bufno++;
	}
#ifndef BETA1
	rtvobj->faddr= (caddr_t)GetNextBuf(rtvobj);
#endif
}
start_async()
{
	signal(SIGIO,rtv_aio_hndlr);
}

