#include <stdio.h>
#include <fcntl.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/mman.h>
#include <sys/signal.h>
#include <sys/asynch.h>
#include <sys/stat.h>
#include <errno.h>
/*
 ***** TO DO: 
#define TRACE_FRAME_SELECT
#define TRACE_PLAYBACK
#define TRACE_SINGLE_STEP
#define TRACE_DIAGS
******/


#include "rtv.h"
#include "rtv_ops.h"
#include "rtvdiskio.h"
extern RTV_AIO *alloc_res();
extern int rtv_aio_hndlr();

#ifdef BETA1
#define SINGLE_FRAME_SIZE 72*1024
static char frmbuf[SINGLE_FRAME_SIZE];
#endif

rtv_check_queue(SERVER_OBJECT *rtvobj)
{
int stat;
int level;
	stat= ioctl(rtvobj->ram_fd,RD_GET_PLAY_LEVEL,(caddr_t)&level);
	return(level);
}
put_field(int fd,caddr_t buf)
{
int stat;
	 stat= ioctl(fd,RD_PUT_FIELD,(caddr_t)buf,NULL);
	 return(stat);
}
rtv_init_play(SERVER_OBJECT *rtvobj)
{
register int n,nbytes,length;
caddr_t buffer;
/*
 *	Rewind field table file
 */
	lseek(rtvobj->fld_fd,0,SEEK_SET);
	read(rtvobj->fld_fd,rtvobj->version,12);
	length= sizeof(RTV_ATTRIBUTES);
	read(rtvobj->fld_fd,(caddr_t)&rtvobj->play_attrs,length);
	lseek(rtvobj->fld_fd,FRAME_TOC_ORIGIN,SEEK_SET);
	rtvobj->frame_count=rtvobj->play_attrs.frame_count;
	rtvobj->toc_count=rtvobj->play_attrs.toc_count;

#ifndef  BETA1
	rtvobj->record_count=rtvobj->play_attrs.record_count;
#endif
#ifdef TRACE_DIAGS
	printf("rtv_init_play: play_attrs.win_w=%d play_attrs.win_h=%d\n",
		rtvobj->play_attrs.win_w,rtvobj->play_attrs.win_h);
#endif
	memcpy((caddr_t)&rtvobj->client->attrs,
		(caddr_t)&rtvobj->play_attrs,sizeof(RTV_ATTRIBUTES));
	lseek(rtvobj->disk_fd,SEEK_SET,0);

#ifdef TRACE_DIAGS
	printf("init_play: frame_count=%d\n",rtvobj->frame_count);
#endif
	rtvobj->end_frame=rtvobj->frame_count;
	if(rtvobj->play_attrs.last_valid_frame >
	   rtvobj->play_attrs.first_valid_frame)
	       rtvobj->end_frame= rtvobj->play_attrs.last_valid_frame;
	read(rtvobj->fld_fd,rtvobj->frmtoc,FRAME_TOC_RECSIZE);
	rtvobj->frmptr=rtvobj->frmtoc;
	rtvobj->frmtoc_tail= &rtvobj->frmtoc[MAX_FRAME_TOC-1];
	rtvobj->frame_offset=0;
	rtvobj->toc_offset=FRAME_TOC_ORIGIN;
	rtvobj->next_frame= 0;
	rtvobj->rec_offset=0;
	rtvobj->buf_inuse=0;
	rtvobj->bufno=0;
	rtvobj->tbl_indx=0;
	rtvobj->toc_indx=0;
	rtvobj->que_level=0;
	rtvobj->errno=0;
	rtvobj->end_of_file=0;
	lseek(rtvobj->disk_fd,0,SEEK_SET);
	rtvobj->seek_offset= 0;
	rtvobj->seek_ahead=0;
	rtvobj->writelist= rtvobj->writelist->head;
	rtvobj->readlist= rtvobj->readlist->head;
	rtv_fill_queue(rtvobj);
#ifdef BETA1
	rtvobj->faddr= rtvobj->fbufr[0];
#else
	rtvobj->blkno= -1;
	rtvobj->Gbytes=0;
#endif
}
rtv_start_play(SERVER_OBJECT *rtvobj)
{
/*
 *	Set PLAY mode in ccube and ramdisk drivers.
 */
	setup_play(rtvobj->ccube_fd,rtvobj->play_attrs.fps);
        set_play_win(rtvobj->ccube_fd,&rtvobj->play_attrs);
	start_play(rtvobj->ccube_fd);
	start_async();
}
rtv_stop_play(SERVER_OBJECT *rtvobj)
{
	stop_play(rtvobj->ccube_fd);
}
rtv_pause_play(SERVER_OBJECT *rtvobj)
{
	pause_play(rtvobj->ccube_fd);	
}
rtv_resume_play(SERVER_OBJECT *rtvobj)
{
	resume_play(rtvobj->ccube_fd);	
}
rtv_play_frame(SERVER_OBJECT *rtvobj)
{
FIELD_INFO *field;
RTV_FRAME_TOC *frmptr;
register int fld,adv_result;
register int field_offset,audio_recsize; 
register caddr_t audio_buf;
static int current_qfactor;
AudioRec audio_rec;

/*
 * Get local copy of frame table of contents pointer and set
 * local relative offset from frame offset.
 */
   frmptr= rtvobj->frmptr;
   rtvobj->rec_offset= frmptr->frame_offset;
#ifdef BETA1
   rtvobj->faddr= rtvobj->fbufr[rtvobj->buf_inuse];
#endif
   /*
    *  Get buffer address and length to pass to play_audio.
    */
   if(frmptr->size[2]>0)
   {
	audio_rec.address= (caddr_t)(rtvobj->faddr+rtvobj->rec_offset);
	audio_rec.length= frmptr->size[2];
	audio_rec.sync_clock= frmptr->audio_sync;
        
	rtvobj->rec_offset += frmptr->size[2];

        if(rtvobj->action==START_RTV_PLAY && rtvobj->audio_mode)
	    ioctl(rtvobj->ram_fd,RD_PUT_AUDIO,&audio_rec);
/*
 *  Increment relative offset to beginning of video fields.
 */
   }

/*
 *   Advance the relative buffer offset for each of the video fields as
 *   each is passed into the ccube driver, via "put_field".
 */
   for(fld=0;fld<2;fld++)
   {
	field= (FIELD_INFO *)(rtvobj->faddr+rtvobj->rec_offset);
	if(field->size<= 0 || field->size>=MAX_FIELD_SIZE)
	{
	    fprintf(stderr,"Invalid Frame ! frame_no= %d inuse=%d size=%d \n",
			field->frame_no,field->inuse,field->size);
	    return(RTV_EIO);
	}
    	put_field(rtvobj->ram_fd,(char *)field);

        rtvobj->rec_offset += (field->size+ sizeof(FIELD_INFO));
   }
   rtvobj->next_frame=field->frame_no;
#ifdef TRACE_PLAYBACK
   if(field->frame_no%60==0)
    fprintf(stderr,"field->frame_no=%d size=%d \n", field->frame_no,field->size);
#endif
   rtvobj->polarity= field->polarity;
   rtvobj->client->next_frame=rtvobj->next_frame;
   if(rtvobj->next_frame>=rtvobj->frame_count)
   {
	rtv_reset_que(rtvobj);
	rtvobj->action=STOP_RTV_PLAY;
	rtvobj->errno= -98;
	return(rtvobj->errno);
   }
   if(rtvobj->next_frame>=rtvobj->end_frame)
   {
	rtv_reset_que(rtvobj);
	rtvobj->action=STOP_RTV_PLAY;
	rtvobj->errno= -98;
	return(rtvobj->errno);
   }
   if(frmptr->record_type & RTV_EOF)
   {
	rtv_reset_que(rtvobj);
	rtvobj->action=STOP_RTV_PLAY;
	fprintf(stderr,"end of file detected\n");
	rtvobj->errno= -98;
	return(rtvobj->errno);
   }
   return(1);
}
rtv_set_frame(SERVER_OBJECT *rtvobj,int frame_no)
{
static int frmtoc_offset=0;

	frmtoc_offset= FRAME_TOC_ORIGIN + (frame_no/MAX_FRAME_TOC)*FRAME_TOC_RECSIZE;
#ifdef TRACE_DIAGS
fprintf(stderr,"frame_no=%d toc_offset=%d frmtoc_offset=%d\n",
	frame_no,rtvobj->toc_offset,frmtoc_offset);
#endif
	if(rtvobj->toc_offset != frmtoc_offset)
	{
	    rtvobj->toc_offset=frmtoc_offset;
	    lseek(rtvobj->fld_fd,rtvobj->toc_offset,SEEK_SET);
	    read(rtvobj->fld_fd,rtvobj->frmtoc,FRAME_TOC_RECSIZE);
	    rtvobj->toc_indx= frame_no/MAX_FRAME_TOC;
	}
	rtvobj->frmptr= &rtvobj->frmtoc[frame_no&0x1ff];
	rtvobj->tbl_indx= frame_no&0x1ff;
}
#ifdef BETA1
rtv_play_selected_frame(SERVER_OBJECT *rtvobj,int action)
{
FIELD_INFO *field ;
RTV_AIO *res;
RTV_FRAME_TOC *frmptr;
register int k,video_offset;
int frame_size,seek_address;
int nbytes,newaddr,newblk;
static int frame_delta;

	rtv_set_frame(rtvobj,rtvobj->frame_selection);
	frmptr= rtvobj->frmptr;

	if(rtvobj->seek_offset!=frmptr->seek_offset)
	{
	    rtvobj->seek_offset=frmptr->seek_offset;
	    rtv_reset_que(rtvobj);
	}
	frame_delta=rtvobj->frame_selection-rtvobj->next_frame;
	if(action==RTV_SHUTTLE && frame_delta==0)return(1);
	seek_address= frmptr->seek_offset+frmptr->frame_offset;
	lseek(rtvobj->disk_fd,seek_address,SEEK_SET);

	if(rtvobj->frame_selection!= rtvobj->frmptr->frame_no || 
	   rtvobj->frame_selection>rtvobj->end_frame)
	{
	    fprintf(stderr,"frame requested=%d frame selected= %d\n",
	        rtvobj->frame_selection,rtvobj->frmptr->frame_no);
	    rtvobj->errno= RTV_EIO;
	    return(RTV_EIO);
	}
	frame_size = frmptr->size[0] + frmptr->size[1] + frmptr->size[2] + 
		 2*sizeof(FIELD_INFO);
	nbytes=read(rtvobj->disk_fd,frmbuf,frame_size);
	if(nbytes!=frame_size)
	{
	   fprintf(stderr,"read error frame_size=%d nbytes=%d\n",frame_size,nbytes);
	   rtvobj->errno= RTV_EIO;
	   return(rtvobj->errno);
	}
	video_offset= frmptr->size[2];
	field= (FIELD_INFO *)((char *)frmbuf+video_offset);
	if(field->size<=0 || field->size>=MAX_FIELD_SIZE )
	{
	    fprintf(stderr,"Frame size %d out of range!\n",field->size);
	    rtvobj->errno= RTV_EIO;
	    return(rtvobj->errno);
	}
	if(action == RTV_SELECT_FRAME || action == RTV_SHUTTLE || 
	   action == RTV_SELECT_FIELD && rtvobj->field_selection==0)
	{
	    put_field(rtvobj->ram_fd,(char *)field);
	}
	video_offset+= (field->size+sizeof(FIELD_INFO));
	field= (FIELD_INFO *)((char *)frmbuf+video_offset);

	if(field->size<=0 || field->size>=MAX_FIELD_SIZE )
	{
	    fprintf(stderr,"Frame size %d out of range!\n",field->size);
	    rtvobj->errno= RTV_EIO;
	    return(rtvobj->errno);
	}
	if(action == RTV_SELECT_FRAME ||  action == RTV_SHUTTLE ||
	   action == RTV_SELECT_FIELD && rtvobj->field_selection==1)
	{
	       put_field(rtvobj->ram_fd,(char *)field);
	}
        rtvobj->next_frame=field->frame_no;
        rtvobj->client->next_frame=rtvobj->next_frame;
	return(1);
}
#else
rtv_play_selected_frame(SERVER_OBJECT *rtvobj,int action)
{
FIELD_INFO *field;
RTV_AIO *res;
RTV_FRAME_TOC *frmptr;
register int k,video_offset;
static int frame_delta;
int frame_size,seek_delta;
char *bufr;

	rtv_set_frame(rtvobj,rtvobj->frame_selection);
	frmptr= rtvobj->frmptr;

	frame_delta=rtvobj->frame_selection-rtvobj->next_frame;
	if(action==RTV_SHUTTLE && frame_delta==0)return(1);

        if(frmptr->blkno!=rtvobj->blkno)
	{
	    rtvobj->blkno=frmptr->blkno;
	    if(frmptr->Gbytes>rtvobj->Gbytes)
	    {
		while(frmptr->Gbytes>rtvobj->Gbytes+1)
		{
		    lseek(rtvobj->disk_fd,MAX_OFFSET,SEEK_CUR);
		    rtvobj->Gbytes++;
		}
		seek_delta=MAX_OFFSET-rtvobj->seek_offset+frmptr->seek_offset;
		lseek(rtvobj->disk_fd,seek_delta,SEEK_CUR);
		seek_delta=frmptr->seek_offset;
		rtvobj->seek_offset=0;
		rtvobj->Gbytes=frmptr->Gbytes;
	    }
	    else if(frmptr->Gbytes<rtvobj->Gbytes)
	    {
		while(frmptr->Gbytes+1<rtvobj->Gbytes)
		{
		    lseek(rtvobj->disk_fd,-MAX_OFFSET,SEEK_CUR);
		    rtvobj->Gbytes--;
		}
		seek_delta= frmptr->seek_offset-MAX_OFFSET-rtvobj->seek_offset;
		lseek(rtvobj->disk_fd,seek_delta,SEEK_CUR);
		rtvobj->seek_offset=frmptr->seek_offset+abs(seek_delta);
		rtvobj->Gbytes=frmptr->Gbytes;
	    }
	    else
	    {
	            seek_delta= (frmptr->seek_offset-rtvobj->seek_offset);
	            lseek(rtvobj->disk_fd,seek_delta,SEEK_CUR);
#ifdef TRACE_DIAGS
	printf("frmptr->seek_offset=%d rtvobj->seek_offset=%d seek_delta=%d\n",
			frmptr->seek_offset,rtvobj->seek_offset,seek_delta);
#endif
	    }
	    rtvobj->faddr= rtvobj->fbufr[0];
	    rtvobj->writelist= rtvobj->writelist->head;
	    rtvobj->readlist= rtvobj->readlist->head;
	    PutNextBuf(rtvobj,rtvobj->faddr);
            res= alloc_res(rtvobj,RTV_PLAY);
            if(aioread(rtvobj->disk_fd,rtvobj->faddr,IoBufSize,
                        0,SEEK_CUR,(aio_result_t *)res)== -1)
            {
	        perror("rtv-AIOREAD: \n");
		rtv_shutdown(rtvobj,99);
		return(0);
            }
            res= (RTV_AIO *)aiowait(NULL);
	    if(res!=NULL)
	    {
	        res->inuse=0;
	        res->action=0;
	        res->aio_result.aio_return=0;
	    }
	    rtvobj->seek_offset +=seek_delta;

#ifdef TRACE_SINGLE_STEP
	    field= (FIELD_INFO *)(rtvobj->faddr+8192);
	    printf("select: frmptr->offset=%d seek_offset=%d blkno=%d frame_no=%d\n",
	     frmptr->seek_offset,rtvobj->seek_offset,rtvobj->blkno,field->frame_no);
#endif
	    rtvobj->que_level=1;
	    rtvobj->bufno=1;
	    rtvobj->faddr= (char *)GetNextBuf(rtvobj);
        }
	if(rtvobj->frame_selection!= rtvobj->frmptr->frame_no || 
	   rtvobj->frame_selection>rtvobj->end_frame)
	{
	    fprintf(stderr,"frame requested=%d frame selected= %d\n",
	        rtvobj->frame_selection,rtvobj->frmptr->frame_no);
	    rtvobj->errno= RTV_EIO;
	    return(RTV_EIO);
	}
	video_offset= frmptr->frame_offset+frmptr->size[2];

	field= (FIELD_INFO *)((char *)rtvobj->faddr+video_offset);
	if(field->size<=0 || field->size>=MAX_FIELD_SIZE )
	{
	    fprintf(stderr,"Frame size %d out of range!\n",field->size);
	    rtvobj->errno= RTV_EIO;
	    return(rtvobj->errno);
	}
	if(action == RTV_SELECT_FRAME || action == RTV_SHUTTLE || 
	   action == RTV_SELECT_FIELD && rtvobj->field_selection==0)
	{
	    put_field(rtvobj->ram_fd,(char *)field);
	}
	video_offset+= (field->size+sizeof(FIELD_INFO));
	field= (FIELD_INFO *)((char *)rtvobj->faddr+video_offset);

	if(field->size<=0 || field->size>=MAX_FIELD_SIZE )
	{
	    fprintf(stderr,"Frame size %d out of range!\n",field->size);
	    rtvobj->errno= RTV_EIO;
	    return(rtvobj->errno);
	}
	if(action == RTV_SELECT_FRAME ||  action == RTV_SHUTTLE ||
	   action == RTV_SELECT_FIELD && rtvobj->field_selection==1)
	{
	       put_field(rtvobj->ram_fd,(char *)field);
	}
        rtvobj->next_frame=field->frame_no;
        rtvobj->client->next_frame=rtvobj->next_frame;
	return(1);
}
#endif
