#include <stdio.h>
#include <fcntl.h>
#include <sys/stream.h>
#include <sys/stropts.h>

#include "rtv.h"
#include "rtv_ops.h"

typedef struct {
	int sid;
	}SID_ATTRS;

typedef struct {
	int  sid;
	int  record_size;
	}RATE_INFO;
typedef struct {
	int sid;
	int start_x;
	int start_y;
	int width;
	int height;
	int video_tag;
	int single_field;
	}START_INFO;

typedef struct {
	int qfactor;
	int min_rate;
	int max_rate;
	int fps;
	}SETUP_INFO;

typedef struct {
		int state;
		int time;
		}STATE_FLDS;

typedef struct {
	int delay_time;
	int qlev;
	}POLL_INFO;
set_max_rate(int fd,int max_rate)
{
SETUP_INFO setup;
register int stat;
	setup.max_rate= max_rate*1024;
        stat=ioctl(fd,SET_MAX_RATE,&setup);
}
setup_play(int fd,int fps)
{
int stat;
SETUP_INFO setup;
	setup.fps=fps;
        stat=ioctl(fd,SETUP_PLAY,&setup);
}
setup_record(int fd,int qfactor,int max_rate,int fps)
{
int stat;
SETUP_INFO setup;

	setup.qfactor=qfactor;
	setup.max_rate= max_rate*1024;
	setup.fps=fps;
        stat=ioctl(fd,SETUP_RECORD,&setup);
}
get_trace(int fd)
{
STATE_FLDS tracebuf[7500];
int i;
#ifdef GET_CCUBE_TRACE
	ioctl(fd,GET_CCUBE_TRACE,&tracebuf);
	for(i=0;i<7500;i++)
	{
	    if(tracebuf[i].state!=0 && tracebuf[i].time!=0)
	    printf("state=%d time=%d\n",tracebuf[i].state,tracebuf[i].time); 
	}
#endif

}
set_play_org(int fd,RTV_ATTRIBUTES *attrs)
{
int istat;
int recv_status;
START_INFO play_info;

	/*
	 * Send Ready message to server host.
	 */
	play_info.sid=attrs->sid;
	play_info.start_x=attrs->win_x;
	play_info.start_y=attrs->win_y;

        istat= ioctl(fd,SET_PLAY_ORIGIN,&play_info);
	return(istat);
}

set_play_win(int fd,RTV_ATTRIBUTES *attrs)
{
int istat;
int recv_status;
START_INFO play_info;

	/*
	 * Send Ready message to server host.
	 */
	play_info.sid=attrs->sid;
	play_info.start_x=attrs->win_x;
	play_info.start_y=attrs->win_y;
	play_info.width=attrs->win_w;
	play_info.height=attrs->win_h;
	play_info.single_field=0;
	play_info.video_tag=0;

        istat= ioctl(fd,SET_PLAY_WINDOW,&play_info);
	return(istat);
}
set_record_org(int fd,RTV_ATTRIBUTES *attrs)
{
int istat;
START_INFO rec_info;
int play_status;
	rec_info.sid=attrs->sid;
	rec_info.start_x=attrs->win_x;
	rec_info.start_y=attrs->win_y;
        istat=ioctl(fd,SET_RECORD_ORIGIN,&rec_info);
	return(istat);
}

set_record_win(int fd,RTV_ATTRIBUTES *attrs)
{
int istat;
START_INFO rec_info;
int play_status;
	rec_info.sid=attrs->sid;
	rec_info.start_x=attrs->win_x;
	rec_info.start_y=attrs->win_y;
	rec_info.width=attrs->win_w;
	rec_info.height=attrs->win_h;
	rec_info.single_field=0;
	rec_info.video_tag=0;
        istat=ioctl(fd,SET_RECORD_WINDOW,&rec_info);
	return(istat);
}
start_play(fd)
{
int istat;
        istat=ioctl(fd,START_PLAY);
}
start_transmit(int fd)
{
int istat;
	istat=ioctl(fd,START_TRANSMIT);
}
start_record(int fd)
{
int istat;
        istat=ioctl(fd,START_RECORD);
}
stop_record(int fd)
{
int istat;
        istat=ioctl(fd,STOP_RECORD);
}
stop_receive(int fd,int sid)
{
int istat;
SID_ATTRS sid_attrs;

	sid_attrs.sid=sid;
	istat=ioctl(fd,PAUSE_RECEIVE,&sid_attrs);
	return(istat);
}
stop_play(int fd)
{
int istat;
	do {
        istat=ioctl(fd,STOP_PLAY);
	}while(istat);
}
pause_record(int fd)
{
int istat;
        istat=ioctl(fd,PAUSE_RECORD);
}
resume_record(int fd)
{
int istat;
	istat=ioctl(fd,RESUME_RECORD);
}
pause_play(int fd)
{
int istat;
        istat=ioctl(fd,PAUSE_PLAY);
}
resume_play(int fd)
{
int istat;
	istat=ioctl(fd,RESUME_PLAY);
}
check_c3_present(int fd)
{
int istat;
	istat=ioctl(fd,CCUBE_PRESENT);
	return(istat);
}
