#include <stdio.h>
#include <fcntl.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/mman.h>
#include <sys/signal.h>
#include <sys/asynch.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <errno.h>
/*
 ***** TO DO: 
 ****  1. Change memory to allocated instead of fixed.
 ******/

#include "rtv.h"
#include "rtv_ops.h"
#include "rtvdiskio.h"
#define VideoBufSize (IoBufSize*MaxBuffers)

static char iobuf[VideoBufSize];

extern SERVER_OBJECT *rtvobj;
#ifndef BETA1
static RtvFreeList(SERVER_OBJECT *rtvobj)
{
struct bufnod *buflist;
	buflist= rtvobj->writelist->head;
	while(buflist->next)
	    buflist=buflist->next;
	while(buflist->prev)
	{
	    if(buflist->next!=NULL)
		free(buflist->next);
	    buflist= buflist->prev;
	}
	free(buflist);
}
#endif


void cleanup(int signalNumber)
{
int i,err,socketValue;
int comm_stat;
fprintf(stderr,"cleanup handler !\n");
	if(rtvobj->client)
	{
	    rtvobj->client->errno=  RTV_EAGAIN;
	    sleep(1);
	}
	rtv_shutdown(rtvobj,99);
	if(rtvobj->srvr_sock!=0)
	      comm_stat=shutdown(rtvobj->srvr_sock,2);
#ifndef BETA1
	if(rtvobj->writelist)
	      RtvFreeList(rtvobj);
#endif
	if(rtvobj!=NULL)free(rtvobj);
	munlockall();
	exit(0);
}
rtv_tvtwo_init(RTV_ATTRIBUTES *attrs,char *device)
{
int fd;

        fd= open(device,O_RDWR|RTV_MODE);
	if(fd == -1)
	   return(-1);
        /*
         * Test for ccube device on board.
         */
        if(check_c3_present(fd)== -1)
        {
	    fprintf(stderr,"No Ccube device!\n");
	    cleanup(0);
        } 
	setup_record(fd,attrs->qfactor,attrs->rate,attrs->fps);
	return(fd);
}
caddr_t rotate_back(SERVER_OBJECT *rtvobj)
{
caddr_t save_addr;

	save_addr= rtvobj->fbufr[0];
	rtvobj->fbufr[0]=rtvobj->fbufr[1];
	rtvobj->fbufr[1]=rtvobj->fbufr[2];
	rtvobj->fbufr[2]=rtvobj->fbufr[3];
	rtvobj->fbufr[3]=rtvobj->fbufr[4];
	rtvobj->fbufr[4]=rtvobj->fbufr[5];
	rtvobj->fbufr[5]=save_addr;
}

caddr_t rotate_forward(SERVER_OBJECT *rtvobj)
{
caddr_t save_addr;

	save_addr= rtvobj->fbufr[5];
	rtvobj->fbufr[5]=rtvobj->fbufr[4];
	rtvobj->fbufr[4]=rtvobj->fbufr[3];
	rtvobj->fbufr[3]=rtvobj->fbufr[2];
	rtvobj->fbufr[2]=rtvobj->fbufr[1];
	rtvobj->fbufr[1]=rtvobj->fbufr[0];
	rtvobj->fbufr[0]=save_addr;
}
int reset_object(SERVER_OBJECT *obj)
{
	obj->frame_count=0;
	obj->toc_offset=FRAME_TOC_ORIGIN;
	obj->frame_offset=0;
	obj->buf_inuse=0;
	obj->bufno=0;
	obj->toc_indx=0;
	obj->tbl_indx=0;
	obj->toc_count=0;
	obj->frmptr= obj->frmtoc;
	obj->seek_offset=0;
	obj->rec_offset=0;
	obj->que_level=0;
	obj->Gbytes=0;
}
#ifndef BETA1
struct bufnod *MakeBufList(SERVER_OBJECT *obj)
{
struct bufnod *buflist;
	buflist= (struct bufnod *)obj->writelist;
	if(buflist==NULL)
	{
	    buflist=(struct bufnod *)malloc(sizeof(struct bufnod));
	    buflist->prev=NULL;
	    buflist->head=buflist;
	}
	buflist->bufr= NULL;
	buflist->next= (struct bufnod *)malloc(sizeof(struct bufnod));
	buflist->next->bufr=NULL;
	buflist->next->next=NULL;
	buflist->next->head= buflist->head;
	buflist->next->prev= buflist;
	buflist= buflist->next;
	return(buflist);
}
char *GetNextBuf(SERVER_OBJECT *obj)
{
struct bufnod *buflist;
char *buf;
FIELD_INFO *field;
	buflist= (struct bufnod *)obj->readlist;
	if(buflist==NULL)return(NULL);
	if(buflist->bufr!=NULL)
	{
	    buf= buflist->bufr;
#ifdef TRACE_BUFIO
	    field= (FIELD_INFO *)(buf+8192);
	    printf("GetNext: obj->blkno=%d field->frame_no=%d\n",
		obj->blkno,field->frame_no);
#endif
	    buflist->bufr=NULL;
	}
	if(obj->readlist->next==NULL)
	    obj->readlist=buflist->head;
	else
	    obj->readlist= buflist->next;
	return(buf);
}
int PutNextBuf(SERVER_OBJECT *obj,char *buf) 
{
struct bufnod *buflist;
FIELD_INFO *field;

	buflist= (struct bufnod *)obj->writelist;
	buflist->bufr= buf;
	buflist->blkno=obj->blkno;
	if(buflist->next==NULL)
	    obj->writelist=buflist->head;
	else
	    obj->writelist=buflist->next;
	return(1);
}
char *FindBlk(SERVER_OBJECT *obj,int blkno)
{
struct bufnod *buflist;
	buflist= (struct bufnod *)obj->readlist->head;
	while(buflist->next)
	{
	printf("FindBlk: blkno=%d\n",buflist->blkno);
	    if(buflist->blkno==blkno)
	    {
	         obj->blkno=buflist->blkno;
		 return(buflist->bufr);
	    }
	    buflist=buflist->next;
	}
	if(buflist->blkno==blkno)
	{
	    obj->blkno=buflist->blkno;
	    return(buflist->bufr);
	}
	else
	    return(NULL);
}
#endif

	

SERVER_OBJECT *rtvdisk_init()
{
	static SERVER_OBJECT *obj;
	register int n;
#ifndef BETA1
	struct bufnod *buflist;
	char *buf;
	int status;
#endif

	obj= (SERVER_OBJECT *)malloc(sizeof(SERVER_OBJECT));
	if(obj==NULL)
	{
	    fprintf(stderr,"Service Object not allocated\n");
	    exit(-1);
	}
	memset((char *)obj,0,sizeof(SERVER_OBJECT));
	obj->frmtoc= (RTV_FRAME_TOC *)malloc(FRAME_TOC_RECSIZE);
	for(n=0;n<MaxBuffers;n++)
	    obj->fbufr[n]= (caddr_t)(iobuf+ (n*IoBufSize));
	obj->faddr= obj->fbufr[0];
#ifndef BETA1
	for(n=0;n<MaxBuffers;n++)
	    obj->writelist=MakeBufList(obj);
	obj->readlist= obj->writelist= obj->writelist->head;
#endif
	mlockall(MCL_CURRENT);
	return(obj);
}
ramdisk_init(SERVER_OBJECT *obj)
{
	obj->ram_fd= open("/dev/rtvramdisk",O_RDWR);
	if(obj->ram_fd == -1)
	{
	     fprintf(stderr,"Ramdisk not properly installed\n");
	     exit(-1);
	}
	ioctl(obj->ram_fd,RD_SET_INTERLACE);
}
open_rtv_files(SERVER_OBJECT *obj,char *filename)
{
struct stat fbuf;
char path[256];
/*
 *	Open primary file as header and table of contents.
 */
	sprintf(path,"%s",filename);
	if(stat(path,&fbuf))
	    obj->fld_fd=  open(path,O_RDWR|O_CREAT|O_TRUNC,0666);
	else
	    obj->fld_fd= open(path,O_RDWR,0666);
	if(obj->fld_fd== -1)
	{
	    fprintf(stderr,"Can't open %s\n",filename);
	    return(-2);
	}
	sprintf(path,"%s.jpeg",filename);
        if(stat(path, &fbuf))
	    obj->disk_fd= open(path, O_RDWR|O_CREAT|O_TRUNC,0666);
	else
	    obj->disk_fd= open(path,O_RDWR,0666);
	if(obj->disk_fd== -1)
	{
	    fprintf(stderr,"Can't open %s\n",path);
	    return(-2);
	}
	return(0);
}
int advance_toc(SERVER_OBJECT *rtvobj)
{
int nbytes;
            rtvobj->tbl_indx++;
            if(rtvobj->tbl_indx >= MAX_FRAME_TOC)
            {
		rtvobj->toc_indx++;
		if(rtvobj->toc_indx>rtvobj->toc_count)
		{
		    lseek(rtvobj->fld_fd,SEEK_SET,FRAME_TOC_ORIGIN);
		    rtvobj->toc_offset=FRAME_TOC_ORIGIN;
                    read(rtvobj->fld_fd,rtvobj->frmtoc,FRAME_TOC_RECSIZE);
		    rtvobj->toc_indx=0;
		    return(0);
		}
		rtvobj->toc_offset+= FRAME_TOC_RECSIZE;
	        lseek(rtvobj->fld_fd,SEEK_SET,rtvobj->toc_offset);
                nbytes=read(rtvobj->fld_fd,rtvobj->frmtoc,FRAME_TOC_RECSIZE);
	        if(nbytes < FRAME_TOC_RECSIZE)
	        {
		    lseek(rtvobj->fld_fd,SEEK_SET,FRAME_TOC_ORIGIN);
		    fprintf(stderr,"Field Table - End of File!\n");
		    rtvobj->toc_indx=0;
		    return(0);
	        }
                rtvobj->frmptr=rtvobj->frmtoc;
                rtvobj->tbl_indx=0;
	        return(1);
	    }
	    rtvobj->frmptr++;
	    return(1);
}
advance_frame(SERVER_OBJECT *rtvobj)
{
int n,status;
caddr_t buffer;

	if(rtvobj->frmptr->record_type == 7)
        {
	    if(rtvobj->que_level>=0)
	    {
   	        rtvobj->rec_offset=0;
		rtvobj->que_level--;
		/* 
		* Roll buffers here so that the last buffer
		* is available to load new data into.
		*/
#ifdef BETA1
		rotate_back(rtvobj);
		buffer= rtvobj->fbufr[5];
	        rtv_diskio(rtvobj,buffer,ASYNC_IO);
	    	rtvobj->faddr= rtvobj->fbufr[rtvobj->buf_inuse];
#else
		if(rtvobj->blkno<rtvobj->record_count)
		{
		    PutNextBuf(rtvobj,rtvobj->faddr);
	            rtv_diskio(rtvobj,rtvobj->faddr,ASYNC_IO);
		}
		rtvobj->faddr= GetNextBuf(rtvobj);
#endif
	    }
	    else
	    {
	        fprintf(stderr,"Queue Level Zero!\n");
	        rtvobj->action=STOP_RTV_PLAY;
	        return(0);
	    }
        }
	if(advance_toc(rtvobj)==0)return(0);
	rtvobj->next_frame++;
	return(1);
}

rtv_shutdown(SERVER_OBJECT *obj,int mode)
{
register int n;
	if(obj->ccube_fd>0)stop_record(obj->ccube_fd);
	if(obj->ccube_fd>0)stop_play(obj->ccube_fd);
	if(obj->disk_fd>0)close(obj->disk_fd);
	if(obj->fld_fd>0)close(obj->fld_fd);
	if(obj->ccube_fd>0)close(obj->ccube_fd,RTV_MODE);
	if(obj->ram_fd>0)close(obj->ram_fd);
}
