
#define START_XMIT     		0x81
#define STOP_XMIT      		0x82
#define START_RECV     		0x83
#define STOP_RECV      		0x84
#define ACK_START_RECV 		0x85
#define ACK_STOP_RECV  		0x86
#define RECV_STATUS		0x87
#define COPY_IN_FIELD_DATA	0x88
#define COPY_OUT_FIELD_DATA	0x89
#define SEND_NEXT_SHM_FIELD	0x8a
#define SEND_NEXT_RAM_FIELD	0x8b
#define ACK_START_XMIT 		0x8e
#define ACK_STOP_XMIT  		0x8f

#define I_ACK_START_RECV 	0x91
#define I_ACK_STOP_RECV  	0x92
#define I_ACK_START_XMIT 	0x93
#define I_ACK_STOP_XMIT  	0x94
#define I_GET_RECORD_STATUS     0x95
#define I_GET_PLAY_STATUS       0x96
#define I_START_XMIT 		0x97
#define I_STOP_XMIT    		0x98
#define I_START_AUDIO		0x99
#define I_STOP_AUDIO		0x9a
#define I_LINK_AUDIO		0x9b
#define I_SET_STREAM		0x9c
#define I_SET_USERIO		0x9d


#define I_QUE_INIT 		0x101
#define I_SET_IP_HDR		0x102
#define QUE_FIELD		0x103
#define GET_NETWORK_RATE	0x104
#define SET_DEST_HOSTADDR	0x105
#define SET_STREAM_ID    	0x107
#define I_SET_INTERLACE		0x108
#define I_SET_NONINTERLACE	0x109
#define I_START_RECV		0x10a
#define I_STOP_RECV		0x10b
#define I_SET_RECEIVE_MODE	0x10c
#define I_SET_SEND_MODE		0x10d
#define I_SET_DISK_MODE		0x10e
#define I_SET_NET_MODE 		0x10f
#define MAX_FIELDS 		30
#define MAX_QUEUE_SIZE 		30
#define MAX_FRAME_COUNT 	30
#define MAX_FIELD_QUE_SIZE 	30
#define MAX_FIELD_SIZE 		65568
#define MAX_BUF_SIZE 		65568
#define MAX_SHM_SIZE		(30*MAX_FIELD_SIZE)
#define MAX_RAM_SIZE		(30*MAX_FIELD_SIZE)


#define RTV_OPEN		0
#define START_COMPRESSION  	1
#define COMPRESSION_IODONE 	2
#define START_DECOMP 		3
#define DECOMP_IODONE 		4

#define RTV_MODE 		0x40
#define RTV_COMPRESSION 	0x20
#define RTV_DECOMPRESSION 	0x30
#define START_RECORD 		0x110
#define START_PLAY   		0x111
#define STOP_RECORD  		0x112
#define STOP_PLAY    		0x113
#define START_TRANSMIT 		0x114
#define SETUP_RECORD 		0x115
#define RTV_RECV_STATUS 	0x116
#define RTV_XMIT_STATUS 	0x117
#define PAUSE_PLAY		0x118
#define PAUSE_RECORD		0x119
#define RESUME_PLAY		0x11a
#define RESUME_RECORD		0x11b
#define PAUSE_RECEIVE		0x11c
#define SETUP_PLAY		0x11d
#define STOP_TRANSMIT		0x11e
#define RESUME_RECEIVE		0x11f
#define IO_MMAP 		0x120
#define SET_PLAY_WINDOW	0x121
#define SET_RECORD_WINDOW	0x122
#define SET_MAX_RATE		0x123
#define SET_PLAY_ORIGIN 	0x124
#define SET_RECORD_ORIGIN 	0x125
#define DOWNLOAD_FIELD_HDR 	0x41
#define DOWNLOAD_FIELD_DATA 	0x42

#define CCUBE_PRESENT		0x133

#define DST_IDLE 	20
#define DST_READY 	21
#define DST_START 	22
#define DST_BUSY 	23
#define DST_IOLATE 	24
#define DST_IOLATE_LATE 25
#define DST_FIELD_DONE  26

#define RTV_NETWORK 1
#define RTV_DISK    2
#define RTV_SCREEN  3
#define LOCAL_ONLY  5

#define STOP		1
#define RECORD		2
#define PLAY		3
#define RESTART         5
#define PAUSE           6
#define RESUME		7
#define SEND		8
#define RECEIVE		9
#define PLAYBACK	10
#define TRANSMIT 	11

#define PUTRAM_TRIG		1
#define GETRAM_TRIG		2

#define RD_SET_BLOCK		2
#define RD_GET_FIELD		3
#define RD_PUT_FIELD		4
#define RD_GET_AUDIO    	5
#define RD_PUT_AUDIO    	6
#define RD_GET_PLAY_LEVEL 	7
#define RD_SET_INTERLACE 	8
#define RD_SET_NONINTERLACE 	9
#define RD_GET_FRAME_SIZE 	10
#define RD_START_AUDIO_RECORD 	11
#define RD_STOP_AUDIO_RECORD 	12
#define INIT_QUEUE 	  	13
#define RD_START_AUDIO_PLAYBACK 14
#define RD_STOP_AUDIO_PLAYBACK 	15
#define SET_OUTPUT_STREAM 	16
#define RD_AUDIO_MONITOR_ON     17
#define RD_AUDIO_MONITOR_OFF    18
#define RD_GET_RECORD_LEVEL 	19
#define RD_SET_AUDIO_RATE	20

#define SELECTED 1
#define RTV_ACTIVE 2
#define DESELECTED 3
#define RTV_IDLE 4
#define UNICAST 1
#define MULTICAST 2

typedef struct {
	int   frame_no;
	int   size;
	int   offset;
	short qfactor;
	short polarity;
	int   clock;
	int   inuse;
	}FIELD_INFO;

