
#define MONITOR_ON 1
#define MONITOR_OFF 0
#define MAX_FRAME_TOC 512
#define  RTV_AUDIO			1
#define  RTV_VIDEO			2
#define  RTV_AVCOMB			3
#define  RTV_EOB			4
#define  RTV_BOB			8
#define  RTV_EOF			0x80

typedef struct {
	aio_result_t aio_result;
	int inuse;
	int action;
	int sync;
	int *obj;
	}RTV_AIO;

#define MAX_WAIT_TIME 1000
#define ASYNC_IO 0
#define SYNC_IO  1

#define MAX_BLOCKS 512
#define MAX_CONNECTIONS 5
#define MaxRotation 5
#define IoBufSize (512*1024)
#define MaxBuffers 6
#define MAX_OFFSET MAX_BLOCKS*IoBufSize
#define FRAME_TOC_RECSIZE MAX_FRAME_TOC*sizeof(RTV_FRAME_TOC)
#define TOC_HDR_SIZE     (sizeof(RTV_ATTRIBUTES)+12)
#define FRAME_TOC_ORIGIN (sizeof(RTV_ATTRIBUTES)+12)
typedef struct {
	int length;
	int sync_clock;
	caddr_t address;
	}AudioRec;

#define RTV_PAUSE_STEP 0x30

RTV_OBJECT *client_obj[MAX_CONNECTIONS];

#define MAX_AIO_QUEUE 64

typedef struct {
        short  record_type;
	int    frame_no;
	short  audio_sync;
	int    seek_offset;
	int    frame_offset;
	int    size[3];
#ifndef BETA1
	int    blkno;
	int    Gbytes;
#endif
	}RTV_FRAME_TOC;

#ifndef BETA1
struct bufnod {
	 char *bufr;
	 int  blkno;
	 struct bufnod *prev;
	 struct bufnod *next;
	 struct bufnod *head;
	 }BUFNOD;
#endif

typedef struct {
	int     srvr_sock;
	int	client_sock[MAX_CONNECTIONS];
	int  	skip;
	int	action;
	int  	remote;
	int  	opcode;
	int	iomode;
	int     ccube_fd;
	int     disk_fd;
	int     fld_fd;
	int	ram_fd;
	int     buf_inuse;
	int	mode;
	int	bufno;
	int	blkno;
	int     frame_selection;
	int     field_selection;
	int	port;
	int     client_connections[MAX_CONNECTIONS];
	int	aud_diskfd;
	int     audio_mode;
	int     audio_status;
	int     start_pixel;
	int     seek_ahead;
	int     Gbytes;
	int	audioFD;
	int     audio_seek;
	int	queue_full;
	int     frame_count;
	int	next_frame;
	int	end_frame;
	int	end_of_file;
	int	seek_offset;
	int     toc_offset;
	int	toc_count;
	int	toc_indx;
	int	tbl_indx;
	int	errno;
	int     frame_offset;
	int	frmtoc_seek;
	int     save_rate;
	int     rec_offset;
	int	que_level;
	int     polarity;
	int		shmid[5];
	char    *local_host;
	char    *remote_host;
	char    *filename;
	char    *tblname;
	int 	*disktoc;
	RTV_FRAME_TOC	*frmtoc;
	RTV_FRAME_TOC	*frmptr;
	RTV_FRAME_TOC   *frmtoc_tail;
	caddr_t frmbuf;
	caddr_t faddr;
	caddr_t fbufr[MaxBuffers];
	int     buf_filled[MaxBuffers];
	RTV_ATTRIBUTES record_attrs;
	RTV_ATTRIBUTES play_attrs;
        struct timeval  timer;
	char	version[12];
	RTV_OBJECT *client;
#ifndef BETA1
	int    record_count;
	struct bufnod *writelist;
	struct bufnod *readlist;
#endif
	}SERVER_OBJECT;

