#pragma ident "@(#)plxWid.c     1.12 94/03/31   SMI"
 
#include    <stdio.h>
#include    "sun.h"
#include     "mpg/mpg.h"
#include     "mpg/wid.h"
#include    "cmap/cmap.h"
#include     "X.h"
#include    "windowstr.h"
#include    <sys/mman.h>
#include    <sys/memfb.h>
#include    <sys/fbio.h>
 
#include    <sys/ioccom.h>
#include    <sys/fcntl.h>
 
#include    "colormap.h"
#include    "colormapst.h"
#include    "resource.h"
#include    "mibstore.h"
#include    "xvideo.h"
#include    "plxInit.h"
#define XV_DIAG 1
#include    "xvdebug.h"
 
/*  FORWARD REFERENCES: */
 
int    plxGetWid();
void   plxWidTv_SetColorLut();
WidPtr plxVideoWidAlloc();
WidPtr plxWidTv_Alloc();
void   plxWidTv_Free();
void   plxWidInit();
 

/*-------------------------------------------------------------------------*
 |"plxWidTv_Alloc"
 |
 |   Sun X server transfer vector entry to allocate window identifiers.
 |
 |  -> window id structure on success, 0 on failure
 *-------------------------------------------------------------------------*/
WidPtr plxWidTv_Alloc( 
	ScreenPtr pScreen,      /* -> screen to allocate window id for. */
    VisualID  visual,       /* =  visual id to allocate wid for. */
    int       numContig,    /* */
    Bool      unique,       /* =  1 if window id cannot be shared. */
    int       flavor        /* */
)
{
    int          i_visual;      /* entry in pScreen->visuals examining. */
    plxScreenPtr pPlx;			/* Per screen context for Parallax boards. */
    WidPtr       pWid;
    int          wid;

   TRACE(("plxWidTv_Alloc...\n"));


	/*  LOOK UP THE REQUESTED VISUAL TYPE TO MAKE SURE WE SUPPORT IT. */

    pPlx =  GetPlxPrivate(pScreen);
    for ( i_visual = 0; i_visual  < pScreen->numVisuals; i_visual++) 
    {
        if (pScreen->visuals[i_visual].vid == visual) break;
    }
    if ( i_visual >= pScreen->numVisuals )
    {
		 ErrorF("Unknown visual type requested\n");
		 return (NULL);
    }


	/*  PROCESS THE REQUEST BASED ON THE VISUAL TYPE:
	 *
	 *  (1) If the request is for a shared window id use entry 0.
	 *  (2) If a unique id is requested look for an unused wid and 
	 *      allocate an entry.
	 */
	switch (pScreen->visuals[i_visual].class)
    {
      case PseudoColor:
		if ( !unique )
		{
			if ( (pWid = pPlx->WidPtrPseudo[0].pWid) == 0 )
			{
				if( !(pWid = widAllocObj()) ) return (NULL);
				widSetValue(pWid, WID_TYPE_PSEUDO);
				pPlx->WidPtrPseudo[0].pWid = pWid;
			}
			return pWid;
		}
		else
		{
			for ( i_wid = 1; i_wid < pPlx->nWidsPseudo; i_wid++ )
			{
				if ( pPlx->WidPtrPseudo[i_wid].pWid == 0 )
				{
					if( !(pWid = widAllocObj()) ) return (NULL);
					widSetValue(pWid, WID_TYPE_PSEUDO | i_wid);
					pPlx->WidPtrPseudo[i_wid].pWid = pWid;
					return pWid;
				}
			}
			if ( (pWid = pPlx->WidPtrPseudo[0].pWid) == 0 )
			{
				if( !(pWid = widAllocObj()) ) return (NULL);
				widSetValue(pWid, WID_TYPE_TRUE);
				pPlx->WidPtrPseudo[0].pWid = pWid;
			}
			return pWid;
		}
		break;

      case TrueColor:  
		if( !unique )
		{
			if ( (pWid = pPlx->WidsPtrTrue24[0].pWid) == 0 )
			{
				if( !(pWid = widAllocObj()) ) return (NULL);
				widSetValue(pWid, WID_TYPE_TRUE);
				pPlx->WidsPtrTrue24[0].pWid = pWid;
			}
			return (pWid);
		}
		else
		{
			for ( i_wid = 1; i_wid < pPlx->nWidsTrue; i_wid++ )
			{
				if ( pPlx->WidsPtrTrue24[i_wid].pWid == 0 )
				{
					if( !(pWid = widAllocObj()) ) return (NULL);
					widSetValue(pWid, WID_TYPE_TRUE | i_wid);
					pPlx->WidsPtrTrue24[i_wid].pWid = pWid;
					return pWid;
				}
			}
			if ( (pWid = pPlx->WidsPtrTrue24[0].pWid) == 0 )
			{
				if( !(pWid = widAllocObj()) ) return (NULL);
				widSetValue(pWid, WID_TYPE_TRUE);
				pPlx->WidsPtrTrue24[0].pWid = pWid;
			}
			return pWid;
		}
		break;

	  case DirectColor:
		if( !unique )
		{
			if ( (pWid = pPlx->WidPtrDirect[0].pWid) == 0 )
			{
				if( !(pWid = widAllocObj()) ) return (NULL);
				widSetValue(pWid, WID_TYPE_DIRECT);
				pPlx->WidPtrDirect[0].pWid = pWid;
			}
			return pWid;
		}
		else
		{
			for ( i_wid = 1; i_wid < pPlx->nWidsDirect; i_wid++ )
			{
				if ( pPlx->WidPtrDirect[i_wid].pWid == 0 )
				{
					if( !(pWid = widAllocObj()) ) return (NULL);
					widSetValue(pWid, WID_TYPE_DIRECT | i_wid);
					pPlx->WidPtrDirect[i_wid].pWid = pWid;
					return pWid;
				}
			}
			if ( (pWid = pPlx->WidPtrDirect[0].pWid) == 0 )
			{
				if( !(pWid = widAllocObj()) ) return (NULL);
				widSetValue(pWid, WID_TYPE_DIRECT);
				pPlx->WidPtrDirect[0].pWid = pWid;
			}
			return pWid;
		}
   }
}


/*-------------------------------------------------------------------------*
 |"plxWidTv_Free"
 |
 |   Sun X server transfer vector routine to free a window id object, and 
 |   remove it from wid list maintained for its visual type.
 *-------------------------------------------------------------------------*/
void plxWidTv_Free(
	WidPtr pWid             /* -> window id to be freed. */
)
{
    int       	 i_wid;    /* Element of window id table examining. */
    plxScreenPtr pPlx;	   /* Per screen context for Parallax boards. */
    ScreenPtr 	 pScreen;  /* -> screen to allocate window id for. */
    int       	 wid;      /* Window id of block we were passed. */

    TRACE(("plxWidTv_Free...\n"));

    pScreen = widGetScreen(pWid);
	pPlx =  GetPlxPrivate(pScreen);

	wid = widGetValue(pWid);
	switch( wid & WID_TYPE_MASK )
	{
	  case WID_TYPE_PSEUDO:
        if( (i_wid = wid & (nWidsPseudo-1)) == 0 ) return;
		pPlx->WidPtrPseudo[i_wid].pWid = 0;
		break;
	  case WID_TYPE_DIRECT:
        if( (i_wid = wid & (nWidsDirect-1)) == 0 ) return;
		pPlx->WidPtrDirect[i_wid].pWid = 0;
		break;
	  default:
        if( (i_wid = wid & (nWidsTrue-1)) == 0 ) return;
		pPlx->WidsPtrTrue24[i_wid].pWid = 0;
		break;
    }
    widFreeObj(pWid);
}


/*-------------------------------------------------------------------------*
 |"plxWidInit"
 |
 |   Initialize Parallax Window Id Support.
 |
 *-------------------------------------------------------------------------*/
void plxWidInit( pScreen )
	ScreenPtr	pScreen;	/* Screen context. */
{
	int				i_wid;			  /* Entry in window id tables accessing. */
    plxScreenPtr    pPlx;	  		  /* Screen private storage this board. */
    extern WidPtr   plxWidAlloc();	  /* Parallax wid allocation program. */
    extern void     plxWidFree();	  /* Parallax wid free tv entry. */
	extern void     plxSetColorLut(); /* Parallax wid set color lut tv entry. */

	pPlx = GetPlxPrivate(pScreen);


	/*  INITIALIZE WINDOW ID TABLES IN PARALLAX PRIVATE AREA: */

	pPlx->nWidsDirect = sizeof(pPlx->WidPtrDirect)/sizeof(plxWidTableRec);	
	pPlx->nWidsTrue = sizeof(pPlx->WidsPtrTrue24)/sizeof(plxWidTableRec);	
	pPlx->nWidsPseudo = sizeof(pPlx->WidPtrPseudo)/sizeof(plxWidTableRec);	
	for ( i_wid = 0; i_wid < pPlx->nWidsDirect; i_wid++ )
	{
		pPlx->WidPtrDirect[i_wid].index = WID_TYPE_DIRECT | i_wid;
		pPlx->WidPtrDirect[i_wid].pWid = 0;
		pPlx->WidPtrDirect[i_wid].pWin = 0;
	}
	for ( i_wid = 0; i_wid < pPlx->nWidsPseudo; i_wid++ )
	{
		pPlx->WidPtrPseudo[i_wid].index = WID_TYPE_PSEUDO | i_wid;
		pPlx->WidPtrPseudo[i_wid].pWid = 0;
		pPlx->WidPtrPseudo[i_wid].pWin = 0;
	}
	for ( i_wid = 0; i_wid < pPlx->nWidsTrue; i_wid++ )
	{
		pPlx->WidsPtrTrue24[i_wid].index = WID_TYPE_TRUE | i_wid;
		pPlx->WidsPtrTrue24[i_wid].pWid = 0;
		pPlx->WidsPtrTrue24[i_wid].pWin = 0;
	}


	/*  INITIALIZE WINDOW ID SUPPORT AND ALLOCATE SHARED WIDS. */

    widScreenInit(pScreen, plxWidAlloc, plxWidFree, plxSetColorLut);

    vid = pScreen->visuals[PLX_COLOR_8].vid;
    pPlx->WidPtr8= widAllocate(pScreen,vid,1,FALSE,0);
	pPlx->WidPtrPseudo[0].pWid = pPlx->WidPtr8;
    pPlx->wid8= widGetValue(pPlx->WidPtr8);

    vid = pScreen->visuals[PLX_COLOR_24].vid;
    pPlx->WidPtrTrue24= widAllocate(pScreen,vid,1,FALSE,0);
    pPlx->wid24True= widGetValue(pPlx->WidPtrTrue24);
	pPlx->WidsPtrTrue24[0].pWid = pPlx->WidPtrTrue24;

    vid = pScreen->visuals[PLX_DIRECT_24].vid;
    pPlx->WidPtrDirect24= widAllocate(pScreen,vid,1,FALSE,0);
    pPlx->wid24Direct= widGetValue(pPlx->WidPtrDirect24);
	pPlx->WidPtrDirect[0].pWid = pPlx->WidPtrDirect24;
}
