/*
 * cfb copy area
 */

/*

Copyright (c) 1989  X Consortium

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall not be
used in advertising or otherwise to promote the sale, use or other dealings
in this Software without prior written authorization from the X Consortium.

Author: Keith Packard

*/
/* $XConsortium: cfbbitblt.c,v 5.51 94/05/27 11:00:56 dpw Exp $ */

#include	"X.h"
#include	"Xmd.h"
#include	"Xproto.h"
#include	"gcstruct.h"
#include	"windowstr.h"
#include	"scrnintstr.h"
#include	"pixmapstr.h"
#include	"regionstr.h"

#include	"plxv.h"
#if 0
#include	"pfb.h"
#include	"cfb.h"
#endif

#if 0
#include	"cfbmskbits.h"
#include	"cfb8bit.h"
#include	"fastblt.h"
#define MFB_CONSTS_ONLY
#include	"maskbits.h"
#endif

int pfbhwbitblt(DrawablePtr pSrcDraw, DrawablePtr pDstDraw,
		       int  alu, RegionPtr prgnDst, DDXPointPtr pptSrc,
		       unsigned long planeMask)
{
#if 0
    XV_struct *xv = GETXV(pDstDraw);
#endif
    BoxPtr              pbox;
    int                 nbox;
    int			sx, dx, sy, dy, w, h;
    BoxPtr pboxTmp, pboxNext, pboxBase, pboxNew1, pboxNew2;
                                /* temporaries for shuffling rectangles */
    DDXPointPtr pptTmp, pptNew1, pptNew2;
                                /* shuffling boxes entails shuffling the
                                   source points too */

    pbox = REGION_RECTS(prgnDst);
    nbox = REGION_NUM_RECTS(prgnDst);

    plxv_mode_24();
    if(pDstDraw->depth == 1)
	planeMask = 0xffffff;
    else if(pDstDraw->depth == 8)
    {
	planeMask &= 0xff;
	planeMask |= ((planeMask << 8) | (planeMask << 16));
    }
    plxv_wmask((planeMask & 0xffffff) | PLXV_WMASK_PIXEL_ATTR);
    plxv_tag ( 0, 0);

    pboxNew1 = NULL;
    pptNew1 = NULL;
    pboxNew2 = NULL;
    pptNew2 = NULL;

    if(pptSrc->y < pbox->y1)
    {
	if (nbox > 1)
	{
	    /* keep ordering in each band, reverse order of bands */
	    pboxNew1 = (BoxPtr)ALLOCATE_LOCAL(sizeof(BoxRec) * nbox);
	    if(!pboxNew1)
		return;
	    pptNew1 = (DDXPointPtr)ALLOCATE_LOCAL(sizeof(DDXPointRec) * nbox);
	    if(!pptNew1)
	    {
	        DEALLOCATE_LOCAL(pboxNew1);
	        return;
	    }
	    pboxBase = pboxNext = pbox+nbox-1;
	    while (pboxBase >= pbox)
	    {
	        while ((pboxNext >= pbox) &&
		       (pboxBase->y1 == pboxNext->y1))
		    pboxNext--;
	        pboxTmp = pboxNext+1;
	        pptTmp = pptSrc + (pboxTmp - pbox);
	        while (pboxTmp <= pboxBase)
	        {
		    *pboxNew1++ = *pboxTmp++;
		    *pptNew1++ = *pptTmp++;
	        }
	        pboxBase = pboxNext;
	    }
	    pboxNew1 -= nbox;
	    pbox = pboxNew1;
	    pptNew1 -= nbox;
	    pptSrc = pptNew1;
        }
    }
    if(pptSrc->x < pbox->x1)
    {
	if (nbox > 1)
	{
	    /* reverse order of rects in each band */
	    pboxNew2 = (BoxPtr)ALLOCATE_LOCAL(sizeof(BoxRec) * nbox);
	    pptNew2 = (DDXPointPtr)ALLOCATE_LOCAL(sizeof(DDXPointRec) * nbox);
	    if(!pboxNew2 || !pptNew2)
	    {
		if (pptNew2) DEALLOCATE_LOCAL(pptNew2);
		if (pboxNew2) DEALLOCATE_LOCAL(pboxNew2);
		if (pboxNew1)
		{
		    DEALLOCATE_LOCAL(pptNew1);
		    DEALLOCATE_LOCAL(pboxNew1);
		}
	        return;
	    }
	    pboxBase = pboxNext = pbox;
	    while (pboxBase < pbox+nbox)
	    {
	        while ((pboxNext < pbox+nbox) &&
		       (pboxNext->y1 == pboxBase->y1))
		    pboxNext++;
	        pboxTmp = pboxNext;
	        pptTmp = pptSrc + (pboxTmp - pbox);
	        while (pboxTmp != pboxBase)
	        {
		    *pboxNew2++ = *--pboxTmp;
		    *pptNew2++ = *--pptTmp;
	        }
	        pboxBase = pboxNext;
	    }
	    pboxNew2 -= nbox;
	    pbox = pboxNew2;
	    pptNew2 -= nbox;
	    pptSrc = pptNew2;
	}
    }
    while(nbox--)
    {
	w = pbox->x2 - pbox->x1;
	h = pbox->y2 - pbox->y1;
	if(pptSrc->x >= pbox->x1)	/* scan left to right */
	{
	    sx = pptSrc->x;
	    dx = pbox->x1;
	}
	else				/* scan right to left */
	{
	    sx = pptSrc->x + w - 1;
	    dx = pbox->x2 - 1;
	    w = -w;
	}
	if(pptSrc->y >= pbox->y1)	/* scan top to bottom */
	{
	    sy = pptSrc->y;
	    dy = pbox->y1;
	}
	else				/* scan bottom to top */
	{
	    sy = pptSrc->y + h - 1;
	    dy = pbox->y2 - 1;
	    h = - h;
	}
	plxv_blit( sx, sy, dx, dy, w, h);
	++pbox;
	++pptSrc;
    }
    if (pboxNew2)
    {
	DEALLOCATE_LOCAL(pptNew2);
	DEALLOCATE_LOCAL(pboxNew2);
    }
    if (pboxNew1)
    {
	DEALLOCATE_LOCAL(pptNew1);
	DEALLOCATE_LOCAL(pboxNew1);
    }
    return 0;
}
#if 0
int pfbsw8bitblt(DrawablePtr pSrcDraw, DrawablePtr pDstDraw,
		       int  alu, RegionPtr prgnDst, DDXPointPtr pptSrc,
		       unsigned long planeMask)
{
    XV_struct *xv = GETXV(pDstDraw);
    unsigned long *sp, *dp;
    register unsigned long *csp, *cdp;
    RegionRec		region;
    DDXPointRec		point;
    BoxPtr              pbox;
    int                 nbox;
    int			soff, sx, dx, sy, dy, w, h, ws, wd, ns, ne;

    pbox = REGION_RECTS(prgnDst);
    nbox = REGION_NUM_RECTS(prgnDst);

    cfbGetLongWidthAndPointer (pSrcDraw, ws, sp)
    cfbGetLongWidthAndPointer (pDstDraw, wd, dp)

    planeMask &= 0xff;
    planeMask |= ((planeMask << 8) | (planeMask << 16));
    plxv_wmask(xv, planeMask | PLXV_WMASK_PIXEL_ATTR);

    while (nbox--)
    {
	w = pbox->x2 - pbox->x1;
	h = pbox->y2 - pbox->y1;
	sx = pptSrc->x;
	sy = pptSrc->y;
	dx = pbox->x1;
	dy = pbox->y1;

	if(ns = (dx & 3))
	{
	    ns = 4 - ns;
	    if(ns > w)
		ns = w;
	}

	if(ne = (dx + w) & 3)
	{
	    if(ns == w)
		ne = 0;
	    else if(ne > w)
		ne = w;
	}

	if(ns || ne)
	{
	   register int i;
	   register unsigned long t;

	   /* first do start pixels, then do end pixels */

	   if(ns)
	   {
		csp = sp + (sy * ws) + (sx >> 2);
		cdp = dp + (dy * wd) + (dx >> 2);
		soff = sx & 3;
		plxv_ctl_1(xv, dx & 3, ns);

	        for(i = 0; i < h; ++i)
	        {
		    t = csp[0];
		    if(soff)
		    {
			t <<= (soff << 3);
			if((4 - soff) < ns)
			    t |= (csp[1] >> ((4 - soff) << 3));
		    }
		    *cdp = t; 
		    csp += ws;
		    cdp += wd;
		}
	    }
	    if(ne)
	    {
		csp = sp + (sy * ws) + (((sx + w) - ne) >> 2);
		cdp = dp + (dy * wd) + (((dx + w) - ne) >> 2);
		plxv_ctl_1(xv, 0, ne);
		soff = ((sx + w) - ne) & 3;
		for(i = 0; i < h; ++i)
		{
		    t = csp[0];
		    if(soff)
		    {
			t <<= (soff << 3);
			if((4 - soff) < ne)
			    t |= (csp[1] >> ((4 - soff) << 3));
		    }
		    *cdp = t; 
		    csp += ws;
		    cdp += wd;
		}
	   }
	   plxv_ctl_1(xv, 0, 32);
	   region.extents.x1 = dx + ns;
	   region.extents.x2 = (dx + w) - ne;
	   region.extents.y1 = dy;
	   region.extents.y2 = dy + h;
	   region.data = NULL;
	   point.x = sx + ns;
	   point.y = sy;
	}
	else
	{
	   region.extents = *pbox;
	   region.data = NULL;
	   point = *pptSrc;
	}
	if(w > (ns + ne))
	 cfbDoBitbltCopy(pSrcDraw, pDstDraw, alu, &region, &point, planeMask);
	++pbox;
	++pptSrc;
    }
}

int pfbsw1bitblt(DrawablePtr pSrcDraw, DrawablePtr pDstDraw,
		       int  alu, RegionPtr prgnDst, DDXPointPtr pptSrc)
{
    XV_struct *xv = GETXV(pDstDraw);
    unsigned long *sp, *dp;
    register unsigned long *csp, *cdp;
    RegionRec		region;
    DDXPointRec		point;
    BoxPtr              pbox;
    int                 nbox;
    int			soff, sx, dx, sy, dy, w, h, ws, wd, ns, ne;
    register unsigned int pmsk;
    pointer savedPriv;

    pbox = REGION_RECTS(prgnDst);
    nbox = REGION_NUM_RECTS(prgnDst);

    cfbGetLongWidthAndPointer (pSrcDraw, ws, sp)
    cfbGetLongWidthAndPointer (pDstDraw, wd, dp)

#ifdef CFB_NEED_SCREEN_PRIVATE
    savedPriv = pDstDraw->pScreen->devPrivate;
    pDstDraw->pScreen->devPrivate = pDstDraw->pScreen->devPrivates[cfbScreenPrivateIndex].ptr;
#endif

    while (nbox--)
    {
	w = pbox->x2 - pbox->x1;
	h = pbox->y2 - pbox->y1;
	sx = pptSrc->x;
	sy = pptSrc->y;
	dx = pbox->x1;
	dy = pbox->y1;

	if(ns = (dx & 31))
	{
	    ns = 32 - ns;
	    if(ns > w)
	    {
		ns = w;
	    }
	}

	if(ne = (dx + w) & 31)
	{
	    if(ns == w)
		ne = 0;
	    else if(ne > w)
		ne = w;
	}

	if(ns || ne)
	{
	    register int i;
	    register unsigned long t;

	   /* first do start, then do end */

	    if(ns)
	    {
		csp = sp + (sy * ws) + (sx >> 5);
		cdp = dp + (dy * wd) + (dx >> 5);
		soff = sx & 31;
		plxv_ctl_1(xv, dx & 31, ns);
		for(i = 0; i < h; ++i)
		{
		    t = csp[0];
		    if(soff)
		    {
			t <<= soff;
			if((32 - soff) < ns)
			    t |= (csp[1] >> (32 - soff));
		    }
		    *cdp = t;
		    csp += ws;
		    cdp += wd;
		}
	    }
	    if(ne)
	    {
		csp = sp + (sy * ws) + (((sx + w) - ne) >> 5);
		cdp = dp + (dy * wd) + (((dx + w) - ne) >> 5);
		soff = ((sx + w) -ne) & 31;
		plxv_ctl_1(xv, 0, ne);
		for(i = 0; i < h; ++i)
		{
		    t = csp[0];
		    if(soff)
		    {
			t <<= soff;
			if((32 - soff) < ne)
			    t |= (csp[1] >> (32 - soff));
		    }
		    *cdp = t;
		    csp += ws;
		    cdp += wd;
		}
	    }
	    plxv_ctl_1(xv, 0, 32);
	    region.extents.x1 = dx + ns;
	    region.extents.x2 = (dx + w) - ne;
	    region.extents.y1 = dy;
	    region.extents.y2 = dy + h;
	    point.x = sx + ns;
	    point.y = sy;
	    region.data = NULL;
	}
	else
	{
	   region.extents = *pbox;
	   region.data = NULL;
	   point = *pptSrc;
	}
	if(w > (ns + ne))
	  mfbDoBitbltCopy(pSrcDraw, pDstDraw, alu, &region, &point);
	++pbox;
	++pptSrc;
    }
#ifdef CFB_NEED_SCREEN_PRIVATE
    pDstDraw->pScreen->devPrivate = savedPriv;
#endif
}

RegionPtr
pfbCopyArea(pSrcDrawable, pDstDrawable,
            pGC, srcx, srcy, width, height, dstx, dsty)
    register DrawablePtr pSrcDrawable;
    register DrawablePtr pDstDrawable;
    GC *pGC;
    int srcx, srcy;
    int width, height;
    int dstx, dsty;
{
    RegionPtr ret;
    int (*doBitBlt) ();
    XV_struct *xv = GETXV(pDstDrawable);

    pfbSetupDraw(pSrcDrawable, NULL);
    if(pfbSetupDraw(pDstDrawable, pGC) == FALSE) /* if pixmap, just use cfb */
    {
	if(pDstDrawable->depth < 24)
	    return(cfbCopyArea(pSrcDrawable, pDstDrawable,
			pGC, srcx, srcy, width, height, dstx, dsty));
	else
	    return(cfb32CopyArea(pSrcDrawable, pDstDrawable,
			pGC, srcx, srcy, width, height, dstx, dsty));
    }

    doBitBlt = NULL;	/* use cfb32 code */

    if((pSrcDrawable->type == DRAWABLE_WINDOW) &&
       (pSrcDrawable->pScreen == pDstDrawable->pScreen)) /* if us to us */
    {
	pfbRestoreDraw(pDstDrawable, pGC);	/* put back mask, and alu */
	doBitBlt = pfbhwbitblt;				/* use hardware */
    }
    else if(pDstDrawable->depth == 8)	/* if 8 use 8 bit software rout. */
	doBitBlt = pfbsw8bitblt;
    else if(pDstDrawable->depth == 1)
    {
	int fpixel = pGC->fgPixel;
	int bpixel = pGC->bgPixel;

	if(pDstDrawable->depth == 1)
	{
	    fpixel = (fpixel & 1) ? 0xffffff : 0;
	    bpixel = (bpixel & 1) ? 0xffffff : 0;
	}
	else if(pDstDrawable->depth == 8)
	{
	    fpixel &= 0xff;
	    fpixel |= ((fpixel << 8) | (fpixel << 16));
	    bpixel &= 0xff;
	    bpixel |= ((fpixel << 8) | (fpixel << 16));
	}

	plxv_colors_1(xv, fpixel, bpixel, 0xffffff);
	doBitBlt = pfbsw1bitblt;	/* if 1 use 1 bit software rout. */
    }
#if 0
	ret = cfbCopyArea(pSrcDrawable, pDstDrawable,
			pGC, srcx, srcy, width, height, dstx, dsty);
#endif
    if(doBitBlt)		/* if not 24bit pixmap to window */
    {
	ret = cfbBitBlt(pSrcDrawable, pDstDrawable, pGC,
			srcx, srcy, width, height, dstx, dsty, doBitBlt, 0);
    }
    else
    {
	ret = cfb32CopyArea(pSrcDrawable, pDstDrawable,
			pGC, srcx, srcy, width, height, dstx, dsty);
    }

    pfbRestoreDraw(pDstDrawable, pGC);

    return ret;

#if 0
    void (*doBitBlt) ();
    
    doBitBlt = pfbDoBitbltCopy;
    if (pGC->alu != GXcopy || (pGC->planemask & PMSK) != PMSK)
    {
	doBitBlt = pfbDoBitbltGeneral;
	if ((pGC->planemask & PMSK) == PMSK)
	{
	    switch (pGC->alu) {
	    case GXxor:
		doBitBlt = pfbDoBitbltXor;
		break;
	    case GXor:
		doBitBlt = pfbDoBitbltOr;
		break;
	    }
	}
    }
    return pfbBitBlt (pSrcDrawable, pDstDrawable,
            pGC, srcx, srcy, width, height, dstx, dsty, doBitBlt, 0L);
#endif
}

RegionPtr
pfbCopyPlane(pSrcDrawable, pDstDrawable,
	     pGC, srcx, srcy, width, height, dstx, dsty, bitPlane)
    DrawablePtr 	pSrcDrawable;
    DrawablePtr		pDstDrawable;
    GCPtr		pGC;
    int 		srcx, srcy;
    int 		width, height;
    int 		dstx, dsty;
    unsigned long	bitPlane;
{
    RegionPtr	ret;
    extern RegionPtr    miHandleExposures();
    void		(*doBitBlt)();
    XV_struct *xv = GETXV(pDstDrawable);

    pfbSetupDraw(pSrcDrawable, NULL);
    if(pfbSetupDraw(pDstDrawable, pGC) == FALSE)
    {
	if(pDstDrawable->depth < 24)
	  return(cfbCopyPlane(pSrcDrawable, pDstDrawable,
	     pGC, srcx, srcy, width, height, dstx, dsty, bitPlane));
	else
	  return(cfb32CopyPlane(pSrcDrawable, pDstDrawable,
	     pGC, srcx, srcy, width, height, dstx, dsty, bitPlane));
    }

    if (pSrcDrawable->bitsPerPixel == pDstDrawable->bitsPerPixel)
    {
	ret = cfbBitBlt (pSrcDrawable, pDstDrawable,
			 pGC, srcx, srcy, width, height, dstx, dsty, 
			 pfbhwbitblt, bitPlane);
    }
    else if ((pSrcDrawable->bitsPerPixel == 1) &&
	     (pDstDrawable->bitsPerPixel != 1))
    {
    	if (bitPlane == 1)
	{
	    int depth = pDstDrawable->depth;
	    int fpixel = pGC->fgPixel;
	    int bpixel = pGC->bgPixel;

	    pfbRestoreDraw(pDstDrawable, pGC);
	    pDstDrawable->depth = 1;
	    pfbSetupDraw(pDstDrawable, pGC);

	    if(depth == 1)
	    {
		fpixel = (fpixel & 1) ? 0xffffff : 0;
		bpixel = (bpixel & 1) ? 0xffffff : 0;
	    }
	    else if(depth == 8)
	    {
		fpixel &= 0xff;
		fpixel |= ((fpixel << 8) | (fpixel << 16));
		bpixel &= 0xff;
		bpixel |= ((bpixel << 8) | (bpixel << 16));
		xplxv_setup_tag(pDstDrawable, pGC, 8); /* restore tag */
	    }

	    plxv_colors_1(xv, fpixel, bpixel, 0xffffff);
    	    ret = cfbBitBlt (pSrcDrawable, pDstDrawable,
			     pGC, srcx, srcy, width, height, dstx, dsty,
			     pfbsw1bitblt, bitPlane);
	    pDstDrawable->depth = depth;
	}
	else
	    ret = miHandleExposures (pSrcDrawable, pDstDrawable,
	    	pGC, srcx, srcy, width, height, dstx, dsty, bitPlane);
    }
    else
    {
      if(pDstDrawable->depth < 24)
	ret = cfbCopyPlane(pSrcDrawable, pDstDrawable,
	     pGC, srcx, srcy, width, height, dstx, dsty, bitPlane);
      else
	ret = cfb32CopyPlane(pSrcDrawable, pDstDrawable,
	     pGC, srcx, srcy, width, height, dstx, dsty, bitPlane);

    }
    pfbRestoreDraw(pDstDrawable, pGC);

    return ret;
}

void
pfbCopyWindow(pWin, ptOldOrg, prgnSrc)
    WindowPtr pWin;
    DDXPointRec ptOldOrg;
    RegionPtr prgnSrc;
{
    DDXPointPtr pptSrc;
    register DDXPointPtr ppt;
    RegionRec rgnDst;
    register WindowPtr pVideo = NULL;
    register BoxPtr pbox;
    register int i, nbox;
    register int dx, dy;
    register ValidatePtr val;
    WindowPtr pwinRoot;

    pfbSetupDraw((DrawablePtr)pWin, NULL);

    pVideo = (WindowPtr) plxSearchVideoWindow (pWin);

    pwinRoot = WindowTable[pWin->drawable.pScreen->myNum];

    REGION_INIT(pWin->drawable.pScreen, &rgnDst, NullBox, 0);

    dx = ptOldOrg.x - pWin->drawable.x;
    dy = ptOldOrg.y - pWin->drawable.y;
    REGION_TRANSLATE(pWin->drawable.pScreen, prgnSrc, -dx, -dy);
    REGION_INTERSECT(pWin->drawable.pScreen, &rgnDst, &pWin->borderClip, prgnSrc);

    pbox = REGION_RECTS(&rgnDst);
    nbox = REGION_NUM_RECTS(&rgnDst);
    if(!nbox || !(pptSrc = (DDXPointPtr )ALLOCATE_LOCAL(nbox * sizeof(DDXPointRec))))
    {
	REGION_UNINIT(pWin->drawable.pScreen, &rgnDst);
	return;
    }
    ppt = pptSrc;

    for (i = nbox; --i >= 0; ppt++, pbox++)
    {
	ppt->x = pbox->x1 + dx;
	ppt->y = pbox->y1 + dy;
    }

    pfbhwbitblt((DrawablePtr)pWin, (DrawablePtr)pWin, GXcopy, &rgnDst,
		pptSrc, ~0L);

    DEALLOCATE_LOCAL(pptSrc);
    REGION_UNINIT(pWin->drawable.pScreen, &rgnDst);

    if (pVideo)
    {
	pbox = REGION_RECTS(&pVideo->clipList);
	nbox = REGION_NUM_RECTS(&pVideo->clipList);
	plxRestartVideoWindow (pVideo, pbox, nbox);
	/*
	 * Avoid generating an exposure event.
	 */

	if (val = pVideo->valdata)
	{
	    REGION_UNINIT(pVideo->drawable.pScreen, &val->after.borderExposed);
#if 0
	    (*pVideo->drawable.pScreen->RegionUninit)(&val->after.borderExposed);
	    (*pVideo->drawable.pScreen->RegionEmpty)(&val->after.exposed);
	    (*pVideo->drawable.pScreen->RegionUninit)(&val->after.exposed);
#endif
	    xfree(val);
	    pVideo->valdata = (ValidatePtr)NULL;
	}
    }
}
#endif
