/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: btlib.c,v $
 * Revision 1.1  1995/11/27  22:46:59  dist
 * Initial revision
 *
 * Revision 1.1  1995/10/30  17:27:33  kevin
 * Initial revision
 *
 * Revision 1.1  1995/10/13  21:35:04  kevin
 * Initial revision
 *
 * Revision 1.12  93/09/30  02:40:38  rocky
 * SQUASH
 * 
 * Revision 1.10  92/10/01  16:01:31  rocky
 * new version for SONYRGB
 * (temp version!)
 * 
 * Revision 1.9  91/12/20  15:57:43  dave
 * driver no longer screws up color tables
 * 
 * Revision 1.8  91/11/13  15:25:01  eric
 * steal gamma table for cursor
 * 
 * Revision 1.7  91/10/23  09:55:37  mears
 * new rev
 * 
 * 
 * Revision 1.6  91/10/14  13:42:54  mears
 * put option clts back into driver code
 * 
 * Revision 1.5  91/10/08  16:57:22  mears
 * new ifdef DRIVER's
 * 
 * Revision 1.4  91/10/04  12:44:07  mears
 * ifdef DRIVER
 * 
 * Revision 1.3  91/09/30  16:18:06  mears
 * many changes
 * 
 * Revision 1.2  91/07/26  19:06:42  eric
 * new from bill
 * 
 * Revision 1.1  91/06/12  16:06:27  eric
 * Initial revision
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: btlib.c,v 1.1 1995/11/27 22:46:59 dist Exp $ Parallax Graphics Inc";
#endif

/* BROOKTREE LIBRARY INTERFACE FOR XVIDEO PRODUCT FAMILY */
/* CONTAINED DETAILED ROUTINES WHICH NEED NOT BE ACCESS BY USERS */
/* standard tag definitions:

	00	- pseudo color
	01	- true color w/tables		/ Direct Color /
	10	- video #1 (no tables on 463)
	11	- video #2 (no tables on 463)

standard calls:

plxv_init_bt()
plxv_load_clt(tag,start,count,pntr)
plxv_load_clts(tag,start,count,rptr,gptr,bptr) driver version of above
plxv_load_cursor(ptr);

*/

#include <stdio.h>
#include "xvideo.h"
#include "plxv.h"

#define CURSOR_FG_ADDR 0x1f0
#define CURSOR_BG_ADDR 0x200
plxv_init_bt(bypass)
int bypass;
{
    int a,b,i,j,k,t;
    XV_color init_c[0x100];

    switch(xv_cp->main.clt_type)
    {
      case BT463:
	plxv_init_bt463(bypass);
	break;
      default:
	printf("init_bt: unknown color table type\n");
    }

    switch(xv_cp->opt.clt_type)
    {
      case BT473:
	plxv_init_bt473();
	break;
      default:
	break;
    }

#ifndef DRIVER

    /* load default pseudo color palette*/
    j = 0;
    for (i=0;i<0x8;i++)
    {
	init_c[j].red    = (i & 0x1) * 0xff;
	init_c[j].green  = ((i & 0x2)>>1) * 0xff;
	init_c[j++].blue = ((i & 0x4)>>2) * 0xff;
    }
    for (i=0;i<0x8;i++)
    {
	init_c[j].red    = (i * 0x1f) + 7;
	init_c[j].green  = (i * 0x1f) + 7;
	init_c[j++].blue = (i * 0x1f) + 7;
    }
    for (i=0;i<0x10;i++)
    {
	init_c[j].red    = 0xff - (i * 0x10);
	init_c[j].green  = 0xff - (i * 0x10);
	init_c[j++].blue = 0xff - (i * 0x10);
    }
    for (i=1;i<8;i++)
    {
	for (k = 0;k<0x20;k++)
	{
	    init_c[j].red    = ((i & 0x1) * (k * 8)) + 7;
	    init_c[j].green  = (((i & 0x2)>>1) * (k * 8)) + 7;
	    init_c[j++].blue = (((i & 0x4)>>2) * (k * 8)) + 7;
	}
    }
    plxv_load_clt(0,0,0x100,init_c);


    plxv_load_cursor(init_c);		

#endif /* DRIVER */

    /* true color palette */
    j = 0;
    for (i=0;i<0x100;i++)
    {
	init_c[j].red    =  i;
	init_c[j].green  =  i;
	init_c[j++].blue =  i;
    }
    plxv_load_clt(1,0,0x100,init_c);
    /*load video 1 */
    plxv_load_clt(2,0,0x100,init_c);
    /*load video 2 */
    plxv_load_clt(3,0,0x100,init_c);

}
    
plxv_load_clt(tag,start,num,cptr)
int tag,start,num;
XV_color *cptr;
{
    int i,j,k;
    XV_color *ptr;

    if (tag > 3)
    {
	printf("tag value too large for color space\n");
	return(-1);
    }
    if (start > 0xff)
    {
	printf("color table start address exceeded\n");
	return(-1);
    }
    if ( (start + num) > 0x100)
    {
	printf("color table load size too big\n");
	return(-1);
    }

    ptr = cptr;
    switch(xv_cp->main.clt_type)
    {
      case BT463:
	if (tag > 1) break;	/* do nothing for video palettes on 463 */
	set_bt463_addr((0x100 * tag) + start);
	for (i=0; i<num; i++)
	{
	    j = ptr->red;
	    XV_WREG(Bt.red.reg3,j);
	    j = ptr->green;
	    XV_WREG(Bt.red.reg3,j);
	    j = ptr->blue;
	    XV_WREG(Bt.red.reg3,j);
	    ptr++;
	}
	break;
      default:
        printf("load_clt: unknown color table type\n");
        return(-1);
    }
    ptr = cptr;

    /* now make the video output card's color tables match */
    switch(xv_cp->opt.clt_type)
    {
      case BT473:
	if ( tag > 0) break;		/* only pseudo-color palette avail */
        set_option_rsaddr(3,0);		/* setup to load start address */
        XV_WREG(Ext.reg1,start);
	set_option_rsaddr(3,1);		/* setup to load palette data */
	for (i=0; i<num; i++)
	{ /* address will auto-increment and use modulo 3 shit */
	    j = ptr->red;
	    XV_WREG(Ext.reg1,j);
	    j = ptr->green;
	    XV_WREG(Ext.reg1,j);
	    j = ptr++->blue;
	    XV_WREG(Ext.reg1,j);
	}
	break;
      default:
	break;
    }

    return(0);
}

#ifdef DRIVER
plxv_load_clts(tag, start, num, rptr0, gptr0, bptr0)
int tag,start,num;
char *rptr0, *gptr0, *bptr0;
{
    int i,j,k;
    char *rptr, *gptr, *bptr;

    if (tag > 3)
    {
	printf("tag value too large for color space\n");
	return(-1);
    }
    if (start > 0xff)
    {
	printf("color table start address exceeded\n");
	return(-1);
    }
    if ( (start + num) > 0x100)
    {
	printf("color table load size too big\n");
	return(-1);
    }

    rptr = rptr0;  gptr = gptr0;  bptr = bptr0;  
    switch(xv_cp->main.clt_type)
    {
      case BT463:
        if (tag > 1) return(0); /* do nothing for video palettes on 463 */
        set_bt463_addr((0x100 * tag) + start);
        for (i=0; i<num; i++)
        {
            j = *rptr++;
            XV_WREG(Bt.red.reg3,j);
            j = *gptr++;
            XV_WREG(Bt.red.reg3,j);
            j = *bptr++;
            XV_WREG(Bt.red.reg3,j);
        }
        break;
      default:
        printf("load_clt: unknown color table type\n");
        return(-1);
    }

    /* now make the video output card's color tables match */
    rptr = rptr0;  gptr = gptr0;  bptr = bptr0;  
    switch(xv_cp->opt.clt_type)
    {
      case BT473:
	if ( tag > 0) break;		/* only pseudo-color palette avail */
        set_option_rsaddr(3,0);		/* setup to load start address */
        XV_WREG(Ext.reg1,start);
	set_option_rsaddr(3,1);		/* setup to load palette data */
	for (i=0; i<num; i++)
	{ /* address will auto-increment and use modulo 3 shit */
	    j = *rptr++;
	    XV_WREG(Ext.reg1,j);
	    j = *gptr++;
	    XV_WREG(Ext.reg1,j);
	    j = *bptr++;
	    XV_WREG(Ext.reg1,j);
	}
	break;
      default:
	break;
    }
    return(0);
}

/* this is used by the driver */
plxv_read_clts(tag, start, num, rptr, gptr, bptr)
int tag,start,num;
char *rptr, *gptr, *bptr;
{
    int i,j,k;

    if (tag > 3)
    {
	printf("tag value too large for color space\n");
	return(-1);
    }
    if (start > 0xff)
    {
	printf("color table start address exceeded\n");
	return(-1);
    }
    if ( (start + num) > 0x100)
    {
	printf("color table load size too big\n");
	return(-1);
    }

    switch(xv_cp->main.clt_type)
    {
      case BT463:
        if (tag > 1) return(0); /* do nothing for video palettes on 463 */
        set_bt463_addr((0x100 * tag) + start);
        for (i=0; i<num; i++)
        {
            XV_RREG(j, Bt.red.reg3);
            *rptr++ = j & 0xff;
            XV_RREG(j, Bt.red.reg3);
            *gptr++ = j & 0xff;
            XV_RREG(j, Bt.red.reg3);
            *bptr++ = j & 0xff;
        }
        break;
      default:
        printf("load_clt: unknown color table type\n");
        return(-1);
    }
}
 
#endif /*DRIVER*/


plxv_load_cursor(ptr0)
XV_color *ptr0;
{
    int i,j,k;
    XV_color *ptr;

    ptr = ptr0;
    switch(xv_cp->main.clt_type)
    {
      case BT463:
#if 0
	set_bt463_addr(CURSOR_FG_ADDR);
	XV_WREG(Bt.red.reg3,ptr->red);
	XV_WREG(Bt.red.reg3,ptr->green);
	XV_WREG(Bt.red.reg3,ptr->blue);
	ptr++;
	set_bt463_addr(CURSOR_BG_ADDR);
	XV_WREG(Bt.red.reg3,ptr->red);
	XV_WREG(Bt.red.reg3,ptr->green);
	XV_WREG(Bt.red.reg3,ptr->blue);
	break;
#else
        for(i=0; i<2; i++)
        {
            set_bt463_addr(0x100 + (0x10 * i));
            j = ptr->red;
            XV_WREG(Bt.red.reg3,j);
            j = ptr->green;
            XV_WREG(Bt.red.reg3,j);
            j = ptr->blue;
            XV_WREG(Bt.red.reg3,j);
            j = ptr->red;
            XV_WREG(Bt.red.reg3,j);
            j = ptr->green;
            XV_WREG(Bt.red.reg3,j);
            j = ptr->blue;
            XV_WREG(Bt.red.reg3,j);
            ptr++;
        }
	break;
#endif
      default:
	break;
    }
    ptr = ptr0;

    switch(xv_cp->opt.clt_type)
    {
      case BT473:
	/* background color at address 1 overlay palette */
	set_option_rsaddr(3,4);  /* setup to load start address */
	XV_WREG(Ext.reg1,1);	 /* start address is 1	 	*/
	set_option_rsaddr(3,5);  /* setup to load palette data */

	/* address will auto-increment and use modulo 3 stuff */
	j = ptr->red;
	XV_WREG(Ext.reg1,j);
	j = ptr->green;
	XV_WREG(Ext.reg1,j);
	j = ptr++->blue;
	XV_WREG(Ext.reg1,j);

	/* foreground color at address 3 overlay palette */
	set_option_rsaddr(3,4);  /* setup to load start address */
	XV_WREG(Ext.reg1,2);	 /* start address is 2		*/
	set_option_rsaddr(3,5);  /* setup to load palette data */

	/* address will auto-increment and use modulo 3 stuff */
	j = ptr->red;
	XV_WREG(Ext.reg1,j);
	j = ptr->green;
	XV_WREG(Ext.reg1,j);
	j = ptr++->blue;
	XV_WREG(Ext.reg1,j);
      default:
	break;
    }
    return(0);
}

plxv_disp_blank(sel)
int sel;
{
    int a,b;
    switch(xv_cp->main.ga_rev)
    {
      case GAREV_2:
	if (sel) a = 1; else a = 0;
	XV_WREG(DispKludge.b.disp_blank,a);
	break;
      default:
	printf("DISPBLNK: don't know what Gate array rev\n");
	break;
    }
    switch(xv_cp->opt.clt_type)
    {
      case BT473:
	break;
      default:
	break;
    }
}

 
plxv_init_bt463(bypass)
int bypass;
{
    int i,t;

    /* load the BT463 command registers 0,1,&2 BANG BANG BANG */
    switch(xv_cp->main.board_code)
    {
	case TCHAN_1:
	    set_bt463_addr(0x201);
	    XV_WREG(Bt.red.reg2, 0xC0);	/* 2:1 mux , blink xx */
	    XV_WREG(Bt.red.reg2, 0x40);	/* overlay common, 24 planes, 4 over */
					/* 16 tables, no under, no cursor */
	    XV_WREG(Bt.red.reg2, 0xc0);	/* sync on green, + pedistal */
	    break;
	case SBUS_1:
	case SBUS_2:
	case SBUS_3:
	case SBUS_4: /* squash */
	case SBUS_5:
	    set_bt463_addr(0x201);
	    XV_WREG(Bt.red.reg2, 0x40);	/* 4:1 mux , blink xx */
	    XV_WREG(Bt.red.reg2, 0x40);	/* overlay common, 24 planes, 4 over */
					/* 16 tables, no under, no cursor */
	    XV_WREG(Bt.red.reg2, 0x40);	/* no sync ,pedistal */
	    break;
	default:
	    printf("plxv_init_bt463: unkown board type\n");
    }
    /* load read mask register = all planes */
    set_bt463_addr(0x205);
    XV_WREG(Bt.red.reg2, 0xff);
    XV_WREG(Bt.red.reg2, 0xff);
    XV_WREG(Bt.red.reg2, 0xff);
    XV_WREG(Bt.red.reg2, 0xff);

   /* no blinking mask */
    XV_WREG(Bt.red.reg2, 0);
    XV_WREG(Bt.red.reg2, 0);
    XV_WREG(Bt.red.reg2, 0);
    XV_WREG(Bt.red.reg2, 0);

    /* NOTE: the BT463 must be in BLANK to load the window table */
    /* so we will turn off the display via vreset !!!! */
    /* check GA REV HERE */
    switch(xv_cp->main.ga_rev)
    {
	case GAREV_2:
	    XV_WREG(DispKludge.b.disp_blank,1);
	    break;
	default:
	    printf("463init: don't know what rev GAs in use\n");
    }

    /* now load the window table */
    switch(bypass)
    {
	case 0:			/* normal window tag tables */
	    set_normal_463();
	    break;
	case 1:			/* bypass mode  =  24 bit true only */
    	    for (i=0;i<0x10;i++) set_bt463_wtab(i,0,8,0,0,0,0,1);
	    break;
	case 2:			/* 8 bit only from tags */
	    break;
	case 3:	 /* showtags for em28 mode */
	    for (i=0;i<0x10;i++) set_bt463_wtab(i,24,4,1,0,0,0,0);
	    break;
	case 4:		/* 8 over 24 */
	    set_8_over_24_463();
	   break;
	case 5:		/* 6 over 24 */
	    break;	
	case 6:			
	    set_normal_463();
	    break;
	default:
	    break;
    }
    /* now turn back on the display */
    switch(xv_cp->main.ga_rev)
    {
        case GAREV_2:
	    XV_WREG(DispKludge.b.disp_blank,0);
            break;
        default:
	    break;
    }

}

set_bt463_wtab(tnum,shft,planes,mode,ovlyloc,ovlymsk,strtad,bypass)
int tnum,shft,planes,mode,ovlyloc,ovlymsk,strtad,bypass;
{
    int i,val;

    if (tnum > 0xf) printf("error: table number out of range\n");
    val  =  (shft    & 0x1f)       | ((planes  & 0xf)  << 5);
    val |= ((mode    & 0x7) << 9)  | ((ovlyloc & 0x1)  << 12);
    val |= ((ovlymsk & 0xf) << 13) | (((strtad >> 4)  & 0x3f) << 17);
    val |= ((bypass & 0x1) << 23) ;

    set_bt463_addr(0x300 | (tnum & 0xf));

    XV_WREG(Bt.red.reg2, val & 0xff);
    XV_WREG(Bt.red.reg2, (val >> 8)  & 0xff);
    XV_WREG(Bt.red.reg2, (val >> 16) & 0xff);
}

set_bt463_addr(addr)
int addr;
{
    int a,b;
	
    a = (addr >> 8) & 0xff;
    b = addr & 0xff;
    XV_WREG(Bt.red.reg0, b);	/* load low order Bt463 address register */
    XV_WREG(Bt.red.reg1, a);	/* load high order Bt463 address register */
}

/* abw mode differs from normal mode in the locations of the cursor LUT
 * locations, and the ability to select the style of each window type
set_bt463_wtab(tnum,shft,planes,mode,ovlyloc,ovlymsk,strtad,bypass)
 */
set_wt_type(wt,type)
{
	switch(type) {
	case 0:
		/* pseudo color with pixel in red green and blue planes */
		set_bt463_wtab(wt,0,8,0,0,0,0 ,0);
		break;
	case 1:
		/* bypass color */
		set_bt463_wtab(wt,0,8,0,0,0,0 ,1);
		break;
	case 2:
		/* true color with lookup */
		set_bt463_wtab(wt,0,8,0,0,0,0x100 ,0);
		break;
	case 3:

		/* pseudo color all in red planes */
		set_bt463_wtab(wt,0,8,1,0,0,0 ,0);
		break;
	}
}

set_normal_463()
{
	XV_WREG(DispKludge.b.disp_blank,1); /* turn on blanking */
	set_wt_type(0,0); /* set window id 0 to Pseudo color */
	set_wt_type(4,0); /* set window id 4 to Pseudo color */
	set_wt_type(1,2); /* set window id 1 to Direct color */
	set_wt_type(5,2); /* set window id 5 to Direct color */
	set_wt_type(2,1); /* set window id 2 to true color */
	set_wt_type(6,1); /* set window id 6 to true color */
	set_wt_type(3,1); /* set window id 3 to bypass color */
	set_wt_type(7,1); /* set window id 7 to bypass color */
				
        set_bt463_wtab(8,27,1,0,0,0,CURSOR_BG_ADDR,0);	/* cursor background */
        set_bt463_wtab(9,27,1,0,0,0,CURSOR_BG_ADDR,0);	/* cursor background */
        set_bt463_wtab(10,27,1,0,0,0,CURSOR_BG_ADDR,0);	/* cursor background */
        set_bt463_wtab(11,27,1,0,0,0,CURSOR_BG_ADDR,0);	/* cursor background */

        set_bt463_wtab(12,27,1,0,0,0,CURSOR_FG_ADDR,0);	/* cursor foreground */
        set_bt463_wtab(13,27,1,0,0,0,CURSOR_FG_ADDR,0);	/* cursor foreground */
        set_bt463_wtab(14,27,1,0,0,0,CURSOR_FG_ADDR,0);	/* cursor foreground */
        set_bt463_wtab(15,27,1,0,0,0,CURSOR_FG_ADDR,0);	/* cursor foreground */
	XV_WREG(DispKludge.b.disp_blank,0); /* turn off blanking */
}

plxv_load_ash_cursor(r0,g0,b0,r1,g1,b1)
unsigned int r0,g0,b0,r1,g1,b1;
{
    int i,j,k;   
        
    switch(xv_cp->main.clt_type)
    {
      case BT463:                       	/* background */
            set_bt463_addr(CURSOR_BG_ADDR);
            for(i=0;i<16;i++){
              XV_WREG(Bt.red.reg3,r0&0xff);
              XV_WREG(Bt.red.reg3,g0&0xff);
              XV_WREG(Bt.red.reg3,b0&0xff);
            }
            set_bt463_addr(CURSOR_FG_ADDR);      /* foreground */
            for(i=0;i<16;i++){
              XV_WREG(Bt.red.reg3,r1&0xff);
              XV_WREG(Bt.red.reg3,g1&0xff);
              XV_WREG(Bt.red.reg3,b1&0xff);
 	    }
        break;
      default:
        break;
    }
         
    switch(xv_cp->opt.clt_type)
    {
      case BT473:
        /* background color at address 1 overlay palette */
        set_option_rsaddr(3,4);  /* setup to load start address */
        XV_WREG(Ext.reg1,1);     /* start address is 1          */
        set_option_rsaddr(3,5);  /* setup to load palette data */
     
        /* address will auto-increment and use modulo 3 stuff */
        XV_WREG(Ext.reg1,r0);
        XV_WREG(Ext.reg1,g0);
        XV_WREG(Ext.reg1,b0);
 
        /* foreground color at address 3 overlay palette */
        set_option_rsaddr(3,4);  /* setup to load start address */
        XV_WREG(Ext.reg1,2);     /* start address is 2          */
        set_option_rsaddr(3,5);  /* setup to load palette data */
 
        /* address will auto-increment and use modulo 3 stuff */
        XV_WREG(Ext.reg1,r1);
        XV_WREG(Ext.reg1,g1);
        XV_WREG(Ext.reg1,b1);
      default:
        break;
    }
    return(0);
}


set_8_over_24_463()
{
    int t = 0;

     /*enable 8 over 24 in the command register */
    /* load the BT463 command registers 0,1,&2 BANG BANG BANG */
    switch(xv_cp->main.board_code)
    {
	case TCHAN_1:
	    set_bt463_addr(0x201);
	    XV_WREG(Bt.red.reg2, 0xC0);	/* 2:1 mux , blink xx */
	    XV_WREG(Bt.red.reg2, 0x10);	/* overlay common, 24 planes, 4 over */
					/* 16 tables, no under, no cursor */
	    XV_WREG(Bt.red.reg2, 0xc0);	/* sync on green, + pedistal */
	    break;
	case SBUS_1:
	case SBUS_2:
	case SBUS_3:
	case SBUS_4: /* squash */
	case SBUS_5:
	    set_bt463_addr(0x201);
	    XV_WREG(Bt.red.reg2, 0x40);	/* 4:1 mux , blink xx */
	    XV_WREG(Bt.red.reg2, 0x10);	/* overlay common, 24 planes, 4 over */
					/* 16 tables, no under, no cursor */
	    XV_WREG(Bt.red.reg2, 0x40);	/* no sync ,pedistal */
	    break;
	default:
	    printf("plxv_init_bt463: unkown board type\n");
    }
    for (t=0;t<0x10;t++)
    {   /* for 8 over 24, set all window tables to
	   no shift,8 planes, true color, all overlay enab, std overlay,
	   start address = 0x100 					*/
        set_bt463_wtab(t,0,8,0,0,0xf,0x100,0);
    }
}


/* the bt473 is used on the option card for output of pseudo colors
   to the low-res video output.
*/
plxv_init_bt473()
{
    /* set command register */
    set_option_rsaddr(3,6);
    XV_WREG(Ext.reg1,0x30);

    /* set read mask */
    set_option_rsaddr(3,2);
    XV_WREG(Ext.reg1,0xff);
}


set_option_rsaddr(device_code,rsaddr)
int rsaddr;
{
    int i,j,k;

    i = (device_code & 3) << 3;
    j = rsaddr & 7;
    k = i | j;
    XV_WREG(Ext.reg0,k);
}

#ifndef DRIVER

/****************************  bt473 stuff ********************/
/* useful bt473 information.
s1 = 0
attr 1/0	SO  OL1  OL0		CALLED
  0  0		0    0    0		pseduocolor mode
  0  1		1    0    0		true color mode
  1  0		x    0    1		cursor background
  1  1		x    1    1		cursor forgroundo
*/



load_bt473_palette(start,num,ptr,overlay_flag)
int start,num;
XV_color *ptr;
{
    /* if overlay_flag == 1 then the overlay palette
	will be addressed instead of the data palette */

    int i=0,j;

    if (overlay_flag) 
	i = 4;
    set_option_rsaddr(3,i | 0);  /* setup to load start address */
    XV_WREG(Ext.reg1,start);
    set_option_rsaddr(3,i | 1);  /* setup to load palette data */
    for (i=0; i<num; i++)
    {
	/* address will auto-increment and use modulo 3 shit */
	j = ptr->red;
	XV_WREG(Ext.reg1,j);
	j = ptr->green;
	XV_WREG(Ext.reg1,j);
	j = ptr++->blue;
	XV_WREG(Ext.reg1,j);
    }
}

read_bt473_palette(start,num,ptr,overlay_flag)
int start,num;
XV_color *ptr;
{
    /* if overlay_flag == 1 then the overlay palette
	will be addressed instead of the data palette */

    int i=0,j;

    if (overlay_flag) 
	i = 4;
    set_option_rsaddr(3,i | 3);  /* setup to load start address */
    XV_WREG(Ext.reg1,start);
    set_option_rsaddr(3,i | 1);  /* setup to load palette data */
    for (i=0; i<num; i++)
    {
	/* address will auto-increment and use modulo 3 shit */
	XV_RREG(j,Ext.reg1);
	ptr->red = j & 0xff;
	XV_RREG(j,Ext.reg1);
	ptr->green = j & 0xff;
	XV_RREG(j,Ext.reg1);
	ptr++->blue = j & 0xff;
    }
}

/******   End of support for BT473			   *****/

/******   Brooktree support routines for the RGB input card *****/
/******   Here (in this file) because brooktree makes them !*****/

/* the bt261 is a sync lock generator whith PLL pump output */

plxv_init_bt261(port,sel_625)
int port,sel_625;
{
    int i,hcount,hactive,zero_stop;
    unsigned char *cp;
    XV_io_port *iop,*plxv_io_port();
    XV_bt261_config *btp;

    if (( iop = plxv_io_port(port)) == (XV_io_port *)0)
    {
	return(-1);
    }
    btp = &(iop->config.rgbin.timing);

    cp = &(iop->config.rgbin.timing.command[0]);
    for (i=0;i<4;i++) plxv_load_bt261(i,*cp++);

    /* get the parametric data parameters */
    sel_625 &= 0x1;
    hcount = iop->config.rgbin.format[sel_625].hcount;
    hactive = iop->config.rgbin.format[sel_625].hactive;
    zero_stop = iop->config.rgbin.format[sel_625].zero_stop;

    plxv_load_bt261_short(0x5,hcount/4);	/* osc count */
    plxv_load_bt261_short(0x18,hcount/2 - btp->ngate_start);
    plxv_load_bt261_short(0x1a,hcount/2 + btp->ngate_stop);	
/*
    plxv_load_bt261_short(0x18,hcount/2 - scale_param(hcount,btp->ngate_start));
    plxv_load_bt261_short(0x1a,hcount/2 + scale_param(hcount,btp->ngate_stop));	
*/
    plxv_load_bt261_short(0x1c,hcount - 1);	/* hcount */
    plxv_load_bt261(4,hcount/4);		/* vsync sample register */
    plxv_load_bt261_short(0x8,scale_param(hcount,btp->hsync_start));
    plxv_load_bt261_short(0xa,0); 		/* hsync stop */
    plxv_load_bt261_short(0xc,scale_param(hcount,btp->clamp_start));
    plxv_load_bt261_short(0xe,scale_param(hcount,btp->clamp_stop));

    plxv_load_bt261_short(0x12,zero_stop);           /* zero stop */
    plxv_load_bt261_short(0x10,zero_stop + hactive); /* zero start */

    plxv_load_bt261_short(0x14,scale_param(hcount,btp->fgate_start));
    plxv_load_bt261_short(0x16,scale_param(hcount,btp->fgate_stop));
}

static int scale_param(hc,v)
int hc,v;
{
    return(v*hc/780);
}


plxv_load_bt261(addr,data)
int addr,data;
{
    set_option_rsaddr(1,0);		/* select bt261 internal address reg */
    XV_WREG(Ext.reg1,addr);
    set_option_rsaddr(1,1);		/* select bt261 data */
    XV_WREG(Ext.reg1,data);
}

plxv_read_bt261(addr,data)
int addr,*data;
{
    set_option_rsaddr(1,0);		/* select bt261 internal address reg */
    XV_WREG(Ext.reg1,addr);
    set_option_rsaddr(1,1);		/* select bt261 data */
    XV_RREG(*data,Ext.reg1);
}


plxv_load_bt261_short(addr,data)
int addr,data;
{
    plxv_load_bt261(addr,data & 0xff);		
    plxv_load_bt261(addr + 1,(data >> 8) & 0xff);	
}

    
/************************************************/
/* the bt253 is ADC's *c plus calibrating DAC's */
plxv_init_bt253(port,sel_yuv)
int port;
{
    unsigned char *cp;
    int i;
    XV_io_port *iop;

    if (( iop = plxv_io_port(port)) == 0)
    {
	return(-1);
    }


    /* bt253 setup for RGB separate sync */    
    plxv_load_bt253(0,0x60);		/* command register */

    sel_yuv &= 0x1;
    cp = &(iop->config.rgbin.cal[sel_yuv].val[0]);
    for (i=0;i<6;i++) plxv_load_bt253(i+1,*cp++);
}


plxv_load_bt253(reg_num,data)
int reg_num,data;
{
    /*
        reg_num 0 --> command register 
		1 --> red white leve 2 --> clamp level offset
		3 --> green white leve 4 --> clamp level offset
		5 --> blue white leve 6 --> blue clamp level
    */
    set_option_rsaddr(0,reg_num);
    XV_WREG(Ext.reg1,data);
}

plxv_read_bt253(reg_num,data)
int reg_num,*data;
{
    set_option_rsaddr(0,reg_num);
    XV_RREG(*data,Ext.reg1);
}

/*************** end of bt253 support ********************/

/* ****** suppport for the bt281  ************************/
/* the bt281 is a color space converter, as well as a set */
/* of color lookup tabes individual for R, G, & b         */
/* Color space converter performs normalized operations	  */
/* The color tables are used to set offset and gain       */
/**********************************************************/

/* routine to load the bt281 color tables (3 x 0x100) */
/* mask: 1 = red, 2 = green,4 = blue, 7 = all	      */
plxv_load_bt281_clt(clt,mask)
int *clt,mask;

{

    int *ip;
    int i,j,k;

    ip = clt;
    for (i=0;i,i<0x100;i++)
    {
	if (mask & 1) plxv_load_bt281(0x000 + i, *ip);
	if (mask & 2) plxv_load_bt281(0x100 + i, *ip);
	if (mask & 4) plxv_load_bt281(0x200 + i, *ip);
	ip++;
    } 
}


/* routine to read back the CLT ram in the bt281 (for testing) */
/* bank: 0 = red, 1 = green, 2 = blue */
plxv_read_bt281_clt(bank,clt)
int *clt,bank;
{
    int i;

    for (i=0;i<0x100;i++)
    {
	    plxv_read_bt281_reg(i | (bank << 8),clt++);
    }
}

/* routine to load the Color Space Converter Matrix */
/* part of the 281				    */
/* RGB uses the Identity matry			    */
/* YUV uses a normalized matrix			    */

plxv_load_bt281_csc(matrix)
float *matrix;
{
    int i;
/*    dprintf("plxv_load_bt281_csc: matrix addr = %x\n",matrix); */
    for (i=0;i<9;i++) plxv_load_bt281_matrix_element(i,*matrix++);
}

plxv_load_bt281_matrix_element(reg_num,mat_val)
int reg_num;
float mat_val;
{
    int reg_val;
    int mat_addr;
    int val_low,val_high;
    float divisor;

    divisor = (3.996 - 0.0) / (0x3ff);
    /* first convert the floating point mat_val into a register pair value */
    if (mat_val > -divisor)
    reg_val = (int)(mat_val / divisor);
    else
    {
	reg_val = (int)((mat_val + 4.000) / divisor); 
	reg_val |= 0x400;	/* set the sign bit */
    }
    /* now load the appropriate register pair with reg_val */
    mat_addr = 0x300 + reg_num  * 2;
    val_low = reg_val & 0xff;
    val_high = (reg_val >> 8) & 0xff;

    plxv_load_bt281(mat_addr,0xff & reg_val);
    plxv_load_bt281(mat_addr + 1,0x7 & (reg_val >> 8));
}

plxv_read_bt281_reg(addr,data)
int addr,*data;
{
    set_bt281_addr(addr);
    set_option_rsaddr(2,2);
    XV_RREG(*data,Ext.reg1);
}

plxv_load_bt281(addr,data)
int addr,data;
{
    set_bt281_addr(addr);
    set_option_rsaddr(2,2);
    XV_WREG(Ext.reg1,data);
}

set_bt281_addr(addr)
int addr;
{
    int a,b;

    a = 0xff & addr;
    b = 0xff & (addr >> 8);
    set_option_rsaddr(2,0);
    XV_WREG(Ext.reg1,a);
    set_option_rsaddr(2,1);
    XV_WREG(Ext.reg1,b);
}

/* end bt281 support routines */

plxv_init_bt281(sel_yuv)
int sel_yuv;
{
/*    dprintf("plxv_init_bt281: sel_yuv = %d\n",sel_yuv); */
    if (sel_yuv)
    {
	/* setup to use csc */
    	plxv_load_bt281(0x312,0x20);		/* command register 0 */
    	plxv_load_bt281(0x313,0);		/* command register 1 */
    }
    else
    {
	/* setup for rgb. for bypass load 0x313 with 0xe0 */
    	plxv_load_bt281(0x312,0);		/* command register 0 */
    	plxv_load_bt281(0x313,0);		/* command register 1 */
    }
}
#endif /*NOT DRIVER*/
load_clt(addr,r,g,b) {
    set_bt463_addr(addr);
    XV_WREG(Bt.red.reg3,r);
    XV_WREG(Bt.red.reg3,g);
    XV_WREG(Bt.red.reg3,b);
}
