/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: drawlib.c,v $
 * Revision 1.1  1995/11/27  22:46:59  dist
 * Initial revision
 *
 * Revision 1.1  1995/10/30  17:27:33  kevin
 * Initial revision
 *
 * Revision 1.1  1995/10/13  21:35:04  kevin
 * Initial revision
 *
 * Revision 1.1  1995/03/30  19:42:32  kevin
 * Initial revision
 *
 * Revision 1.14  93/09/30  02:44:05  rocky
 * SQUASH, expansion chassis slowdown option
 * 
 * Revision 1.12  92/08/18  16:18:16  eric
 * forget the nhorz stuff
 * add a new plxv_vector_done
 * 
 * Revision 1.11  92/08/18  15:51:59  eric
 * set nhorz for horizontal vectors
 * 
 * Revision 1.10  92/04/13  13:45:58  eric
 * enable read-modify-write when wmask of tag planes is non-zero
 * 
 * Revision 1.9  91/12/19  10:51:53  dave
 * dec changes
 * 
 * Revision 1.8  91/11/26  18:24:21  eric
 * fixed sbus narrow box bug
 * 
 * Revision 1.7  91/11/12  14:22:33  dave
 * changes for dec
 * 
 * Revision 1.6  91/10/25  16:45:24  mears
 * just use wbflush, and changed mips wf_done
 * 
 * Revision 1.5  91/10/23  09:55:54  mears
 * new rev
 * 
 * 
 * Revision 1.4  91/10/04  12:45:21  mears
 * ifdef DRIVER
 * 
 * Revision 1.3  91/09/30  16:29:02  mears
 * removed blit from driver
 * 
 * Revision 1.2  91/07/26  19:06:48  eric
 * new from bill
 * 
 * Revision 1.1  91/06/12  16:06:29  eric
 * Initial revision
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: drawlib.c,v 1.1 1995/11/27 22:46:59 dist Exp $ Parallax Graphics Inc";
#endif


#include <stdio.h>
#include "xvideo.h"
#include "plxv.h"

#define NARROW_BOX_BUG	/* certain boxes narrower than the interleave factor are incorrectly drawn */

static int plxv_accel_color,rop_num,stencil_mask;
static int plxv_wmask_val;

int is_28_now = 0;


plxv_28_now(sel)
int sel;
{

    if (sel) sel = 1;
    is_28_now = sel;
    XV_WREG(RopCtl.b.em28,sel);
#ifdef mips
wbflush();
#endif
}

plxv_init_draw()
{
    /* disable video blue hardware here for now */
    XV_WREG(KeyColCtl.l,0);
    XV_WREG(RopCtl.l,0);

    /* misc things to do go here for now */
    plxv_map_ctl(0,0x1f,0);
    plxv_vector_window(0,0);

}



/******************************   24 bit stuff   ***********************/
/* setup basic 24 bit mode */
plxv_mode_24()
{
    plxv_wf_done();
    plxv_tag(PLXV_TAG_PIXEL_ATTR,PLXV_TAG_TRUE_COLOR);	
    plxv_wmask(PLXV_WMASK_PIXEL_ALL);
    plxv_stencil(0,0);		/* draw all pixels */
    plxv_rop(PLXV_ROP_COPY);
    plxv_transp_off();
#ifdef mips
wbflush();
#endif
}

plxv_color_24(val)
int val;
{
    int i;
    plxv_wf_done();
    if (is_28_now)
    {
	i = (val & 0xf000000) << 4;
	val = (val & 0xfffffff) | i;
    }
    plxv_accel_color = val;
    XV_WREG(SolidCol.l, val);
}

/*******************************   8 bit stuff   *********************/
/* setup basic 8 bit modes */
plxv_mode_8()
{
    plxv_wf_done();
    plxv_tag(PLXV_TAG_PIXEL_ATTR,PLXV_TAG_PSEUDO_COLOR);	
    plxv_wmask(PLXV_WMASK_PIXEL_ALL);
    plxv_stencil(0,0);		/* draw all pixels */
    plxv_rop(PLXV_ROP_COPY);
    plxv_transp_off();
    plxv_map_ctl(0,0x1f,0);
    plxv_read8(0);
#ifdef mips
wbflush();
#endif
}


/* set color value for accel operations with an 8 bit value */
plxv_color_8(i)
int i;
{
    int k,j = 0;
    plxv_wf_done();
    if ( is_28_now)
    {
	j = (i & 0xf) | ((i & 0xf) << 4) ;
	j = (j<<24);
    } 
    k = (i) | (i<<8) | (i<<16) | j;
    plxv_accel_color =k;
    XV_WREG(SolidCol.l, k);
}

/* select which byte to read from when accessing 8 bit map */
plxv_read8(select)
int select;
{
    /* select=0 means readback red, 1=green, 2= blue and 3=tag  */
    plxv_wf_done();
#if GA_REV==GAREV_1
    XV_WREG(TagCtl.b.m8rb, select);
#else
    XV_WREG(MMode.b.m8rb,(select & 0x3));
#endif
#ifdef mips
wbflush();
#endif
}

/*************************  one bit stuff   *********************/
plxv_mode_1()
{
     plxv_tag(3,1);
     plxv_rop(5);
     plxv_stencil(0,0);
#ifdef mips
wbflush();
#endif
}

/* set colors to use for access to 1 bit map.  when reading one
   bit map if (pixel & readbacl_mask == fgcolor.... bit = 1) */
plxv_colors_1(fgcolor,bgcolor,readback_mask)
int fgcolor,bgcolor,readback_mask;
{
    plxv_wf_done();
    /* if (pixel & readback_mask == fgcolor) then readback 1 */
    XV_WREG(M1ForCol.l,fgcolor);
    XV_WREG(M1BakCol.l,bgcolor);
    XV_WREG(M1RdMask.l,readback_mask);
#ifdef mips
wbflush();
#endif
}

#ifndef DRIVER
/* set transparent mode for 1 bit operations.  forground color must have
  bit-24 a 1 to write, bg color must have bit-24 a 0 to not write when
  this mode is active.  (1's write fgcolor, 0's don't write at all    */
plxv_transp_on()
{
    plxv_wf_done();
    XV_WREG(MMode.b.trans, 1);
#ifdef mips
wbflush();
#endif
}
#endif

/* disable 1 bit transparent mode .... must do this if not in 1 bit map */
plxv_transp_off()
{
    plxv_wf_done();
    XV_WREG(MMode.b.trans,0);
#ifdef mips
wbflush();
#endif
}

/* set special contrl register for 1 bit access.  */
/* offset is a number 0-31 which determines the number of pixels
       to index into the longword of the 1 bit map. length determines the number
       of pixels the drawing (or reading) operation will do */

plxv_ctl_1(offset,length)
int offset,length;
{
    plxv_map_ctl(0,length - 1,offset);
}

/* a new routine to support the offsetting map hardware in all access modes */
plxv_map_ctl(start,end,offset)
int offset,start,end;
{
    plxv_wf_done();
    XV_WREG(MStart.l,start);
    XV_WREG(MEnd.l,end);
    XV_WREG(MOffset.l,offset);
#ifdef mips
wbflush();
#endif
}

/******************************  drawing control ****************/
/* WAIT FOR DONE:  can't use access maps while accelertor busy  */
/* this routine waits for the accellerator to be done, and the fifo's empty */
/* must use this before any mode control changes, and after accell operations */

plxv_wf_done()
{
    int i;
    int before;
#ifdef mips
wbflush();
    do
    {
	i = (volatile int) xv_rreg->DBusy.l;
    } while(i);
#else
    i = 1;
    while (i)
    {
	i = xv_rreg->DBusy.l;	/* XV_RREG(i,DBusy.l); */
    }
#endif
}
#define SHDW(src) (fprintf(stderr,"(src)= %x\n",xv_shdw->b.src));

/* Sets the ROP type for all MAP access and accell operations */
/* normally set to COPY....   See plxv.h for all ROP modes    */
plxv_rop(rop)
int rop;
{
    int sten_mask;

    plxv_wf_done();
    /* the parameter rop must repeat the selected operation over all
 	7 nybbles. eg. 0x5050505 for default setting */
    if(rop !=5)
	{
	  plxv_wf_done();
	}
    XV_WREG4(DrawRop.l,rop);
    
    rop_num = rop;
    if ((rop_num != PLXV_ROP_COPY) || 
    ((stencil_mask !=0) && ((plxv_wmask_val & 0xff000000) != 0))   )
    {
	XV_WREG(RopCtl.b.rmw, 1);
	XV_WREG(RopCtl.b.atag, 0);
    }
    else if (stencil_mask !=0) 
    {
    /*
	XV_WREG(RopCtl.b.rmw, 0);
	XV_WREG(RopCtl.b.atag, 1);
    */
	XV_WREG(RopCtl.b.rmw, 1);
	XV_WREG(RopCtl.b.atag, 0);
    } 
    else
    {
	XV_WREG(RopCtl.b.rmw, 0);
	XV_WREG(RopCtl.b.atag, 0);
    } 
#ifdef mips
wbflush();
#endif
}

/* sets the write mask for all 28 bitplanes 1 bits enable writes to that bit,
   0 bits disable writes.  This overrides all tag & stensil modes.  NOTE:
   video cycles can't ever write to the TAG planes (bits 24-27)		    */
plxv_wmask(val)
int val;
{
    int i;
    /* kludge code for now */
    if (is_28_now)
    {
	i = (val & 0xf000000) << 4;;
	val |= i;
    }
    /* set write mask val */
    plxv_wmask_val = val;
    plxv_wf_done();
    XV_WREG(DrawMask.l,val);

    if ((rop_num != PLXV_ROP_COPY) || 
    ((stencil_mask !=0) && ((plxv_wmask_val & 0xff000000) != 0))   )
    {
	XV_WREG(RopCtl.b.rmw, 1);
	XV_WREG(RopCtl.b.atag, 0);
    }
    else if (stencil_mask !=0) 
    {
	XV_WREG(RopCtl.b.rmw, 0);
	XV_WREG(RopCtl.b.atag, 1);
	XV_WREG(RopCtl.b.rmw, 1);
	XV_WREG(RopCtl.b.atag, 0);
    } 
    else
    {
	XV_WREG(RopCtl.b.rmw, 0);
	XV_WREG(RopCtl.b.atag, 0);
    } 
#ifdef mips
wbflush();
#endif
}

/* CONFIGURE the TAG value override control			  */
/* when writing pixels the tag planes are determined by MUX & VAL */
/* if a bit in MUX is on then the corresponding bit in VAL is written */
/* instead of the source pixel value (from bus or blit) */
/* thus if MUX =0, the FIFO contents are written to the TAG */
plxv_tag(mux,val)
int val,mux;
{
    int i,j;
    plxv_wf_done();
    if ( is_28_now )
    { /* shift the bits to the right position */
	mux = (mux << 4) + mux;
	val = (val << 4) + val;
     }
    XV_WREG(TagCtl.b.ovr_mux,mux); 
    XV_WREG(TagCtl.b.ovr_val,val);
#ifdef mips
wbflush();
#endif
}

plxv_force_stencil()
{
	XV_WREG(RopCtl.b.rmw, 1);
	XV_WREG(RopCtl.b.atag, 0);
}

/* Stencil decides on a pixel by pixel basis if a pixel is to written
   to the memories.  if (PIXEL'S TAG & MASK) == VALUE, then write the pixel */
plxv_stencil(mask,comp)
int mask,comp;
{
    stencil_mask = mask;
    plxv_wf_done();

    if ((rop_num != PLXV_ROP_COPY) || 
    ((stencil_mask !=0) && ((plxv_wmask_val & 0xff000000) != 0))   )
    {
	XV_WREG(RopCtl.b.rmw, 1);
	XV_WREG(RopCtl.b.atag, 0);
    }
    else if (stencil_mask !=0) 
    {
	XV_WREG(RopCtl.b.rmw, 0);
	XV_WREG(RopCtl.b.atag, 1);
	XV_WREG(RopCtl.b.rmw, 1);
	XV_WREG(RopCtl.b.atag, 0);
    } 
    else
    {
	XV_WREG(RopCtl.b.rmw, 0);
	XV_WREG(RopCtl.b.atag, 0);
    } 
    if ( is_28_now )
    { /* shift the bits to the right position */
	mask = (mask << 4);
	comp = (comp << 4);
     }
    XV_WREG(TagClip.b.mask, mask);
    XV_WREG(TagClip.b.comp, comp);
#ifdef mips
wbflush();
#endif
}



/************************  BOXES **********************************/

/* draw a box starting at x0,y0.  size is sx,sy and must not be zero !! */
/* negaative sizes draw to left and up respectively		        */
/*
#define DLY for(ii=0; ii<2000; ii++);
*/
#define DLY ;
plxv_box(x0,y0,sx,sy)
int x0,y0,sx,sy;
{
    int addr;
    int wm,dy;

#ifdef NARROW_BOX_BUG
    register int absx, xinc;
    if(sx < 0)
    {
	absx = -sx;
	xinc = -1;
    }
    else
    {
	absx = sx;
	xinc = 1;
    }
#ifdef mips
    if((absx > 1) && (absx < 5))
#else
    if (absx == 3)	/* could do a 2 then a 1, but why bother? */
#endif
    {
	register int i,j;
	j = x0;
	for(i = absx; i--;)
	{
	    plxv_box(j, y0, 1, sy);
	    j += xinc;
	}
	return;
    }
#endif

    addr = PLXV_ADDR_REG(x0,y0);
    if (sx == 0 || sy == 0) return(0);
    plxv_wf_done();

    switch (xv_cp->main.ga_rev)
    {  /* fix a GA bug on box vertical size */
      case GAREV_2:
    	dy = ((sy<0) ? -1 : 1);		/* get abs of sy */
	wm = plxv_wmask_val;		/* save old write mask */
	plxv_wmask(0);			/* set temp mask to zeo */
	xv_wreg->DstW.l = 0;		/* draw a bogus vector  */
	xv_wreg->VectDY.l = dy;
	plxv_vector_done();		/* wait for done	*/
	plxv_wmask(wm);			/* then, restore write mask */
	break;
      default:
	break;
    }
    xv_wreg->SolidCol.l = plxv_accel_color;
#ifdef mips
    XV_WREG(DstStartAdd.l, addr);
#else
    xv_wreg->DstStartAdd.l = addr;
#endif

    xv_wreg->DstW.l = sx;
    xv_wreg->DstH.l = sy;
    plxv_wf_done();
}


/* copy a box starting at xs,sys to x0,y0..... size sx,sy		*/
/* if sizes are negative, then proceed to left (up)			*/
/* mirroring is not supported						*/
plxv_blit(xs,ys,x0,y0,sx,sy)  /* point xs,ys copies to x0,y0 */
int xs,ys,x0,y0,sx,sy;
{
    int addrS,addrD;
    int dy,wm;

    if (sx == 0 || sy == 0) return(0);

    addrS = PLXV_ADDR_REG(xs,ys);
    addrD = PLXV_ADDR_REG(x0,y0);
    if (sx < 0)
    {
#ifdef mips
	if (( xs % 5) > ( x0 % 5)) addrS += 5;
#else
	if (( xs & 0x3) > (x0 & 3 )) addrS +=4;
#endif
    }
    plxv_wf_done();

    switch (xv_cp->main.ga_rev)
    {  /* fix a GA bug on box vertical size */
      case GAREV_2:
    	dy = ((sy<0) ? -1 : 1);		/* get abs of sy */
	wm = plxv_wmask_val;		/* save old write mask */
	plxv_wmask(0);			/* set temp mask to zeo */
	xv_wreg->DstW.l = 0;		/* draw a bogus vector  */
	xv_wreg->VectDY.l = dy;
	plxv_wf_done();			/* wait for done	*/
	plxv_wmask(wm);			/* then, restore write mask */
	break;
      default:
	break;
    }

    /* do the normal code for blit */
#ifdef mips
    XV_WREG(SrcStartAdd.l, addrS);
    XV_WREG(DstStartAdd.l, addrD);
#else
    xv_wreg->SrcStartAdd.l = addrS;
    xv_wreg->DstStartAdd.l = addrD;
#endif
    xv_wreg->DstW.l = sx;
    xv_wreg->DstH.l = sy;
    plxv_wf_done();
}

/*****************************   VECTORS **************************/

plxv_vector_done()
{
    int i=1;
#ifdef mips
wbflush();
    do
    {
	i = (volatile int) xv_rreg->VBusy.l;
    } while(i);
#else
    while (i) XV_RREG(i,VBusy.l)
#endif
}

#ifndef DRIVER 
plxv_vect_last(nlast)
int nlast;
{
    /* if set then graphics accellerator will draw last pixels on vectors */

    plxv_wf_done();
    nlast &= 0x1;
}

#endif
plxv_vector_window(x,y)
int x,y;
{
    xv_wreg->WindowX.l = x;
    xv_wreg->WindowY.l = y;
#ifdef mips
wbflush();
#endif
}

#ifndef DRIVER

/* Draw a vector starting at x0,y0.  dx and dy arr DELTAS to final pixel 
   of the vector							*/
plxv_vector_abs(x0,y0,x1,y1)
int x0,y0,x1,y1;
{
    plxv_wf_done();
    xv_wreg->SolidCol.l = plxv_accel_color;
    xv_wreg->VectX0.l = x0;
    xv_wreg->VectY0.l = y0;
    xv_wreg->VectX1.l = x1;
    xv_wreg->VectY1.l = y1;
    plxv_vector_done();
}

plxv_vector(x0,y0,dx,dy)
int x0,y0,dx,dy;
{
    plxv_vector_rel(x0,y0,dx,dy);
}

plxv_vector_rel(x0,y0,dx,dy)
int x0,y0,dx,dy;
{
    plxv_wf_done();
    xv_wreg->SolidCol.l = plxv_accel_color;
    xv_wreg->VectX0.l = x0;
    xv_wreg->VectY0.l = y0;
    plxv_vector_done();
    xv_wreg->DstW.l = dx;
    xv_wreg->VectDY.l = dy;
    plxv_vector_done();
}

plxv_vector_cont(dx,dy)
int dx,dy;
{
   plxv_vector_cont_rel(dx,dy);
} 

plxv_vector_cont_rel(dx,dy)
int dx,dy;
{
    plxv_wf_done();
    xv_wreg->DstW.l = dx; 
    xv_wreg->VectDY.l = dy; 
    plxv_vector_done();
}

plxv_vector_cont_abs(x1,y1)
int x1,y1;
{
    plxv_wf_done();
    xv_wreg->VectX1.l = x1; 
    xv_wreg->VectY1.l = y1; 
    plxv_vector_done();
}

plxv_vector_uncook(x0,y0,num_pix,i1,i2,e,left_flag,up_flag,x_major_flag)
int x0,y0,num_pix,i1,i2,e,left_flag,up_flag,x_major_flag;
{
    int i,addr, temp;
    /* all colors are 28 bit (include tag data */
    /* how to vector:
	load rop,stencil, plane mask, etc
	set color
	load start address
	load i1, i2, e
	set number of pixels, flags, and major_axis
	wait for done
    */
/* preceed uncooked vectors with a 'null' cooked vector to prime mode */

    plxv_wf_done();

    addr = PLXV_ADDR_REG(x0,y0);
    xv_wreg->SolidCol.l = plxv_accel_color;


#if GA_REV == GAREV_1
    temp = plxv_wmask_val;		/* save the mask value */
    plxv_wmask(0);			/* so we don't draw anything */
    xv_wreg->DstStartAdd.l = addr;
    xv_wreg->DstW.l = 0;
    xv_wreg->VecH.l = 1;		/* NOTE must not be horizontal */
    plxv_wf_done();
    plxv_wmask(temp);			/* put the mask back */
#endif


/* now do the real vector */

    xv_wreg->VecI1.l = i1;
    xv_wreg->VecI2.l = i2;
    xv_wreg->VecAcc.l = e;
#ifdef mips
    XV_WREG(DstStartAdd.l, addr);
#else
    xv_wreg->DstStartAdd.l = addr;
#endif
    i  = ((x_major_flag & 1) << 15) | ((up_flag  & 1) << 14);
    i |= ((left_flag & 1) <<13) | (num_pix & 0xfff);
    xv_wreg->VecMsc.l = i;
    plxv_wf_done();
}

/* ***************************************************************** */
/*		parameter vector stuff 				     */
/* ***************************************************************** */

plxv_pvector(x0,y0,dx,dy)
int x0,y0,dx,dy;
{
    plxv_pvector_rel(x0,y0,dx,dy);
}

plxv_pvector_rel(x0,y0,dx,dy)
int x0,y0,dx,dy;
{
    int i;
    int i1,i2,e,left,up,major,minor,xmajor,len,addr;
    int nofirst,a;

    left = 0;
    if (dx < 0)
    {
	left = 1;
	dx = -dx;
    }
    up = 0;
    if (dy < 0)
    {
	up = 1;
	dy = -dy;
    }
    if (dx >= dy)
    {
	major = dx;
	minor = dy;
	xmajor = 1;
    }
    else
    {
	major = dy;
	minor = dx;
	xmajor = 0;
    }

    i1 = 2 * minor;
    i2 = 2 * (minor - major);
    e = (2 * minor) - major;
    len = major;
    addr = PLXV_ADDR_REG(x0,y0);
    
    plxv_wf_done();
    xv_wreg->SolidCol.l = plxv_accel_color;

    xv_wreg->VecI1.l = i1;
    xv_wreg->VecI2.l = i2;
    xv_wreg->VecAcc.l = e;
#ifdef mips
    XV_WREG(DstStartAdd.l, addr);
#else
    xv_wreg->DstStartAdd.l = addr;
#endif
    nofirst = 1;
    a = (len) | (nofirst << 12) | (left  << 13) | 
		(up  << 14) | (xmajor << 15);
    xv_wreg->VecMsc.l = a;
    plxv_wf_done();
}

#ifdef excluded
continue_uncooked_vector(i1,i2,e,num_pixel,left_flag,up_flag, x_major)
int i1,i2,e,num_pixel,left_flag,up_flag,x_major;
{
    /* all colors are 28 bit (include tag data */
    /* how to vector:
	load rop,stencil, plane mask, etc
	set color (already done)
	load start address (already done)
	load i1, i2, e
	set number of pixels, flags, and major_axis
	wait for done
    */
    /* this routine is not responsible for setting up the drawing modes */
    int i;

    XV_WREG(VecI1.l, i1);
    XV_WREG(VecI2.l, i2);
    XV_WREG(VecAcc.l, e);
    i = (x_major << 15) | (up_flag << 14) | (left_flag <<13) | num_pixel;
    XV_WREG(VecMsc.l, i);
    plxv_wf_done();
}


#endif
#endif /* !DRIVER */
