/*
 *   Copyright (c) 1987, 88 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 */

/* "@(#)Xplx.h	2.10 02/11/89 Parallax Graphics Inc" */
#ifndef lint
static char *_XPlx_SID = "%W% 	%G% 	Parallax Graphics Inc";
#endif 	/* lint */
static char *rcsid_Xplx_h = "@(#)$Id: Xplx.h,v 1.1 92/02/18 10:57:41 dave Exp $";

#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/time.h>

#ifdef PARALLAX_QEVENT
#ifdef vax
#include	"vaxuba/qevent.h"
#else
#include	"local/qevent.h"
#endif /* vax */
#endif /* PARALLAX_QEVENT */

#include "Xmd.h"
#include "X.h"
#include "Xproto.h"

#include "pixmapstr.h"
#include "regionstr.h"
#include "scrnintstr.h"
#include "servermd.h"
#include "windowstr.h"
#include "gcstruct.h"
#include "input.h"
#include "cursorstr.h"
#include "colormapst.h"
#include "fontstruct.h"
#include "dixfontstr.h"
#include "mi.h"
#define PSZ 8
#include "cfb.h"
extern void miRecolorCursor();		/* not in mi.h */
extern void miClipNotify();		/* not in mi.h */
#include "mistruct.h"
#ifndef X11R2
#include "mibstore.h"
#endif /* not X11R2 */

#ifdef NOTDEF
/* private field of GC */
typedef struct {
	int		freeCompClip;
	RegionPtr	pAbsClientRegion;/* client region in screen coords */
	RegionPtr	pCompositeClip; /* FREE_CC or REPLACE_CC */
	PixmapPtr	plxRotatedTile;	/* tile/stipple rotated to align with window or pixmap */
	PixmapPtr	plxStipple;	/* stipple with correct colors */
} plxPrivGC;
typedef plxPrivGC	*plxPrivGCPtr;
#endif

/*
 * freeCompositeClip values
 */

/*
 * REPLACE_CC
 *	compsite clip is a copy of a pointer, so it doesn't need to be
 *	freed; just overwrite it.  this happens if there is no client clip and
 *	the gc is clipped by children.
 *
 * FREE_CC
 *	composite clip is a real region that we need to free.
 */
#define	REPLACE_CC	0
#define	FREE_CC		1


#ifdef NOTDEF
typedef struct _plxtile {
	Bool expand;			/* true when expaned */
	Bool rotate;			/* true if needs rotation */
	short plxcanstipple;		/* = 1 (use stip8())
  					   = 2 (use stip16
					   = 0 (use Handstippling 
					   = -1 (Not yet initialized
					*/
	int x, y;			/* x & y rotation */
	PixmapPtr original;		/* the 'base' tile/stipple */
} plxTile;
#endif
	
typedef struct _mappriv {
	cfbPrivWin cfb;			/* cfb private */
	int video;			/* flag for live video */
	int tag;			/* type of window: graphics, */
					/* video, or graphics over video */
	int channel;			/* video channel */
	int xdirection;			/* x video draw direction 0=l to r */
	int ydirection;			/* y video draw direction 0=d */
	int vidtype;			/* type of video ie color or b&w */
} MapPriv;


/*
 * Clip macros, this is now a noop.
 */


#define	CLIPREG(execute_code) \
{ \
	execute_code ; \
}

/*
 * Debug macros
 * the debug control is based on a mask, you can turn on many
 * at a time.
 */

#ifdef NOTDEF
extern int plx_debug;
#define	ifdebug(mask)	if (plx_debug & (1<<mask))
#endif
