/***************************************************************************
 The following are the immediate defines for the Parallax video extension. 
****************************************************************************/

/*
The following are valid values of the plx_hardware variable updated as
a result of a XPlxQueryConfig call.
*/

#define	PLX_UNKNOWN	0	/* Unknown configuration */
#define	PLX_1280	2	/* 1280 Series	*/	
#define	PLX_VIPER	3	/* Viper Series	*/
#define	PLX_VIDEOVIEW	4	/* VideoView	*/
#define	PLX_XVIDEO_8	8	/* XVideo, eight bitplane version */
#define	PLX_XVIDEO_24	9	/* XVideo, twenty four bitplane version	*/

/*
The following are valid nvselect Parameters for the XPlxVideoValuesSave and
XPlxVideoValuesRecall functions.
*/

#define USER_0		0	/* user 0 */
#define USER_1		1	/* user 1 */
#define FACTORY		2	/* factory. XPlxVideoValuesRecall only */

/*
The following are valid values of the standard parameter of XPlxInputSelect and
XPlxOutputSelect and are vaild standard values returned by XPlxQueryVideo.
*/
#define	PLX_NTSC	2		/* Video standards...	*/
#define	PLX_PAL		4
#define	PLX_SECAM	5

/*
The following are valid values of the channel parameter of
XPlxVideoInputSelect and XPlxVideoOutputSelect and are valid channel values
returned by XPlxQueryConfig.
*/
#define	PLX_IO_OFF	0		/* Various input/output defs... */
#define	PLX_INPUT_0	1
#define	PLX_INPUT_1	2
#define PLX_OUTPUT_0	32	

/*
The following are valid values of the format parameter of
XPlxVideoInputSelect and XPlxVideoOutputSelect and are vaild
format values returned by XPlxQueryConfig.
*/
#define	PLX_COMP	2		/* Composite	*/
#define	PLX_YC		3		/* SuperVHS	*/
#define	PLX_YUV		4		/* YUV Component */
#define	PLX_RGB		5		/* RGB Compontent */

/*
The following are valid values of the type parameter of XPlxVideoInputSelect
and XPlxVideoOutputSelect and are vaild  type values returned by
XPlxQueryConfig.
*/
#define	PLX_YUV7	1	/* Seven bit YUV format described in */
				/* 1280 or VIPER Series hardware manual */
#define	PLX_RGB24	4	/* Twenty four bit RGB (True Color)	*/
#define	PLX_RGB8	5	/* Eight bit Pseudo color		*/
#define PLX_GRAY5	7	/* Five bit Grayscale (bit <0>=0)	*/
				/* see Viper Manual			*/
#define	PLX_GRAY7	8	/* Seven bit grayscale (bit <0>=0)	*/
#define	PLX_GRAY8	9	/* Eight bit grayscale			*/

/*
The following are valid values of the type parameter of XPlxVideoTag.
*/	
#define	PLX_VIDEO	2	/* Video pixels	*/
#define	PLX_VIDEO_OVR	3	/* Graphics overlay	*/
#define	PLX_GRAPHICS_1	4	/* One bit graphics	*/
#define	PLX_GRAPHICS_8	5	/* Eight bit graphics	*/
#define	PLX_GRAPHICS_24	6	/* Twenty four bit graphics */
#define PLX_GRAPHICS    7	/* just graphics, superseeds 1,8,24 above */


