/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: mainlib.c,v $
 * Revision 1.1  1995/11/27  22:46:59  dist
 * Initial revision
 *
 * Revision 1.1  1995/10/30  17:27:33  kevin
 * Initial revision
 *
 * Revision 1.1  1995/10/13  21:35:04  kevin
 * Initial revision
 *
 * Revision 1.1  1995/03/30  19:42:32  kevin
 * Initial revision
 *
 * Revision 1.19  93/09/30  02:39:02  rocky
 * SQUASH screen sizes
 * 
 * Revision 1.18  92/11/18  12:50:04  rocky
 * updates for 76Hz serration pulses
 * 
 * Revision 1.17  92/10/02  18:01:06  rocky
 * updates for SONY 60hz
 * 
 * Revision 1.15  91/11/22  14:42:14  eric
 * added init_bt to init_drvr
 * 
 * Revision 1.14  91/10/31  14:58:10  dave
 * no loading StartUp in lib for dec
 * 
 * Revision 1.13  91/10/25  16:38:15  dave
 * added shared memory shadow ram
 * 
 * Revision 1.12  91/10/14  13:45:43  mears
 * added auto-hlib versioning to driver
 * 
 * Revision 1.11  91/10/08  16:59:58  mears
 * new ifdef DRIVER's
 * 
 * Revision 1.10  91/10/04  12:46:50  mears
 * ifdef DRIVER
 * 
 * Revision 1.9  91/09/30  16:29:58  mears
 * a few small changes
 * 
 * Revision 1.8  91/08/14  12:23:33  mears
 * TmrInit in nvram
 * 
 * Revision 1.7  91/08/13  13:44:02  mears
 * added power cycle and hours up code
 * 
 * Revision 1.6  91/08/10  14:44:33  mears
 * fixed nvread on option card
 * 
 * 
 * Revision 1.5  91/08/09  19:05:42  eric
 * don't define DEBUG in the files, do it only for make debug
 * 
 * Revision 1.4  91/08/09  16:57:31  mears
 * new nvram stuff
 * 
 * Revision 1.3  91/07/28  04:52:32  eric
 * less debugging
 * 
 * Revision 1.2  91/07/26  19:06:54  eric
 * new from bill
 * 
 * Revision 1.1  91/06/12  16:06:31  eric
 * Initial revision
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: mainlib.c,v 1.1 1995/11/27 22:46:59 dist Exp $ Parallax Graphics Inc";
#endif

#ifdef DEBUG
#define dprintf printf
#else
#define dprintf junkprint
#endif

#include <stdio.h>
#include "xvideo.h"
#include "plxv.h"
#include "c3.h"

#ifdef sun
#define NVRAM_CONFIG
#else
#define NVRAM_CONFIG
#endif


/*
#define TICKS_PER_HOUR (90000 * 3600)
*/
#define TICKS_PER_HOUR (90000 * 10)


#ifdef DRIVER
    static XV_struct cpstatic;

    static XV_shdw_regs spstatic;

    static XV_addr_maps apstatic;
#endif

/******************************************/
/* ALL OF THE GLOBAL POINTERS DEFINED HERE */
int *xv_regbase,*xv_m1base,*xv_m24base,*xv_c3base,*xv_eprombase;
int plxv_addr_wrap = 0x100000;
char *xv_m8base;
XV_write_regs *xv_wreg;
XV_read_regs *xv_rreg;
C3_RREGS *c3_rreg;
C3_WREGS *c3_wreg;
XV_shdw_regs *xv_shdw;
XV_struct *xv_cp;
XV_addr_maps *xv_ap;
/******************************************/

#ifdef DRIVER
#ifdef mips
XV_struct *plxv_init_drvr(reg,m1,m8,m24,c3,eprom, shadow)
unsigned long *reg,*m1,*m24,*c3,*eprom, *shadow;
#else
XV_struct *plxv_init_drvr(reg,m1,m8,m24,c3,eprom)
unsigned long *reg,*m1,*m24,*c3,*eprom;
#endif
unsigned char *m8;
{


#ifndef mips    
    xv_cp = plxv_init_context(reg,m1,m8,m24,c3,eprom);
    plxv_init_disp();
#else
    xv_cp = plxv_init_context(reg,m1,m8,m24,c3,eprom, shadow);
#endif

    /* init the timer */
    XV_WREG(TmrSpd.l,0x171);	/* 90,000 timer ticks per second */

    plxv_init_video();
    plxv_init_draw();
    plxv_28_now(0);
    plxv_mode_8();
    plxv_wmask(PLXV_WMASK_PIXEL_ALL);
    plxv_init_bt(0);
    return(xv_cp);
}

plxv_set_hourint()
{
    static unsigned int next_intr_time = 0;
    unsigned int plxv_read_timer();

    if (next_intr_time == 0) next_intr_time  = plxv_read_timer();
    next_intr_time  += TICKS_PER_HOUR;
    XV_WREG(TmrInt.l,next_intr_time);
    XV_WREG(BIntMask.b.timer,1);
}
    
plxv_inc_hours()
{
#ifdef NOTDEF
    int i,j;

    i = NV_POSITION(main,power_hours);
#endif
    xv_cp->main.power_hours += 1;
#ifdef NOTDEF
    if (plxv_nv_write(0,&(xv_cp->main.power_hours),i,sizeof(long)))
    {
	printf("plxv_inc_hours: can't write controller nvram\n");
	return(-1);
    }
#endif
    if (xv_cp->opt.board_code)
    {   /* service the option card (its there ) */
	xv_cp->opt.power_hours += 1;
#ifdef NOTDEF
	i = NV_POSITION(opt,power_hours);
	if (plxv_nv_write(1,&(xv_cp->opt.power_hours),i,sizeof(long)))
	{
	    printf("plxv_inc_hours: can't write option nvram\n");
	    return(-1);
	}
#endif
    }
    return(0);
}

plxv_inc_powerups()
{
#ifdef NOTDEF
    int i,j;

    i = NV_POSITION(main,power_cycles);
#endif
    xv_cp->main.power_cycles += 1;
#ifdef NOTDEF
    if (plxv_nv_write(0,&(xv_cp->main.power_cycles),i,sizeof(short)))
    {
	printf("plxv_inc_powerups: can't write option nvram\n");
	return(-1);
    }
#endif
    if (xv_cp->opt.board_code)
    {   /* service the option card (its there ) */
	xv_cp->opt.power_cycles += 1;
#ifdef NOTDEF
	i = NV_POSITION(opt,power_cycles);
	if (plxv_nv_write(1,&(xv_cp->opt.power_cycles),i,sizeof(short)))
	{
	    printf("plxv_inc_powerups: can't write option nvram\n");
	    return(-1);
	}
#endif
    }
    return(0);
}

#endif

plxv_init_bus()
{
    int k;
#ifdef NOTDEF
#ifndef mips	/* this is done by the driver! DONT TOUCH THIS REG!!!!! */
    XV_WREG(StartUp.l,xv_cp->main.StartUp);
#endif
#endif
    XV_WREG(Attr.l,xv_cp->main.Attr);
    
    XV_WREG(BIntMask.l,0);
    XV_WREG(IntMask.l,0x8000);
    XV_WREG(RasMode.l,xv_cp->main.RasMode);
}

plxv_init_timer()
{
    /* init the timer */
    XV_WREG(TmrSpd.l,xv_cp->main.TmrInit);
}


unsigned int plxv_read_timer(a)
int a;
{
    int i;
    XV_RREG(i,TmrCnt.l);
    return(i);
}

/*
 *  determine screen attributes (horiz and vert size)
 *  if squash, determine from switch and sense lines
 *  if not squash, default to 1152 x 900
 */

plxv_get_screen_size(xp,yp)
int *xp, *yp;
{
	int i,j;

	if(xv_cp->main.board_code == SBUS_5) /* purvis */
	{
		*xp = 640;
		*yp = 480;
		return;
	}

	if(xv_cp->main.board_code != SBUS_4) /* not squash */
	{
		*xp = 1152;
		*yp = 900;
		return;
	}

	XV_RREG(i,Bt.grn.reg0);
	j = i & 0xff;
	i = j >> 4;
	j = j & 0xf;
	switch(i)
	{
	    case 1:
	    case 2:
	    case 3:
	    default:
		*xp = 1152;
		*yp = 900;
		break;
	    case 4:
		*xp = 1024;
		*yp = 768;
		break;
	    case 5:
		*xp = 640;
		*yp = 480;
		break;
	    case 0xe:
		/* read NVRAM settings */
		break;
	    case 0xf:
		switch(j)
		{
		    case 0:
		    case 5:
			*xp = 1024;
			*yp = 768;
			break;
		    default:
			*xp = 1152;
			*yp = 900;
			break;
		}
	}
/*
	printf("plxv_get_screen_size: x,y = %d,%d\n",*xp,*yp);
*/
}

plxv_init_disp()
{
    short i;
    XV_WREG(DispKludge.l,xv_cp->main.DispKludge);
    XV_WREG(OLDI2C.l,xv_cp->main.OLDI2C);
    if((xv_cp->main.board_code == SBUS_4) || /* squash */
       (xv_cp->main.board_code == SBUS_5))  /* purvis */
    {
	return;
    }
/*
    printf("DispFlgs = 0x%x\n",xv_cp->main.DispFlgs);
    printf("hfp = 0x%x\n",xv_cp->main.h.fp);
    printf("hsy = 0x%x\n",xv_cp->main.h.sy);
    printf("hbp = 0x%x\n",xv_cp->main.h.bp);
    printf("hdisp = 0x%x\n",xv_cp->main.h.disp);
    printf("vfp = 0x%x\n",xv_cp->main.v.fp);
    printf("vbp = 0x%x\n",xv_cp->main.v.bp);
    printf("vdisp = 0x%x\n",xv_cp->main.v.disp);
    printf("vsy = 0x%x\n",xv_cp->main.v.sy);
    printf("hsyncser = 0x%x\n",xv_cp->main.h.hsync_ser);
    printf("hsyncnser = 0x%x\n",xv_cp->main.h.hsync_nser);
*/
    XV_WREG(DispFlgs.l,xv_cp->main.DispFlgs);
    XV_WREG(HFP.l,xv_cp->main.h.fp);
    XV_WREG(HSync.l,xv_cp->main.h.sy);
    XV_WREG(HBP.l,xv_cp->main.h.bp);
    XV_WREG(HDisp.l,xv_cp->main.h.disp);  
    XV_WREG(VFP.l,xv_cp->main.v.fp); 
    XV_WREG(VBP.l,xv_cp->main.v.bp);
    XV_WREG(VDisp.l,xv_cp->main.v.disp);
    XV_WREG(VSync.l,xv_cp->main.v.sy);
    i = xv_cp->main.h.hsync_ser;
    if(i & 0x80) i += 0x80;
    XV_WREG(HSyncS.l,i);
    XV_WREG(HNSyncS.l,xv_cp->main.h.hsync_nser);
}

/* function to initialize context structure and 
   SWITCH CONTEXT TO THE INDICATED BOARD	  */

#ifdef mips
XV_struct *plxv_init_context(reg,m1,m8,m24,c3,eprom, shadow)
int *reg,*m1,*m24,*c3,*eprom, *shadow;
#else
XV_struct *plxv_init_context(reg,m1,m8,m24,c3,eprom)
int *reg,*m1,*m24,*c3,*eprom;
#endif
char *m8;
{
    int Xres,Yres,i,*ip,j;
    XV_struct      *cp;
    XV_shdw_regs   *sp;
    XV_addr_maps   *ap;

#ifdef mips
	sp = (XV_shdw_regs *) shadow;
#endif

#ifdef DRIVER
	cp = &cpstatic;
#ifndef mips
	sp = &spstatic;
#endif
	ap = &apstatic;
#else
    if ((cp = (XV_struct *)malloc(sizeof(XV_struct))) == NULL)
    {   /* malloc failed */
	printf("malloc failed on plxv_init_struct:main struct\n");
	exit(-1);
    }
#ifndef mips
    if ((sp = (XV_shdw_regs *)malloc(sizeof(XV_shdw_regs))) == NULL)
    {   /* malloc failed */
	printf("malloc failed on plxv_init_struct:shadow\n");
	exit(-1);
    }
#endif
    if ((ap = (XV_addr_maps *)malloc(sizeof(XV_addr_maps))) == NULL)
    {   /* malloc failed */
	printf("malloc failed on plxv_init_struct:addr_maps\n");
	exit(-1);
    }
#endif

    /* fill in the structure */
    cp->eprombase = eprom;
    cp->regbase = reg;
    cp->c3base = c3;
    cp->m24base = m24;
    cp->m8base = m8;
    cp->m1base = m1;
    cp->shadow = (int *)sp;
    cp->maps = ap;
	
    /* init the REGISTER FILE shadow ram structure */
    j = sizeof(XV_shdw_regs) >> 2;
    for (ip = (int *)sp, i = 0; i++; i<j) *ip++ = 0;

    /* move all the address pointers into the global set */
    /* (this is doing the actual context switch */
    xv_cp = cp;
    xv_regbase = reg;
    xv_wreg = (XV_write_regs *)reg;
    xv_rreg = (XV_read_regs *)reg;
    xv_eprombase = eprom;
    xv_c3base = c3;
    c3_rreg = (C3_RREGS *)xv_c3base;
    c3_wreg = (C3_WREGS *)xv_c3base;
    xv_m24base = m24;
    xv_m8base = m8;
    xv_m1base = m1;
    xv_shdw = sp;
    xv_ap = ap;

#ifdef never
    if (plxv_nv_read(0,&(xv_cp->main),0,sizeof(XV_controller_nvram)))
    {
    } else if (xv_cp->main.hlib_rev != HLIB_REV)
    {
	/* make sure to init CLT_TYPE & YSIZE */
    }
    if (plxv_nv_read(1,&(xv_cp->opt),0,sizeof(XV_option_nvram)))
    {   /* read error on nvram */
    } else if (xv_cp->opt.hlib_rev != HLIB_REV)
    {
    }
#endif

#ifdef NVRAM_CONFIG
    /* load in the nvram structures from the board */
    if (plxv_nv_read(0,&(xv_cp->main),0,sizeof(XV_controller_nvram)))
    {   /* read error on nvram */
        printf("Error: can't read controller nvram \n");
        xv_cp->main.board_code = 0;
	plxv_load_struct(cp);
    } else if (xv_cp->main.hlib_rev != HLIB_REV)
    {   /* oops new library has differences in NVRAM STRUCT */
	int size,i;
	unsigned char save_buf[100],*cp1;

	dprintf("moving controller NV to new hardware library revision\n");

	/* save the first 14 bytes of NVRAM */
	cp1 = (unsigned char *)(&xv_cp->main);
	size = ((unsigned char *)(&xv_cp->main.xsize)) - (cp1);
	for (i=0;i<size;i++) save_buf[i] = *cp1++;

	/* load the new defaults	    */
	plxv_init_ram(xv_cp,xv_cp->main.board_code,0);

	/* put back the first 14 bytes	    */
	cp1 = (unsigned char *)(&xv_cp->main);
	for (i=0;i<size;i++) *cp1++ = save_buf[i];;

	/* poke the new HLIB revision */
	xv_cp->main.hlib_rev = HLIB_REV;

	/* write the NVRAM */
	dprintf("Writing update NV structure to controller\n");

        if (plxv_nv_write(0,&(xv_cp->main),0,sizeof(XV_controller_nvram)))
        {
            printf("main board nvram not responding to write\n");
            return(xv_cp);
        }
    }

    if (plxv_nv_read(1,&(xv_cp->opt),0,sizeof(XV_option_nvram)))
    {   /* read error on nvram */
        dprintf("No option card present\n");
        xv_cp->opt.board_code = 0;
        xv_cp->opt.clt_type = 0;
    } else if (xv_cp->opt.hlib_rev != HLIB_REV)
    {   /* oops new library has differences in NVRAM STRUCT */
	int size,i;
	unsigned char save_buf[100],*cp1;

	dprintf("moving option card NV to new hardware library revision\n");

	/* save the first 14 bytes of NVRAM */
	cp1 = (unsigned char *)(&xv_cp->opt);
	size = ((unsigned char *)(&xv_cp->opt.unused_2[0])) - (cp1);
	for (i=0;i<size;i++) save_buf[i] = *cp1++;

	/* load the new defaults	    */
	plxv_init_ram(xv_cp,xv_cp->opt.board_code,1);

	/* put back the first 14 bytes	    */
	cp1 = (unsigned char *)(&xv_cp->opt);
	for (i=0;i<size;i++) *cp1++ = save_buf[i];;

	/* poke the new HLIB revision */
	xv_cp->opt.hlib_rev = HLIB_REV;

	/* write the NVRAM */
	dprintf("Writing update NV structure to option card\n");
        if (plxv_nv_write(1,&(xv_cp->opt),0,sizeof(XV_option_nvram)))
        {
            printf(" option board nvram not responding to write\n");
            return(cp);
        }

    } else dprintf("option board %x installed\n",xv_cp->opt.board_code);
#else
    plxv_load_struct(cp);
#endif  /*NVRAM_CONFIG*/

    plxv_get_screen_size(&Xres,&Yres);

    dprintf("x,y = %d,%d\n",Xres,Yres);

    cp->main.xsize = Xres;
    cp->main.ysize = Yres;

    if ( Xres == 640) cp->addr_wrap = 0x100000;
    if ( Xres == 1024) cp->addr_wrap = 0x100000;
    if ( Xres == 1152) cp->addr_wrap = 0x100000;
    if ( Xres == 1280) cp->addr_wrap = 0x140000;

    if(Xres == 640)
    {
	Xres = 1024;
	cp->main.linebytes = 1024;
    }
    else
    {
	cp->main.linebytes = cp->main.xsize;
    }

    Yres = 1024; /* fill arrays to max */

    for (i=0;i<Yres;i++) ap->reg[i] = (Xres * i);
    for (i=0;i<Yres;i++) ap->m24[i] = (int *)( (int) m24 + ((Xres*4) * i));
    for (i=0;i<Yres;i++) ap->m8[i] = (char *)( (int) m8 + (Xres * i));
    for (i=0;i<Yres;i++) ap->m1[i] = (int *)( (int) m1 + ((Xres/8) * i));

    return(cp);
}

/* routine to switch hardware library to new controller */
plxv_switch_context(cp)
XV_struct *cp;
{

    if (xv_cp == cp) return; else
    {
	xv_cp = cp;
	xv_regbase = cp->regbase;
	xv_wreg = (XV_write_regs *)cp->regbase;
	xv_rreg = (XV_read_regs *)cp->regbase;
	xv_eprombase = cp->eprombase;
	xv_c3base = cp->c3base;
	c3_rreg = (C3_RREGS *)xv_c3base;
	c3_wreg = (C3_WREGS *)xv_c3base;
	xv_m24base = cp->m24base;
	xv_m8base = cp->m8base;
	xv_m1base = cp->m1base;
	xv_shdw = (XV_shdw_regs *)cp->shadow;
	xv_ap = cp->maps;
    }
}
