/*
 * Fill rectangles.
 */

/*
Copyright 1989 by the Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the software
without specific, written prior permission.  M.I.T. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.
*/


#include <stdio.h>
#include "sun.h"
#include "X.h"
#include "Xmd.h"
#include "servermd.h"
#include "gcstruct.h"
#include "window.h"
#include "pixmapstr.h"
#include "scrnintstr.h"
#include "windowstr.h"


#define PSZ 8

#include "cfb.h"
#include "cfbmskbits.h"
#include "mergerop.h"
#include "plxInit.h"
extern int plxroptbl[];

#ifdef DEBUG
extern int dbg_trace;
extern int wid_trace;
#endif
void
plxFillWid (pDrawable, pGC, nBox, pBox)
    DrawablePtr	    pDrawable;
    GCPtr	    pGC;
    int		    nBox;
    BoxPtr	    pBox;
{
int		    h;
int		    w;

plxGCPtr	privGC = GetPlxGCPrivate(pGC);
plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);

    plxv_rop(5);
    plxv_tag(PLXV_TAG_ST_MASK,pGC->fgPixel);
    plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
    plxv_wmask(PLXV_TAG_MASK_SHIFTED);
    plxv_color_24(0);
    for (; nBox; nBox--, pBox++)
    {
	w = pBox->x2 - pBox->x1;
    	h = pBox->y2 - pBox->y1;
	if( h != 0 && w != 0) 
	    plxv_box(pBox->x1,pBox->y1,w,h);
    }
}
extern int *plxv_peek();
void
plxFillRectSolid (pDrawable, pGC, nBox, pBox)
    DrawablePtr	    pDrawable;
    GCPtr	    pGC;
    int		    nBox;
    BoxPtr	    pBox;
{
    int		    h;
    int		    w;
    int		    *addr;

#ifdef DEBUG
if(wid_trace)
{
    addr = plxv_peek(pBox->x1,pBox->y1);
    fprintf(stderr,"value at x=%d y=%d = 0x%x\n",pBox->x1,pBox->y1,*addr);
}
#endif
    for (; nBox; nBox--, pBox++)
    {
	w = pBox->x2 - pBox->x1;
    	h = pBox->y2 - pBox->y1;
	if( h != 0 && w != 0) 
	    plxv_box(pBox->x1,pBox->y1,w,h); 
    }
}

