
#include <stdio.h>
#include "sun.h"
#include "mpg/mpg.h"
#include "mpg/wid.h"
#include "X.h"
#include "Xmd.h"
#include "Xproto.h"
#define PSZ 8
#include "cfb.h"
#include "fontstruct.h"
#include "dixfontstr.h"
#include "gcstruct.h"
#include "windowstr.h"
#include "pixmapstr.h"
#include "scrnintstr.h"
#include "region.h"

#include "mistruct.h"
#include "mibstore.h"

#include "cfbmskbits.h"
#include "cfb8bit.h"
#include "plxInit.h"
#define XV_DIAG 1
#include "xvdebug.h"

#define	PLX_VIDEO	2	/* Video pixels	*/
#define	PLX_VIDEO_OVR	3	/* Graphics overlay	*/
#define	PLX_GRAPHICS_1	4	/* One bit graphics	*/
#define	PLX_GRAPHICS_8	5	/* Eight bit graphics	*/
#define	PLX_GRAPHICS_24	6	/* Twenty four bit graphics */
#define PLX_GRAPHICS    7	/* just graphics, superseeds 1,8,24 above */
#ifdef DEBUG
extern int dbg_trace;
extern int wid_trace;
int color_trace;
int rop_trace;
#endif
extern RegionPtr plxOneBitCopyArea();
void plxValidateGC(),plxChangeGC(),plxCopyGC(),plxDestroyGC(),
     plxChangeClip(),plxDestroyClip(),plxCopyClip();
extern int cfbGCPrivateIndex;

void cfbValidateGC(), cfbChangeGC(), cfbCopyGC(), cfbDestroyGC();
void cfbChangeClip(), cfbDestroyClip(), cfbCopyClip();

#if PSZ == 8
# define useTEGlyphBlt  cfbTEGlyphBlt8
#else
# ifdef WriteFourBits
#  define useTEGlyphBlt	cfbImageGlyphBlt8
# else
#  define useTEGlyphBlt	cfbTEGlyphBlt
# endif
#endif

#ifdef WriteFourBits
# define useImageGlyphBlt	cfbImageGlyphBlt8
# define usePolyGlyphBlt	cfbPolyGlyphBlt8
#else
# define useImageGlyphBlt	miImageGlyphBlt
# define usePolyGlyphBlt	miPolyGlyphBlt
#endif

#ifdef FOUR_BIT_CODE
# define usePushPixels	cfbPushPixels8
#else
# define usePushPixels	mfbPushPixels
#endif

#ifdef PIXEL_ADDR
# define ZeroPolyArc	cfbZeroPolyArcSS8Copy
#else
# define ZeroPolyArc	miZeroPolyArc
#endif

extern int plxroptbl[];

GCFuncs plxGCFuncs = {
    plxValidateGC,
    cfbChangeGC,
    cfbCopyGC,
    plxDestroyGC,
    cfbChangeClip,
    cfbDestroyClip,
    cfbCopyClip,
};

extern void	    PlxPolyFillRect8();
extern void 	    pfbPolylines();
extern void 	    pfbPolySegment();


static void	    PlxFillSpans(),	PlxSetSpans(),	   PlxPutImage();
static RegionPtr    PlxCopyArea8(),	PlxCopyPlane();
static void	    PlxPolyPoint(),	PlxPolylines(),    PlxPolySegment();
static void	    PlxPolyRectangle(),	PlxPolyArc(),	   PlxFillPolygon();
static void	    PlxPolyFillArc(),   PlxPolyFillRect();
static int	    PlxPolyText8(),	PlxPolyText16();
static void	    PlxImageText8(),	PlxImageText16();
static void	    PlxImageGlyphBlt(),	PlxPolyGlyphBlt();
static void	    PlxPushPixels(),	PlxLineHelper();


#ifdef OLDGLYPH
static GCOps plxTEOps = {
    PlxFillSpans,	PlxSetSpans,	PlxPutImage,	
    PlxCopyArea8,	PlxCopyPlane,  	PlxPolyPoint,
    PlxPolylines,	PlxPolySegment,	PlxPolyRectangle,
    PlxPolyArc,		PlxFillPolygon,	PlxPolyFillRect,
    PlxPolyFillArc,	PlxPolyText8,  	PlxPolyText16,
    PlxImageText8,	PlxImageText16,	PlxImageGlyphBlt,
    cfbPolyGlyphBlt8,	PlxPushPixels, 	PlxLineHelper,
};
static GCOps plxNonTEOps = {
    PlxFillSpans,	PlxSetSpans,	PlxPutImage,	
    PlxCopyArea8,	PlxCopyPlane,  	PlxPolyPoint,
    PlxPolylines,	PlxPolySegment,	PlxPolyRectangle,
    PlxPolyArc,		PlxFillPolygon,	PlxPolyFillRect,
    PlxPolyFillArc,	PlxPolyText8,  	PlxPolyText16,
    PlxImageText8,	PlxImageText16,	PlxImageGlyphBlt,
    cfbPolyGlyphBlt8,	PlxPushPixels, 	PlxLineHelper,
};
#else
static GCOps plxTEOps = {
    PlxFillSpans,	PlxSetSpans,	PlxPutImage,	
    PlxCopyArea8,	PlxCopyPlane,  	PlxPolyPoint,
    PlxPolylines,	PlxPolySegment,	PlxPolyRectangle,
    PlxPolyArc,		PlxFillPolygon,	PlxPolyFillRect,
    PlxPolyFillArc,	miPolyText8,  	miPolyText16,
    miImageText8,	miImageText16,	PlxImageGlyphBlt,
    cfbPolyGlyphBlt8,	miPushPixels, 	PlxLineHelper,
};
static GCOps plxNonTEOps = {
    PlxFillSpans,	PlxSetSpans,	PlxPutImage,	
    PlxCopyArea8,	PlxCopyPlane,  	PlxPolyPoint,
    PlxPolylines,	PlxPolySegment,	PlxPolyRectangle,
    PlxPolyArc,		PlxFillPolygon,	PlxPolyFillRect,
    PlxPolyFillArc,	miPolyText8,  	miPolyText16,
    miImageText8,	miImageText16,	PlxImageGlyphBlt,
    cfbPolyGlyphBlt8,	miPushPixels, 	PlxLineHelper,
};
#endif

GCOps *PlxMatchCommon();


#define GET_PWID(w) (widGetValue(widGetWindowWid(((WindowPtr)(w))->parent)))

#define PlxPrivate
#ifdef DEBUG_LEAK
extern int used_memory;
extern int gc_mem,win_mem,scrn_mem,ops_mem,curs_mem;
#endif
Bool
plxCreateGC(pGC)
    register GCPtr pGC;
{
plxGCPtr	privGC;
Bool ret;
plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);

    switch(pGC->depth)
    {
    case 1:
	 ret= mfbCreateGC(pGC);
	/*
	 * Replace original function table with Plx version.
	 * This allows replacement of mfbCopyArea in "Ops" tables.
	 * The replacement is accomplished in PlxMfbValidateGC.
	 */
	 plxWrapGc(pGC);
	 return(ret);
	 break;
    case 8:
         if (!cfbCreateGC(pGC)) return FALSE;
         privGC = (plxGCPtr)xalloc(sizeof(plxGCRec));
         if (!privGC)
           return FALSE;
	 privGC->rop=5;
	 privGC->linebytes=1152;
	 privGC->fg=1;;
	 privGC->wid_value=0;
	 privGC->bg=0;
	 privGC->planemask=0xffffff;
	 privGC->bpp=8;
	 privGC->win_type=0;
	 privGC->video_priv=NULL;
         pGC->devPrivates[plxGCPrivateIndex].ptr= (pointer)privGC;
	 if(pPlxPrivate->privGC[PLX_COLOR_8] == NULL)
	         pPlxPrivate->privGC[PLX_COLOR_8] = (plxGCPtr)privGC;
         pGC->ops = &plxNonTEOps;
         pGC->funcs = &plxGCFuncs;
	 break;
    case 24:
	 FatalError("plxGc: illegal depth 24\n");
	 break;
    }
	
    return TRUE;
}


void
plxDestroyGC(pGC)
    GC 			*pGC;
{
cfbPrivGC *pPriv;
plxGCPtr	privGC = GetPlxGCPrivate(pGC);

    if(privGC)
    {
        if(privGC->video_priv!=NULL)
	    xfree(privGC->video_priv);
        xfree(privGC);
    }

    pPriv = (cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr);
    if (pPriv->pRotatedPixmap)
	cfbDestroyPixmap(pPriv->pRotatedPixmap);
    if (pPriv->freeCompClip)
	(*pGC->pScreen->RegionDestroy)(pPriv->pCompositeClip);
    cfbDestroyOps (pGC->ops);
}


void
plxValidateGC(pGC, changes, pDrawable)
    register GCPtr  pGC;
    Mask	    changes;
    DrawablePtr	    pDrawable;
{
    WindowPtr   pWin;
    int         mask;		/* stateChanges */
    int         index;		/* used for stepping through bitfields */
    int		new_rrop;
    int         new_line, new_text, new_fillspans, new_fillarea;
    int		new_rotate;
    int		xrot, yrot;
    /* flags for changing the proc vector */
    cfbPrivGCPtr devPriv;
    int		oneRect;
    int		vid;
    int		pwid;
    plxGCPtr	plxPrivGC,privGC;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);
    privGC = GetPlxGCPrivate(pGC);
    
    plxPrivGC = pPlxPrivate->privGC[PLX_COLOR_8];

    new_rotate = pGC->lastWinOrg.x != pDrawable->x ||
		 pGC->lastWinOrg.y != pDrawable->y;

    pGC->lastWinOrg.x = pDrawable->x;
    pGC->lastWinOrg.y = pDrawable->y;
    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	pWin = (WindowPtr) pDrawable;
	vid = WindowVisual(pWin);
	if(pPlxPrivate->pg != PLX_WID_PG)
	    plxPrivGC->wid_value = privGC->wid_value= widWinGetValue(pWin);
    }
    else
    {
	pWin = (WindowPtr) NULL;
	vid = 0;
    }

    devPriv = ((cfbPrivGCPtr) (pGC->devPrivates[cfbGCPrivateIndex].ptr));

    new_rrop = FALSE;
    new_line = FALSE;
    new_text = FALSE;
    new_fillspans = FALSE;
    new_fillarea = FALSE;

    /*
     * if the client clip is different or moved OR the subwindowMode has
     * changed OR the window's clip has changed since the last validation
     * we need to recompute the composite clip 
     */

    if ((changes & (GCClipXOrigin|GCClipYOrigin|GCClipMask|GCSubwindowMode)) ||
	(pDrawable->serialNumber != (pGC->serialNumber & DRAWABLE_SERIAL_BITS))
	)
    {
	ScreenPtr pScreen = pGC->pScreen;

	if (pWin) {
	    RegionPtr   pregWin;
	    Bool        freeTmpClip, freeCompClip;

	    pregWin = &pWin->clipList;

	    if (pGC->subWindowMode == IncludeInferiors) {
		pregWin = NotClippedByChildren(pWin);
		freeTmpClip = TRUE;
	    }
	    else {
		pregWin = &pWin->clipList;
		freeTmpClip = FALSE;
	    }
	    freeCompClip = devPriv->freeCompClip;

	    /*
	     * if there is no client clip, we can get by with just keeping
	     * the pointer we got, and remembering whether or not should
	     * destroy (or maybe re-use) it later.  this way, we avoid
	     * unnecessary copying of regions.  (this wins especially if
	     * many clients clip by children and have no client clip.) 
	     */
	    if (pGC->clientClipType == CT_NONE) {
		if (freeCompClip)
		    (*pScreen->RegionDestroy) (devPriv->pCompositeClip);
		devPriv->pCompositeClip = pregWin;
		devPriv->freeCompClip = freeTmpClip;
	    }
	    else {
		/*
		 * we need one 'real' region to put into the composite
		 * clip. if pregWin the current composite clip are real,
		 * we can get rid of one. if pregWin is real and the
		 * current composite clip isn't, use pregWin for the
		 * composite clip. if the current composite clip is real
		 * and pregWin isn't, use the current composite clip. if
		 * neither is real, create a new region. 
		 */

		(*pScreen->TranslateRegion)(pGC->clientClip,
					    pDrawable->x + pGC->clipOrg.x,
					    pDrawable->y + pGC->clipOrg.y);
						  
		if (freeCompClip)
		{
		    (*pGC->pScreen->Intersect)(devPriv->pCompositeClip,
					       pregWin, pGC->clientClip);
		    if (freeTmpClip)
			(*pScreen->RegionDestroy)(pregWin);
		}
		else if (freeTmpClip)
		{
		    (*pScreen->Intersect)(pregWin, pregWin, pGC->clientClip);
		    devPriv->pCompositeClip = pregWin;
		}
		else
		{
		    devPriv->pCompositeClip = (*pScreen->RegionCreate)(NullBox,
								       0);
		    (*pScreen->Intersect)(devPriv->pCompositeClip,
					  pregWin, pGC->clientClip);
		}
		devPriv->freeCompClip = TRUE;
		(*pScreen->TranslateRegion)(pGC->clientClip,
					    -(pDrawable->x + pGC->clipOrg.x),
					    -(pDrawable->y + pGC->clipOrg.y));
						  
	    }
	}			/* end of composite clip for a window */
	else {
	    BoxRec      pixbounds;

	    /* XXX should we translate by drawable.x/y here ? */
	    pixbounds.x1 = 0;
	    pixbounds.y1 = 0;
	    pixbounds.x2 = pDrawable->width;
	    pixbounds.y2 = pDrawable->height;

	    if (devPriv->freeCompClip)
		(*pScreen->RegionReset)(devPriv->pCompositeClip, &pixbounds);
	    else {
		devPriv->freeCompClip = TRUE;
		devPriv->pCompositeClip = (*pScreen->RegionCreate)(&pixbounds,
								   1);
	    }

	    if (pGC->clientClipType == CT_REGION)
	    {
		(*pScreen->TranslateRegion)(devPriv->pCompositeClip,
					    -pGC->clipOrg.x, -pGC->clipOrg.y);
		(*pScreen->Intersect)(devPriv->pCompositeClip,
				      devPriv->pCompositeClip,
				      pGC->clientClip);
		(*pScreen->TranslateRegion)(devPriv->pCompositeClip,
					    pGC->clipOrg.x, pGC->clipOrg.y);
	    }
	}			/* end of composute clip for pixmap */
	oneRect = REGION_NUM_RECTS(devPriv->pCompositeClip) == 1;
	if (oneRect != devPriv->oneRect)
	    new_line = TRUE;
	devPriv->oneRect = oneRect;
    }

    mask = changes;
    while (mask) {
	index = lowbit (mask);
	mask &= ~index;

	/*
	 * this switch acculmulates a list of which procedures might have
	 * to change due to changes in the GC.  in some cases (e.g.
	 * changing one 16 bit tile for another) we might not really need
	 * a change, but the code is being paranoid. this sort of batching
	 * wins if, for example, the alu and the font have been changed,
	 * or any other pair of items that both change the same thing. 
	 */
	switch (index) {
	case GCFunction:
	    if(pPlxPrivate->pg!=PLX_WID_PG)
	    {
		 plxPrivGC->rop = privGC->rop=plxroptbl[pGC->alu];
	         new_rrop = TRUE;
	    }
	    break;
	case GCForeground:
	    plxPrivGC->fg =privGC->fg = pGC->fgPixel;
	    new_rrop = TRUE;
	    break;
	case GCPlaneMask:
	    new_rrop = TRUE;
	    new_text = TRUE;
	    plxPrivGC->planemask = privGC->planemask=pGC->planemask;
	    break;
	case GCBackground:
	    plxPrivGC->bg = privGC->bg=pGC->bgPixel;
	    break;
	case GCLineStyle:
	case GCLineWidth:
	    new_line = TRUE;
	    break;
	case GCJoinStyle:
	case GCCapStyle:
	    break;
	case GCFillStyle:
	    new_text = TRUE;
	    new_fillspans = TRUE;
	    new_line = TRUE;
	    new_fillarea = TRUE;
	    break;
	case GCFillRule:
	    break;
	case GCTile:
	    new_fillspans = TRUE;
	    new_fillarea = TRUE;
	    break;

	case GCStipple:
	    if (pGC->stipple)
	    {
		int width = pGC->stipple->drawable.width;
		PixmapPtr nstipple;

		if ((width <= 32) && !(width & (width - 1)) &&
		    (nstipple = cfbCopyPixmap(pGC->stipple)))
		{
		    cfbPadPixmap(nstipple);
		    cfbDestroyPixmap(pGC->stipple);
		    pGC->stipple = nstipple;
		}
	    }
	    new_fillspans = TRUE;
	    new_fillarea = TRUE;
	    break;

	case GCTileStipXOrigin:
	    new_rotate = TRUE;
	    break;

	case GCTileStipYOrigin:
	    new_rotate = TRUE;
	    break;

	case GCFont:
	    new_text = TRUE;
	    break;
	case GCSubwindowMode:
	    break;
	case GCGraphicsExposures:
	    break;
	case GCClipXOrigin:
	    break;
	case GCClipYOrigin:
	    break;
	case GCClipMask:
	    break;
	case GCDashOffset:
	    break;
	case GCDashList:
	    break;
	case GCArcMode:
	    break;
	default:
	    break;
	}
    }
    /*
     * If the drawable has changed,  ensure suitable
     * entries are in the proc vector. 
     */
    if (pDrawable->serialNumber != (pGC->serialNumber & (DRAWABLE_SERIAL_BITS))) {
	new_fillspans = TRUE;	/* deal with FillSpans later */
    }

    if (new_rotate || new_fillspans)
    {
	Bool new_pix = FALSE;

	xrot = pGC->patOrg.x + pDrawable->x;
	yrot = pGC->patOrg.y + pDrawable->y;

	switch (pGC->fillStyle)
	{
	case FillTiled:
	    if (!pGC->tileIsPixel)
	    {
		int width = pGC->tile.pixmap->drawable.width * PSZ;

		if ((width <= 32) && !(width & (width - 1)))
		{
		    cfbCopyRotatePixmap(pGC->tile.pixmap,
					&devPriv->pRotatedPixmap,
					xrot, yrot);
		    new_pix = TRUE;
		}
	    }
	    break;
#ifdef FOUR_BIT_CODE
	case FillStippled:
	case FillOpaqueStippled:
	    {
		int width = pGC->stipple->drawable.width;

		if ((width <= 32) && !(width & (width - 1)))
		{
		    mfbCopyRotatePixmap(pGC->stipple,
					&devPriv->pRotatedPixmap, xrot, yrot);
		    new_pix = TRUE;
		}
	    }
	    break;
#endif
	}
	if (!new_pix && devPriv->pRotatedPixmap)
	{
	    cfbDestroyPixmap(devPriv->pRotatedPixmap);
	    devPriv->pRotatedPixmap = (PixmapPtr) NULL;
	}
    }

    if (new_rrop)
    {
	int old_rrop;

	old_rrop = devPriv->rop;
	devPriv->rop = cfbReduceRasterOp (pGC->alu, pGC->fgPixel,
					   pGC->planemask,
					   &devPriv->and, &devPriv->xor);
	if (old_rrop == devPriv->rop)
	    new_rrop = FALSE;
	else
	{
#ifdef PIXEL_ADDR
	    new_line = TRUE;
#endif
#ifdef WriteFourBits
	    new_text = TRUE;
#endif
	    new_fillspans = TRUE;
	    new_fillarea = TRUE;
	}
    }

    if (new_rrop || new_fillspans || new_text || new_fillarea || new_line)
    {
	GCOps	*newops;

	if (newops = PlxMatchCommon (pGC, devPriv))
 	{
	    if (pGC->ops->devPrivate.val)
		cfbDestroyOps (pGC->ops);
	    pGC->ops = newops;
	    new_rrop = new_line = new_fillspans = new_text = new_fillarea = 0;
	}
 	else
 	{
	    if (!pGC->ops->devPrivate.val)
	    {
		pGC->ops = cfbCreateOps (pGC->ops);
		pGC->ops->devPrivate.val = 1;
	    }
	}
    }

    /* deal with the changes we've collected */
    if (new_line)
    {
	pGC->ops->FillPolygon = PlxFillPolygon;
	if (devPriv->oneRect && pGC->fillStyle == FillSolid)
	{
	       pGC->ops->FillPolygon = PlxFillPolygon;
	}
	if (pGC->lineWidth == 0)
	{
#ifdef PIXEL_ADDR
	    if ((pGC->lineStyle == LineSolid) && (pGC->fillStyle == FillSolid))
	    {
                SetAttributes(pDrawable,pGC);
		plxv_rop(5);
		switch (devPriv->rop)
		{
		case GXxor:
		    pGC->ops->PolyArc = cfbZeroPolyArcSS8Xor;
		    break;
		case GXcopy:
		    pGC->ops->PolyArc = cfbZeroPolyArcSS8Copy;
		    break;
		default:
		    pGC->ops->PolyArc = cfbZeroPolyArcSS8General;
		    break;
		}
	    }
	    else
#endif
		pGC->ops->PolyArc = miZeroPolyArc;
	}
	else
	    pGC->ops->PolyArc = miPolyArc;

	pGC->ops->PolySegment = PlxPolySegment;
#ifdef notnow
	switch (pGC->lineStyle)
	{
	case LineSolid:
	    if(pGC->lineWidth == 0)
	    {
		if (pGC->fillStyle == FillSolid)
		{
#ifdef PIXEL_ADDR
		    if (devPriv->oneRect)
		    {
			pGC->ops->Polylines = cfb8LineSS1Rect;
			pGC->ops->PolySegment = cfb8SegmentSS1Rect;
		    } else
		    {
		    	pGC->ops->Polylines = cfbLineSS;
		    	pGC->ops->PolySegment = cfbSegmentSS;
		    }
		}
 		else
		    pGC->ops->Polylines = miZeroLine;
	    }
	    else
		pGC->ops->Polylines = miWideLine;
#endif
	    break;
	case LineOnOffDash:
	case LineDoubleDash:
	    if (pGC->lineWidth == 0 && pGC->fillStyle == FillSolid)
	    {
		pGC->ops->Polylines = cfbLineSD;
		pGC->ops->PolySegment = cfbSegmentSD;
	    } else
		pGC->ops->Polylines = miWideDash;
	    break;
	}
#endif
    }

    if (new_text && (pGC->font))
    {
        if (FONTMAXBOUNDS(pGC->font,rightSideBearing) -
            FONTMINBOUNDS(pGC->font,leftSideBearing) > 32 ||
	    FONTMINBOUNDS(pGC->font,characterWidth) < 0)
        {
#ifdef OLDGLYPHBLT
            pGC->ops->PolyGlyphBlt = PlxPolyGlyphBlt;
            pGC->ops->ImageGlyphBlt = PlxImageGlyphBlt;
#else
            pGC->ops->PolyGlyphBlt = miPolyGlyphBlt;
            pGC->ops->ImageGlyphBlt = miImageGlyphBlt;
#endif
        }
        else
        {
#ifdef WriteFourBits
	    if (pGC->fillStyle == FillSolid)
	    {
		if (devPriv->rop == GXcopy)
		    pGC->ops->PolyGlyphBlt = cfbPolyGlyphBlt8;
		else
#ifdef FOUR_BIT_CODE
		    pGC->ops->PolyGlyphBlt = cfbPolyGlyphRop8;
#else
		    pGC->ops->PolyGlyphBlt = PlxPolyGlyphBlt;
#endif
	    }
	    else
#endif
#ifdef OLDGLYPHBLT
		pGC->ops->PolyGlyphBlt = PlxPolyGlyphBlt;
#else
		pGC->ops->PolyGlyphBlt = miPolyGlyphBlt;
#endif
            /* special case ImageGlyphBlt for terminal emulator fonts */
#if !defined(WriteFourBits) || PSZ == 8
	    if (TERMINALFONT(pGC->font) &&
		(pGC->planemask & PMSK) == PMSK
#ifdef FOUR_BIT_CODE
		&& FONTMAXBOUNDS(pGC->font,characterWidth) >= 4
#endif
		&& (pGC->fillStyle == FillSolid)
		)
	    {
		pGC->ops->ImageGlyphBlt = useTEGlyphBlt;
	    }
            else
#endif
	    {
#ifdef WriteFourBits
		if (devPriv->rop == GXcopy &&
		    pGC->fillStyle == FillSolid &&
		    (pGC->planemask & PMSK) == PMSK)
		    pGC->ops->ImageGlyphBlt = PlxImageGlyphBlt;
		else
#endif
		    pGC->ops->ImageGlyphBlt = miImageGlyphBlt;
	    }
        }
    }    


    if (new_fillspans) {
	switch (pGC->fillStyle) {
	case FillSolid:
		pGC->ops->FillSpans = PlxFillSpans;
	    break;
	case FillTiled:
	    if (devPriv->pRotatedPixmap)
	    {
		if (pGC->alu == GXcopy && (pGC->planemask & PMSK) == PMSK)
		    pGC->ops->FillSpans = cfbTile32FSCopy;
		else
		    pGC->ops->FillSpans = cfbTile32FSGeneral;
	    }
	    else
		pGC->ops->FillSpans = cfbUnnaturalTileFS;
	    break;
	case FillStippled:
#ifdef FOUR_BIT_CODE
	    if (devPriv->pRotatedPixmap)
		pGC->ops->FillSpans = cfb8Stipple32FS;
	    else
#endif
		pGC->ops->FillSpans = cfbUnnaturalStippleFS;
	    break;
	case FillOpaqueStippled:
#ifdef FOUR_BIT_CODE
	    if (devPriv->pRotatedPixmap)
		pGC->ops->FillSpans = cfb8OpaqueStipple32FS;
	    else
#endif
		pGC->ops->FillSpans = cfbUnnaturalStippleFS;
	    break;
	default:
	    FatalError("plxValidateGC: illegal fillStyle\n");
	}
    } /* end of new_fillspans */

    if (new_fillarea) {
#ifndef FOUR_BIT_CODE
	pGC->ops->PolyFillRect = miPolyFillRect;

	if (pGC->fillStyle == FillSolid)
	       pGC->ops->PolyFillRect = PlxPolyFillRect;
	else if (pGC->fillStyle == FillTiled)
	       pGC->ops->PolyFillRect = cfbPolyFillRect;
#endif
#ifdef FOUR_BIT_CODE
	pGC->ops->PushPixels = mfbPushPixels;
	if (pGC->fillStyle == FillSolid && devPriv->rop == GXcopy)
	    pGC->ops->PushPixels = PlxPushPixels;
#endif
	pGC->ops->PolyFillArc = miPolyFillArc;
	if (pGC->fillStyle == FillSolid)
	{
	    switch (devPriv->rop)
	    {
	    case GXcopy:
		pGC->ops->PolyFillArc = cfbPolyFillArcSolidCopy;
		break;
	    default:
		pGC->ops->PolyFillArc = cfbPolyFillArcSolidGeneral;
		break;
	    }
	}
    }
}


extern RegionPtr cfbCopyPlane(),cfbCopyArea();

/****************************************************************************/
/*                             Plx GC OPS                                   */
/****************************************************************************/
static void
PlxFillSpans(pDrawable, pGC, nInit, pptInit, pwidthInit, fSorted)
    DrawablePtr	pDrawable;
    GCPtr	pGC;
    int		nInit;		
    DDXPointPtr pptInit;
    int		*pwidthInit;
    int 	fSorted;
{
plxGCPtr	privGC = GetPlxGCPrivate(pGC);
    cfbPrivGCPtr devPriv = 
	((cfbPrivGCPtr) (pGC->devPrivates[cfbGCPrivateIndex].ptr));
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);

#ifdef DEBUG
    if(dbg_trace)
	fprintf(stderr,"FillSpans \n");
#endif
    if(privGC->rop == PLXV_ROP_INVERT || privGC->rop == PLXV_ROP_XOR)
    {
	SetSWxorOrInvert(pDrawable, pGC);
    }
    else
    {
	SetAttributes(pDrawable,pGC);
    }

    switch (devPriv->rop) {
    case GXcopy:
	cfbSolidSpansCopy(pDrawable, pGC, nInit, pptInit, pwidthInit, fSorted);
	break;
    case GXxor:
	cfbSolidSpansXor(pDrawable, pGC, nInit, pptInit, pwidthInit, fSorted);
	break;
    default:
	cfbSolidSpansGeneral (pDrawable, pGC, nInit, pptInit, pwidthInit, fSorted);
	break;
    }
}

static void
PlxSetSpans(pDrawable, pGC, psrc, ppt, pwidth, nspans, fSorted)
    DrawablePtr	pDrawable;
    GCPtr	pGC;
    int		*psrc;
    DDXPointPtr ppt;
    int		*pwidth;
    int		nspans;
    int		fSorted;
{
#ifdef DEBUG
if(dbg_trace)
    fprintf(stderr,"SetSpans\n");
#endif
    SetAttributes(pDrawable,pGC);
    cfbSetSpans(pDrawable, pGC, psrc, ppt, pwidth, nspans, fSorted);

}

static void
PlxPutImage(pDrawable, pGC, depth, x, y, w, h, leftPad, format, pBits)
    DrawablePtr	pDrawable;
    GCPtr   	pGC;
    int		depth;
    int	    	x;
    int	    	y;
    int	    	w;
    int	    	h;
    int	    	format;
    char    	*pBits;
{

#ifdef DEBUG
if(dbg_trace)
	fprintf(stderr,"PutImage\n");
#endif
    SetAttributes(pDrawable,pGC);
    cfbPutImage(pDrawable, pGC, depth, x, y, w, h, leftPad, format, pBits);
}
extern RegionPtr Plx8ScrnCopyArea();
extern RegionPtr plxCopyArea();


static RegionPtr
PlxCopyArea8(pSrc, pDst, pGC, srcx, srcy, w, h, dstx, dsty)
    DrawablePtr	pSrc;
    DrawablePtr	pDst;
    GCPtr   	pGC;
    int	    	srcx;
    int	    	srcy;
    int	    	w;
    int	    	h;
    int	    	dstx;
    int	    	dsty;
{
    static RegionPtr rgn;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);
        
        plxv_tag(PLXV_TAG_MASK_DISABLE,PLXV_TAG_DISABLE);
        plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
        plxv_rop(PLXV_ROP_COPY); 
        if((pSrc->type  == DRAWABLE_WINDOW) && (pDst->type == DRAWABLE_WINDOW))
	{
            if(pPlxPrivate->pg == PLX_WID_PG)
	    {
	        plxv_wmask(PLXV_TAG_ST_PIXEL_MASK);
                rgn= Plx8ScrnCopyArea(pSrc, pDst,pGC, srcx, srcy, w, h, dstx, dsty);
    	    }
	    else
	    {
	        plxv_wmask(PLXV_PIXEL_MASK);
	        plxv_wmask(PLXV_TAG_ST_PIXEL_MASK); /* #### */
                rgn= Plx8ScrnCopyArea(pSrc, pDst,pGC, srcx, srcy, w, h, dstx, dsty);
	    }
	}
        else
        {
            rgn= cfbCopyArea(pSrc, pDst, pGC, srcx, srcy, w, h, dstx, dsty);
        }
    return(rgn);
}
RegionPtr plxMpgCopyArea(pSrc, pDst, pGC, srcx, srcy, w, h, dstx, dsty)
    DrawablePtr	pSrc;
    DrawablePtr	pDst;
    GCPtr   	pGC;
    int	    	srcx;
    int	    	srcy;
    int	    	w;
    int	    	h;
    int	    	dstx;
    int	    	dsty;
{
    static RegionPtr rgn;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);
        
        plxv_tag(PLXV_TAG_MASK_DISABLE,PLXV_TAG_DISABLE);
        plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
        plxv_rop(PLXV_ROP_COPY); 
        if(pSrc == pDst)
	{
            if(pPlxPrivate->pg == PLX_WID_PG)
	    {
	        plxv_wmask(PLXV_TAG_ST_PIXEL_MASK);
                rgn= Plx8ScrnCopyArea(pSrc, pDst,pGC, srcx, srcy, w, h, dstx, dsty);
    	    }
	    else
	    {
                rgn = (RegionPtr)plxCheckExposures(pSrc, pDst,pGC, srcx, srcy, 
		    w, h, dstx, dsty);
	    }
	}
    return(rgn);
}

static RegionPtr
PlxCopyPlane(pSrc, pDst, pGC, srcx, srcy, w, h, dstx, dsty, plane)
    DrawablePtr		pSrc;
    DrawablePtr 	pDst;
    GCPtr  	 	pGC;
    int         	srcx;
    int         	srcy;
    int         	w;  
    int         	h;
    int         	dstx;
    int         	dsty;
    unsigned long	plane;
{
    RegionPtr	rgn;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);
    plxv_tag(PLXV_TAG_MASK_DISABLE,PLXV_TAG_DISABLE);
    plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
    plxv_rop(5);
    if(pPlxPrivate->pg == PLX_WID_PG)
	plxv_wmask(PLXV_TAG_MASK_SHIFTED);
    else
	plxv_wmask(PLXV_PIXEL_MASK);
    rgn= cfbCopyPlane(pSrc, pDst, pGC, srcx, srcy, w, h, dstx, dsty, plane);
    return(rgn);
}

static void
PlxPolyPoint(pDrawable, pGC, mode, npt, pptInit)
    DrawablePtr pDrawable;
    GCPtr	pGC;
    int		mode;
    int		npt;
    xPoint	*pptInit;
{
#ifdef DEBUG
if(dbg_trace)
	fprintf(stderr,"PolyPoint\n");
#endif
    SetAttributes(pDrawable,pGC);
    miPolyPoint(pDrawable, pGC, mode, npt, pptInit);
}

static void
PlxPolylines(pDrawable, pGC, mode, npt, pptInit)
    DrawablePtr	pDrawable;
    GCPtr   	pGC;
    int	    	mode;
    int	    	npt;
    DDXPointPtr	pptInit;
{
    void	    (*Polylines)();

plxGCPtr	privGC = GetPlxGCPrivate(pGC);
cfbPrivGCPtr devPriv = 
	((cfbPrivGCPtr) (pGC->devPrivates[cfbGCPrivateIndex].ptr));
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);
    
#ifdef DEBUG
    if(dbg_trace)
    	fprintf(stderr,"Polylines\n");
#endif

    if(privGC->rop == PLXV_ROP_INVERT || privGC->rop == PLXV_ROP_XOR)
    {
	SetSWxorOrInvert(pDrawable, pGC);
    }
    else
    {
	SetAttributes(pDrawable,pGC);
    }

    switch (pGC->lineStyle)
    {
	case LineSolid:
	    if(pGC->lineWidth == 0)
	    {
		if (pGC->fillStyle == FillSolid)
		{
		  if((pDrawable->type == DRAWABLE_WINDOW) ||
		     ((pointer)(pDrawable->pScreen->devPrivate) ==
		      (pointer)pDrawable))
		
			Polylines = pfbPolylines;
		  else
		  {
		    if (devPriv->oneRect)
			Polylines = cfb8LineSS1Rect;
		     else
		    	Polylines = cfbLineSS;
		  }
		}
 		else
		    Polylines = miZeroLine;
	    }
	    else
		Polylines = miWideLine;
	    break;
	case LineOnOffDash:
	case LineDoubleDash:
	    if (pGC->lineWidth == 0 && pGC->fillStyle == FillSolid)
		Polylines =cfbLineSD;
	    else
		Polylines = miWideDash;
	    break;
    }
    (*Polylines)(pDrawable, pGC, mode, npt, pptInit);
}


static void
PlxPolySegment(pDrawable, pGC, nseg, pSegs)
    DrawablePtr pDrawable;
    GCPtr 	pGC;
    int		nseg;
    xSegment	*pSegs;
{
    void	    (*PolySegment)();
	void        cfb32SegmentSS1Rect();
    plxGCPtr	privGC = GetPlxGCPrivate(pGC);
    cfbPrivGCPtr devPriv = 
	((cfbPrivGCPtr) (pGC->devPrivates[cfbGCPrivateIndex].ptr));
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);

#ifdef DEBUG
if(dbg_trace)
	fprintf(stderr,"PolySegment\n");
#endif
    if(privGC->rop == PLXV_ROP_XOR || privGC->rop == PLXV_ROP_INVERT)
    {
	    SetSWxorOrInvert(pDrawable, pGC);
    }
    else
    {
        SetAttributes(pDrawable,pGC);
    }
    PolySegment = miPolySegment;
    switch (pGC->lineStyle)
	{
	case LineSolid:
	    if(pGC->lineWidth == 0)
	    {
		if (pGC->fillStyle == FillSolid)
		{
		  if((pDrawable->type == DRAWABLE_WINDOW) ||
		     ((pointer)(pDrawable->pScreen->devPrivate) ==
		      (pointer)pDrawable))
		    PolySegment = pfbPolySegment;
		  else
		  {
		    if (devPriv->oneRect)
			PolySegment = cfb8SegmentSS1Rect;
		    else
		    	PolySegment = cfbSegmentSS;
		  }
		}
            }
      
	    break;
	case LineOnOffDash:
	case LineDoubleDash:
	    if (pGC->lineWidth == 0 && pGC->fillStyle == FillSolid)
		PolySegment = cfbSegmentSD;
	    break;
	}
    (*PolySegment) (pDrawable, pGC, nseg, pSegs);
}

static void
PlxPolyRectangle(pDrawable, pGC, nrects, pRects)
    DrawablePtr	pDrawable;
    GCPtr	pGC;
    int		nrects;
    xRectangle	*pRects;
{

#ifdef DEBUG
if(dbg_trace)
	fprintf(stderr,"PolyRectangle\n");
#endif
    SetAttributes(pDrawable,pGC);
    miPolyRectangle(pDrawable, pGC, nrects, pRects);
}

void
PlxPolyFillRect(pDrawable, pGC, nrectFill, prectInit)
    DrawablePtr pDrawable;
    register GCPtr pGC;
    int		nrectFill; 	/* number of rectangles to fill */
    xRectangle	*prectInit;  	/* Pointer to first rectangle to fill */
{
plxGCPtr	privGC = GetPlxGCPrivate(pGC);
plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);

         if (pGC->fillStyle == FillSolid)
		PlxPolyFillRect8(pDrawable, pGC, nrectFill, prectInit);
	 else
	 {
    		if(privGC->rop == PLXV_ROP_XOR || privGC->rop == PLXV_ROP_INVERT)
    		{
		    SetSWxorOrInvert(pDrawable, pGC);
    		}
    		else
		{
        		SetAttributes(pDrawable,pGC);
		}
		cfbPolyFillRect(pDrawable, pGC, nrectFill, prectInit);
	 }
}

static void PlxPolyArc(pDrawable, pGC, narcs, parcs)
    DrawablePtr	pDrawable;
    GCPtr	pGC;
    int		narcs;
    xArc	*parcs;
{
    SetAttributes(pDrawable,pGC);
    ZeroPolyArc(pDrawable, pGC, narcs, parcs);
}       

static void 
PlxFillPolygon(pDrawable, pGC, shape, mode, count, pPts)
    DrawablePtr	pDrawable;
    GCPtr	pGC;
    int		shape, mode;
    int		count;
    DDXPointPtr	pPts;
{
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);
    if(pPlxPrivate->pg == PLX_WID_PG)return;
    SetAttributes(pDrawable,pGC);
    miFillPolygon(pDrawable, pGC, shape, mode, count, pPts);
}

static void
PlxPolyFillArc(pDrawable, pGC, narcs, parcs)
    DrawablePtr	pDrawable;
    GCPtr	pGC;
    int		narcs;
    xArc	*parcs;
{
    SetAttributes(pDrawable,pGC);
    miPolyFillArc(pDrawable, pGC, narcs, parcs);
}

static int
PlxPolyText8(pDrawable, pGC, x, y, count, chars)
    DrawablePtr pDrawable;
    GCPtr	pGC;
    int		x, y;
    int 	count;
    char	*chars;
{
    ScreenPtr pScreen = pDrawable->pScreen;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);
    SetAttributes(pDrawable,pGC);
    plxv_rop(5);
    pScreen->devPrivate    = (pointer) &pPlxPrivate->pixmaps[PLX_COLOR_8];
    pGC->ops->PolyGlyphBlt  = cfbPolyGlyphBlt8;
    pGC->ops->PushPixels   = cfbPushPixels8;
    miPolyText8(pDrawable, pGC, x, y, count, chars);
}

static int
PlxPolyText16(pDrawable, pGC, x, y, count, chars)
    DrawablePtr 	pDrawable;
    GCPtr		pGC;
    int			x, y;
    int			count;
    unsigned short 	*chars;
{
    ScreenPtr pScreen = pDrawable->pScreen;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);
    SetAttributes(pDrawable,pGC);
    plxv_rop(5);
    miPolyText16(pDrawable, pGC, x, y, count, chars);
}

static void
PlxImageText8(pDrawable, pGC, x, y, count, chars)
    DrawablePtr pDrawable;
    GCPtr	pGC;
    int		x, y;
    int		count;
    char	*chars;
{
    ScreenPtr pScreen = pDrawable->pScreen;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);
    SetAttributes(pDrawable,pGC);
    plxv_rop(5);
#ifdef NOT
    pScreen->devPrivate    = (pointer) &pPlxPrivate->pixmaps[PLX_COLOR_8];
    pGC->ops->PolyGlyphBlt  = cfbImageGlyphBlt8;
    pGC->ops->PushPixels   = cfbPushPixels8;
#endif
    miImageText8(pDrawable, pGC, x, y, count, chars);
}

static void
PlxImageText16(pDrawable, pGC, x, y, count, chars)
    DrawablePtr pDrawable;
    GCPtr	pGC;
    int		x, y;
    int		count;
    char	*chars;
{
    SetAttributes(pDrawable,pGC);
    plxv_rop(5);
    miImageText16(pDrawable, pGC, x, y, count, chars);
}

static void
PlxImageGlyphBlt(pDrawable, pGC, x, y, nglyph, ppci, pglyphBase)
    DrawablePtr		pDrawable;
    GCPtr		pGC;
    int 		x, y;
    unsigned int 	nglyph;
    CharInfoPtr 	*ppci;
    pointer 		pglyphBase;
{
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);
    SetAttributes(pDrawable,pGC);
    miImageGlyphBlt(pDrawable, pGC, x, y, nglyph, ppci, pglyphBase);
}

static void
PlxPolyGlyphBlt(pDrawable, pGC, x, y, nglyph, ppci, pglyphBase)
    DrawablePtr 	pDrawable;
    GCPtr		pGC;
    int 		x, y;
    unsigned int 	nglyph;
    CharInfoPtr 	*ppci;	
    char 		*pglyphBase;
{
    SetAttributes(pDrawable,pGC);
    miPolyGlyphBlt(pDrawable, pGC, x, y, nglyph, ppci, pglyphBase);
}

static void
PlxPushPixels(pGC, pBitMap, pDst, w, h, x, y)
    GCPtr	pGC;
    PixmapPtr	pBitMap;
    DrawablePtr pDst;
    int		w, h, x, y;
{
int fgcol;
plxGCPtr	privGC = GetPlxGCPrivate(pGC);
plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);

    if(pDst->type == DRAWABLE_WINDOW && !privGC->win_type)
    {
	/*
	 * Set up the hardware for transparent accesses with tag override,
	 * rop = copy, and the enable bit set in the color value.
	 */
        fgcol= 0x01000000 | pGC->fgPixel<<16 | pGC->fgPixel<<8 | pGC->fgPixel;
        plxv_transp_on();
	plxv_wmask(PLXV_PIXEL_MASK);
        plxv_tag(PLXV_TAG_MASK_DISABLE,PLXV_TAG_DISABLE);
        plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
        plxv_rop(5);
	plxv_colors_1(fgcol,0,0);
        plxPushPixels8(pGC, pBitMap, pDst, w, h, x, y);
	plxv_transp_off();
	plxv_colors_1(-1,0,-1);
    }
    else
    {
	SetAttributes(pDst,pGC);
        usePushPixels(pGC, pBitMap, pDst, w, h, x, y);
    }
}

static void
PlxLineHelper()
{
    FatalError("PlxLineHelper called\n");
}
GCOps *
PlxMatchCommon (pGC, devPriv)
    GCPtr	    pGC;
    cfbPrivGCPtr    devPriv;
{
    if (pGC->lineWidth != 0)
	return 0;
    if (pGC->lineStyle != LineSolid)
	return 0;
    if (pGC->fillStyle != FillSolid)
	return 0;
    if (devPriv->rop != GXcopy)
	return 0;
    if (pGC->font &&
	FONTMAXBOUNDS(pGC->font,rightSideBearing) -
        FONTMINBOUNDS(pGC->font,leftSideBearing) <= 32 &&
	FONTMINBOUNDS(pGC->font,characterWidth) >= 0)
    {
	if (TERMINALFONT(pGC->font)
#ifdef FOUR_BIT_CODE
	    && FONTMAXBOUNDS(pGC->font,characterWidth) >= 4
#endif
	)
	{
	    return &plxTEOps;
        }
	else
	 {
	    return &plxNonTEOps;
	 }
    }
    return 0;
}
XV_struct *PlxGetCtx(pScreen)
ScreenPtr pScreen;
{
    hwlibPrivPtr  hwlibPriv;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);
    hwlibPriv = (hwlibPrivPtr) &pPlxPrivate->hwlibPriv;
    return( hwlibPriv->xv);
}
SetAttributes(DrawablePtr pDrawable,GCPtr pGC)
{
    u_int   color;
	u_int   wmask;
    TV2Priv *tv2_priv;
    plxGCPtr	privGC = GetPlxGCPrivate(pGC);
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);

    if(privGC->rop == PLXV_ROP_INVERT || privGC->rop == PLXV_ROP_XOR)
    {
	if (privGC->rop == PLXV_ROP_INVERT)
	    plxv_rop(PLXV_ROP_INVERT);
	else
	    plxv_rop(PLXV_ROP_XOR);
	if(pGC->depth== 8)
	{
		plxv_rop(PLXV_ROP_XOR); 
	    plxv_tag(PLXV_TAG_MASK,pPlxPrivate->wid8);
	    if(privGC->bg && privGC->fg)
	    {
		if(privGC->fg+privGC->bg != privGC->planemask)
		    plxv_color_8(privGC->fg);
		else
		     plxv_color_8(privGC->planemask & 0xff);
	    }
	    else if(privGC->bg)
	       plxv_color_8(privGC->bg);
	    else
	       plxv_color_8(privGC->fg);
	}
	else if(pGC->depth==24) /* #### Direct Color? */
	{
	    plxv_tag(PLXV_TAG_MASK,pPlxPrivate->wid24True);
	    plxv_color_24(privGC->planemask);
	}
	plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
	plxv_wmask(PLXV_PIXEL_MASK);
    }

    else if (privGC->rop == PLXV_ROP_XOR)
    {
	    plxv_rop(PLXV_ROP_COPY);
	    switch (pGC->depth)
	    {
	      default: plxv_color_8(privGC->fg);  break;
	      case 8:  plxv_color_8(privGC->fg);  break;
	      case 24: plxv_color_24(privGC->fg); break;
	    }
	    plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
	    plxv_wmask(PLXV_PIXEL_MASK);
    }
      

    else
    {
	plxv_rop(privGC->rop);
	plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
	plxv_wmask(PLXV_TAG_ST_PIXEL_MASK);
	switch(privGC->win_type)
	{
	  case PLX_GRAPHICS_24:
	    plxv_tag(PLXV_TAG_MASK,pPlxPrivate->wid24True);
	    wmask = PLXV_PIXEL_MASK & privGC->planemask;
	    plxv_wmask(PLXV_TAG_MASK_SHIFTED | wmask);
	    plxv_color_24(privGC->fg);
	    break;
	  case PLX_GRAPHICS_8:
	    plxv_tag(PLXV_TAG_MASK,pPlxPrivate->wid8);
	    plxv_color_8(privGC->fg);
	    wmask = privGC->planemask & 0xff;
	    wmask = wmask | (wmask << 8) | (wmask << 16);
	    plxv_wmask(PLXV_TAG_MASK_SHIFTED | wmask);
	    break;
	  case PLX_VIDEO:
	    if(pGC->depth== 8)
	    {
	       plxv_color_8(privGC->fg);
	       wmask = privGC->planemask & 0xff;
	       wmask = wmask | (wmask << 8) | (wmask << 16);
	    }
	    else if(pGC->depth==24)
	    {
	       plxv_color_24(privGC->fg);
	       wmask = PLXV_PIXEL_MASK & privGC->planemask;
	    }
	    if(privGC->video_priv)
	    {
		 tv2_priv= (TV2Priv *)privGC->video_priv;
		 plxv_tag(PLXV_TAG_MASK,tv2_priv->video_tag);
		 wmask |= PLXV_TAG_MASK_SHIFTED;
	    }
	    plxv_wmask(wmask);
	    break;
	  case PLX_VIDEO_OVR:
	  default: 
	    switch (pGC->depth)
	    {
	      case 8: 
		plxv_color_8(privGC->fg);
		wmask = privGC->planemask & 0xff;
		wmask = wmask | (wmask << 8) | (wmask << 16);
		plxv_wmask(wmask);
		break;
	      case 24:
		plxv_color_24(privGC->fg);
		wmask = PLXV_PIXEL_MASK & privGC->planemask;
		plxv_wmask(wmask);
		break;
	       default:
		ERRORF((fd,"Bad depth %d found\n"));
	     }
	     break;
	 }
    }
}

SetSWxorOrInvert(DrawablePtr pDrawable, GCPtr pGC)
{
    plxGCPtr      privGC = GetPlxGCPrivate(pGC);
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);
 
    plxv_rop(PLXV_ROP_COPY);
    switch (pGC->depth)
    {
      default: plxv_color_8(privGC->fg);  break;
      case 8:  plxv_color_8(privGC->fg);  break;
      case 24: plxv_color_24(privGC->fg); break;
    }
#ifdef NOTDEF
    plxv_tag(PLXV_TAG_MASK,pPlxPrivate->wid8);
#endif
    plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
    plxv_wmask(PLXV_PIXEL_MASK /* & privGC->planemask */);
}

