#pragma ident "@(#)plxInit.c	1.11 93/04/19   SMI"

#include    <stdio.h>
#include    "sun.h"
/*
#include    "mpg/mpg.h"
#include    "mpg/wid.h"
*/
#include    "mpg.h"
#include    "wid.h"
#include    "cmap/cmap.h"
#include     "X.h"
#include    "windowstr.h"
#include    <sys/mman.h>
#include    <sys/memfb.h>
#include    <sys/fbio.h>

#include    <sys/ioccom.h>
#include    <sys/fcntl.h>

#include    "colormap.h"
#include    "colormapst.h"
#include    "resource.h"
#include    "mibstore.h"
#include    "mipointer.h"
# include   "mispritest.h"

extern Bool		noMinExp;
#define PSZ 8
#define Xv
#define PlxVideo
#include    "cfb.h"
#include    "gcstruct.h"
#include    "pixmapstr.h"
#include    "servermd.h"
#include    "regionstr.h"
#include    "mi.h"
#include    "xvideo.h"
#include    "plxInit.h"

FILE *errfp;

#ifdef DGA
#include "../../dga/dgawinstr.h"
#endif /* DGA */

#define PlxGCPrivate(g) \
  ((g)->devPrivates[plxGCPrivateIndex].ptr)
#define GetplxGCPrivate(g) (plxGCPtr) PlxGCPrivate(g)

static PixmapFormatRec formats[] = {
    1,	  1,  BITMAP_SCANLINE_PAD,
    8,	  8,  BITMAP_SCANLINE_PAD,
    24,  32,  BITMAP_SCANLINE_PAD,
};

#ifdef XV_TRACE
int xv_trace=1;
#endif

#ifdef DEBUG_LEAK
int used_memory;
int gc_mem,win_mem,scrn_mem,ops_mem,vid_mem;
#endif

#define PLX_NUM_PIXMAP_FORMATS	(sizeof formats)/(sizeof formats[0])

static VisualRec plxVisuals[] = {
/*    vid  class      bpRGB cmpE nplan rMask gMask  bMask oRed oGreen oBlue */
    { 0,   StaticGray,  1,     2,  1,    0,    0,     0,    0,   0,     0},
    { 0,   PseudoColor, 8,  1<<8,  8,    0,    0,     0,    0,   0,     0},
    { 0,   TrueColor,	8,  1<<8,  24,  255, 255<<8, 255<<16, 0,  8,    16},
    { 0,   DirectColor,	8,  1<<8,  24,  255, 255<<8, 255<<16, 0,  8,    16},
};

int dbg_trace=0;
int wid_trace=0;
extern int rop_trace;
int trace_attributes;

#ifndef PIX_GROUP
#define PIX_GROUP(g)            ((g) << 25)
#endif
#ifndef	PR_FORCE_UPDATE
#define PR_FORCE_UPDATE (1 << 24)
#endif
#ifndef PIXPG_8BIT_COLOR
#define PIXPG_8BIT_COLOR    2
#endif
#ifndef PIXPG_OVERLAY
#define PIXPG_OVERLAY       4
#endif
#ifndef PIXPG_24BIT_COLOR
#define PIXPG_24BIT_COLOR   5
#endif

typedef struct {
    unsigned char red;
    unsigned char green;
    unsigned char blue;
    }plx_color_map;
/* int	plx_fd;*/
int	clutindex;

#define NUMVISUALS   4

#define NUMDEPTHS	3 /*1, 8 and 24 bit */
VisualID VIDs[NUMVISUALS];

static DepthRec depths[] = {
/* depth	numVid		vids */
  1,		1,		&VIDs[0],
  8,		1,		&VIDs[1],
  24,		2,		&VIDs[2],
};


mpgInfoRec mono_chrome_info,  pseudo_color_info, true_color_info, direct_color_info ;

mpgInfoRec cursor_info;


static mpgPerVisInfo plxMpgVisInfo[NUMVISUALS] = {
    (VisualID)0, &mono_chrome_info,
    (VisualID)0, &pseudo_color_info,
    (VisualID)0, &true_color_info,
    (VisualID)0, &direct_color_info,
};

/*
 *  COLORMAP INFORMATION:
 */
Bool 		plxTV2storeColors();
int 		plxTV2writeClut();
static CmapDevFuncs pDevFuncs = { 
			plxTV2writeClut,
		  	plxTV2storeColors,
		  	NULL
		};
/*
 * 	MHC table definition and initialization.
 */
static CmapClutPoolDesc pClutPoolDesc[] = {
/*            numCluts  pClutIds numPgs 	pPgs      maxFlavors  */
		{ 1,       { 0 },   1,     { PLX_CURSOR },   0 },
		{ 1,       { 1 },   1,     { PLX_COLOR_8 },  0 },
		{ 1,       { 2 },   1,     { PLX_COLOR_24 }, 0 },
		{ 1,       { 3 },   1,     { PLX_DIRECT_24 }, 0 },
};

plxScreenPtr	pPlxPrivate;

extern Bool 		plx32CreateGC(), PlxCreateGC();
extern void 		plxmfbGetImage(), cfbGetImage(), cfb32GetImage();
extern PixmapPtr 	mfbCreatePixmap(), cfbCreatePixmap(), plx32CreatePixmap();
extern Bool  		mfbDestroyPixmap(), cfb32DestroyPixmap();

extern void 		mfbGetSpans(),cfbGetSpans(),cfb32GetSpans();
extern void		PlxmfbSaveAreas(),PlxmfbRestoreAreas();
extern void		cfbSaveAreas(),  cfbRestoreAreas();
extern void		cfb32SaveAreas(),cfb32RestoreAreas();

#ifdef SPECIAL_CFB
extern void plx32SaveAreas(),plx32RestoreAreas();
#endif
extern Bool		PlxUnmapWindow();
extern Bool		PlxDestroyWindow();
extern void		PlxWindowExposures();
extern void		PlxMpgCopyWindow();
XV_struct *PlxGetContext(ScreenPtr pScreen);

    int video_active;

    extern miBSFuncRec cfbBSFuncRec,cfb32BSFuncRec;


    miBSFuncRec PlxmfbBSFuncRec = {
	PlxmfbSaveAreas,
	PlxmfbRestoreAreas,
	(void (*)()) 0,
	(PixmapPtr (*)()) 0,
	(PixmapPtr (*)()) 0,
    };

#ifdef SPECIAL_CFB
    miBSFuncRec Plx32BSFuncRec = {
	plx32SaveAreas,
	plx32RestoreAreas,
	(void (*)()) 0,
	(PixmapPtr (*)()) 0,
	(PixmapPtr (*)()) 0,
	};
#endif


    extern Bool sunSaveScreen(ScreenPtr pScreen, int on);
						     
    static const mpgPerDepthInfo plxMpgDepthInfo[NUMDEPTHS] = {
#ifdef WRAPGC
      { 1, plxCreateGC, mfbCreatePixmap, mfbDestroyPixmap, plxmfbGetImage,
#endif
#ifndef WRAPGC
      { 1, plxCreateGC, mfbCreatePixmap, mfbDestroyPixmap, mfbGetImage,
#endif
	mfbGetSpans},
  { 8, plxCreateGC, cfbCreatePixmap, cfbDestroyPixmap, cfbGetImage,
      cfbGetSpans },
  { 24, plx32CreateGC, plx32CreatePixmap, cfb32DestroyPixmap, cfb32GetImage,
      cfb32GetSpans },
};

/*
 *-----------------------------------------------------------------------
 * PlxSaveScreen
 *-----------------------------------------------------------------------
 */

static Bool plxSaveScreen(pScreen, what)
ScreenPtr pScreen;
Bool what;
{
    plxv_switch_context(PlxGetContext(pScreen));
    plxv_disp_blank(!what);
    return(TRUE);
}

/*
 *-----------------------------------------------------------------------
 * PlxUpdateColormap --
 *
 *-----------------------------------------------------------------------
 */
#ifdef DGA
extern void DgaDevFuncsunit();
extern DgaDevFuncs plxDgaFuncs[];
#endif /* DGA */

/*-
 *-----------------------------------------------------------------------
 * plxinit --
 *	Attempt to find and initialize a plx framebuffer
 *
 * Results:
 *	TRUE if everything went ok. FALSE if not.
 *
 * Side Effects:
 *	Most of the elements of the ScreenRec are filled in. Memory is
 *	allocated for the frame buffer and the buffer is mapped. The
 *	video is enabled for the frame buffer...
 *
 *-----------------------------------------------------------------------
 */
#define MAX_FLAVORS 0
/*ARGSUSED*/
Bool
PlxTv2Init(index, pScreen, argc, argv)
    int	    	  index;    	/* The index of pScreen in the ScreenInfo */
    ScreenPtr	  pScreen;  	/* The Screen to initialize */
    int	    	  argc;	    	/* The number of the Server's arguments. */
    char    	  **argv;   	/* The arguments themselves. Don't change! */
{
    int			fd;
    sunScreenPtr	pSunPrivate;
    plxScreenPtr	pPlxPrivate; 

    extern miPointerScreenFuncRec   sunPointerScreenFuncs;
    extern Bool		plxPutInHardware;
    extern void		PlxClearToBackground();
    extern WidPtr 	plxWidAlloc();
    extern void		plxWidFree(), plxSetColorLut();
    extern void		PlxInitializeColormaps();
    static int		plxGeneration;
    extern void 	PlxPGSwitch();
    extern void		PlxEnterLeave();
    int                 defClass, defDepth;
    int 		defaultDepth;
    int           	defclass=PseudoColor;
    int vid;

    if (!sunScreenAllocate(pScreen)) {
	return FALSE;
    }
    /*
     * Open the framebuffer device using the Sun default interface.
     */
    pSunPrivate = GetScreenPrivate(pScreen);

    if ((fd = sunOpenFrameBuffer(FBTYPE_MEMCOLOR,
			         &pSunPrivate->sunFbs.info,
				 index,
				 &pSunPrivate->sunFbs,
				 argc, argv)) < 0) {
	    /* Free stuff allocated by sunScreenAllocate */
	    xfree(pSunPrivate);
	    return FALSE;
    }
#ifdef DEBUG_STARTUP
    fprintf(stderr, "sunOpenFrameBuffer fd: %d pSunPrivate %x\n", fd, pSunPrivate);
    fprintf(stderr, "index %d pScreen %x\n", index, pScreen);
#endif

    /*
     *	Set initial values of frame buffer device in SunPrivate.
     */
    pSunPrivate->sunFbs.fd = fd;
    pSunPrivate->sunFbs.mapped = FALSE;
    pSunPrivate->sunFbs.parent = FALSE;
    pSunPrivate->sunFbs.EnterLeave = NULL;

#ifdef DEBUG_STARTUP
	fprintf(stderr, "<%s>\n", sunFbDevList[index].deviceName);
#endif

    strcpy(pSunPrivate->sunFbs.devName, sunFbDevList[index].deviceName);
    if (plxGeneration != serverGeneration) {
	int	i;
	
	if (!(plxScreenPrivateIndex = AllocateScreenPrivateIndex())) {
	    xfree(pSunPrivate);
	    (void)close(fd);
	    return(FALSE);
	}

	plxWindowPrivateIndex=AllocateWindowPrivateIndex();

	plxGCPrivateIndex = AllocateGCPrivateIndex();
/*
 *	Copy local visual information to Mpg visual info array.
 */
	for (i = 0; i < NUMVISUALS; i++) {
	    plxVisuals[i].vid = FakeClientID(0);
	    plxMpgVisInfo[i].vid = VIDs[i] = plxVisuals[i].vid;
    	}
/*
 *	Set all PIXMAP formats using standard Sun interface. 
 *	sunSetPixmapFormat().
 */
	for (i=0; i< PLX_NUM_PIXMAP_FORMATS; i++) {
	    if (!sunSetPixmapFormat(&formats[i])) {
		FatalError("plx cannot set pixmap format");
		/* NOTREACHED */
	    }
	}
    /*
     * Set up MPG info data using mpgInsertPlanegroups.
     */
        PlxBuildMpgInfo(pScreen);
	plxGeneration = serverGeneration;
    }
    /*
     * Initalize Plx private data structure for private Screen function
     * pointers and other necessary local data.
     */
#ifdef DEBUG_LEAK
     used_memory= sizeof(plxScreenRec);
     fprintf(stderr,"plxInit: used_memory=%d\n",used_memory);
     scrn_mem++;
#endif
    if (!(pPlxPrivate = (plxScreenPtr)xalloc(sizeof(plxScreenRec)))) {
	xfree(pSunPrivate);
	close(fd);
	return FALSE;
    }

    memset(pPlxPrivate,0,sizeof(plxScreenRec));
    pScreen->devPrivates[plxScreenPrivateIndex].ptr = (pointer)pPlxPrivate;
    pPlxPrivate->tv2_video_fd=fd;
    pPlxPrivate->copy_done=0;
    pPlxPrivate->video_active=0;
    video_active=0;

    /*
     *	Actually map in the framebuffer and initialize pixmaps for each
     *  planegroup.
     */
    if (!PlxMapIn(fd, pScreen)) {
	xfree(pSunPrivate);
	xfree(pPlxPrivate);
	(void)close(fd);
	return FALSE;
    }
    /*
     *	Setup seperate pScreen objects for each Visual type 
     *  (drawable planegroups).
     */
    PlxSetupScreens(pScreen);
    pScreen->allowedDepths = depths;
    pScreen->numDepths = NUMDEPTHS;
    pScreen->visuals = plxVisuals;
    pScreen->numVisuals = NUMVISUALS;

    if(sunFbDevList[index].defDepth != 24)
    {
	  defaultDepth = sunFbDevList[index].defDepth=8;
          defclass = sunFbDevList[index].defClass=PseudoColor;
    }
    else
    {
         defaultDepth=sunFbDevList[index].defDepth;
	 if(sunFbDevList[index].defClass == DirectColor)
             defclass= sunFbDevList[index].defClass=DirectColor;
	 else
             defclass= sunFbDevList[index].defClass=TrueColor;
    }
                        /* if command line options are not specified, set defaults */
    if(defclass == -1) defclass = sunFbDevList[index].defClass = PseudoColor;
    if(defaultDepth == 0)  defaultDepth = sunFbDevList[index].defDepth = 8;
 
    /*
     * Complete MPG intialization by passing plxMpgVisInfo , plxMpgDepthInfo
     * and planegroup switch function pointer. This is initialized for either
     * 8 or 24 bit depth so the Allplanes uses the correct depth.
     */
    if(defaultDepth == 8)
        mpgScreenInit(pScreen, N_PLX_PLANEGROUPS, pPlxPrivate->pixmaps,
	          ( mpg_bit_encoded(PLX_COLOR_8)),
		  plxMpgVisInfo, plxMpgDepthInfo, PlxPGSwitch);
    else		/* It's 24 Bit - True or Direct Color */
	if(defclass == TrueColor)
            mpgScreenInit(pScreen, N_PLX_PLANEGROUPS, pPlxPrivate->pixmaps,
	          ( mpg_bit_encoded(PLX_COLOR_24)),
		  plxMpgVisInfo, plxMpgDepthInfo, PlxPGSwitch);
	else		/* Direct Color */
            mpgScreenInit(pScreen, N_PLX_PLANEGROUPS, pPlxPrivate->pixmaps,
	          ( mpg_bit_encoded(PLX_DIRECT_24)),
		  plxMpgVisInfo, plxMpgDepthInfo, PlxPGSwitch);
	
    /*
     *  Set up the default Clut table. Needed for MPG operations.
     */

    if (!cmapScreenInit(pScreen, &pDevFuncs, FALSE, 0, NULL,
    		CmapWidUnknown)) 
    {
		FatalError("TV2 failed cmapScreenInitExt\n");
    }
    pPlxPrivate->WindowExposures= pScreen->WindowExposures;
    pScreen->WindowExposures= PlxWindowExposures;
    pScreen->CopyWindow = PlxMpgCopyWindow;

    /*
     *  Initalize Xv Video extension.
     */

	XvplxVideoInit();

#ifdef NOTDEF
    XvExtensionInit(); 
#endif /* #### NOTDEF */
    /*
     * Start Parallax Video extension.
     */
    PlxVideoExtensionInit();
    /*
     *  Initailize Cursor and Direct color maps.
     */
    PlxInitializeColormaps(fd);
    /*
     * Set default foreground and background colors.
     */
    pScreen->whitePixel = 0xFFFFFF;
    pScreen->blackPixel = 0;

    sunSaveScreen(pScreen, SCREEN_SAVER_OFF);

    if (!sunScreenInit (pScreen))
	return FALSE;
/*
 *  Mpg	cursor initialization.
    mpgCursorInitialize(pScreen, PLX_CURSOR, PLX_CURSOR_ENABLE, TRUE);
 */

/*
 *	Window id screen initialization.
 */

/*
 * Initialization for new display
 */
    widScreenInit(pScreen, plxWidAlloc, plxWidFree, plxSetColorLut);
    vid = pScreen->visuals[PLX_COLOR_8].vid;
    pPlxPrivate->WidPtr8= widAllocate(pScreen,vid,1,FALSE,0);
    pPlxPrivate->wid8= widGetValue(pPlxPrivate->WidPtr8);
    vid = pScreen->visuals[PLX_COLOR_24].vid;
    pPlxPrivate->WidPtrTrue24= widAllocate(pScreen,vid,1,FALSE,0);
    pPlxPrivate->wid24True= widGetValue(pPlxPrivate->WidPtrTrue24);
    vid = pScreen->visuals[PLX_DIRECT_24].vid;
    pPlxPrivate->WidPtrDirect24= widAllocate(pScreen,vid,1,FALSE,0);
    pPlxPrivate->wid24Direct= widGetValue(pPlxPrivate->WidPtrDirect24);
/*
 *	Parallax clone of Shared memory initialization.
 */
    PlxShmExtensionInit();

    pScreen->defColormap = FakeClientID(0);

#if 0
    pScreen->SaveScreen = sunSaveScreen;
#endif

    /*
     *  Set this global to TRUE so all exposure events are
     *  accepted and processed. Required for Multiplanegroup framebuffers.
     */
	noMinExp = TRUE;
#ifdef DGA
    /*
     *  Initalize DGA funtion vector table.
     */
	DgaDevFuncsInit(pScreen, &plxDgaFuncs);
#endif DGA
    cfbCreateDefColormap(pScreen);

/* New cursor code
*/
    plxPointerInitialize(pScreen);
/* new screen saver code
*/
    pScreen->SaveScreen = plxSaveScreen;
    return 1;
}

plxGetPlnGrp(ScreenPtr pScreen)
{
    plxScreenPtr	pPlxPrivate;
    pPlxPrivate = GetPlxPrivate(pScreen);
    return(pPlxPrivate->pg);
}


/* ARGSUSED */
static Bool
PlxCloseScreen(index, pScreen)
    int index;
    ScreenPtr pScreen;
{
    sunScreenPtr	pSunPrivate;
    plxScreenPtr	pPlxPrivate;
    mpgPrivScreenPtr	mpgScrPriv;
    int			i;
  
    pSunPrivate = GetScreenPrivate(pScreen);
    pPlxPrivate = GetPlxPrivate(pScreen);

    mpgScrPriv =
	(mpgPrivScreenPtr)pScreen->devPrivates[mpgScreenPrivateIndex].ptr;
#if 0
    sunSaveScreen(pScreen, SCREEN_SAVER_OFF);
#else
    plxSaveScreen(pScreen, SCREEN_SAVER_OFF);
#endif
    plxv_reset_screen();
    widScreenClose(pScreen);
    for( i= 0;i < 3;i++)
    {
           if(munmap(pPlxPrivate->mapping[i].addr,
		     pPlxPrivate->mapping[i].len)== -1) 
			 Error( "plx munmap failed\n");
    }
    freeMpgInfo(&cursor_info);
    freeMpgInfo(&mono_chrome_info);
    freeMpgInfo(&pseudo_color_info);
    freeMpgInfo(&true_color_info);
    freeMpgInfo(&direct_color_info);
    close(pSunPrivate->sunFbs.fd);
#ifdef DEBUG_LEAK
    used_memory-= sizeof(plxScreenRec);
    fprintf(stderr,"CloseScreen: used_memory=%d\n",used_memory);
    scrn_mem--;
#endif
    xfree(pPlxPrivate);
    xfree(pSunPrivate); /* sun devPrivates */
    xfree(mpgScrPriv->pixmap); /* Free array of fake pixmaps */
/* #### plxFreeResources(pScreen); /* Free jpeg buffer */
    return(TRUE);
}
plxGetScreenFd(ScreenPtr pScreen)
{
plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);
	return(pPlxPrivate->tv2_video_fd);
}

XV_struct *PlxGetContext(ScreenPtr pScreen)
{
    hwlibPrivPtr  hwlibPriv;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);
    hwlibPriv = (hwlibPrivPtr) &pPlxPrivate->hwlibPriv;
	return(hwlibPriv->xv);
}

typedef struct {
	int *address;
	int len;
	}PLX_MAPS;

static Bool PlxMapIn(fd, pScreen)
    int		fd;
    ScreenPtr	pScreen;
{
    PLX_MAPS map_array[3];
    register PixmapPtr pPixmap;
    int		  width, height,n;
    hwlibPrivPtr  hwlibPriv;
    XV_struct *ctx;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);
    hwlibPriv = (hwlibPrivPtr) &pPlxPrivate->hwlibPriv;
    
/*
 *	Initialize Parallax video board registers, clear fb memory, and
 *      set in 8 bit mode.
 */

    /*
     * Map framebuffer and registers, initialize plx context.
     */
    ctx = (XV_struct *) plx_map_framebuffer(fd,&map_array);
    plxv_init_hw();
    /*
     * Initialize ccube compression qtable with default table .
	 * - ABW 11-16-95.
     */
    plxv_ccube_init(fd);
    pPlxPrivate->numMappings = 3;

    for( n= 0;n < pPlxPrivate->numMappings;n++)
    {
        pPlxPrivate->mapping[n].addr = (char *)map_array[n].address;
        pPlxPrivate->mapping[n].len = map_array[n].len;
    }
#ifdef DEBUG
    fprintf(stderr, "PlxMapIn ctx %x\n", ctx);
#endif
fflush(stderr); 

    hwlibPriv->xv= ctx;

    /* 
     * Set screen Width and Height from hardware register context.
     */
    width =pScreen->width = ctx->main.xsize;
    height =pScreen->height = ctx->main.ysize;

    /* 
     * Initializize the screen pixmaps for 1, 8, & 24 bit planes.
     */
#if 0
    initPixmap(pScreen, width, height, PixmapBytePad(width,1), 1,
	       &pPlxPrivate->pixmaps[PLX_COLOR_1],ctx->m1base);

    initPixmap(pScreen, width, height, PixmapBytePad(width,1), 1,
	       &pPlxPrivate->pixmaps[PLX_CURSOR],ctx->m1base);

    initPixmap(pScreen, width, height, PixmapBytePad(width,1), 1,
	       &pPlxPrivate->pixmaps[PLX_CURSOR_ENABLE],ctx->m1base);
#else
    initPixmap(pScreen, width, height, ctx->main.linebytes / 8, 1,
	       &pPlxPrivate->pixmaps[PLX_COLOR_1],ctx->m1base);

    initPixmap(pScreen, width, height, ctx->main.linebytes / 8, 1,
	       &pPlxPrivate->pixmaps[PLX_CURSOR],ctx->m1base);

    initPixmap(pScreen, width, height, ctx->main.linebytes / 8, 1,
	       &pPlxPrivate->pixmaps[PLX_CURSOR_ENABLE],ctx->m1base);
#endif

#if 0
    initPixmap(pScreen, width, height, PixmapBytePad(width, 8), 8,
	       &pPlxPrivate->pixmaps[PLX_COLOR_8],ctx->m8base);
#else
    initPixmap(pScreen, width, height, ctx->main.linebytes, 8,
	       &pPlxPrivate->pixmaps[PLX_COLOR_8],ctx->m8base);
#endif
#if 0
    initPixmap(pScreen, width, height, PixmapBytePad(width, 24), 24,
	       &pPlxPrivate->pixmaps[PLX_COLOR_24],ctx->m24base);

    initPixmap(pScreen, width, height, PixmapBytePad(width, 24), 24,
	       &pPlxPrivate->pixmaps[PLX_DIRECT_24],ctx->m24base);

#else
    initPixmap(pScreen, width, height, ctx->main.linebytes * 4, 24,
	       &pPlxPrivate->pixmaps[PLX_COLOR_24],ctx->m24base);

    initPixmap(pScreen, width, height, ctx->main.linebytes * 4, 24,
	       &pPlxPrivate->pixmaps[PLX_DIRECT_24],ctx->m24base);
#endif

#if 0
    initPixmap(pScreen, width, height, PixmapBytePad(width, 8), 8,
	       &pPlxPrivate->pixmaps[PLX_WID_PG],ctx->m8base);
#else
    initPixmap(pScreen, width, height, ctx->main.linebytes, 8,
	       &pPlxPrivate->pixmaps[PLX_WID_PG],ctx->m8base);
#endif

    return(TRUE);
}

static void
PlxmfbSetup(pScreen)
    ScreenPtr   pScreen;
{
    plxScreenPtr        pPlxPrivate=GetPlxPrivate(pScreen);
    pScreen->devPrivate = (pointer)&pPlxPrivate->pixmaps[PLX_COLOR_1];
}


static void
PlxCfbSetup(pScreen)
    ScreenPtr   pScreen;
{
    plxScreenPtr        pPlxPrivate=GetPlxPrivate(pScreen);
    pScreen->devPrivate = (pointer)&pPlxPrivate->pixmaps[PLX_COLOR_8];
}


static void
PlxCfbDirect32Setup(pScreen)
    ScreenPtr   pScreen;
{
    extern int cfb32ScreenPrivateIndex;
    plxScreenPtr        pPlxPrivate=GetPlxPrivate(pScreen);
    pScreen->devPrivate = (pointer)&pPlxPrivate->pixmaps[PLX_DIRECT_24];
    pScreen->devPrivates[cfb32ScreenPrivateIndex].ptr = pScreen->devPrivate;
}

static void
PlxCfb32Setup(pScreen)
    ScreenPtr   pScreen;
{
    extern int cfb32ScreenPrivateIndex;
    plxScreenPtr        pPlxPrivate=GetPlxPrivate(pScreen);
    pScreen->devPrivate = (pointer)&pPlxPrivate->pixmaps[PLX_COLOR_24];
    pScreen->devPrivates[cfb32ScreenPrivateIndex].ptr = pScreen->devPrivate;
}


Bool
plxCreateColormap(pcmap)
register ColormapPtr    pcmap;
{
 ScreenPtr pScreen;
}

PlxSetupScreens(pScreen)
    ScreenPtr	pScreen;
{
    plxScreenPtr	pPlxPrivate;
    extern int cfb32ScreenPrivateIndex;
    extern Bool		PlxCreateWindow();
    extern void 	PlxPaintWindow();

    pPlxPrivate = GetPlxPrivate(pScreen);

    mfbSetupScreen(pScreen, pPlxPrivate->pixmaps[PLX_COLOR_1].devPrivate,
		   pScreen->width, pScreen->height,
		   monitorResolution, monitorResolution,
		   pScreen->width);

    pScreen->devPrivate = (pointer)&pPlxPrivate->pixmaps[PLX_COLOR_1];
    pScreen->blackPixel = 1;
    pScreen->whitePixel = 0;
    mpgGetScreenState(pScreen, &mono_chrome_info, PlxmfbSetup, &PlxmfbBSFuncRec);

    cfb32SetupScreen(pScreen, pPlxPrivate->pixmaps[PLX_COLOR_24].devPrivate,
		     pScreen->width, pScreen->height,
		     monitorResolution, monitorResolution,
		     pScreen->width);

    pScreen->blackPixel = 0;
    pScreen->whitePixel = 0xFFFFFF;
    pScreen->CloseScreen = PlxCloseScreen;
    pScreen->CreateWindow= PlxCreateWindow;
    pScreen->DestroyWindow= PlxDestroyWindow;
    pScreen->PaintWindowBackground = PlxPaintWindow;
    pScreen->PaintWindowBorder = PlxPaintWindow;
    pScreen->UnrealizeWindow = PlxUnmapWindow;
    pScreen->CreatePixmap = plx32CreatePixmap;

    mpgGetScreenState(pScreen, &mono_chrome_info, PlxmfbSetup, &PlxmfbBSFuncRec);

#ifdef SPECIAL_CFB
    mpgGetScreenState(pScreen, &true_color_info,PlxCfb32Setup, &Plx32BSFuncRec);
#else
    mpgGetScreenState(pScreen, &true_color_info,PlxCfb32Setup, &cfb32BSFuncRec);
#endif
    mpgGetScreenState(pScreen, &direct_color_info,PlxCfbDirect32Setup, &Plx32BSFuncRec);
    pScreen->devPrivate = (pointer)&pPlxPrivate->pixmaps[PLX_COLOR_24];
    pScreen->devPrivates[cfb32ScreenPrivateIndex].ptr = pScreen->devPrivate;

    cfbSetupScreen(pScreen, pPlxPrivate->pixmaps[PLX_COLOR_8].devPrivate,
		     pScreen->width, pScreen->height,
		     monitorResolution, monitorResolution,
		     pScreen->width);

    pScreen->blackPixel = 0;
    pScreen->whitePixel = 0xFF;
    pScreen->CloseScreen = PlxCloseScreen;
    pScreen->CreateWindow= PlxCreateWindow;
    pScreen->DestroyWindow= PlxDestroyWindow;
    pScreen->PaintWindowBackground = PlxPaintWindow;
    pScreen->PaintWindowBorder = PlxPaintWindow;
    pScreen->UnrealizeWindow = PlxUnmapWindow;

    pPlxPrivate->CreateColormap = pScreen->CreateColormap;
    mpgGetScreenState(pScreen, &pseudo_color_info, PlxCfbSetup, &cfbBSFuncRec);

    pScreen->devPrivate = (pointer)&pPlxPrivate->pixmaps[PLX_COLOR_8];
}

void PlxEnterLeave(ScreenPtr pScreen, int select)
{
	printf("PlxEnterLeave pScreen= 0x%x select=%d\n",pScreen,select);
}
#define PFILL(x) ((x)<<16|(x)<<8|(x))

void PlxPGSwitch(ScreenPtr pScreen,	int pg)
{
        extern XV_struct	*xv_cp;

		hwlibPrivPtr  hwlibPriv;
        plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);

        hwlibPriv = (hwlibPrivPtr) &pPlxPrivate->hwlibPriv;


	if ( (int)hwlibPriv->xv != (int)xv_cp ) plxv_switch_context(hwlibPriv->xv);

        pPlxPrivate->pg=pg;	
        plxv_tag(PLXV_TAG_MASK_DISABLE,PLXV_TAG_DISABLE);
        plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
#ifdef NOT
	     ErrorF("PlxPGSwitch: to Color8\n");
	     ErrorF("PlxPGSwitch: to Color24\n");
	     ErrorF("PlxPGSwitch: to WID_PG\n");
#endif
	switch(pg)
	{
	case PLX_CURSOR_ENABLE:
	     plxv_rop(5);
	     plxv_wmask(PLXV_CURSOR_ENABLE_MASK);
	     plxv_colors_1(0x8fffffff,0,PLXV_CURSOR_MASK_SHIFTED);
	     break;
	case PLX_CURSOR:
	     plxv_rop(5);
	     plxv_wmask(PLXV_CURSOR_PLANE_MASK);
	     plxv_colors_1(0x4fffffff,0,PLXV_CURSOR_MASK_SHIFTED);
	     break;
	case PLX_COLOR_8:
#ifdef NOTDEF
	     plxv_stencil(PLXV_TAG_ST_MASK,pPlxPrivate->wid8);
#else
	     plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
#endif
	     plxv_wmask(PLXV_PIXEL_MASK);
	     break;
	case PLX_DIRECT_24:
	case PLX_COLOR_24:
#ifdef NOTDEF
	     plxv_stencil(PLXV_TAG_ST_MASK,pPlxPrivate->wid24True);
#else
	     plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
#endif
	     plxv_wmask(PLXV_PIXEL_MASK);
	     break;
	case PLX_WID_PG:
             plxv_transp_off();
	     plxv_wmask(PLXV_TAG_MASK_SHIFTED);
	     break;
	}
}
PlxBuildMpgInfo(pScreen)
    ScreenPtr	pScreen;
{

    mpgInsertPlanegroup(&mono_chrome_info, PLX_COLOR_1, 0,
			MPG_DRAWABLE, MPG_DRAW, 0);
    mpgInsertPlanegroup(&mono_chrome_info, PLX_WID_PG, 0,
			MPG_VISIBLE, MPG_FILL_WID,0);

    mpgInsertPlanegroup(&pseudo_color_info, PLX_COLOR_8, 0,
			MPG_DRAWABLE, MPG_DRAW, 0);
    mpgInsertPlanegroup(&pseudo_color_info, PLX_WID_PG, 0,
			MPG_VISIBLE, MPG_FILL_WID,0);

    mpgInsertPlanegroup(&true_color_info, PLX_COLOR_24, 0,
			MPG_DRAWABLE, MPG_DRAW, 0);
    mpgInsertPlanegroup(&true_color_info, PLX_WID_PG, 0,
			MPG_VISIBLE, MPG_FILL_WID,0);

    mpgInsertPlanegroup(&direct_color_info, PLX_DIRECT_24, 0,
			MPG_DRAWABLE, MPG_DRAW, 0);
    mpgInsertPlanegroup(&direct_color_info, PLX_WID_PG, 0,
			MPG_VISIBLE, MPG_FILL_WID,0);

    pScreen->maxInstalledCmaps = 2;
    pScreen->minInstalledCmaps = 1;

}
static void plxInitColormap24(fd)
int fd;
{
    struct fbcmap   cmap;		/* Structure to pass in ioctl. */
    int 	i_ramp;		/* Intensity and element in ramp accessing. */
    u_char  	ramp[256];	/* Red, green, and blue value for true color. */

    for (i_ramp=0; i_ramp < 256; i_ramp++) 
    {
        ramp[i_ramp] = i_ramp;
    }
    cmap.index = PIX_GROUP(PIXPG_24BIT_COLOR) | PR_FORCE_UPDATE;
    cmap.count =  256;
    cmap.red = cmap.green = cmap.blue = ramp;
    if (ioctl(fd, FBIOPUTCMAP, &cmap) == -1) 
    {
		perror("FBIOPUTMAP (24 bit) failed on tv2");
    }
}
static void
PlxInitializeColormaps(fd)
    int fd;
{
  int i;
			/* initialize the colormap luts with black*/
   fill_bt(0,528,0x0);
			/*  bg      ,   fg      */
   plxv_load_ash_cursor(0xff,0xff,0xff,0x0,0x0,0x0);
}

read_wtab()
{
  int i,val0,val1,val2,val;
  XV_WREG(DispKludge.b.disp_blank,1);
  set_bt463_addr(0x300 | (0x0 & 0xf));
  for(i=0;i<16;i++){
    XV_RREG(val0,Bt.red.reg2);
    XV_RREG(val1,Bt.red.reg2);
    XV_RREG(val2,Bt.red.reg2);
    val = (val0&0xff)|((val1&0xff)<<8)|((val2&0xff)<<16);
    ErrorF("val = 0x%x\n",val);
  }
  XV_WREG(DispKludge.b.disp_blank,0);
}

dump_bt()
{
  int i,red,green,blue;
  set_bt463_addr(0);
  for(i=0;i<528;i++){
    XV_RREG(red,Bt.red.reg3);
    XV_RREG(green,Bt.red.reg3);
    XV_RREG(blue,Bt.red.reg3);
  }
}

fill_bt(start,end,color)
int start,end;
unsigned int color;
{
  int i;
  set_bt463_addr(start);
  for(i=start;i<=end;i++){
    XV_WREG(Bt.red.reg3,(color>>16)&0xff);
    XV_WREG(Bt.red.reg3,(color>>8)&0xff);
    XV_WREG(Bt.red.reg3,(color&0xff));
  }
}

/*----------------------------------------------------------------------------*
 |"plxTV2storeColors"
 |
 |  Parallax TV2 device support to store one or more colors values into a
 |  color map.
 |
 |  Function value:
 |    = TRUE on success, FALSE if error occurred.
 *----------------------------------------------------------------------------*/
plxTV2storeColors(
	ColormapPtr pCmap, 
	CARD32 		clutId,
    int 		ndef, 
 	xColorItem *pdefs
)
{
    struct fbcmap sunCmap;
    unsigned char rmap[256], gmap[256], bmap[256];
    SetupScreen(pCmap->pScreen);
    VisualPtr       pVisual = pCmap->pVisual;

 
    sunCmap.red   = rmap;
    sunCmap.green = gmap;
    sunCmap.blue  = bmap;
 
    /*
     *  GET CURRENT COLOR LUT CONTENTS:
     */
	switch( pVisual->nplanes )
	{
	  case 1:
                sunCmap.index = 0;
		sunCmap.count = 4;
		break;
          case 8:
                sunCmap.index = PIX_GROUP(PIXPG_8BIT_COLOR) | PR_FORCE_UPDATE | 0;
		sunCmap.count = 256;
		break;
          case 24:
          case 32:
                sunCmap.index = PIX_GROUP(PIXPG_24BIT_COLOR) | PR_FORCE_UPDATE | 0;
		sunCmap.count = 256;
#ifdef DEBUG
		    fprintf(stderr, "plxTV2storeColors() Class = %x\n", pVisual->class);
#endif
		break;
	}
        sunCmap.red   = rmap;
        sunCmap.green = gmap;
        sunCmap.blue  = bmap;
 
    if (ioctl(pPrivate->sunFbs.fd, FBIOGETCMAP, &sunCmap) < 0) {
        Error("plxTV2storeColors: FBIOGETCMAP failed.\n");
        return(0);
    }
 
	/*  APPLY CHANGES TO COLOR LUT FOR 1- OR 8-BIT PLANEGROUP:
	 *
	 *  Color lut 0 is supposed to act like it's monochrome.  Thus,
	 *  don't allow separate channel changes.   If one flag is specified,    
	 *  treat as if they're all specified.  The DIX layer is expected
	 *  to ensure that the color data for all changes is identical.
	 */
    if (pVisual->nplanes <= 8) 
    {
 
        while (ndef--) {
            if (pdefs->flags & (DoRed|DoGreen|DoBlue)) {
                rmap[pdefs->pixel] = pdefs->red >> 8;
                gmap[pdefs->pixel] = pdefs->green >> 8;
                bmap[pdefs->pixel] = pdefs->blue >> 8;
            }
            pdefs++;
        }
    } 
	
/* 
 *	APPLY CHANGES TO 24-BIT COLOR LUT
 */
    else 
	if(pVisual->class == DirectColor)
	{
        Pixel           chanPix;
 
        while (ndef--) 
		{
            if (pdefs->flags & DoRed) 
			{
                chanPix = (pdefs->pixel & pVisual->redMask) >> pVisual->offsetRed;
                rmap[chanPix] = pdefs->red >> 8;
            }
            if (pdefs->flags & DoGreen) 
			{
                chanPix = (pdefs->pixel & pVisual->greenMask) >> pVisual->offsetGreen;
                gmap[chanPix] = pdefs->green >> 8;
            }
            if (pdefs->flags & DoBlue) 
			{
                chanPix = (pdefs->pixel & pVisual->blueMask) >> pVisual->offsetBlue;
                bmap[chanPix] = pdefs->blue >> 8;
            }
            pdefs++;
        }

	if(pVisual->class == TrueColor)
    	    return (1);
		
    }
 
    /* 
     *  UPDATE HARDWARE:
     */
#ifdef DEBUG
	fprintf(stderr, "plxTV2storeColors() Update HW\n");
#endif
    if (ioctl(pPrivate->sunFbs.fd, FBIOPUTCMAP, &sunCmap) < 0) 
	{
        Error("plxTV2StoreColors: FBIOPUTCMAP failed.\n");
        return(0);
    }

 
    return (1);
}

/*----------------------------------------------------------------------------*
 |"plxTV2writeClut"
 |
 |  Write a color map to a Parallax tv2 device.
 |
 |  Function value:
 |    = TRUE on success, FALSE if error occurred.
 *----------------------------------------------------------------------------*/
static int plxTV2writeClut(
	ColormapPtr pCmap, 		/* -> color map to load. */
	CARD32 		clutId		/* =  color lookup table index to be loaded. */
)
{
    SetupScreen(pCmap->pScreen);

    unsigned char 	bmap[256];
    Bool 			ballocs[256];
    extern XID 		clientErrorValue;
    int     		count = 256;
    unsigned char 	gmap[256];
    Bool 		gallocs[256];
    Pixel   		i;
    int     		offset = 0;
    EntryPtr      	pent;
    VisualPtr     	pVisual = pCmap->pVisual;
    Bool 		rallocs[256];
    unsigned char 	rmap[256];
    struct fbcmap 	sunCmap;


	/* 
	 *	SETUP BASED ON WHICH COLOR MAP IS TO BE WRITTEN:
	 */
	switch(pVisual->nplanes)
	{
	  case 1: 
        	sunCmap.index = PIX_GROUP(PIXPG_OVERLAY);
        	sunCmap.count = 3;
    		break;   
	  case 8: 
        	sunCmap.index = PIX_GROUP(PIXPG_8BIT_COLOR) | PR_FORCE_UPDATE | 0;
        	sunCmap.count = count;
		break;
	  case 24: 
        	sunCmap.index = PIX_GROUP(PIXPG_24BIT_COLOR) | PR_FORCE_UPDATE | 0;
        	sunCmap.count = count;
        	if(pVisual->class == DirectColor)
		    break;
		else
		    return;  /* TrueColor is in bypass mode, just return */
	  default :
		ErrorF("Invalid depth %d\n",pVisual->nplanes);
    }   
/*	fprintf(stderr, "plxTV2writeClut() Visual = (0x%x) Count = (0x%x)\n", pVisual->class, count); */
	dump_bt();
    sunCmap.red = &rmap[offset];
    sunCmap.green = &gmap[offset];
    sunCmap.blue = &bmap[offset];

/* 
 *	GET EXISTING COLOR MAP VALUES (WE MAY BE CHANGING SUBCOMPONENTS ONLY):
 */
    if (ioctl(pPrivate->sunFbs.fd, FBIOGETCMAP, &sunCmap) < 0) 
    {
        Error("plxTV2writeClut: FBIOGETCMAP failed.\n");
    	return(0);
    }

/*	fprintf(stderr, "plxTV2writeClut() Update HW\n"); */
	cmapGetColorData8 (pCmap, rmap, gmap, bmap, rallocs, gallocs, ballocs);

	/*
	 *  WRITE BACK CHANGED VALUES:
	 */
 	if (ioctl(pPrivate->sunFbs.fd, FBIOPUTCMAP, &sunCmap) < 0) 
	{
            Error("plxTV2writeClut: FBIOPUTCMAP failed.\n");
            return(0);
        }
 
    return(count);
}
