#pragma ident "@(#)sunPlx.h     1.10 93/04/26   SMI"

#ifndef _PLX_H
#define _PLX_H

#include "plxv.h"
#include     "mpg/mpg.h"
#include     "mpg/wid.h"
#include "rtv.h"

#define PLX_WIDTH       1152
#define PLX_HEIGHT      900
#define INIT_VAL 0xAA55AA55
#define FULL_FB_MAPSIZE 0x534800

#ifdef WORKS
#define PLX_DIRECT_COLOR_TAG    0x0
#define PLX_PSEUDO_COLOR_TAG    0x1
#define PLX_TRUE_COLOR_TAG      0x2 
#define PLX_VIDEO_TAG           0x3 
#else
                /* pre-defined window ID's */
#define PLX_PSEUDO_COLOR_TAG    0x0
#define PLX_DIRECT_COLOR_TAG    0x1
#define PLX_TRUE_COLOR_TAG      0x2 
#define PLX_VIDEO_TAG           0x3 
#endif

#define PLX_PSEUDO_COLOR_CLUT 0
#define PLX_TRUE_COLOR_CLUT  1
#define PLX_DIRECT_COLOR_CLUT  2

#define PLX_MAX_PSEUDO_ST       0xf
#define PLX_MAX_TRUE_COLOR_ST   0xf
#define PLX_MAX_VIDEO_ST        0xf

#define PSEUDO_COLOR_WINDOW_TYPE 0
#define TRUE_COLOR_WINDOW_TYPE 1
#define DIRECT_COLOR_WINDOW_TYPE 2

#define PLX_TRUE_COLOR_MAX_CLUTS 1
#define PLX_PSEUDO_COLOR_MAX_CLUTS 1
#define ON 1
#define OFF 0

#define PLX_WINDOW_TYPE 1
#define XV_WINDOW_TYPE 2

                                /* masks */
#define PLXV_TAG_MASK_SHIFTED           0x3F000000
#define PLXV_CURSOR_MASK_SHIFTED        0xC0000000
#define PLXV_CURSOR_ENABLE_MASK         0x80000000
#define PLXV_CURSOR_PLANE_MASK          0x40000000
                                /* unshifted masks */
#define PLXV_TAG_MASK      0x3F
#define PLXV_ST_MASK       0x3F
#define PLXV_TAG_ST_MASK   0x3F
#define PLXV_CURSOR_MASK   0xC0

                                /* disable masks */
#define PLXV_TAG_DISABLE      0x0
#define PLXV_ST_DISABLE       0x0
#define PLXV_TAG_MASK_DISABLE 0x0
#define PLXV_ST_MASK_DISABLE  0x0

#define PLXV_TAG_ST_PIXEL_MASK  0x3fffffff
#define PLXV_PIXEL_MASK         0x00ffffff

#define PLX_MMAP_SIZE   PLX_COLOR_SIZE + PLX_ENABLE_SIZE + PLX_OVERLAY_SIZE
enum plx_planegroup {
    PLX_COLOR_1=0,
    PLX_COLOR_8,
    PLX_COLOR_24,
	PLX_DIRECT_24,
    PLX_WID_PG,
    PLX_CURSOR,
    PLX_CURSOR_ENABLE,
    N_PLX_PLANEGROUPS,
    };

#define PLX_PSEUDO_VISUAL 1
#define PLX_TRUE_VISUAL 2
#define plxPMSK 0xFFFFFF

typedef struct {
        int     rop;
        int     plane_enable;
        int     bcol;
        int     col;
        }ATTRS;

#define PLX_MAX_MAPPINGS N_PLX_PLANEGROUPS

#define WidPriv   1
#define VideoPriv 2

typedef struct {
        CursorPtr  pCursor;
        int     x, y;
} plxPointerRec, *plxPointerPtr;

struct plxmapping {
    caddr_t addr;
    int len;
};
int plxGCPrivateIndex;
int plxScreenPrivateIndex;
int plxWindowPrivateIndex;
#define WindowVisual(w) ((w)->optional? \
                         (w)->optional->visual : \
                         ((w)->parent ? \
                          FindWindowWithOptional(w)->optional->visual : 0))

u_int planemask_8;
u_int planemask_24;
u_int wid_plnmsk;
int OverlayMask;

typedef struct {
    int                 window_type;    /* type of window : graphics, */
                                        /* video, or graphics over video */
    int                 channel;        /* video input or output channel */
    int                 standard;       /* video signal standard : NTSC or */
                                        /* PAL */
    int                 format;         /* video signal format : COMP, YC, */
                                        /* RGB or YUV */
    int                 type;           /* digital-storage-format, RGB24 */
    int                 xdirection;     /* x video draw direction 0 = l to r */
    int                 ydirection;     /* y video draw direction 0 = d */
    int                 video_tag;      /* video tag associated with window */
    int                 gov_mode;
    int                 gov_tag;        /* wid value associated with graphics*/
    GCPtr               pGC;
	ScreenPtr			pScreen;		/* Screen pointer. */
	WidPtr 				pWid;			/* Window id or 0 if using window's. */
    short               *qtab;          /* QTable pointer */
    short               *htab;          /* HTable pointer */
    } TV2Priv;


typedef struct _hwlibPrivate {
    XV_struct   *xv;
} hwlibPrivRec;

typedef struct _hwlibPrivate *hwlibPrivPtr;

typedef struct _PlxGC {
    int                 linebytes;      /* Linebytes */
    unsigned long       planemask;
    int                 bpp;            /* bytes per pixel */
    int                 rop;
    int                 fg,bg;
    int                 wid_value;
    int                 win_type;
    int                 *video_priv;
} plxGCRec, *plxGCPtr;

#define MAX_WIDS_16 16
#define MAX_WIDS 32
typedef struct _plxWidTableRec {
        int index;
        WidPtr pWid;
        WindowPtr pWin;
} plxWidTableRec, *plxWidTablePtr;

typedef struct _PLXChannel {
    WindowPtr   window;
    short       port, output;
    int         vx, vy, vw, vh, xs, ys, xe, ye;
    short       xdir, ydir;
    short       xorg, yorg;
    short       vtag;
    } PLXChannelRec;
typedef struct _PLXChannel *PLXChannelPtr;

typedef struct plxScreen {
    short*              compression_qtable;
    int                 copy_done;
    int*                c3buf1;
    short*              decompression_qtable;
    struct _hwlibPrivate* hwlibPriv;
    struct plxmapping   mapping[10];
    int                 numMappings;
    int                 pg;
    PixmapRec           pixmaps[10];
    PLXChannelRec       plxvideochannel[2];
    int                 tv2_video_fd;
    int                 wid8;
    int                 wid24True;
    int                 wid24Direct;
    int                 video_active;
    int                 video_restored;
    plxWidTableRec      WidPtrDirectVideo[MAX_WIDS_16];
    WidPtr              WidPtrDirect24;
    plxWidTableRec      WidPtrTrueVideo[MAX_WIDS];
    WidPtr              WidPtrTrue24;
    WidPtr              WidPtr8;
    plxPointerPtr       plxPointer;
    struct _PlxGC       *privGC[N_PLX_PLANEGROUPS];
    Bool                (* CreateColormap)();   /* pcmap */
    void                (* ClearToBackground)();        /* Clear background */
    void                (* WindowExposures)(); /* Hold default WindowExposure */
} plxScreenRec, *plxScreenPtr;

typedef struct _plxPrivWinRec {
    int         explicitPrepare; /* = 1 if client does surface prep. */
    int         hash;
    int         mapped;
	RTV_STRUCT  rtv;					/* RTV server information. */
	int			rtv_track;		/* RTV tracking mode (see enum below). */
    int         video_active;
    int         video_type;
    int         video_wid_set;  /* = 1 if a video wid has been allocated. */
    int         wid;
    int         *widptr;
    int         window_type;
    int         *barfVideo_Priv;
    }plxWinRec, *plxPrivWinPtr;

enum {                  /* rtv_track modes: */
	RtvTrackNone = 0,	/* Don't track this window for RTV. */
	RtvTrackGetCImage,	/* Track this window for GetCImage operations. */
	RtvTrackPutCImage	/* Track this window for PutCImage operations. */
};

#define GetPlxPrivate(pScreen) (plxScreenPtr)(pScreen)->devPrivates[plxScreenPrivateIndex].ptr;
Bool plxCreateGC();

#define PlxGCPrivate(g) \
  ((g)->devPrivates[plxGCPrivateIndex].ptr)
#define GetPlxGCPrivate(g) (plxGCPtr) PlxGCPrivate(g)

#ifdef DEBUG
#define TRACE(x) ErrorF x
#else  
#define TRACE(X)
#endif

#endif _PLX_H



