#ident "@(#)mpgwindow.c	1.13 93/05/18 MPG SMI"

/*
 * Multiple planegroup window routines.
 */

#include <stdio.h>
#include "mpg.h"

extern mpgPlanes oldPlanes;
extern mpgPlanes newPlanes;
extern void mpgCopyClips();
extern RegionPtr pOldRegions[];
extern RegionPtr pNewRegions[];
extern void mpgPrepareRegionList();

extern void miWindowExposures();
extern void miClearToBackground();

void
PlxMpgCopyWindow(pWin, ptOldOrg, prgnSrc)
    DDXPointRec ptOldOrg;
    register WindowPtr pWin;
    register RegionPtr prgnSrc;
{
    int i, j, dx, dy;
    mpgPlanes planes;
    register GCPtr pGC;
    register DrawablePtr pDrawable;
    register RegionPtr prgnDst, tmpRegion;
    register ScreenPtr pScreen = pWin->drawable.pScreen;
   
    planes = mpg_tree_planes(pWin);
    dx = ptOldOrg.x - pWin->drawable.x;
    dy = ptOldOrg.y - pWin->drawable.y;

    prgnDst = (* pScreen->RegionCreate)(NULL, 1);
    (* pScreen->TranslateRegion)(prgnSrc, -dx, -dy);
    (* pScreen->Intersect)(prgnDst, &pWin->borderClip, prgnSrc);
    mpgCheckAndDropCursor(pScreen, planes, prgnDst, NULL);
    (* pScreen->TranslateRegion)(prgnDst, dx, dy);
    mpgCheckAndDropCursor(pScreen, planes, prgnDst, NULL);
    (* pScreen->TranslateRegion)(prgnDst, -dx, -dy);

    /* reduce flashing by copying images first */
    for (i = mpg_max_pgs; planes && (i >= 0); i--) {
        j = mpg_bit_encoded(i);
        if (mpg_intersect(planes, j)) { /* found planegroup */
            planes = mpg_subtract(planes, j); /* AND it out */
            pDrawable = mpgDrawable(pScreen, i);
            tmpRegion =  (* pScreen->RegionCreate)(NULL, 1);
            (* pScreen->RegionCopy)(tmpRegion, prgnDst);
            pGC = GetScratchGC(pDrawable->depth, pScreen);
            (*pGC->funcs->ChangeClip)(pGC, CT_REGION, tmpRegion, 0);
            ValidateGC(pDrawable, pGC);

	    plxMpgCopyArea(pDrawable, pDrawable, pGC,
                prgnDst->extents.x1 + dx, prgnDst->extents.y1 + dy,
                prgnDst->extents.x2 - prgnDst->extents.x1,
                prgnDst->extents.y2 - prgnDst->extents.y1,
                prgnDst->extents.x1, prgnDst->extents.y1);

            (*pGC->funcs->ChangeClip)(pGC, CT_NONE, 0, 0);
            FreeScratchGC(pGC);
        }
    }    
}
