/*
 * Push Pixels for 8 bit displays.
 */

/*
Copyright 1989 by the Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the software
without specific, written prior permission.  M.I.T. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.
*/

#define PSZ 8

#include	<stdio.h>
#include	"sun.h"
#include	"X.h"
#include	"Xmd.h"
#include	"Xproto.h"
#include	"gcstruct.h"
#include	"windowstr.h"
#include	"scrnintstr.h"
#include	"pixmapstr.h"
#include	"regionstr.h"
#include	"cfb.h"
#include	"cfbmskbits.h"
#include	"cfb8bit.h"
#include	"plxInit.h"

extern void mfbPushPixels();
extern XV_struct *PlxGetCtx();
extern int plxroptbl[];

void
plxPushPixels8 (pGC, pBitmap, pDrawable, dx, dy, xOrg, yOrg)
    GCPtr	pGC;
    PixmapPtr	pBitmap;
    DrawablePtr	pDrawable;
    int		dx, dy, xOrg, yOrg;
{
    register unsigned long   *src, *dst;
    register unsigned long   pixel;
    register unsigned long   c, bits;
    unsigned long   *pdstLine, *psrcLine;
    unsigned long   *pdstBase;
    int		    srcWidth;
    int		    dstWidth;
    unsigned long   rightMask;
    BoxRec	    bbox;
    cfbPrivGCPtr    devPriv;
    int n;
    XV_struct 		*xv_context=PlxGetCtx(pGC->pScreen);

    bbox.x1 = xOrg;
    bbox.y1 = yOrg;
    bbox.x2 = bbox.x1 + dx;
    bbox.y2 = bbox.y1 + dy;
    devPriv = (cfbPrivGC *)pGC->devPrivates[cfbGCPrivateIndex].ptr;
    
    switch ((*pGC->pScreen->RectIn)(devPriv->pCompositeClip, &bbox))
    {
      case rgnPART:
	mfbPushPixels(pGC, pBitmap, pDrawable, dx, dy, xOrg, yOrg);
      case rgnOUT:
	return;
    }

    cfbGetLongWidthAndPointer (pDrawable, dstWidth, pdstBase)

    psrcLine = (unsigned long *) pBitmap->devPrivate.ptr;
    srcWidth = (int) pBitmap->devKind >> 2;
    
    {
     /*
      *	Draw pixels to the one bit framebuffer while in transparent mode
      * using map_ctl which allows for 32 bit writes.
      */
	    int offset,start,end,fgcol;

            fgcol= 0x01000000 | pGC->fgPixel<<16 | pGC->fgPixel<<8 | pGC->fgPixel;
	/*
	 * Calculate source and destination pointers as 32 bit aligned.
	 */
            pdstBase = (u_long *)xv_context->m1base;
	    dstWidth = 36; /* number of 32 bit words in screen size of 1152 */
            pdstLine = pdstBase + (yOrg * dstWidth) + (xOrg >> 5);
	/*
	 * Set the offset variable based on the starting pixel of the 
	 * destination modulo 32. (xOrg & 0x1f).
	 */
            offset= xOrg&0x1f;
	/*
	 * Set the end value based on "dx" , the length in bits
	 * of the source pixels.
	 */
	    if(dx>32)
	        end=31;
	    else
	        end = (dx-1)&0x1f;
	    plxv_map_ctl(0,end,offset);
	/*
	 * Loop thru the height of the source (dy) and increment
	 * the long word aligned destination.
	 */
            while (dy--)
            {
	/*
	 * TODO:
	 *  - test srcWidth > 0 use 31 as end for first access.
	 *  eg (plxv_map_ctl(0,31,offset);
	 */
	 
	        src = psrcLine;
	        dst = pdstLine;
       /*
	* Copy all full width pixels here.
	*/
	        *dst++ = *src++;
	/*
	 * Do Last pixel here.
	 * Reset the variable "end" if source > 0 long words
	 * and copy remaining long words of source.
	 */
	        pdstLine += dstWidth;
	        psrcLine += srcWidth;
            }
            plxv_map_ctl(0,31,0);
     }
}
