/*
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 */

#define NEED_EVENTS

#include        <stdio.h>
#include        <signal.h>
#include        <sys/unistd.h>
#include        <sys/types.h>
#include        <sys/time.h>
#include        <sys/fbio.h>
#include        <alloca.h>

#define PSZ 32

#include "Xmd.h"
#include "X.h"
#include "Xproto.h"

#include     "mpg/mpg.h"
#include     "mpg/wid.h"

#include "pixmapstr.h"
#include "regionstr.h"
#include "scrnintstr.h"
#include "servermd.h"
#include "windowstr.h"
#include "gcstruct.h"
#include "dixstruct.h"
#include "input.h"
#include "cursorstr.h"
#include "colormapst.h"
#include "mi.h"
#include "cfb.h"
extern void miRecolorCursor();          /* not in mi.h */
extern void miClipNotify();             /* not in mi.h */
#include "mistruct.h"
#include "mibstore.h"
#include "osstruct.h"
#include "selection.h"
#include "opaque.h"
/*
#include "inputstr.h"
*/

#include "plxv.h"
#include "plxv_xpoint.h"
#include "plxvideo.h"
#include "plxInit.h"

/*  XV_DIAG FLAGS MEANINGS:
 *
 *    0x40 - Request tracing.
 *    0x20 - RTV support tracing.
 *       1 - normal one-shot debugging
 * #define XV_DIAG 0x40
 */
#include "xvdebug.h"

#define CHECKWIN(p) if(((DrawablePtr)p)->type != DRAWABLE_WINDOW) \
	return BadDrawable

extern FILE *errfp;

#define xv_QueryExtension                  0
#define xv_QueryAdaptors                   1
#define xv_QueryEncodings                  2
#define xv_GrabPort                        3
#define xv_UngrabPort                      4
#define xv_PutVideo                        5
#define xv_PutStill                        6
#define xv_GetVideo                        7
#define xv_GetStill                        8
#define xv_StopVideo                       9
#define xv_SelectVideoNotify              10
#define xv_SelectPortNotify               11
#define xv_QueryBestSize                  12
#define xv_SetPortAttribute               13
#define xv_GetPortAttribute               14
#define xv_PlxScaleCopyArea               15  /* Parallax requests begin here */
#define xv_PlxGetCImage                   16
#define xv_PlxPutCImage                   17
#define xv_PlxPutQTable                   18
#define xv_PlxShmGetCImage                19
#define xv_PlxShmPutCImage                20
typedef unsigned long ShmSeg;


extern int video_active;

typedef struct _ShmDesc {
    struct _ShmDesc *next;
    int shmid;
    int refcnt;
    char *addr;
    Bool writable;
    unsigned long size;
} ShmDescRec, *ShmDescPtr;

typedef struct _ShmCompletion {
    BYTE        type;           /* always eventBase + ShmCompletion */
    BYTE        bpad0;
    CARD16      sequenceNumber B16;
    Drawable    drawable B32;
    CARD16      minorEvent B16;
    BYTE        majorEvent;
    BYTE        bpad1;
    ShmSeg      shmseg B32;
    CARD32      offset B32;
    CARD32      pad0 B32;
    CARD32      pad1 B32;
    CARD32      pad2 B32;
} xShmCompletionEvent;


TV2Priv *GetTv2Priv(),*SetTv2Priv();
TV2Priv *glb_tv2_priv;

extern void (* ReplySwapVector[256]) ();
extern void Swap32Write();

extern unsigned char PlxShmReqCode;
extern int PlxShmCompletionCode;
extern int PlxBadShmSegCode;
extern RESTYPE PlxShmSegType;

extern XV_struct *xv_ctx;

static int rtv_state=0; /* Added by ABW - 12-29-95 */

#ifndef swapl
#include "misc.h"
#endif

#define CHANNEL_V       0
#define CHANNEL_W       1
#define NTSC_WIDTH      640
#define NTSC_HEIGHT     525
#define NTSC_HEIGHT_HALF 241
#define NTSC_BLANK      43
#define NTSC_RATE       60
#ifdef notdef
#define NTSC_SLEEP      70000
#else
#define NTSC_SLEEP      35000
#endif
#define PAL_WIDTH       768
#define PAL_HEIGHT      625
#define PAL_HEIGHT_HALF 287
#define PAL_BLANK       50
#define PAL_RATE        60
#ifdef notdef
#define PAL_SLEEP       100000
#else
#define PAL_SLEEP       50000
#endif

#ifdef hpux
extern int xosGCPrivateIndex;
#define cfbGCPrivateIndex xosGCPrivateIndex 
#endif

typedef struct _PLXPort {
    int         io_type;
    XV_knob_rec knob;
    } PLXPortRec;

PLXPortRec plxvideoport[4];

int input1_port = ~0;
int output0_port = ~0;

static int q_factor=80;

/*
 * this is a copy of the current video state, move it into a GC
 * sometime
 */

struct plxvideomodes {
    int framemode;      /* frame or field */
    int framestart;     /* even, odd or dont care */
    struct {
        int luma;       /* dither control */
        int chroma;
    } dither;
    int input;          /* input 1 or input 2 */
    int priority;       /* 0,1,2,3 relative pri gived to video */
    short vparam[6];    /* sat, cont, lgain, cgain, hue, brit */
} plxvideomodes;

#ifdef STOP_VIDEO
void plxGetVidChannel( vidchannel )
        PLXChannelRec vidchannel[2];
{
        int i;
            for (i=0; i<2 ;i++) vidchannel[i] = plxvideochannel[i];
        return;
}
#endif

void MyUSleep(microseconds)
     unsigned int microseconds;
{
  int                   descriptorTableSize = 0;
  int                   result;
  struct timeval        waitTime;
  
  descriptorTableSize = sysconf(_SC_OPEN_MAX);
  waitTime.tv_sec = 0;                  
  waitTime.tv_usec = microseconds;
  result = select(descriptorTableSize,
                      (fd_set*)0, (fd_set*)0,(fd_set*)0,
                      &waitTime);               
  return;
}

/*
 *  ALLOCATE A VIDEO CHANNEL FOR USE.
 */
int allocate_channel(pScreen, pDrawable, port)
    ScreenPtr   pScreen;
    DrawablePtr pDrawable;
    int         port;
{
    int           channel;      /* Channel to return. */
    plxScreenPtr  pPlx;		/* Per-screen context for Parallax cards. */
    plxPrivWinPtr plxWinPtr = (plxPrivWinPtr)plxGetPwinPriv(pDrawable);

	CHECKWIN(pDrawable);
	if(plxWinPtr->rtv_track != RtvTrackNone)
	{
		rtv_state= plxWinPtr->rtv_track; /* Added by ABW 12-29-95 */
		return(CHANNEL_V);
	}

    pPlx =  GetPlxPrivate(pScreen);

    if ( pPlx->plxvideochannel[CHANNEL_V].window == 0 ||
         (pPlx->plxvideochannel[CHANNEL_V].window == (WindowPtr) pDrawable) &&
         (pPlx->plxvideochannel[CHANNEL_V].port == port)
    )
    {
        channel = CHANNEL_V;
    }
    else
    {
        channel = CHANNEL_W;
    }
    return channel;
}

#ifdef REMOVE
/*
 * This procedure sets up the tag for graphics operation only.
 */
xplxv_setup_tag (pDrawable, pGC, depth)
register DrawablePtr pDrawable;
GCPtr pGC;
register int depth;
{

    plxScreenPtr  pPlx;         /* Per-screen context for Parallax cards. */
    TV2Priv*      tv2_priv;
    int           wtype = PLX_UNKNOWN; 

    pPlx=  GetPlxPrivate(pScreen);
    if (pGC)
    {
        tv2_priv = SetTv2Priv(pDrawable,pGC);
        wtype = tv2_priv->window_type;
    }

    switch (wtype)
    {
        case PLX_VIDEO_OVR:
            plxv_tag(PLXV_TAG_MASK_DISABLE,PLXV_TAG_DISABLE);
            break;
        case PLX_VIDEO:
            if (tv2_priv->video_tag &&
                (plxvideochannel[CHANNEL_V].window == (WindowPtr) pDrawable ||
                 plxvideochannel[CHANNEL_W].window == (WindowPtr) pDrawable))
                plxv_tag(PLXV_TAG_ST_MASK,tv2_priv->video_tag);
            break;
        case PLX_UNKNOWN:
        case PLX_GRAPHICS:
            if (depth == 8)
                plxv_tag(PLXV_TAG_ST_MASK, PLX_PSEUDO_COLOR_TAG);
            else
                plxv_tag(PLXV_TAG_ST_MASK, PLX_TRUE_COLOR_TAG);
            break;
    }
}
#endif /* REMOVE */


static void plxdrawback (pDrawable, pGC, x, y, w, h)
register DrawablePtr pDrawable;
register GCPtr pGC;
int x, y, w, h;
{
    RegionPtr prgnClip;
    register BoxPtr pbox;       /* used to clip with */
    register BoxPtr pboxClipped;
    BoxPtr pextent;
    BoxRec box;
	RTV_OBJECT *rtv_hndl;
    int n, x2, y2, rgnResult;
    cfbPrivGC *pPriv;
    plxPrivWinPtr plxWinPtr = (plxPrivWinPtr)plxGetPwinPriv(pDrawable);

    if(pDrawable->type != DRAWABLE_WINDOW)
	return;

    pPriv =(cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr);
    prgnClip = pPriv->pCompositeClip;
    pextent = (*pGC->pScreen->RegionExtents)(prgnClip);

    box.x1 = x;
    if(box.x1 < pextent->x1)
        box.x1 = pextent->x1;
    box.y1 = y;
    if(box.y1 < pextent->y1)
        box.y1 = pextent->y1;
    x2 = x + w;
    if (x2 > pextent->x2)
        x2 = pextent->x2;
    box.x2 = x2;
    y2 = y + h;
    if (y2 > pextent->y2)
        y2 = pextent->y2;
    box.y2 = y2;

    if ((box.x1 > box.x2) || (box.y1 > box.y2))
        return;

    n=REGION_NUM_RECTS(prgnClip);
    rgnResult = (*pGC->pScreen->RectIn)(prgnClip, &box);
    if (rgnResult == rgnPART)
    {
        pboxClipped = (BoxPtr)xalloc(sizeof(BoxRec));
        if(!pboxClipped)
            return;

        n = REGION_NUM_RECTS(prgnClip);
        pbox = REGION_RECTS(prgnClip);
        while (n--)
        {
            pboxClipped->x1 = max(box.x1, pbox->x1);
            pboxClipped->y1 = max(box.y1, pbox->y1);
            pboxClipped->x2 = min(box.x2, pbox->x2);
            pboxClipped->y2 = min(box.y2, pbox->y2);
            pbox++;

            /* see if clipping left anything */
            if(pboxClipped->x1 <= pboxClipped->x2 &&
               pboxClipped->y1 <= pboxClipped->y2)
            {

                plxv_box(pboxClipped->x1, pboxClipped->y1,
                         (pboxClipped->x2 - pboxClipped->x1) + 1,
                         (pboxClipped->y2 - pboxClipped->y1) + 1);
            }
        }
        xfree(pboxClipped);
    }
    else if(n == 1)
    {
        plxv_box(box.x1, box.y1, (box.x2 - box.x1) + 1, (box.y2 - box.y1) + 1);
    }
        
    plxv_wmask(PLXV_PIXEL_MASK);
}

plxGetVideoType(GCPtr pGC)
{
    TV2Priv *tv2_priv=GetTv2Priv(pGC);
    return(tv2_priv->standard);
}
int
PlxVideoProc (pDrawable, pGC, videoReqType, xva, client)
DrawablePtr pDrawable;
GCPtr pGC;
int videoReqType;
xVideoArgs *xva;
ClientPtr client;
{
    short xorg, yorg;
    Bool goingtodraw = FALSE;
    BoxRec r;
    xCVideoArgs *xcva;
    DrawablePtr sdraw;
    short video_max_width;
    short video_max_height;
    TV2Priv *tv2_priv;
    plxPrivWinPtr plxWinPtr;
    plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pGC->pScreen);
    plxWinPtr = (plxPrivWinPtr)plxGetPwinPriv((WindowPtr) pDrawable);
    xorg = yorg = 0;


    if(pGC)
    {
      glb_tv2_priv =tv2_priv = SetTv2Priv(pDrawable,pGC);
      if (pDrawable->type == DRAWABLE_WINDOW && pGC->miTranslate)
      {
	/* plxWinPtr only good if window */
        plxWinPtr->video_type= tv2_priv->standard;

        xorg = pDrawable->x;
        yorg = pDrawable->y;
      }

      if (tv2_priv->standard == PLX_NTSC)
      {
        video_max_width = NTSC_WIDTH;
        video_max_height = NTSC_HEIGHT;
      }
      else if (tv2_priv->standard == PLX_PAL || tv2_priv->standard == PLX_SECAM)
      {
        video_max_width = PAL_WIDTH;
        video_max_height = PAL_HEIGHT;
      }
      else
      {
        video_max_width = 0;
        video_max_height = 0;
      }
    }
/*
 *  Added to switch context for different screens (ABW 7-15-94).
 */
    plxv_switch_context(PlxGetCtx(pGC->pScreen));

    switch (videoReqType) {
        case X_VideoSet:
	    DEBUGF(0x40, (fd, "PlxVideoSet: entry and exit\n"));
            return (Success);
        case X_VideoLive:
	    CHECKWIN(pDrawable);
            if (!video_max_width || !video_max_height)
                return (BadMatch);

            if (xva->w > video_max_width)
                xva->w = video_max_width;
            if (xva->h > video_max_height)
                xva->h = video_max_height;
            xva->x += xorg;
            xva->y += yorg;
            if(plxWinPtr && (plxWinPtr->video_active == 0))
            {
                 plxWinPtr->video_active=1;
                 if(pPlxPrivate->video_active<=3)
                 {
                     pPlxPrivate->video_active++;
                     video_active=pPlxPrivate->video_active;
                 }
            }
            plxVideoLive(pDrawable, pGC, xva->vx, xva->vy,
                         xva->x, xva->y, xva->w, xva->h, 0);
            break;
        case X_VideoFlipLive:
            return (Success);
        case X_VideoStill:
	    CHECKWIN(pDrawable);
            if (!video_max_width || !video_max_height)
                return (BadMatch);

            if (xva->w > video_max_width)
                xva->w = video_max_width;
            if (xva->h > video_max_height)
                xva->h = video_max_height;
            xva->x += xorg;
            xva->y += yorg;

/*
            if(plxWinPtr && (plxWinPtr->video_active == 0))
            {
                plxWinPtr->video_active=0;
                if(pPlxPrivate->video_active>0)
                {
                    pPlxPrivate->video_active--;
                    video_active= pPlxPrivate->video_active;
                }
            }
*/
            plxVideoStill(pDrawable, pGC, xva->vx, xva->vy,
                          xva->x, xva->y, xva->w, xva->h);
            return;
            break;
        case X_VideoSqueezeLive:
	    CHECKWIN(pDrawable);
            if (!video_max_width || !video_max_height)
                return (BadMatch);

            if (xva->w > video_max_width)
                xva->w = video_max_width;
            if (xva->h > video_max_height)
                xva->h = video_max_height;
            if ((xva->vw + xva->vx) > video_max_width)
                xva->vw = video_max_width - xva->vx;
            if (xva->vw < xva->w)
                xva->vw = xva->w;
            if ((xva->vh + xva->vy) > video_max_height)
                xva->vh = video_max_height - xva->vy;
            if (xva->vh < xva->h)
                xva->vh = xva->h;
            xva->x += xorg;
            xva->y += yorg;

            if(plxWinPtr && (plxWinPtr->video_active == 0))
            {
                 plxWinPtr->video_active=1;
                 if(pPlxPrivate->video_active<=3)
                 {
                     pPlxPrivate->video_active++;
                     video_active=pPlxPrivate->video_active;
                 }
            }
            plxVideoSqueezeLive(pDrawable, pGC, xva->vx, xva->vy,
                                xva->vw, xva->vh, xva->x, xva->y,
                                xva->w, xva->h);
            break;
        case X_VideoSqueezeStill:
	    CHECKWIN(pDrawable);
            if (!video_max_width || !video_max_height)
                return (BadMatch);

            if (xva->w > video_max_width)
                xva->w = video_max_width;
            if (xva->h > video_max_height)
                xva->h = video_max_height;
            if ((xva->vw + xva->vx) > video_max_width)
                xva->vw = video_max_width - xva->vx;
            if (xva->vw < xva->w)
                xva->vw = xva->w;
            if ((xva->vh + xva->vy) > video_max_height)
                xva->vh = video_max_height - xva->vy;
            if (xva->vh < xva->h)
                xva->vh = xva->h;
            xva->x += xorg;
            xva->y += yorg;
            /*
            if(plxWinPtr && (plxWinPtr->video_active == 0))
            {
                plxWinPtr->video_active=0;
                if(pPlxPrivate->video_active>0)
                {
                    pPlxPrivate->video_active--;
                    video_active=pPlxPrivate->video_active;
                }
            }
            */
            plxVideoSqueezeStill(pDrawable, pGC, xva->vx, xva->vy,
                                 xva->vw, xva->vh, xva->x, xva->y,
                                 xva->w, xva->h);
            return;
            break;
        case X_VideoScale:
            return (Success);
        case X_VideoStop:
	     CHECKWIN(pDrawable);
             if(plxWinPtr && (plxWinPtr->video_active == 0))
             {
                 plxWinPtr->video_active=0;
                 if(pPlxPrivate->video_active>0)
                 {
                     pPlxPrivate->video_active--;
                     video_active=pPlxPrivate->video_active;
                 }
             }
            return (plxVideoStop(pDrawable));
            break;
        case X_VideoFrameMode:
            /* this should be a GC saved value */
            plxvideomodes.framemode = xva->xva_arg1;
            return (Success);
            break;
        case X_VideoFrameStart:
            /* this should be a GC saved value */
            plxvideomodes.framestart = xva->xva_arg1;
            return (Success);
            break;
        case X_VideoDitherControl:
            /* this should be a GC saved value */
            plxvideomodes.dither.luma = xva->xva_arg1;
            plxvideomodes.dither.chroma = xva->xva_arg2;
            return (Success);
            break;
        case X_VideoPriority:
            /* this should be a GC saved value */
            plxvideomodes.priority = 3 - ((3 * xva->xva_arg1 + 49) / 100);
        case X_Plx_zoom_on:
        case X_Plx_zoom_off:
            return (Success);
            break;
        case X_Plx_Debug:
            return (plxSetDebug (xva->vx));
            break;
        case X_VideoInput:
            {
                /* this should be a GC saved value */
                plxvideomodes.input = xva->xva_arg1;
                switch (plxvideomodes.input) {
                case 1:
                case 2:
                    return (Success);
                    break;
                default:
                    return (BadValue);
                    break;
                }
            }
                break;
        case X_VideoValueFactory:
            return (Success);
            break;
        case X_VideoValueSet:
           return (plxVideoValuesSet((xVideoValueArgs *) xva));
           break;

        /* new functions defined in rev 4.0 */
        case X_VideoQueryConfig:
            return (plxVideoQueryConfig(client, pDrawable, pGC));
            break;
        case X_VideoQueryVideo:
            return (plxVideoQueryVideo(client, pDrawable, pGC));
            break;
        case X_VideoValueQuery:
            return (plxVideoValueQuery(client, pGC));
            break;
        case X_VideoValueLoad:
            return (plxVideoValueLoad(pGC, (xVidValueArgs *) xva));
            break;
        case X_VideoValueSave:
            return (plxVideoValueSave(pDrawable,pGC,(xVidValueArgs *) xva));
            break;
        case X_VideoValueRecall:
            return (plxVideoValueRecall(pDrawable,pGC,(xVidValueArgs *) xva));
            break;
        case X_VideoTag:        
            return (plxVideoTag((WindowPtr) pDrawable, pGC, (int *) xva));
            break;
        case X_VideoDirection:
            return (plxVideoDirection((WindowPtr) pDrawable, pGC,
                                      (short *) xva));
            break;
        case X_VideoInputSelect:
        {
            return (plxVideoInputSelect((WindowPtr) pDrawable, pGC,
                                        (xVideoSelectArgs *) xva));
        }
            break;
        case X_Plx_Pan: /* not new but was in plxVga */
            return (Success);
            break;
        case X_Plx_ScaleCopyArea:
	    CHECKWIN(pDrawable);
            return (plxScaleCopyArea(pDrawable, pGC, (xCVideoArgs *) xva));
            break;
        case X_VideoOutput:     
        case X_VideoScaleOutput:
	    CHECKWIN(pDrawable);
	    DEBUGF(2, (fd, "X_VideoOutput or X_VideoScaleOutput\n"));
            if (!video_max_width || !video_max_height)
                return (BadMatch);

	    DEBUGF(2, (fd, "X_VideoOutput: width and height ok\n"));
            if ((int)(xva->vx + xva->vw) > (int)xv_ctx->main.xsize)
                xva->vx = xv_ctx->main.xsize - xva->vw;
            if ((int)(xva->vy + xva->vh) > (int)xv_ctx->main.ysize)
                xva->vy = xv_ctx->main.ysize - xva->vh;
            if (xva->vx < 0)
                xva->vx = 0;
	    if (xva->vw > xva->w)
		xva->vw = xva->w;
            if (xva->vy < 0)
                xva->vy = 0;
            if (xva->vh > xva->h)
                xva->vh = xva->h;
            xva->vx += xorg;
            xva->vy += yorg;
#ifdef OBSOLETED_VIDEO_TRACKING
            if(plxWinPtr && (plxWinPtr->video_active == 0))
            {
                 plxWinPtr->video_active=1;
                 if(pPlxPrivate->video_active<=3)
                 {
		     DEBUGF(2, (fd, "VideoOutput: increment video_active\n"));
                     pPlxPrivate->video_active++;
                     video_active=pPlxPrivate->video_active;
                 }
            }
#endif

            return (plxVideoScaleOutput((WindowPtr) pDrawable, pGC, xva->x,
                                        xva->y, xva->w, xva->h, xva->vx,
                                        xva->vy, xva->vw, xva->vh));
            break;
        case X_VideoOutputSelect:
        {
	    xVideoSelectArgs *args= (xVideoSelectArgs *)xva;
	    DEBUGF(2, (fd, "X_VideoOutputSelect args->channel=%d\n",
                        args->channel));
#ifdef OBSOLETED_VIDEO_TRACKING
            if(plxWinPtr && (plxWinPtr->video_active == 0))
            {
                 plxWinPtr->video_active=1;
                 if(pPlxPrivate->video_active<=3)
                 {
		     DEBUGF(2, (fd, "VideoOutputSelect: increment video_active\n"));
                     pPlxPrivate->video_active++;
                     video_active=pPlxPrivate->video_active;
                 }
            }
            else if(plxWinPtr && (plxWinPtr->video_active))
            {
                if(pPlxPrivate->video_active>0)
                {
                    if(args->channel == PLX_IO_OFF)
                    {
                         pPlxPrivate->video_active--;
                         video_active=pPlxPrivate->video_active;
		     DEBUGF(2, (fd, 
			"VideoOutputSelect: decrement video_active pPlxPrivate->video_active=%d\n",
                        pPlxPrivate->video_active));
                    }
                    else if(pPlxPrivate->video_active<=3)
                    {

                         pPlxPrivate->video_active++;
                         video_active=pPlxPrivate->video_active;
		         DEBUGF(2, (fd, "VideoOutputSelect: increment video_active pPlxPrivate->video_active=%d\n",
                pPlxPrivate->video_active));
                     }
                }
            }
#endif
            return (plxVideoOutputSelect((WindowPtr) pDrawable, pGC,
                                         (xVideoSelectArgs *) xva));
        }
        case X_Plx_SPString:
            return (plxSetParameterString(client, pGC, (char *)xva));
            break;
        case X_Plx_GPString:
            return (plxGetParameterString(client, pGC));
            break;
    }
    return (BadRequest);
}



plxVideoTag(pDrawable, pGC, window_type)
DrawablePtr pDrawable;
register GCPtr pGC;
int *window_type;
{
    plxGCPtr    privGC = GetPlxGCPrivate(pGC);
    TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);
    plxPrivWinPtr plxWinPtr = (plxPrivWinPtr)plxGetPwinPriv(pDrawable);

	CHECKWIN(pDrawable);
            
        tv2_priv->gov_mode= *window_type;
        privGC->win_type= *window_type;
        switch (*window_type)
        {
            case PLX_VIDEO:     /* Video pixels */
                 if(tv2_priv->window_type != PLX_VIDEO)
                 {
                    /*  IF OUR WINDOW DOES NOT YET HAVE AN UNIQUE VIDEO WID 
                     *  ALLOCATE ONE HERE AND USE IT FOR THE GC's TAG VALUE.
                     *  OTHERWISE ALLOCATE A NEW WID AND REMEMBER IT IN THE
                     *  TV2 PRIVATE STRUCTURE. 
                     */
                    if (plxWinPtr && !plxWinPtr->video_wid_set )
                    {
                                tv2_priv->video_tag = 
                                        plxGetWid(pGC->pScreen,pDrawable, 0);
                                tv2_priv->window_type=PLX_VIDEO;
                    }
                    else
                    {
                        tv2_priv->pWid = (WidPtr)
                                plxVideoWidAlloc (pGC->pScreen, pDrawable);
                        tv2_priv->video_tag = widGetValue(tv2_priv->pWid);
                    }
                    tv2_priv->window_type=PLX_VIDEO;
                 }
                break;
            case PLX_GRAPHICS_24:       /* Twenty four bit graphics */
            case PLX_GRAPHICS_8:        /* Eight bit graphics   */
            case PLX_VIDEO_OVR: /* Graphics overlay     */
            case PLX_GRAPHICS:/* just graphics, superseeds 1,8,24 above */
                break;
            case PLX_CLIENT_PREPARE:
		if(plxWinPtr)
                    plxWinPtr->explicitPrepare = 1;
                break;
            case PLX_SERVER_PREPARE:
		if(plxWinPtr)
                    plxWinPtr->explicitPrepare = 0;
                break;
        }
        return(Success);
}


int
plxVideoDirection (pDrawable, pGC, dirs)
register WindowPtr pDrawable;
register GCPtr pGC;
short dirs[2];
{
        TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);
            
        tv2_priv->xdirection = dirs[0];
        tv2_priv->ydirection = dirs[1];
        return(Success);
}


int
plxVideoInputSelect (pDrawable, pGC, args)
register WindowPtr pDrawable;
register GCPtr pGC;
xVideoSelectArgs *args;
{
        register int port;
        TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);

	DEBUGF(0x40, (fd, "plxVideoInputSelect: entry\n"));
            

        if (args->channel == PLX_INPUT_0)
            port = PORT_D;
        else if (args->channel == PLX_INPUT_1)
            port = input1_port;
        else
	{
	    DEBUGF(0x40, (fd, "plxVideoInputSelect: exit w/Bad channel\n"));
            return (BadValue);
	}

        if(tv2_priv->channel != args->channel)
        {
             tv2_priv->channel = args->channel;
        }

#ifdef GAIN_HACK
                        /* temporary hack for gain application! */
        if(args->standard == PLX_NTSC) 
                args->standard = PLX_PAL;
#endif
        if (args->standard == PLX_NTSC)
            plxv_input_config(port, "PAL 525");
        else if (args->standard == PLX_PAL)
            plxv_input_config(port, "625 PAL");
        else if (args->standard == PLX_SECAM)
            plxv_input_config(port, "625 SECAM");
        else
	{
	    DEBUGF(0x40, (fd, "plxVideoInputSelect: exit w/Bad standard\n"));
            return (BadValue);
	}
        tv2_priv->standard = args->standard;

        switch (args->format)
        {
            case PLX_COMP:
                plxv_input_config(port, "COMPOSITE");
                break;
            case PLX_YC:
                plxv_input_config(port, "YC");
                break;
            case PLX_YUV:
                plxv_input_config(port, "YUV");
                break;
            case PLX_RGB:
                plxv_input_config(port, "RGB");
                break;
            default:
		DEBUGF(0x40, (fd, "plxVideoInputSelect: exit w/Bad format\n"));
                return (BadValue);
        }
        tv2_priv->format = args->format;

        if (args->type != PLX_RGB24)
	{
	    DEBUGF(0x40, (fd, "plxVideoInputSelect: exit w/Bad type\n"));
            return (BadValue);
	}

        tv2_priv->type = args->type;
	DEBUGF(0x40, (fd, "plxVideoInputSelect: exit\n"));
        return(Success);
}


int
plxVideoScaleOutput (pDrawable, pGC, x, y, w, h, vx, vy, vw, vh)
WindowPtr pDrawable;
GCPtr pGC;
int x, y, w, h, vx, vy, vw, vh;
{
        register xs, ys, xe, ye;
        register PLXChannelPtr channelptr;
        plxScreenPtr  pPlx;         /* Per-screen context for Parallax cards. */
        TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);
        plxPrivWinPtr plxWinPtr = (plxPrivWinPtr)plxGetPwinPriv(pDrawable);

	CHECKWIN(pDrawable);

	DEBUGF(0x40, (fd, "plxVideoScaleOutput: entry\n"));

        pPlx =  GetPlxPrivate(pGC->pScreen);
        if(tv2_priv->video_tag==0)
        {
            tv2_priv->video_tag = plxGetWid(pGC->pScreen,pDrawable, 0);
                tv2_priv->window_type=PLX_VIDEO;
        }
        xs = (tv2_priv->xdirection < 0) ? (vx + vw - 1) : vx;
        xe = (tv2_priv->xdirection < 0) ? -vw : vw;
        ys = (tv2_priv->ydirection < 0) ? (vy + vh - 1) : vy;
        ye = (tv2_priv->ydirection < 0) ? -vh : vh;

        channelptr = &pPlx->plxvideochannel[CHANNEL_W];
        if (channelptr->window)
            plxv_flash_w_off_now();

	/* 
	 *  Test of rtv_state is to prevent reusing W channel 
	 *  during RTV playback -Added by ABW 12-29-95.
	 */
	if(rtv_state == RtvTrackNone)
            plxv_xpoint_w (output0_port + OUTPUT_A, 1);

        plxv_output_w (xs, ys, xe, ye, x, y, w, h, 0, 0);
        plxv_output_config (output0_port, "ENABLE");
        channelptr->window = pDrawable;
        channelptr->output = TRUE;
        channelptr->vx = x;
        channelptr->vy = y;
        channelptr->vw = w;
        channelptr->vh = h;
        channelptr->xs = xs;
        channelptr->ys = ys;
        channelptr->xe = xe;
        channelptr->ye = ye;

	DEBUGF(0x40, (fd, "plxVideoScaleOutput: exit\n"));
	return(Success);
}


int
plxVideoOutputSelect (pDrawable, pGC, args)
register WindowPtr pDrawable;
register GCPtr pGC;
xVideoSelectArgs *args;
{
    TV2Priv*      tv2_priv=SetTv2Priv(pDrawable,pGC);
    plxScreenPtr  pPlx;         /* Per-screen context for Parallax cards. */
    plxPrivWinPtr plxWinPtr = (plxPrivWinPtr)plxGetPwinPriv(pDrawable);

    CHECKWIN(pDrawable);
        
    DEBUGF(0x40, (fd, "plxVideoOutputSelect: entry\n"));
/* 
 *  Test of rtv_state is to prevent reseting W channel 
 *  during RTV playback -Modified by ABW 12-29-95.
 */
    if(rtv_state == RtvTrackNone)
    {
        plxv_output_config (output0_port, "DISABLE");
    }
    else
    {
        /*
         * Turn off output.
         */
        pPlx =  GetPlxPrivate(pGC->pScreen);
        if (args->channel == PLX_IO_OFF && 
	    pPlx->plxvideochannel[CHANNEL_W].output &&
	    pPlx->plxvideochannel[CHANNEL_W].window == pDrawable)
        {
	    DEBUGF(1, (fd, "plxVideoOutputSelect: turning off output\n"));
	    plxv_flash_w_off_now();
	    pPlx->plxvideochannel[CHANNEL_W].window = NullWindow;
        }
        else if (args->channel != PLX_OUTPUT_0)
        {
	    DEBUGF(0x40, (fd, "plxVideoOutputSelect: exit w/bad channel\n"));
	    return (BadValue);
        }
    }
    tv2_priv->channel = args->channel;

    if (args->standard == PLX_NTSC)
	plxv_output_config(output0_port, "525");
    else if (args->standard == PLX_PAL )
	plxv_output_config(output0_port, "625");
    else
    {
	DEBUGF(0x40, (fd, "plxVideoOutputSelect: exit w/bad standard\n"));
	return (BadValue);
    }
    tv2_priv->standard = args->standard;

    switch (args->format)
    {
	case PLX_COMP:
/*
	    plxv_output_config(output0_port, "COMPOSITE");
*/
	    break;
	case PLX_YC:
/*
	    plxv_output_config(output0_port, "YC");
*/
	    break;
	case PLX_YUV:
	    plxv_output_config(output0_port, "YUV");
	    break;
	case PLX_RGB:
	    plxv_output_config(output0_port, "RGB");
	    break;
	default:
	    DEBUGF(0x40, (fd, "plxVideoOutputSelect: exit w/bad format\n"));
	    return (BadValue);
    }
    tv2_priv->format = args->format;

    if (args->type != PLX_RGB24)
    {
	DEBUGF(0x40, (fd, "plxVideoOutputSelect: exit w/bad type\n"));
	return (BadValue);
    }
    tv2_priv->type = args->type;
    DEBUGF(1, (fd, "plxVideoOutputSelect: configured with s:%d f:%d t:%d\n", args->standard, args->format, args->type));
    DEBUGF(0x40, (fd, "plxVideoOutputSelect: exit\n"));
    return(Success);
}


int
plxVideoValueSave (pDrawable,pGC,vva)
register WindowPtr pDrawable;
register GCPtr pGC;
xVidValueArgs *vva;
{
        register int port;
        TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);

	DEBUGF(0x40, (fd, "plxVideoValueSave: entry\n"));

        if (tv2_priv->channel == PLX_IO_OFF)
	{
	    DEBUGF(0x40, (fd, "plxVideoValueSave: exit video off\n"));
            return(Success);
	}

        if (tv2_priv->channel == PLX_INPUT_0)
            port = PORT_D;
        else if (tv2_priv->channel == PLX_INPUT_1)
            port = input1_port;
        else
            port = output0_port;

        if(vva->select == USER_0)
            plxv_save_knobs(port, 1, &plxvideoport[port].knob);
        else if(vva->select == USER_1)
            plxv_save_knobs(port, 2, &plxvideoport[port].knob);

	DEBUGF(0x40, (fd, "plxVideoValueSave: exit\n"));
        return(Success);
}


int
plxVideoValueRecall (pDrawable,pGC,vva)
register WindowPtr pDrawable;
register GCPtr pGC;
xVidValueArgs *vva;
{
        register int port;
        TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);

	DEBUGF(0x40, (fd, "plxVideoValueRecall: entry\n"));

        if (tv2_priv->channel == PLX_IO_OFF)
	{	
	    DEBUGF(0x40, (fd, "plxVideoValueRecall: exit\n"));
            return(Success);
	}

        if (tv2_priv->channel == PLX_INPUT_0)
            port = PORT_D;
        else if (tv2_priv->channel == PLX_INPUT_1)
            port = input1_port;
        else
            port = output0_port;

        if(vva->select == USER_0)
    {
        switch (port)
        {
            case PORT_A:
                plxvideoport[port].knob = xv_ctx->opt.a.u1;
                break;
            case PORT_B:
                plxvideoport[port].knob = xv_ctx->opt.b.u1;
                break;
            case PORT_D:
                plxvideoport[port].knob = xv_ctx->main.d.u1;
                break;
        }
    }
    else if(vva->select == USER_1)
    {
        switch (port)
        {
            case PORT_A:
                plxvideoport[port].knob = xv_ctx->opt.a.u2;
                break;
            case PORT_B:
                plxvideoport[port].knob = xv_ctx->opt.b.u2;
                break;
            case PORT_D:
                plxvideoport[port].knob = xv_ctx->main.d.u2;
                break;
        }
    }
    else if(vva->select == FACTORY)
    {
        switch (port)
        {
            case PORT_A:
                plxvideoport[port].knob = xv_ctx->opt.a.factory;
                break;
            case PORT_B:
                plxvideoport[port].knob = xv_ctx->opt.b.factory;
                break;
            case PORT_D:
                plxvideoport[port].knob = xv_ctx->main.d.factory;
                break;
        }
    }


    plxv_set_knobs(port, &plxvideoport[port].knob);

    DEBUGF(0x40, (fd, "plxVideoValueRecall: exit\n"));
    return(Success);
}


static void VVQswap (Client, Size, Reply)
register ClientPtr Client;
register int Size;
register xVidValueReply *Reply;
{
    register n;

    swaps(&Reply->sequenceNumber, n);
    swapl(&Reply->length, n);
    swapl(&Reply->sat, n);
    swapl(&Reply->cont, n);
    swapl(&Reply->hue, n);
    swapl(&Reply->brit, n);
    (void)WriteToClient(Client, Size, (char *) Reply);
}


int
plxVideoValueQuery (client, pGC)
register ClientPtr client;
register GCPtr pGC;
{
    xVidValueReply reply;
    register int port;
    TV2Priv *tv2_priv=GetTv2Priv(pGC);

    REQUEST(xVideoReq);
    REQUEST_SIZE_MATCH(xVideoReq);

    reply.type = X_Reply;
    reply.sequenceNumber = client->sequence;
    reply.length = 0;

    if (tv2_priv->channel == PLX_INPUT_0)
        port = PORT_D;
    else if (tv2_priv->channel == PLX_INPUT_1)
        port = input1_port;
    else
        port = output0_port;

    reply.sat = plxvideoport[port].knob.saturation;
    reply.cont = plxvideoport[port].knob.contrast;
    reply.hue = plxvideoport[port].knob.hue;
    reply.brit = plxvideoport[port].knob.bright;

    ReplySwapVector[((xReq *)client->requestBuffer)->reqType] = VVQswap;
    WriteReplyToClient(client, sz_xVidValueReply, &reply);

    return(Success);
}


int
plxVideoValueLoad (pGC, vals)
register GCPtr pGC;
xVidValueArgs *vals;
{
    register int port;
    TV2Priv *tv2_priv=GetTv2Priv(pGC);
        
    if (tv2_priv->channel == PLX_INPUT_0)
        port = PORT_D;
    else if (tv2_priv->channel == PLX_INPUT_1)
        port = input1_port;
    else
        port = output0_port;

    plxvideoport[port].knob.saturation = vals->sat & 0xff;
    plxvideoport[port].knob.contrast = vals->cont & 0xff;
    plxvideoport[port].knob.hue = vals->hue & 0xff;
    plxvideoport[port].knob.bright = vals->brit & 0xff;

    plxv_set_knobs(port, &plxvideoport[port].knob);
    return(Success);
}


static void VCswap (Client, Size, Reply)
register ClientPtr Client;
register int Size;
register xVideoConfigReply *Reply;
{
    register n;

    swaps(&Reply->sequenceNumber, n);
    swapl(&Reply->hardware, n);
    swapl(&Reply->length, n);
    swapl(&Reply->nformats, n);
    swapl(&Reply->ntypes, n);
    swapl(&Reply->nsignals, n);
    (void) WriteToClient(Client, Size, (char *) Reply);
}
        

extern char *getenv();

int
plxVideoQueryVideo (client, pDrawable, pGC)
register ClientPtr client;
register WindowPtr pDrawable;
register GCPtr pGC;
{
    xVideoConfigReply reply;
    int port, status, standard_flag;
    int nbytes = sizeof(PlxVideoSignal);
    char retbuf[sizeof(PlxVideoSignal)];
    register PlxVideoSignal *sig;
    int look_again;
    int sync; 
    TV2Priv *tv2_priv=GetTv2Priv(pGC);

    REQUEST(xVideoReq);
    REQUEST_SIZE_MATCH(xVideoReq);

    reply.type = X_Reply;
    reply.sequenceNumber = client->sequence;

    sig = (PlxVideoSignal *) retbuf;
    sig->channel = tv2_priv->channel;
    if (tv2_priv->channel == PLX_OUTPUT_0)
        sig->type = 1;
    else if (tv2_priv->channel != PLX_IO_OFF) /* what if IO_OFF, type is ?? */
        sig->type = 0;

    if (tv2_priv->channel == PLX_INPUT_0)
        port = PORT_D;
    else if (tv2_priv->channel == PLX_INPUT_1)
        port = input1_port;
    else
        port = output0_port;

    sig->standard = tv2_priv->standard;
    if (tv2_priv->standard == PLX_NTSC)
    {
        sig->w = NTSC_WIDTH;
        sig->h = NTSC_HEIGHT;
        sig->b = NTSC_BLANK;
        sig->r = NTSC_RATE;
        sig->interlaced = TRUE;
        standard_flag = 0x20;
    }
    else if (tv2_priv->standard == PLX_PAL || tv2_priv->standard == PLX_SECAM)
    {
        sig->w = PAL_WIDTH;
        sig->h = PAL_HEIGHT;
        sig->b = PAL_BLANK;
        sig->r = PAL_RATE;
        sig->interlaced = TRUE;
        standard_flag = 0;
    }

    for (look_again = 0; look_again < 3; look_again++)
    {
        if (look_again > 1)
            MyUSleep(100000);         /* two pal frame times, 1/10 sec */
        plxv_input_status(port, &status);
        if (((status & 0x40) == 0) && ((status & 0x20) == standard_flag))
            break;      /* 40==0 is line lock, 1==1 is color lock */
    }

    if (((status & 0x40) == 0) && ((status & 0x20) == standard_flag))
    {
        if (tv2_priv->standard == PLX_NTSC)
            sig->sync_ok = TRUE; 
        else
            if (tv2_priv->standard == PLX_PAL)
                if (getenv("TV2_SECAM"))
                        sig->sync_ok = FALSE ;
                else    sig->sync_ok = TRUE ;
            else
                if (getenv("TV2_SECAM"))
                        sig->sync_ok = TRUE ;
                else    sig->sync_ok = FALSE ;
    }
    else
        sig->sync_ok = FALSE;

    reply.length = nbytes >> 2;
    ReplySwapVector[((xReq *)client->requestBuffer)->reqType] = VCswap;
    WriteReplyToClient(client, sz_xVideoConfigReply, &reply);
    client->pSwapReplyFunc = Swap32Write;
    WriteSwappedDataToClient(client, nbytes, retbuf);
    return(Success);
}

#define VIDEO_FORMAT_SZ (sizeof(PlxVideoFormat)*5)
#define VIDEO_TYPE_SZ (sizeof(PlxVideoType)*3)
#define VIDEO_SIGNAL_SZ (sizeof(PlxVideoSignal)*8)


int
plxVideoQueryConfig(client, pDrawable, pGC)
register ClientPtr client;
register DrawablePtr pDrawable;
register GCPtr pGC;
{
    xVideoConfigReply reply;
    char retbuf[VIDEO_FORMAT_SZ+VIDEO_TYPE_SZ+VIDEO_SIGNAL_SZ+8];
    register PlxVideoSignal *sig;
    register PlxVideoFormat *format;
    register PlxVideoType *type;
    register int nbytes;
    int  is_secam;
    XV_struct *xv=xv_ctx;
    TV2Priv *tv2_priv=GetTv2Priv(pGC);

    REQUEST(xVideoReq);
    REQUEST_SIZE_MATCH(xVideoReq);


    reply.type = X_Reply;
    reply.sequenceNumber = client->sequence;
    reply.hardware = PLX_XVIDEO_24;

    is_secam = (((xv->opt.a.flags & IO_CHAN_TYPE) == IO_DMSD) || 
                ((xv->opt.b.flags & IO_CHAN_TYPE) == IO_DMSD));
    if (!xv->opt.board_code)
        nbytes = (1 * sizeof(PlxVideoFormat)) +
                 (1 * sizeof(PlxVideoType)) +
                 (3 * sizeof(PlxVideoSignal));
    else if (is_secam)
        nbytes = (5 * sizeof(PlxVideoFormat)) +
                 (3 * sizeof(PlxVideoType)) +
                 (8 * sizeof(PlxVideoSignal));
    else
        nbytes = (5 * sizeof(PlxVideoFormat)) +
                 (3 * sizeof(PlxVideoType)) +
                 (7 * sizeof(PlxVideoSignal));


    format = (PlxVideoFormat *) &retbuf;

    if (!xv->main.d.flags)
    {
        format->channel = 0;
        format->format = 0;
    }
    else
    {
        format->channel = PLX_INPUT_0;
        format->format = PLX_COMP;
    }
    format->type = 0; /* for input */
    ++format;
    reply.nformats = 1;

    if (xv->opt.board_code)
    {
        if (xv->opt.board_code == OPT_1)
        {
            format->channel = PLX_INPUT_1;
            format->type = 0; /* for input */
            format->format = PLX_COMP;
            ++format;
            reply.nformats++;
            format->channel = PLX_INPUT_1;
            format->type = 0; /* for input */
            format->format = PLX_YC;
            ++format;
            reply.nformats++;

            format->channel = PLX_OUTPUT_0;
            format->type = 1; /* for output */
            format->format = PLX_COMP;
            ++format;
            reply.nformats++;
            format->channel = PLX_OUTPUT_0;
            format->type = 1; /* for output */
            format->format = PLX_YC;
            ++format;
            reply.nformats++;
        }
        else if (xv->opt.board_code == OPT_2)
        {
            format->channel = PLX_INPUT_1;
            format->type = 0; /* for input */
            format->format = PLX_YUV;
            ++format;
            reply.nformats++;
            format->channel = PLX_INPUT_1;
            format->type = 0; /* for input */
            format->format = PLX_RGB;
            ++format;
            reply.nformats++;

            format->channel = PLX_OUTPUT_0;
            format->type = 1; /* for output */
            format->format = PLX_YUV;
            ++format;
            reply.nformats++;
            format->channel = PLX_OUTPUT_0;
            format->type = 1; /* for output */
            format->format = PLX_RGB;
            ++format;
            reply.nformats++;
        }
    }

    type = (PlxVideoType *) format;
    if (!xv->main.d.flags)
    {
        type->channel = 0;
        type->format = 0;
    }
    else
    {
        type->channel = PLX_INPUT_0;
        type->format = PLX_RGB24;
    }
    type->type = 0; /* for input */
    ++type;
    reply.ntypes = 1;

    if (xv->opt.board_code)
    {
        type->channel = PLX_INPUT_1;
        type->type = 0; /* for input */
        type->format = PLX_RGB24;
        ++type;
        reply.ntypes++;

        type->channel = PLX_OUTPUT_0;
        type->type = 1; /* for output */
        type->format = PLX_RGB24;
        ++type;
        reply.ntypes++;
    }

    sig = (PlxVideoSignal *) type;
    if (!xv->main.d.flags)
    {
        sig->channel = 0;
        sig->type = 0; /* for input */
        sig->standard = 0;
        sig->w = 0;
        sig->h = 0;
        sig->b = 0;
        sig->r = 0;
        sig->interlaced = 0;
        sig->sync_ok = 0;
    }
    else
    {
        sig->channel = PLX_INPUT_0;
        sig->type = 0; /* for input */
        sig->standard = PLX_NTSC;
        sig->w = NTSC_WIDTH;
        sig->h = NTSC_HEIGHT;
        sig->b = NTSC_BLANK;
        sig->r = NTSC_RATE;
        sig->interlaced = TRUE;
        sig->sync_ok = FALSE;
    }
    ++sig;
    reply.nsignals = 1;
    if (!xv->main.d.flags)
    {
        sig->channel = 0;
        sig->type = 0; /* for input */
        sig->standard = 0;
        sig->w = 0;
        sig->h = 0;
        sig->b = 0;
        sig->r = 0;
        sig->interlaced = 0;
        sig->sync_ok = 0;
    }
    else
    {
        sig->channel = PLX_INPUT_0;
        sig->type = 0; /* for input */
        sig->standard = PLX_PAL;
        sig->w = PAL_WIDTH;
        sig->h = PAL_HEIGHT;
        sig->b = PAL_BLANK;
        sig->r = PAL_RATE;
        sig->interlaced = TRUE;
        sig->sync_ok = FALSE;
    }
    ++sig;
    reply.nsignals++;
    if (!xv->main.d.flags)
    {
        sig->channel = 0;
        sig->type = 0; /* for input */
        sig->standard = 0;
        sig->w = 0;
        sig->h = 0;
        sig->b = 0;
        sig->r = 0;
        sig->interlaced = 0;
        sig->sync_ok = 0;
    }
    else
    {
        sig->channel = PLX_INPUT_0;
        sig->type = 0; /* for input */
        sig->standard = PLX_SECAM;
        sig->w = PAL_WIDTH;
        sig->h = PAL_HEIGHT;
        sig->b = PAL_BLANK;
        sig->r = PAL_RATE;
        sig->interlaced = TRUE;
        sig->sync_ok = FALSE;
    }
    ++sig;
    reply.nsignals++;

    if (xv->opt.board_code)
    {
        sig->channel = PLX_INPUT_1;
        sig->type = 0; /* for input */
        sig->standard = PLX_NTSC;
        sig->w = NTSC_WIDTH;
        sig->h = NTSC_HEIGHT;
        sig->b = NTSC_BLANK;
        sig->r = NTSC_RATE;
        sig->interlaced = TRUE;
        sig->sync_ok = FALSE;
        ++sig;
        reply.nsignals++;
        sig->channel = PLX_INPUT_1;
        sig->type = 0; /* for input */
        sig->standard = PLX_PAL;
        sig->w = PAL_WIDTH;
        sig->h = PAL_HEIGHT;
        sig->b = PAL_BLANK;
        sig->r = PAL_RATE;
        sig->interlaced = TRUE;
        sig->sync_ok = FALSE;
        ++sig;
        reply.nsignals++;

        if (is_secam)
        {
            sig->channel = PLX_INPUT_1;
            sig->type = 0; /* for input */
            sig->standard = PLX_SECAM;
            sig->w = PAL_WIDTH;
            sig->h = PAL_HEIGHT;
            sig->b = PAL_BLANK;
            sig->r = PAL_RATE;
            sig->interlaced = TRUE;
            sig->sync_ok = FALSE;
            ++sig;
            reply.nsignals++;
        }

        sig->channel = PLX_OUTPUT_0;
        sig->type = 1; /* for output */
        sig->standard = PLX_NTSC;
        sig->w = NTSC_WIDTH;
        sig->h = NTSC_HEIGHT;
        sig->b = NTSC_BLANK;
        sig->r = NTSC_RATE;
        sig->interlaced = TRUE;
        sig->sync_ok = FALSE;
        ++sig;
        reply.nsignals++;
        sig->channel = PLX_OUTPUT_0;
        sig->type = 1; /* for output */
        sig->standard = PLX_PAL;
        sig->w = PAL_WIDTH;
        sig->h = PAL_HEIGHT;
        sig->b = PAL_BLANK;
        sig->r = PAL_RATE;
        sig->interlaced = TRUE;
        sig->sync_ok = FALSE;
        ++sig;
        reply.nsignals++;
    }
    
    nbytes = (reply.nformats * sizeof(PlxVideoFormat)) +
             (reply.ntypes * sizeof(PlxVideoType)) +
             (reply.nsignals * sizeof(PlxVideoSignal));

    reply.length = nbytes >> 2;

    ReplySwapVector[((xReq *)client->requestBuffer)->reqType] = VCswap;
    WriteReplyToClient(client, sz_xVideoConfigReply, &reply);
    client->pSwapReplyFunc = Swap32Write;
    WriteSwappedDataToClient(client, nbytes, retbuf);
    return(Success);
}


plxVideoInit(pScreen, xv)
    ScreenPtr  pScreen;
    XV_struct* xv;
{
    plxScreenPtr  pPlx;    /* Per-screen context for Parallax cards. */

    /*
     * Just in case it was not clean up last time.
     */
    plxv_flash_v_off();
    plxv_flash_w_off();

    pPlx =  GetPlxPrivate(pScreen);
    pPlx->plxvideochannel[CHANNEL_V].window = 0;
    pPlx->plxvideochannel[CHANNEL_V].port   = 0;
    pPlx->plxvideochannel[CHANNEL_V].output = 0;
    pPlx->plxvideochannel[CHANNEL_V].vx     = 0;
    pPlx->plxvideochannel[CHANNEL_V].vy     = 0;
    pPlx->plxvideochannel[CHANNEL_V].vw     = 0;
    pPlx->plxvideochannel[CHANNEL_V].vh     = 0;
    pPlx->plxvideochannel[CHANNEL_V].xs     = 0;
    pPlx->plxvideochannel[CHANNEL_V].ys     = 0;
    pPlx->plxvideochannel[CHANNEL_V].xe     = 0;
    pPlx->plxvideochannel[CHANNEL_V].ye     = 0;
    pPlx->plxvideochannel[CHANNEL_V].xdir   = 0;
    pPlx->plxvideochannel[CHANNEL_V].ydir   = 0;
    pPlx->plxvideochannel[CHANNEL_V].vtag   = 0;
    pPlx->plxvideochannel[CHANNEL_V].xorg   = 0;
    pPlx->plxvideochannel[CHANNEL_V].yorg   = 0;

    pPlx->plxvideochannel[CHANNEL_W].window = 0;
    pPlx->plxvideochannel[CHANNEL_W].port   = 0;
    pPlx->plxvideochannel[CHANNEL_W].output = 0;
    pPlx->plxvideochannel[CHANNEL_W].vx     = 0;
    pPlx->plxvideochannel[CHANNEL_W].vy     = 0;
    pPlx->plxvideochannel[CHANNEL_W].vw     = 0;
    pPlx->plxvideochannel[CHANNEL_W].vh     = 0;
    pPlx->plxvideochannel[CHANNEL_W].xs     = 0;
    pPlx->plxvideochannel[CHANNEL_W].ys     = 0;
    pPlx->plxvideochannel[CHANNEL_W].xe     = 0;
    pPlx->plxvideochannel[CHANNEL_W].ye     = 0;
    pPlx->plxvideochannel[CHANNEL_W].xdir   = 0;
    pPlx->plxvideochannel[CHANNEL_W].ydir   = 0;
    pPlx->plxvideochannel[CHANNEL_W].vtag   = 0;
    pPlx->plxvideochannel[CHANNEL_W].xorg   = 0;
    pPlx->plxvideochannel[CHANNEL_W].yorg   = 0;

    plxvideoport[PORT_D].io_type = xv->main.d.flags & IO_CHAN_TYPE;
    plxvideoport[PORT_D].knob  = xv->main.d.factory;
    if (!xv->opt.board_code)
        return (Success);

    /*
     * Save the input/output for a and b.
     */
    if (xv->opt.a.flags & 0x30)
    {
        input1_port = PORT_B;
        output0_port = PORT_A;
    }
    else
    {
        input1_port = PORT_A;
        output0_port = PORT_B;
    }

    plxvideoport[PORT_A].io_type = xv->opt.a.flags & IO_CHAN_TYPE;
    plxvideoport[PORT_A].knob  = xv->opt.a.factory;
    plxvideoport[PORT_B].io_type = xv->opt.b.flags & IO_CHAN_TYPE;
    plxvideoport[PORT_B].knob  = xv->opt.b.factory;
    plxvideoport[PORT_C].io_type = 0;
}


int
plxVideoLive (pDrawable, pGC, vx, vy, x, y, w, h, flip)
DrawablePtr pDrawable;
GCPtr pGC;
int vx, vy, x, y, w, h, flip;
{

    int xs, xe, ys, ye, port, channel;
    register PLXChannelPtr channelptr;
    WindowPtr pParent = ((WindowPtr) pDrawable)->parent;
    TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);
	plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);


        
    if (!tv2_priv || !pParent->realized)
        return (Success);

    if(tv2_priv->video_tag==0)
    {
        tv2_priv->video_tag = plxGetWid(pGC->pScreen,pDrawable, 0);
        tv2_priv->window_type=PLX_VIDEO;
    }
    /* create x and y endpoints based on x and y dirs */
    xs = (tv2_priv->xdirection < 0) ? (x + w - 1) : x;
    xe = (tv2_priv->xdirection < 0) ? -w : w;
    ys = (tv2_priv->ydirection < 0) ? (y + h - 1) : y;
    ye = (tv2_priv->ydirection < 0) ? -h : h;

    if (tv2_priv->channel == PLX_INPUT_0)
        port = PORT_D;
    else if (tv2_priv->channel == PLX_INPUT_1)
        port = input1_port;
    else
        return (BadValue);

    channel = allocate_channel(pGC->pScreen, pDrawable, port);
    channelptr = &pPlx->plxvideochannel[channel];
     
    switch (plxvideomodes.framemode) {
        case 0:                 /* frame capture */
            switch (plxvideomodes.framestart) {
                case 0:         /* any field first */
                case 1:         /* even field first */
                case 2:         /* odd field first */
                    if (channelptr->window != (WindowPtr) pDrawable ||
                        channelptr->port != port ||
                        channelptr->vx != vx || channelptr->vy != vy ||
                        channelptr->vw != w  || channelptr->vh != h  ||
                        channelptr->xs != xs || channelptr->ys != ys ||
                        channelptr->xe != xe || channelptr->ye != ye)
                    {
                        if (!channel)
                        {
/*
                            plxv_flash_v_off_now();
*/
                            plxv_xpoint_v(port, 1);
                        }
                        else
                        {
/*
                            plxv_flash_w_off_now();
*/
                            plxv_xpoint_w(port, 1);
                        }
                    }
                    plxPutVideo(pDrawable, pGC, channel, FALSE, x, y,
                                w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                    break;
            }
            break;
        case 1:                 /* field capture */
            switch (plxvideomodes.framestart) {
                case 0:
                case 1:
                case 2:
                    if (channelptr->window != (WindowPtr) pDrawable ||
                        channelptr->port != port ||
                        channelptr->vx != vx || channelptr->vy != vy ||
                        channelptr->vw != w  || channelptr->vh != h  ||
                        channelptr->xs != xs || channelptr->ys != ys ||
                        channelptr->xe != xe || channelptr->ye != ye)
                    {
                        if (!channel)
                        {
/*
                            plxv_flash_v_off_now();
*/
                            plxv_xpoint_v(port, 1);
                        }
                        else
                        {
/*
                            plxv_flash_w_off_now();
*/
                            plxv_xpoint_w(port, 1);
                        }
                    }
                    plxPutVideo(pDrawable, pGC, channel, FALSE, x, y,
                                w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                    break;
            }
            break;
    }

    channelptr->window = (WindowPtr) pDrawable;
    channelptr->port = port;
    channelptr->output = FALSE;
    channelptr->vx = vx;
    channelptr->vy = vy;
    channelptr->vw = w;
    channelptr->vh = h;
    channelptr->xs = xs;
    channelptr->ys = ys;
    channelptr->xe = xe;
    channelptr->ye = ye;
    channelptr->xdir = tv2_priv->xdirection;
    channelptr->ydir = tv2_priv->ydirection;
    channelptr->vtag = tv2_priv->video_tag;
    channelptr->xorg = pDrawable->x;
    channelptr->yorg = pDrawable->y;
    return (Success);
}


int
plxVideoSqueezeStill (pDrawable, pGC, vx, vy, vw, vh, x, y, w, h)
DrawablePtr pDrawable;
GCPtr pGC;
int vx, vy, vw, vh, x, y, w, h;
{
    int xs, ys, xe, ye, port;
    WindowPtr pParent = ((WindowPtr) pDrawable)->parent;
    TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);
	plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);
        
    if (!tv2_priv || !pParent->realized)
        return (Success);

    if(tv2_priv->video_tag==0)
    {
        tv2_priv->video_tag = plxGetWid(pGC->pScreen,pDrawable, 0);
        tv2_priv->window_type=PLX_VIDEO;
    }
    /* create x and y endpoints based on x and y dirs */
    xs = (tv2_priv->xdirection < 0) ? (x + w - 1) : x;
    xe = (tv2_priv->xdirection < 0) ? -w : w;
    ys = (tv2_priv->ydirection < 0) ? (y + h - 1) : y;
    ye = (tv2_priv->ydirection < 0) ? -h : h;

    if (tv2_priv->channel == PLX_INPUT_0)
        port = PORT_D;
    else if (tv2_priv->channel == PLX_INPUT_1)
        port = input1_port;
    else
        return (BadValue);

    switch (plxvideomodes.framemode) {
        case 0:                 /* frame capture */
            switch (plxvideomodes.framestart) {
                case 0:         /* any field first */
                case 1:         /* even field first */
                case 2:         /* odd field first */
                    if (pPlx->plxvideochannel[CHANNEL_V].window == (WindowPtr) pDrawable)
                    {
                        plxv_flash_v_off_now();
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                        pPlx->plxvideochannel[CHANNEL_V].window = NullWindow;
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_W].window == (WindowPtr) pDrawable)
                    {
                        plxv_flash_w_off_now();
                        plxv_xpoint_w(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_W, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                        pPlx->plxvideochannel[CHANNEL_W].window = NullWindow;
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_V].window == NullWindow)
                    {
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_W].window == NullWindow)
                    {
                        plxv_xpoint_w(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_W, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                    }
                    else
                    {
                        /*
                         * Steal channel v momentarily.
                         */
                        plxv_flash_v_off_now();
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, TRUE);
                        plxv_xpoint_v(pPlx->plxvideochannel[CHANNEL_V].port, 1);
                        plxv_tag(PLXV_TAG_ST_MASK|PLXV_CURSOR_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
                        plxv_video_v_stencil(PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
                        plxv_flash_v_squeeze(pPlx->plxvideochannel[CHANNEL_V].vx,
                                             pPlx->plxvideochannel[CHANNEL_V].vy,
                                             pPlx->plxvideochannel[CHANNEL_V].vw,
                                             pPlx->plxvideochannel[CHANNEL_V].vh,
                                             pPlx->plxvideochannel[CHANNEL_V].xs,
                                             pPlx->plxvideochannel[CHANNEL_V].ys,
                                             pPlx->plxvideochannel[CHANNEL_V].xe,
                                             pPlx->plxvideochannel[CHANNEL_V].ye,
                                             0, 0);

                    }
                    break;
            }
            break;
        case 1:                 /* field capture */
            switch (plxvideomodes.framestart) {
                case 0:
                case 1:
                case 2:
                    if (pPlx->plxvideochannel[CHANNEL_V].window == (WindowPtr) pDrawable)
                    {
                        plxv_flash_v_off_now();
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                        pPlx->plxvideochannel[CHANNEL_V].window = NullWindow;
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_W].window == (WindowPtr) pDrawable)
                    {
                        plxv_flash_w_off_now();
                        plxv_xpoint_w(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_W, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                        pPlx->plxvideochannel[CHANNEL_W].window = NullWindow;
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_V].window == NullWindow)
                    {
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_W].window == NullWindow)
                    {
                        plxv_xpoint_w(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_W, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                    }
                    else
                    {
                        /*
                         * Steal channel v momentarily.
                         */
                        plxv_flash_v_off_now();
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, vw, vh, xs, ys, xe, ye, TRUE);
                        plxv_xpoint_v(pPlx->plxvideochannel[CHANNEL_V].port, 1);
                        plxv_tag(PLXV_TAG_ST_MASK|PLXV_CURSOR_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
                        plxv_video_v_stencil(PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
                        plxv_flash_v_squeeze(pPlx->plxvideochannel[CHANNEL_V].vx,
                                             pPlx->plxvideochannel[CHANNEL_V].vy,
                                             pPlx->plxvideochannel[CHANNEL_V].vw,
                                             pPlx->plxvideochannel[CHANNEL_V].vh,
                                             pPlx->plxvideochannel[CHANNEL_V].xs,
                                             pPlx->plxvideochannel[CHANNEL_V].ys,
                                             pPlx->plxvideochannel[CHANNEL_V].xe,
                                             pPlx->plxvideochannel[CHANNEL_V].ye,
                                             0, 0);
                    }
                    break;
            }
            break;
    }
    return (Success);
}


int
plxVideoSqueezeLive (pDrawable, pGC, vx, vy, vw, vh, x, y, w, h)
DrawablePtr pDrawable;
GCPtr pGC;
int vx, vy, vw, vh, x, y, w, h;
{
    int xs, xe, ys, ye, port, channel;
    register      PLXChannelPtr channelptr;
    WindowPtr     pParent = ((WindowPtr) pDrawable)->parent;
    TV2Priv*      tv2_priv=SetTv2Priv(pDrawable,pGC);
	plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);
        
    if (!tv2_priv || !pParent->realized)
        return (Success);
    if(tv2_priv->video_tag==0)
    {
        tv2_priv->video_tag = plxGetWid(pGC->pScreen,pDrawable, 0);
        tv2_priv->window_type=PLX_VIDEO;
    }
        
    /* create x and y endpoints based on x and y dirs */
    xs = (tv2_priv->xdirection < 0) ? (x + w - 1) : x;
    xe = (tv2_priv->xdirection < 0) ? -w : w;
    ys = (tv2_priv->ydirection < 0) ? (y + h - 1) : y;
    ye = (tv2_priv->ydirection < 0) ? -h : h;

    if (tv2_priv->channel == PLX_INPUT_0)
        port = PORT_D;
    else if (tv2_priv->channel == PLX_INPUT_1)
        port = input1_port;
    else
        return (BadValue);

    channel = allocate_channel(pGC->pScreen, pDrawable, port);

    channelptr = &pPlx->plxvideochannel[channel];

    switch (plxvideomodes.framemode) {
        case 0:                 /* frame capture */
            switch (plxvideomodes.framestart) {
                case 0:         /* any field first */
                case 1:         /* even field first */
                case 2:         /* odd field first */
                    if (channelptr->window != (WindowPtr) pDrawable ||
                        channelptr->port != port ||
                        channelptr->vx != vx || channelptr->vy != vy ||
                        channelptr->vw != w  || channelptr->vh != h  ||
                        channelptr->xs != xs || channelptr->ys != ys ||
                        channelptr->xe != xe || channelptr->ye != ye)
                    {
                        if (!channel)
                        {
/*
                            plxv_flash_v_off_now();
*/
                            plxv_xpoint_v(port, 1);
                        }
                        else
                        {
/*
                            plxv_flash_w_off_now();
*/
                            plxv_xpoint_w(port, 1);
                        }
                    }
                    plxPutVideo(pDrawable, pGC, channel, FALSE, x, y,
                                w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                    break;
            }
            break;
        case 1:                 /* field capture */
            switch (plxvideomodes.framestart) {
                case 0:
                case 1:
                case 2:
                    if (channelptr->window != (WindowPtr) pDrawable ||
                        channelptr->port != port ||
                        channelptr->vx != vx || channelptr->vy != vy ||
                        channelptr->vw != w  || channelptr->vh != h  ||
                        channelptr->xs != xs || channelptr->ys != ys ||
                        channelptr->xe != xe || channelptr->ye != ye)
                    {
                        if (!channel)
                        {
/*
                            plxv_flash_v_off_now();
*/
                            plxv_xpoint_v(port, 1);
                        }
                        else
                        {
/*
                            plxv_flash_w_off_now();
*/
                            plxv_xpoint_w(port, 1);
                        }
                    }
                    plxPutVideo(pDrawable, pGC, channel, FALSE, x, y,
                                w, h, vx, vy, vw, vh, xs, ys, xe, ye, FALSE);
                    break;
            }
            break;
    }

    channelptr->window = (WindowPtr) pDrawable;
    channelptr->port = port;
    channelptr->output = FALSE;
    channelptr->vx = vx;
    channelptr->vy = vy;
    channelptr->vw = vw;
    channelptr->vh = vh;
    channelptr->xs = xs;
    channelptr->ys = ys;
    channelptr->xe = xe;
    channelptr->ye = ye;
    channelptr->xdir = tv2_priv->xdirection;
    channelptr->ydir = tv2_priv->ydirection;
    channelptr->vtag = tv2_priv->video_tag;
    channelptr->xorg = pDrawable->x;
    channelptr->yorg = pDrawable->y;
    return (Success);
}


int
plxVideoStill (pDrawable, pGC, vx, vy, x, y, w, h)
DrawablePtr pDrawable;
GCPtr pGC;
int vx, vy, x, y, w, h;
{
    int xs, ys, xe, ye, port;
    WindowPtr pParent = ((WindowPtr) pDrawable)->parent;
    TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);
    plxGCPtr    privGC = GetPlxGCPrivate(pGC);
	plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);
    
        
    DEBUGF(0x40, (fd, "PlxVideoStill: entry\n"));

    if (!tv2_priv || !pParent->realized)
    {
	DEBUGF(0x40, (fd, "PlxVideoStill: exit no video or window realized\n"));
        return (Success);
    }
    if(tv2_priv->video_tag==0)
    {
        tv2_priv->video_tag = plxGetWid(pGC->pScreen,pDrawable, 0);
        tv2_priv->window_type=PLX_VIDEO;
        privGC->video_priv= (int *)tv2_priv;
    }

    /* create x and y endpoints based on x and y dirs */
    xs = (tv2_priv->xdirection < 0) ? (x + w - 1) : x;
    xe = (tv2_priv->xdirection < 0) ? -w : w;
    ys = (tv2_priv->ydirection < 0) ? (y + h - 1) : y;
    ye = (tv2_priv->ydirection < 0) ? -h : h;

    if (tv2_priv->channel == PLX_INPUT_0)
        port = PORT_D;
    else if (tv2_priv->channel == PLX_INPUT_1)
        port = input1_port;
    else
    {
	DEBUGF(0x40, (fd, "PlxVideoStill: exit w/Bad channel\n"));
        return (BadValue);
    }

    switch (plxvideomodes.framemode) {
        case 0:                 /* frame capture */
            switch (plxvideomodes.framestart) {
                case 0:         /* any field first */
                case 1:         /* even field first */
                case 2:         /* odd field first */
                    if (pPlx->plxvideochannel[CHANNEL_V].window == (WindowPtr) pDrawable)
                    {
                        plxv_flash_v_off_now();
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                        pPlx->plxvideochannel[CHANNEL_V].window = NullWindow;
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_W].window == (WindowPtr) pDrawable)
                    {
                        plxv_flash_w_off_now();
                        plxv_xpoint_w(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_W, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                        pPlx->plxvideochannel[CHANNEL_W].window = NullWindow;
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_V].window == NullWindow)
                    {
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_W].window == NullWindow)
                    {
                        plxv_xpoint_w(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_W, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                    }
                    else
                    {
                        /*
                         * Steal channel v momentarily.
                         */
                        plxv_flash_v_off_now();
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, TRUE);
                        plxv_xpoint_v(pPlx->plxvideochannel[CHANNEL_V].port, 1);
                        plxv_tag(PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
                        plxv_video_v_stencil(PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
                        plxv_flash_v_squeeze(pPlx->plxvideochannel[CHANNEL_V].vx,
                                             pPlx->plxvideochannel[CHANNEL_V].vy,
                                             pPlx->plxvideochannel[CHANNEL_V].vw,
                                             pPlx->plxvideochannel[CHANNEL_V].vh,
                                             pPlx->plxvideochannel[CHANNEL_V].xs,
                                             pPlx->plxvideochannel[CHANNEL_V].ys,
                                             pPlx->plxvideochannel[CHANNEL_V].xe, 
                                             pPlx->plxvideochannel[CHANNEL_V].ye,
                                             0, 0);

                    }
                    break;
            }
            break;
        case 1:                 /* field capture */
            switch (plxvideomodes.framestart) {
                case 0:
                case 1:
                case 2:
                    if (pPlx->plxvideochannel[CHANNEL_V].window == (WindowPtr) pDrawable)
                    {
                        plxv_flash_v_off_now();
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                        pPlx->plxvideochannel[CHANNEL_V].window = NullWindow;
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_W].window == (WindowPtr) pDrawable)
                    {
                        plxv_flash_w_off_now();
                        plxv_xpoint_w(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_W, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                        pPlx->plxvideochannel[CHANNEL_W].window = NullWindow;
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_V].window == NullWindow)
                    {
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                    }
                    else if (pPlx->plxvideochannel[CHANNEL_W].window == NullWindow)
                    {
                        plxv_xpoint_w(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_W, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, FALSE);
                    }
                    else
                    {
                        /*
                         * Steal channel v momentarily.
                         */
                        plxv_flash_v_off_now();
                        plxv_xpoint_v(port, 1);
                        plxPutVideo(pDrawable, pGC, CHANNEL_V, TRUE, x, y,
                                    w, h, vx, vy, w, h, xs, ys, xe, ye, TRUE);
                        plxv_xpoint_v(pPlx->plxvideochannel[CHANNEL_V].port, 1);
                        plxv_tag(PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
                        plxv_video_v_stencil(PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
                        plxv_flash_v_squeeze(pPlx->plxvideochannel[CHANNEL_V].vx,
                                             pPlx->plxvideochannel[CHANNEL_V].vy,
                                             pPlx->plxvideochannel[CHANNEL_V].vw,
                                             pPlx->plxvideochannel[CHANNEL_V].vh,
                                             pPlx->plxvideochannel[CHANNEL_V].xs,
                                             pPlx->plxvideochannel[CHANNEL_V].ys,
                                             pPlx->plxvideochannel[CHANNEL_V].xe, 
                                             pPlx->plxvideochannel[CHANNEL_V].ye,
                                             0, 0);
                    }
                    break;
            }
            break;
    }
    DEBUGF(0x40, (fd, "PlxVideoStill: exit\n"));
    return (Success);
}


int
plxVideoScale(pDrawable, pGC, vx, vy, vw, vh, x, y, w, h)
DrawablePtr pDrawable;
GCPtr pGC;
{
    TV2Priv *tv2_priv=GetTv2Priv(pGC);
    DEBUGF(0x40, (fd, "PlxVideoScale: entry and exit\n"));
    return (Success);
}

extern int plxv_video_w_stencil();
extern int plxv_video_v_stencil();
extern int plxv_video_v_wmask();
extern int plxv_video_w_wmask();

int
plxScaleCopyArea(pDrawable, pGC, xva)
DrawablePtr pDrawable;
GCPtr pGC;
xCVideoArgs *xva;
{
    int i, sleep_time;
    short sx, sy, sw, sh, dx, dy, dw, dh, xs, ys, xe, ye;
    Drawable sDrawable;
    TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);
    plxGCPtr    privGC = GetPlxGCPrivate(pGC);
	plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);

    DEBUGF(0x40, (fd, "PlxScaleCopyArea: entry\n"));
    if(tv2_priv->video_tag==0)
    {
        tv2_priv->video_tag = plxGetWid(pGC->pScreen,pDrawable, 0);
        tv2_priv->window_type=PLX_VIDEO;
        privGC->video_priv= (int *)tv2_priv;
    }
    sDrawable = xva->drawable;
    sx = xva->sx;
    sy = xva->sy;
    sw = xva->sw;
    sh = xva->sh;
    dx = xva->dx;
    dy = xva->dy;
    dw = xva->dw;
    dh = xva->dh;

    if (!xv_ctx->main.d.flags && !xv_ctx->opt.board_code)
    {
	DEBUGF(0x40, (fd, "PlxScaleCopyArea: exit hardware not capable\n"));
        return (Success);
    }

    if (tv2_priv->standard == PLX_NTSC)
    {
        sleep_time = NTSC_SLEEP;
        if (dh < NTSC_HEIGHT_HALF)
            sleep_time >>= 1;
    }
    else if (tv2_priv->standard == PLX_PAL || tv2_priv->standard == PLX_SECAM)
    {
        sleep_time = PAL_SLEEP;
        if (dh < PAL_HEIGHT_HALF)
            sleep_time >>= 1;
    }

    if (pPlx->plxvideochannel[CHANNEL_V].window)
    {
        plxv_flash_v_off();
        MyUSleep(sleep_time);
    }

    if (pPlx->plxvideochannel[CHANNEL_W].window)
    {
        plxv_flash_w_off();
        MyUSleep(sleep_time);
    }

    if (output0_port == ~0)
    {
        /*
         * No output port exist.
         */
        i = B_DATA_OUTPUT_W | B_CLK_OUTPUT_D | B_CTL_OUTPUT_D |
            OUTPUT_EN_DATA | OUTPUT_EN_CTL | OUTPUT_EN_CLK |
            HSYNC_HIGH | ODD_HIGH | VSYNC_HIGH | CE_HIGH;
        plxv_xpoint_b(i);
        plxv_xpoint_v(INPUT_LOOPBACK_B,1);
        plxv_xpoint_w(OUTPUT_LOOPBACK_B,1);
    }
    else
    {
        plxv_xpoint_w(OUTPUT_A,1);
        plxv_xpoint_v(INPUT_A,1);
    }
        
    plxv_output_w (sx, sy, sw, sh, 0, 0, dw, dh, 0, 0);

    dx += pDrawable->x;
    dy += pDrawable->y;

    xs = (tv2_priv->xdirection < 0) ? (dx + dw - 1) : dx;
    xe = (tv2_priv->xdirection < 0) ? -dw : dw;
    ys = (tv2_priv->ydirection < 0) ? (dy + dh - 1) : dy;
    ye = (tv2_priv->ydirection < 0) ? -dh : dh;

    plxPutVideo (pDrawable, pGC, CHANNEL_V, TRUE, dx, dy, dw, dh,
                 0, 0, xe, ye, xs, ys, xe, ye, TRUE);

    /*
     * Restore both channels.
     */
    if (pPlx->plxvideochannel[CHANNEL_V].window)
    {
        plxv_xpoint_v(pPlx->plxvideochannel[CHANNEL_V].port, 1);
        plxv_tag(PLXV_CURSOR_MASK|PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
        plxv_video_v_stencil(PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_V].vtag);
        plxv_flash_v_squeeze(pPlx->plxvideochannel[CHANNEL_V].vx,
                             pPlx->plxvideochannel[CHANNEL_V].vy,
                             pPlx->plxvideochannel[CHANNEL_V].vw,
                             pPlx->plxvideochannel[CHANNEL_V].vh,
                             pPlx->plxvideochannel[CHANNEL_V].xs,
                             pPlx->plxvideochannel[CHANNEL_V].ys,
                             pPlx->plxvideochannel[CHANNEL_V].xe,
                             pPlx->plxvideochannel[CHANNEL_V].ye,
                             0, 0);

    }

    if (pPlx->plxvideochannel[CHANNEL_W].window)
    {
        if (pPlx->plxvideochannel[CHANNEL_W].output)
        {
            plxv_xpoint_w(output0_port + OUTPUT_A, 1);
            plxv_output_w(pPlx->plxvideochannel[CHANNEL_W].xs,
                          pPlx->plxvideochannel[CHANNEL_W].ys,
                          pPlx->plxvideochannel[CHANNEL_W].xe,
                          pPlx->plxvideochannel[CHANNEL_W].ye,
                          pPlx->plxvideochannel[CHANNEL_W].vx,
                          pPlx->plxvideochannel[CHANNEL_W].vy,
                          pPlx->plxvideochannel[CHANNEL_W].vw,
                          pPlx->plxvideochannel[CHANNEL_W].vh,
                          0, 0);
            plxv_output_config(output0_port, "ENABLE");
        }
        else
        {
            plxv_xpoint_w(pPlx->plxvideochannel[CHANNEL_W].port, 1);
            plxv_tag(PLXV_CURSOR_MASK|PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_W].vtag);
            plxv_video_w_stencil(PLXV_TAG_ST_MASK, pPlx->plxvideochannel[CHANNEL_W].vtag);
            plxv_flash_w_squeeze(pPlx->plxvideochannel[CHANNEL_W].vx,
                                 pPlx->plxvideochannel[CHANNEL_W].vy,
                                 pPlx->plxvideochannel[CHANNEL_W].vw,
                                 pPlx->plxvideochannel[CHANNEL_W].vh,
                                 pPlx->plxvideochannel[CHANNEL_W].xs,
                                 pPlx->plxvideochannel[CHANNEL_W].ys,
                                 pPlx->plxvideochannel[CHANNEL_W].xe,
                                 pPlx->plxvideochannel[CHANNEL_W].ye,
                                 0, 0);
        }
    }

    DEBUGF(0x40, (fd, "PlxScaleCopyArea: exit\n"));
    return (Success);
}


int
plxVideoStop(pDrawable)
DrawablePtr pDrawable;
{
    plxPrivWinPtr plxWinPtr = (plxPrivWinPtr)plxGetPwinPriv(pDrawable);
    plxScreenPtr  pPlx =  GetPlxPrivate(pDrawable->pScreen);

    CHECKWIN(pDrawable);

    DEBUGF(0x40, (fd, "PlxVideoStop: entry\n"));

    if (pPlx->plxvideochannel[CHANNEL_V].window == (WindowPtr) pDrawable)
    {
	plxv_flash_v_off_now();
	pPlx->plxvideochannel[CHANNEL_V].window = NullWindow;
    }
    if (pPlx->plxvideochannel[CHANNEL_W].window == (WindowPtr) pDrawable)
    {
	plxv_flash_w_off_now();
	pPlx->plxvideochannel[CHANNEL_W].window = NullWindow;
    }
    DEBUGF(0x40, (fd, "PlxVideoStop: exit\n"));
    return (Success);
}


void
plxVideoReshape(pWindow, dx, dy)
WindowPtr pWindow;
int     dx, dy;
{
}


int
plxVideoZoomOn (pWindow,x,y, w, h)
WindowPtr pWindow;
int x,y, w, h;
{
    return (Success);
}


int
plxVideoZoomOff (pWindow,x,y)
WindowPtr pWindow;
int x,y;
{
    return (Success);
}


int
plxSetDebug (val)
unsigned short  val;
{

#ifdef NOTDEF
        plx_debug = val;
#endif
    return (Success);
}


int
plxVideoValuesSet (xvva)
xVideoValueArgs *xvva;
{
    DEBUGF(0x40, (fd, "plxVideoValuesSet: entry and exit\n"));
    return (Success);
}


int
plxPan (x, y)
int  x, y;
{
    return(Success);
}


int
plxCommand (pDrawable, pGC, buf)
Drawable pDrawable;
GC pGC;
short *buf;
{
    return(Success);
}


WindowPtr plxSearchVideoWindow (pWin,now)
WindowPtr pWin;
int now;
{
    register WindowPtr pChild;
	plxScreenPtr  pPlx =  GetPlxPrivate(pWin->drawable.pScreen);

    pChild = pWin;
    while (1)
    {
        if (pChild == pPlx->plxvideochannel[CHANNEL_V].window)
        {
            if(now)
                plxv_flash_v_off_now();
            else
                plxv_flash_v_off();
            return (pChild);
        }
        else if (pChild == pPlx->plxvideochannel[CHANNEL_W].window)
        {
            if(now)
                plxv_flash_w_off_now();
            else
                plxv_flash_w_off();
            return (pChild);
        }
        if (pChild->firstChild)
        {
            pChild = pChild->firstChild;
            continue;
        }
        while (!pChild->nextSib && (pChild != pWin))
            pChild = pChild->parent;
        if (pChild == pWin)
            break;
        pChild = pChild->nextSib;
    }
    return (NullWindow);
}

plxBlankVideoWindow (pWin, pbox, nbox,wid)
WindowPtr pWin;
register BoxPtr pbox;
register int nbox;
register int wid;
{
    int x, y, w, h;

    plxv_tag(PLXV_TAG_MASK_DISABLE,PLXV_TAG_DISABLE);
    plxv_stencil(PLXV_TAG_ST_MASK, wid);
    plxv_wmask(PLXV_PIXEL_MASK);
    plxv_color_24(0);

    while (nbox--)
    {
        plxv_box(pbox->x1, pbox->y1, pbox->x2 - pbox->x1, pbox->y2 - pbox->y1 );

        ++pbox;
    }
}

plxRestartVideoWindow (pWin, pbox, nbox)
WindowPtr pWin;
register BoxPtr pbox;
register int nbox;
{
    register PLXChannelPtr channelptr;
    int channel;
    int x, y, w, h;
    int dx,dy;
    XV_struct *xv=xv_ctx;
    RTV_OBJECT *rtv_hndl;
    TV2Priv *tv2_priv;
    plxPrivWinPtr plxWinPtr = (plxPrivWinPtr)plxGetPwinPriv(pWin);
    plxScreenPtr  pPlx =  GetPlxPrivate(pWin->drawable.pScreen);

    CHECKWIN(pWin);

    /*  IF THIS WINDOW IS TRACKING RTV OPERATIONS, LET THE RTV SERVER KNOW
     *  IT SHOULD RESTART.
     */
    if(plxWinPtr->rtv.handle!=NULL)
    {
	    rtv_hndl= plxWinPtr->rtv.handle;
    }

    if (pWin == pPlx->plxvideochannel[CHANNEL_V].window)
    {
	channel=CHANNEL_V;
        dx=dy=0;
        channelptr = &pPlx->plxvideochannel[CHANNEL_V];
        if(pWin->drawable.x != channelptr->xorg) 
            dx = pWin->drawable.x - channelptr->xorg;
        if(pWin->drawable.y != channelptr->yorg) 
            dy = pWin->drawable.y - channelptr->yorg;
        channelptr->xs += dx;
        channelptr->ys += dy;
        channelptr->xorg= pWin->drawable.x;
        channelptr->yorg= pWin->drawable.y;
        plxv_video_v_stencil(PLXV_TAG_ST_MASK, channelptr->vtag);
        plxv_video_v_wmask(PLXV_PIXEL_MASK);
        plxv_flash_v_squeeze(channelptr->vx, channelptr->vy,
                         channelptr->vw, channelptr->vh,
                         channelptr->xs, channelptr->ys,
                         channelptr->xe, channelptr->ye,
                         0, 0);
	if(plxWinPtr->rtv_track == RtvTrackGetCImage && 
	    rtv_hndl->mode==RTV_RECORD)
	{
	     /* Modified by ABW 12-27-95 */
             SetRTVRecordWindow(&plxWinPtr->rtv,
				channelptr->xs,channelptr->ys-15,
		                channelptr->xe,channelptr->ye);
	     return;
	}
	/*
	 *  The following condintion test was moved from W channel 
	 *  to use V channel instead of W channel. This leaves W channel
	 *  available for Video output. Modified by ABW 12-26-95 .
	 */
	if(plxWinPtr->rtv_track == RtvTrackPutCImage &&
	    rtv_hndl->mode== RTV_PLAY)
	{
            RtvInitC3PutImage(0, 0, channelptr->xe,channelptr->ye,
		 channelptr->xs,channelptr->ys,channelptr->xe, channelptr->ye);
            SetRTVPlayWindow(&plxWinPtr->rtv,channelptr->xs,channelptr->ys,
		 channelptr->xe,channelptr->ye); 
	    return;
	}
    }
    if ((pWin == pPlx->plxvideochannel[CHANNEL_W].window) &&
	    (plxWinPtr->rtv_track == RtvTrackNone)) 
    {
        dx=dy=0;
	channel=CHANNEL_W;
        channelptr = &pPlx->plxvideochannel[CHANNEL_W];
        if(pWin->drawable.x != channelptr->xorg) 
            dx = pWin->drawable.x - channelptr->xorg;
        if(pWin->drawable.y != channelptr->yorg) 
            dy = pWin->drawable.y - channelptr->yorg;
        channelptr->xs += dx;
        channelptr->ys += dy;
        channelptr->xorg= pWin->drawable.x;
        channelptr->yorg= pWin->drawable.y;
        if (channelptr->output)
        {
	    DEBUGF(1, (fd, "plxRestartWindow restarting w signal "));
	    DEBUGF(1, (fd, "(%d, %d, %d, %d) to (%d, %d, %d, %d)\n",
                channelptr->xs, channelptr->ys, channelptr->xe, channelptr->ye,
	        channelptr->vx, channelptr->vy, channelptr->vw,channelptr->vh));
            plxv_xpoint_w(output0_port + OUTPUT_A, 1);
            plxv_output_w(channelptr->xs, channelptr->ys,
                          channelptr->xe, channelptr->ye,
                          channelptr->vx, channelptr->vy,
                          channelptr->vw, channelptr->vh, 0, 0);
            plxv_output_config(output0_port, "ENABLE");
        }
        else
        {
            plxv_video_w_stencil(PLXV_TAG_ST_MASK, channelptr->vtag);
            plxv_video_w_wmask(PLXV_PIXEL_MASK);
            plxv_flash_w_squeeze(channelptr->vx, channelptr->vy,
                         channelptr->vw, channelptr->vh,
                         channelptr->xs, channelptr->ys,
                         channelptr->xe, channelptr->ye,
                         0, 0);
        }
    }
}


plxPutVideo (pDrawable, pGC, channel, single, x, y, w, h, vx, vy, vw, vh, xs, ys, xe, ye, sleep_flag)
DrawablePtr pDrawable;
GCPtr pGC;
int channel, single, x, y, w, h, vx, vy, vw, vh, xs, ys, xe, ye, sleep_flag;
{
    int sleep_time;
    TV2Priv *tv2_priv=SetTv2Priv(pDrawable,pGC);
    plxGCPtr    privGC = GetPlxGCPrivate(pGC);

    DEBUGF(0x40, (fd, "plxPutVideo: entry\n"));
    plxv_tag(PLXV_TAG_ST_MASK,tv2_priv->video_tag);
    plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
    plxv_wmask(PLXV_TAG_MASK_SHIFTED);
    plxv_color_24(0);

    if ( privGC->win_type != PLX_VIDEO_OVR )
        plxdrawback(pDrawable, pGC, x, y, w, h);

    if (channel == CHANNEL_V)
    {
        plxv_video_v_stencil(PLXV_TAG_ST_MASK, tv2_priv->video_tag);
        plxv_video_v_wmask(PLXV_PIXEL_MASK);
        plxv_flash_v_squeeze(vx, vy, vw, vh, xs, ys, xe, ye, 0, single);
    }
    else if (channel == CHANNEL_W)
    {
        plxv_video_w_stencil(PLXV_TAG_ST_MASK, tv2_priv->video_tag);
        plxv_video_w_wmask(PLXV_PIXEL_MASK);
        plxv_flash_w_squeeze(vx, vy, vw, vh, xs, ys, xe, ye, 0, single);
    }

    if (tv2_priv->standard == PLX_NTSC)
    {
        sleep_time = NTSC_SLEEP;
        if (h < NTSC_HEIGHT_HALF)
            sleep_time >>= 1;
    }
    else if (tv2_priv->standard == PLX_PAL || tv2_priv->standard == PLX_SECAM)
    {
        sleep_time = PAL_SLEEP;
        if (h < PAL_HEIGHT_HALF)
            sleep_time >>= 1;
    }
    if (sleep_flag)
        sleep_time <<= 1;
    MyUSleep(sleep_time);
    DEBUGF(0x40, (fd, "plxPutVideo: exit\n"));
}


PlxVideoImageProc(pDrawable, pGC, req, client)
register DrawablePtr pDrawable;
register GCPtr pGC;
register xPlxImageReq *req;
register ClientPtr client;
{

/*
 *  Added to switch context for different screens (ABW 7-15-94).
 */
    CHECKWIN(pDrawable);

    plxv_switch_context(PlxGetCtx(pGC->pScreen));

    switch (req->videoReqType) {
        case X_PlxPutQTable:
        case xv_PlxPutQTable:
            return plxPutQTable(pDrawable, pGC, req, &req[1]);
        case X_PlxGetCImage:
        case xv_PlxGetCImage:
            return PlxGetCImage(pDrawable, pGC, req, client, FALSE);
        case X_PlxPutCImage:
        case xv_PlxPutCImage:
            return PlxPutCImage(pDrawable, pGC, req, &req[1]);
        case X_PlxShmGetCImage:
        case xv_PlxShmGetCImage:
            return PlxGetCImage(pDrawable, pGC, req, client, TRUE);
        case X_PlxShmPutCImage:
        case xv_PlxShmPutCImage:
            return PlxShmPutCImage(pDrawable, pGC, req, client);
        case X_PlxRtvGetCImage:
            return PlxRtvGetCImage(pDrawable, pGC, req, client);
        case X_PlxRtvPutCImage:
            return PlxRtvPutCImage(pDrawable, pGC, req, client);
	case X_PlxRtvConnect:
	      return PlxRtvConnect(pDrawable,pGC,req,client);
	case X_PlxRtvDisconnect:
	      return PlxRtvDisconnect(pDrawable,pGC,req,client);
        default:
        return (BadRequest);
    }
}

#define CCCBUFSIZE 0x40000

PlxPutCImage(pDraw, pGC, req, data)
register DrawablePtr pDraw;
register GCPtr pGC;
register xPlxImageReq *req;
int *data;
{

    int ccube_fd;
    int size, channel;
    int (*stencil_func)();
    int (*wmask_func)();
    int *buf;
    TV2Priv *tv2_priv;
    register PLXChannelPtr channelptr;
    plxGCPtr      privGC = GetPlxGCPrivate(pGC);
    plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);


    DEBUGF(0x40, (fd, "PlxPutCImage: entry\n"));
    tv2_priv = SetTv2Priv(pDraw,pGC);
    ccube_fd= plxGetScreenFd(pGC->pScreen);

    if (pPlx->plxvideochannel[CHANNEL_W].window == NullWindow)
    {
        channel = CHANNEL_W;
        stencil_func = plxv_video_w_stencil;
        wmask_func =  plxv_video_w_wmask;
    }
    else
    {
        channel = CHANNEL_V;
        stencil_func = plxv_video_v_stencil;
        wmask_func =  plxv_video_v_wmask;
        /*
         * Steal channel v momentarily.
         */
        if (pPlx->plxvideochannel[CHANNEL_V].window)
        {
            plxv_flash_v_off_now();
        }
    }

    size = req->planeMask;

    if(tv2_priv->video_tag==0)
    {
        tv2_priv->video_tag = plxGetWid(pGC->pScreen,pDraw, 0);
        tv2_priv->window_type=PLX_VIDEO;
        privGC->video_priv= (int *)tv2_priv;
        plxv_tag(PLXV_CURSOR_MASK|PLXV_TAG_ST_MASK,tv2_priv->video_tag);
        plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
        plxv_wmask(PLXV_TAG_MASK);
        plxv_color_24(0);
        plxdrawback(pDraw, pGC, req->dst_x + pDraw->x, req->dst_y + pDraw->y,
                req->dst_w, req->dst_h);
    }
    else if ( (tv2_priv->gov_mode == PLX_VIDEO) && 
              (privGC->win_type != PLX_VIDEO_OVR) )
    {
        plxv_tag(PLXV_TAG_ST_MASK,tv2_priv->video_tag);
        plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
        plxv_wmask(PLXV_TAG_ST_PIXEL_MASK);
        plxv_color_24(0);
        plxdrawback(pDraw, pGC, req->dst_x + pDraw->x, req->dst_y + pDraw->y,
                req->dst_w, req->dst_h);
    }
    else
    {
    }

     (*stencil_func)(PLXV_TAG_ST_MASK, tv2_priv->video_tag);
     (*wmask_func)(PLXV_PIXEL_MASK);


    /*
     *  centralize the output image and fake the destination size when it is 
     *  bigger than the size of the source
     */

    if (req->dst_w > req->src_w || req->dst_h > req->src_h )
    {
        if (req->dst_w > req->src_w)
        {
            req->dst_x = req->src_x + (int)(req->dst_w - req->src_w)/2;
            req->dst_w = req->src_w;
        }
        if (req->dst_h > req->src_h )
        {
            req->dst_y = req->src_y + (int)(req->dst_h - req->src_h)/2;
            req->dst_h = req->src_h;
        }
    }

    if(tv2_priv->qtab == NULL)
    {
        if(pPlx->decompression_qtable == NULL)
        {
             fprintf(stderr,"No QTABLE supplied for Decompressiong - C3PutImage\n");
             get_qtables(q_factor,&pPlx->compression_qtable,
				&pPlx->decompression_qtable);
        }

        size = C3PutImage(ccube_fd,req->src_x,req->src_y,req->src_w,req->src_h,
               req->dst_x + pDraw->x, req->dst_y + pDraw->y, req->dst_w,
               req->dst_h, req->format, data, size, 
                        pPlx->decompression_qtable, tv2_priv->htab, channel);
    }
    else
        size = C3PutImage(ccube_fd,req->src_x,req->src_y,req->src_w,req->src_h,
               req->dst_x + pDraw->x, req->dst_y + pDraw->y, req->dst_w,
               req->dst_h, req->format, data, size, 
                        tv2_priv->qtab, tv2_priv->htab, channel);

    /*
     * Restore channel v.
     */
    channelptr = &pPlx->plxvideochannel[channel];
    if (channelptr->window)
    {
        plxv_xpoint_v(channelptr->port, 1);
        plxv_tag(PLXV_CURSOR_MASK|PLXV_TAG_ST_MASK, channelptr->vtag);
        plxv_video_v_stencil(PLXV_TAG_ST_MASK, channelptr->vtag);
        plxv_flash_v_squeeze(channelptr->vx, channelptr->vy,
                             channelptr->vw, channelptr->vh,
                             channelptr->xs, channelptr->ys,
                             channelptr->xe, channelptr->ye, 0, 0);
    }

   /* Disable for double buffer test.
   MyUSleep(25000);      
   */
    DEBUGF(0x40, (fd, "PlxPutCImage: exit\n"));
    return (Success);
}
/*----- Rtv Connect proc---- */
PlxRtvConnect(pDraw, pGC, req, client)
register DrawablePtr pDraw;
register GCPtr pGC;
register xPlxImageReq *req;
register ClientPtr client;
{
	xPlxRtvImageReply rtv;
    plxPrivWinPtr plxWinPtr;
    CHECKWIN(pDraw);
    plxWinPtr = (plxPrivWinPtr) plxGetPwinPriv((WindowPtr) pDraw);
    if(plxWinPtr->rtv.handle)
    {
		fprintf(stderr,"PlxRtvConnect: allready connected\n");
	    return BadValue;
    }

    if(ConnectRTV(&plxWinPtr->rtv) == 0)
    {
	    fprintf(stderr, "PlxRtvConnect: connect failed\n");
	    return BadValue;
    }
    rtv.type = X_Reply;
    rtv.sequenceNumber = client->sequence;
    rtv.length = 0;
	rtv.reply=1;
    WriteReplyToClient(client, sizeof(xPlxRtvImageReply), &rtv);
    return (Success);
}

PlxRtvDisconnect(pDraw, pGC, req, client)
register DrawablePtr pDraw;
register GCPtr pGC;
register xPlxImageReq *req;
register ClientPtr client;
{
	xPlxRtvImageReply rtv;
    plxPrivWinPtr plxWinPtr;
    plxWinPtr = (plxPrivWinPtr) plxGetPwinPriv((WindowPtr) pDraw);
    
    CHECKWIN(pDraw);

    if(plxWinPtr->rtv.handle==NULL)
    {
	    fprintf(stderr,"PlxRtvPutDisconnect: not tracking\n");
	    return BadValue;
    }
	plxWinPtr->rtv_track = RtvTrackNone;
	rtv_state=0; /* reset of rtv_state Added by ABW 12-29-95 */
	DisconnectRTV(&plxWinPtr->rtv);
	plxWinPtr->rtv.handle = NULL;
    rtv.type = X_Reply;
    rtv.sequenceNumber = client->sequence;
    rtv.length = 0;
	rtv.reply=1;
    WriteReplyToClient(client, sizeof(xPlxRtvImageReply), &rtv);
    return (Success);
}



/*---------------------------------------------------------------------------*
 |"PlxRtvPutCImage"
 |
 |  Initiate an RTV put compressed image operation.
 |
 |    = Success on success, error code on failure.
 *---------------------------------------------------------------------------*/
PlxRtvPutCImage(pDraw, pGC, req, client)
register DrawablePtr pDraw;
register GCPtr pGC;
register xPlxImageReq *req;
register ClientPtr client;
{
    int channel,dx;
    int *buf;
    xPlxRtvImageReply rtv;
    RTV_OBJECT *rtv_hndl;
    TV2Priv *tv2_priv;
    XV_struct *xv=xv_ctx;
    register PLXChannelPtr channelptr;
    plxPrivWinPtr plxWinPtr;
    plxGCPtr      privGC = GetPlxGCPrivate(pGC);
    plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);

    CHECKWIN(pDraw);

    plxWinPtr = (plxPrivWinPtr) plxGetPwinPriv((WindowPtr) pDraw);
    channelptr = &pPlx->plxvideochannel[CHANNEL_V];
    tv2_priv = SetTv2Priv(pDraw,pGC);

    if(plxWinPtr->rtv.handle==NULL)
    {
	fprintf(stderr,"PlxRtvPutCImage: Rtv Server not connected\n");
	return BadValue;
    }
    rtv_hndl= plxWinPtr->rtv.handle;

    rtv_state=plxWinPtr->rtv_track = RtvTrackPutCImage; /* Modified by ABW 12-29-95 */
    rtv_hndl->mode=RTV_PLAY;

    if(tv2_priv->video_tag==0)
    {
        tv2_priv->video_tag = plxGetWid(pDraw->pScreen,pDraw, 0);
        tv2_priv->window_type=PLX_VIDEO;
        privGC->video_priv= (int *)tv2_priv;
        plxv_tag(PLXV_CURSOR_MASK|PLXV_TAG_ST_MASK,tv2_priv->video_tag);
        plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
        plxv_wmask(PLXV_TAG_MASK);
        plxv_color_24(0);
        plxdrawback(pDraw, pGC, pDraw->x+req->dst_x ,pDraw->y+req->dst_y-15,
                req->dst_w, req->dst_h+15);
    }
    else if ( (tv2_priv->gov_mode == PLX_VIDEO) && 
              (privGC->win_type != PLX_VIDEO_OVR) )
    {
        plxv_tag(PLXV_TAG_ST_MASK,tv2_priv->video_tag);
        plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
        plxv_wmask(PLXV_TAG_ST_PIXEL_MASK);
        plxv_color_24(0);
        plxdrawback(pDraw, pGC, pDraw->x+req->dst_x , pDraw->y+req->dst_y-15,
                req->dst_w, req->dst_h+15);
    }
    plxv_video_v_stencil(PLXV_TAG_ST_MASK, tv2_priv->video_tag);
    plxv_video_v_wmask(PLXV_PIXEL_MASK);

    channelptr->window = (WindowPtr) pDraw;
    channelptr->port = 0;
    channelptr->output = FALSE;
    channelptr->vx = req->dst_x;
    channelptr->vy = req->dst_y+25; /* Modified by ABW 12-26-95 */
    channelptr->vw = req->dst_w;
    channelptr->vh = req->dst_h;
    channelptr->xs = pDraw->x+req->src_x; /* Modified by ABW 12-26-95 */
    channelptr->ys = pDraw->y+req->src_y-15; /* Modified by ABW 12-26-95 */
    channelptr->xe = req->dst_w;
    channelptr->ye = req->dst_h;
    channelptr->xdir = tv2_priv->xdirection;
    channelptr->ydir = tv2_priv->ydirection;
    channelptr->vtag = tv2_priv->video_tag;
    channelptr->xorg = pDraw->x;
    channelptr->yorg = pDraw->y;


    if(xv->opt.board_code)
    {
        if(req->format==PLX_NTSC)
	    plxv_output_config(output0_port,"525");
        else
	    plxv_output_config(output0_port, "625");
    }
    else
    {
        if(req->format==PLX_NTSC)
	    plxv_input_config(INPUT_A,"525");
        else
	    plxv_input_config(INPUT_A, "625");
    }

#ifdef RTV_DEBUG
    fprintf(stderr,"PlxRtvPutCImage: xs=%d ys=%d xe=%d ye=%d\n",
    channelptr->xs,channelptr->ys,channelptr->xe,channelptr->ye); 
#endif
    /* Added to reset window size and position. Changes made
     * to support RTV playback on V channel by ABW 12-26-95.
     */
    plxv_flash_v_squeeze(channelptr->vx, channelptr->vy,
                         channelptr->vw, channelptr->vh,
                         channelptr->xs, channelptr->ys,
                         channelptr->xe, channelptr->ye, 0, 0);

    RtvInitC3PutImage(0, 0, channelptr->xe,channelptr->ye,
		 channelptr->xs,channelptr->ys,channelptr->xe, channelptr->ye);
    SetRTVPlayWindow(&plxWinPtr->rtv, 
		channelptr->xs,channelptr->ys, channelptr->xe, channelptr->ye);

    rtv.type = X_Reply;
    rtv.sequenceNumber = client->sequence;
    rtv.length = 0;
	rtv.reply=1;
    WriteReplyToClient(client, sizeof(xPlxRtvImageReply), &rtv);
    return (Success);
}


#define VERIFY_SHMSEG(shmseg,shmdesc,client) \
{ \
    shmdesc = (ShmDescPtr)LookupIDByType(shmseg, PlxShmSegType); \
    if (!shmdesc) \
    { \
        client->errorValue = shmseg; \
        return PlxBadShmSegCode; \
    } \
}

#define VERIFY_SHMPTR(shmseg,offset,needwrite,shmdesc,client) \
{ \
    VERIFY_SHMSEG(shmseg, shmdesc, client); \
    if ((offset & 3) || (offset > shmdesc->size)) \
    { \
        client->errorValue = offset; \
        return BadValue; \
    } \
    if (needwrite && !shmdesc->writable) \
        return BadAccess; \
}

#define VERIFY_SHMSIZE(shmdesc,offset,len,client) \
{ \
    if ((offset + len) > shmdesc->size) \
    { \
        return BadAccess; \
    } \
}


PlxShmPutCImage(pDrawable, pGC, req, client)
register DrawablePtr pDrawable;
register GCPtr pGC;
register xPlxImageReq *req;
register ClientPtr client;
{
    ShmDescPtr          shmdesc;

    VERIFY_SHMPTR(req->shmseg, req->offset, FALSE, shmdesc, client);

    PlxPutCImage(pDrawable, pGC, req, shmdesc->addr + req->offset);

    if (req->sendEvent)
    {
        xShmCompletionEvent ev;
        ev.type = PlxShmCompletionCode;
        ev.drawable = req->drawable;
        ev.sequenceNumber = client->sequence;
        ev.minorEvent = X_PlxShmGetCImage;
        ev.majorEvent = PlxShmReqCode;
        ev.shmseg = req->shmseg;
        ev.offset = req->offset;
        WriteEventsToClient(client, 1, (xEvent *) &ev);
    }
     return (client->noClientException);
}

/*#define CCCBUFSIZE 0x40000 */

static void XIswap (Client, Size, Reply)
register ClientPtr Client;
register int Size;
register xPlxGetImageReply *Reply;
{
    register n;

    swaps(&Reply->sequenceNumber, n);
    swapl(&Reply->length, n);
    swapl(&Reply->visual, n);
    swapl(&Reply->size, n);
    (void) WriteToClient(Client, Size, (char *) Reply);
}
plxFreeResources(pScreen)
    ScreenPtr pScreen;
{
    plxScreenPtr  pPlx =  GetPlxPrivate(pScreen);
    if(pPlx->c3buf1) xfree(pPlx->c3buf1);
}

PlxGetCImage(pDraw, pGC, req, client, shm_flag)
register DrawablePtr pDraw;
register GCPtr pGC;
register xPlxImageReq *req;
register ClientPtr client;
int shm_flag;
{

    int ccube_fd;
    int size;
    int *buf;
    ShmDescPtr shmdesc;
    xPlxGetImageReply xgi;
    TV2Priv *tv2_priv;
    PLXChannelPtr channelptr;
    plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);

    DEBUGF(0x40, (fd, "PlxGetCImage: entry\n"));
    channelptr = &pPlx->plxvideochannel[CHANNEL_W];
    tv2_priv = SetTv2Priv(pDraw,pGC);
    ccube_fd= plxGetScreenFd(pGC->pScreen);



    if (shm_flag)
    {
        VERIFY_SHMPTR(req->shmseg, req->offset, TRUE, shmdesc, client);
        buf = (int *)(shmdesc->addr + req->offset);
        size = shmdesc->size - req->offset;
    }
    else
    {
        if (!pPlx->c3buf1)
        {
            pPlx->c3buf1 = (int *) xalloc(CCCBUFSIZE+4);
            if(pPlx->c3buf1 == NULL)return(BadAlloc);
        }
            
        buf = (int *) pPlx->c3buf1;
        size = CCCBUFSIZE;
    }


    if (channelptr->window)
        plxv_flash_w_off_now();

    if(tv2_priv->qtab == NULL)
    {
        if(pPlx->compression_qtable == NULL)
        {
	    fprintf(stderr,"No QTABLE supplied for Compression - C3GetImage\n");
            get_qtables(q_factor,&pPlx->compression_qtable,
			 &pPlx->decompression_qtable);
        }
        size = C3GetImage(ccube_fd,req->src_x + pDraw->x,req->src_y + pDraw->y,
                      req->src_w, req->src_h, req->dst_x, req->dst_y,
                      req->dst_w, req->dst_h, 0, buf, size, 
                      pPlx->compression_qtable, tv2_priv->htab);
    }
    else
        size = C3GetImage(ccube_fd,req->src_x + pDraw->x,req->src_y + pDraw->y,
                      req->src_w, req->src_h, req->dst_x, req->dst_y,
                      req->dst_w, req->dst_h, 0, buf, size, 
                      tv2_priv->qtab, tv2_priv->htab);

    /*
     * Restore channel w.
     */
    if (channelptr->window)
    {
        if (channelptr->output)
        {
            plxv_xpoint_w(output0_port + OUTPUT_A, 1);
            plxv_output_w(channelptr->xs, channelptr->ys,
                          channelptr->xe, channelptr->ye,
                          channelptr->vx, channelptr->vy,
                          channelptr->vw, channelptr->vh, 0, 0);
            plxv_output_config(output0_port, "ENABLE");
        }
        else
        {
            plxv_xpoint_w(channelptr->port, 1);
            plxv_tag(PLXV_CURSOR_MASK|PLXV_TAG_ST_MASK, channelptr->vtag);
            plxv_video_w_stencil(PLXV_TAG_ST_MASK, channelptr->vtag);
            plxv_flash_w_squeeze(channelptr->vx, channelptr->vy,
                                 channelptr->vw, channelptr->vh,
                                 channelptr->xs, channelptr->ys,
                                 channelptr->xe, channelptr->ye, 0, 0);
        }
    }

    xgi.type = X_Reply;
    xgi.depth = pDraw->depth;
    xgi.sequenceNumber = client->sequence;
    xgi.length = (size + 3) >> 2;
    xgi.visual = None;

    if (size > 0)
    {
        xgi.visual = wVisual(((WindowPtr)pDraw));
        xgi.size = size;
    }
    else
    {
        xgi.visual = None;
        xgi.size = 0;
    }

    ReplySwapVector[((xReq *)client->requestBuffer)->reqType] = XIswap;
    WriteReplyToClient(client, sz_xPlxGetImageReply, &xgi);

    if ((size > 0) && (shm_flag == 0))
            WriteToClient(client, size, buf);

    DEBUGF(0x40, (fd, "PlxGetCImage: exit\n"));

    return (Success);
}


/*---------------------------------------------------------------------------*
 |"PlxRtvGetCImage"
 |
 |  Initiate an RTV get compressed image operation.
 |
 |    = Success on success, error code on failure.
 *---------------------------------------------------------------------------*/

int PlxRtvGetCImage(pDraw, pGC, req, client)
register DrawablePtr pDraw;
register GCPtr pGC;
register xPlxImageReq *req;
register ClientPtr client;
{
    xPlxRtvImageReply rtv;
    TV2Priv *tv2_priv;
    PLXChannelPtr channelptr;
    RTV_OBJECT *rtv_hndl;
    plxPrivWinPtr plxWinPtr;

    plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);

    CHECKWIN(pDraw);

    DEBUGF(0x40, (fd, "PlxRtvGetCImage: entry\n"));

    plxWinPtr = (plxPrivWinPtr) plxGetPwinPriv((WindowPtr) pDraw);
    channelptr = &pPlx->plxvideochannel[CHANNEL_W];
    tv2_priv = SetTv2Priv(pDraw,pGC);

    DEBUGF(0x20, (fd, "#### plxRtvGetCImage: setting RTV TrackGetCImage\n"));

    if(plxWinPtr->rtv.handle==NULL)
    {
	    fprintf(stderr,"PlxRtvGetCImage: Rtv Server not connected\n");
	    return BadValue;
    }
    rtv_hndl= plxWinPtr->rtv.handle;
    rtv_hndl->mode=RTV_RECORD;
    rtv_state=plxWinPtr->rtv_track = RtvTrackGetCImage; /* Modified by ABW 12-29-95 */

    channelptr->window = (WindowPtr) pDraw;
    channelptr->port = 0;
    channelptr->output = FALSE;
    channelptr->vx = req->src_x;
    channelptr->vy = req->src_y;
    channelptr->vw = req->src_w;
    channelptr->vh = req->src_h;
    channelptr->xs = pDraw->x+req->dst_x;
    channelptr->ys = pDraw->y+req->dst_y;
    channelptr->xe = pDraw->width;
    channelptr->ye = pDraw->height;
    channelptr->xdir = tv2_priv->xdirection;
    channelptr->ydir = tv2_priv->ydirection;
    channelptr->vtag = tv2_priv->video_tag;
    channelptr->xorg = pDraw->x;
    channelptr->yorg = pDraw->y;


    RtvInitC3GetImage(channelptr->xs,channelptr->ys,
	              channelptr->xe,channelptr->ye,
		      0, 0, channelptr->xe, channelptr->ye);
    SetRTVRecordWindow(&plxWinPtr->rtv,channelptr->xs,channelptr->ys-15,
	channelptr->xe,channelptr->ye);
	

    rtv.type = X_Reply;
    rtv.sequenceNumber = client->sequence;
    rtv.length = 0;
	rtv.reply=1;
    WriteReplyToClient(client, sizeof(xPlxRtvImageReply), &rtv);
    return (Success);
}



plxPutQTable (pDraw,pGC, req, data)
DrawablePtr pDraw;
GCPtr pGC;
register xPlxImageReq *req;
short *data;
{
    int size, tab_flag;
    unsigned short *table;
    TV2Priv *tv2_priv;
    plxScreenPtr  pPlx =  GetPlxPrivate(pGC->pScreen);

    DEBUGF(0x40, (fd, "plxPutQTable: entry\n"));

    tv2_priv = SetTv2Priv(pDraw,pGC);
    size = (req->length << 2) - sizeof(xPlxImageReq);
    tab_flag = plxv_create_c3table(req->format, data, size, &table);
    if (tab_flag & 0x1)
    {
        if(tv2_priv->qtab != NULL)
            free ((pointer) tv2_priv->qtab);
        tv2_priv->qtab = (short *)table;
        if(req->format == 1)
            pPlx->compression_qtable=  (short *)table;
        else
            pPlx->decompression_qtable= (short *)table;
    }
    else if (tab_flag & 0x2)
    {
        if (tv2_priv->htab != NULL)
            free ((pointer) tv2_priv->htab);
        tv2_priv->htab = (short *) table;
    }
    DEBUGF(0x40, (fd, "plxPutQTable: exit\n"));
    return (Success);
}


plxSetParameterString(client, pGC, s)
ClientPtr client;
GCPtr pGC;
char *s;
{
    register int port;
    char *v;
    TV2Priv *tv2_priv=GetTv2Priv(pGC);


    if (tv2_priv->channel == PLX_INPUT_0)
        port = PORT_D;
    else if (tv2_priv->channel == PLX_INPUT_1)
        port = input1_port;
    else if (tv2_priv->channel == PLX_OUTPUT_0)
        port = output0_port;
    else
        return (BadValue);

    s += strspn(s, " \t\n\r");
    s = (char *)(strtok(s, " \t\n\r"));
    if(strcmp(s,"input_config")==0){  /* input config */
      while (s) {
        v = (char *)(strtok(NULL, " \t\n\r"));
        if (v==NULL) break;
        plxv_input_config(port, v);
        s = (char *)(strtok(NULL, " \t\n\r"));
      }
    }
    else {              /* output config */
      while (s) {
        v = (char *)(strtok(NULL, " \t\n\r"));
        if (v==NULL) break;
        plxv_output_config(output0_port, v);
        s = (char *)(strtok(NULL, " \t\n\r"));
      }
    }

    return (Success);
}


plxGetParameterString(client, pGC)
ClientPtr client;
GCPtr pGC;
{
    xVideoConfigReply reply;
    static char buf[4096];
    char nbuf[256];
    int nbytes, status, standard_flag;
    register int port;
    TV2Priv *tv2_priv=GetTv2Priv(pGC);


    if (tv2_priv->channel == PLX_INPUT_0)
        port = PORT_D;
    else if (tv2_priv->channel == PLX_INPUT_1)
        port = input1_port;
    else if (tv2_priv->channel == PLX_OUTPUT_0)
        port = output0_port;
    else
        return (BadValue);

    buf[0] = '\0' ;

    sprintf(nbuf, "hardware ex_video hardware_code %d ", PLX_XVIDEO_24);
    strcat(buf, nbuf);

    if (port != 2)
    {
        sprintf(nbuf, "hue %d saturation %d brightness %d contrast %d ",
                plxvideoport[port].knob.hue, plxvideoport[port].knob.saturation,
                plxvideoport[port].knob.bright, plxvideoport[port].knob.contrast);
        strcat(buf, nbuf);

    }

    sprintf(nbuf, "channel_code %d format_code %d ", tv2_priv->channel,  tv2_priv->format);
    strcat(buf, nbuf);

    if (tv2_priv->standard == PLX_NTSC)
    {
        standard_flag = 0x20;
        sprintf(nbuf, "standard ntsc standard_code %d signal_width %d signal_height %d signal_blanking %d signal_rate %d ",
                PLX_NTSC, NTSC_WIDTH, NTSC_HEIGHT, NTSC_BLANK, NTSC_RATE);
    }
    else if (tv2_priv->standard == PLX_PAL)
    {
        standard_flag = 0;
        sprintf(nbuf, "standard pal standard_code %d signal_width %d signal_height %d signal_blanking %d signal_rate %d ",
                PLX_PAL, PAL_WIDTH, PAL_HEIGHT, PAL_BLANK, PAL_RATE);
    }
    else if (tv2_priv->standard == PLX_SECAM)
    {
        standard_flag = 0;
        sprintf(nbuf, "standard secam standard_code %d signal_width %d signal_height %d signal_blanking %d signal_rate %d ",
                PLX_SECAM, PAL_WIDTH, PAL_HEIGHT, PAL_BLANK, PAL_RATE);
    }

    strcat(buf, nbuf);
    strcat(buf, "interlaced true ");
    if (tv2_priv->channel != PLX_OUTPUT_0)
    {
        plxv_input_status(port, &status);
        if (((status & 0x40) == 0) && ((status & 0x20) == standard_flag))
            strcat(buf, "sync present ");
        else
            strcat(buf, "sync absent ");

        if (status & 1)
            strcat(buf, "burst present ");
        else
            strcat(buf, "burst absent ");
    }
    else
        strcat(buf, "sync present ");

    nbytes = strlen(buf) + 1;

    reply.type = X_Reply;
    reply.sequenceNumber = client->sequence;
    reply.length = (nbytes+3) >> 2 ;
    WriteReplyToClient(client, sz_xVideoConfigReply, &reply);

    if (nbytes)
        WriteToClient(client, nbytes, buf);
    return(Success);
}
