

#include    <stdio.h>
#include    "sun.h"
#include    "mpg/mpg.h"
#include    "mpg/wid.h"
#include    "cmap/cmap.h"
#include     "X.h"
#include    "windowstr.h"
#include    <sys/mman.h>
#include    <sys/memfb.h>
#include    <sys/fbio.h>

#include    <sys/ioccom.h>
#include    <sys/fcntl.h>

#include    "colormap.h"
#include    "colormapst.h"
#include    "resource.h"
#include    "mibstore.h"
#include    "plxInit.h"
#define XV_DIAG 1
#include    "xvdebug.h"

#define PLX_PAL 4

extern int clutindex;
extern int video_active;
extern VisualID VIDs[];

#define GET_PWID(w) (widGetValue(widGetWindowWid(((WindowPtr)(w))->parent)))


extern void cfbDestroyWindow();



extern void plx32PaintWindow();
extern void plx8PaintWindow();

extern void plx32CopyWindow();
extern void plx8CopyWindow();

PlxPaintWindow(WindowPtr        pWin,
                    RegionPtr   pRegion,
                    int         what)
{
    int pg; 
    int wid;
    
/*    pg = mpg_drawable_id(pWin);       */
    wid = widWinGetValue(pWin);
    plxv_rop(PLXV_ROP_COPY);
    plxv_tag(PLXV_TAG_MASK_DISABLE,PLXV_TAG_DISABLE);
#ifdef NOTDEF
    plxv_stencil(PLXV_TAG_ST_MASK,wid);
#else
    plxv_stencil(PLXV_ST_MASK_DISABLE,PLXV_ST_DISABLE);
#endif
    plxv_wmask(PLXV_PIXEL_MASK);

    switch(pWin->drawable.depth)
    {
    case 8:
         plx8PaintWindow(pWin, pRegion, what,wid);
         break;
    case 24:
         plx32PaintWindow(pWin, pRegion, what,wid);
         break;
    default:
      ErrorF("PlxPaintWindow : Invalid depth <%d>\n",pWin->drawable.depth);
    }

}

Bool
PlxUnmapWindow(pWin)
    WindowPtr pWin;
{
register BoxPtr pbox;
register int nbox;
plxPrivWinPtr plxWinPtr;
register WindowPtr pVideo = NULL;
WindowPtr pParent = pWin->parent;
ScreenPtr pScreen = pWin->drawable.pScreen;
plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);

  plxWinPtr = (plxPrivWinPtr )pWin->devPrivates[plxWindowPrivateIndex].ptr;
  if ( pParent!=NULL &&  plxWinPtr->window_type)
#ifdef STOP_VW
  if (pWin->mapped && pParent!=NULL && !pParent->realized && plxWinPtr->window_type)
#endif
  {
    if(plxWinPtr->window_type==PLX_WINDOW_TYPE)
    {
        plxVideoStop((DrawablePtr)pWin);
        pbox = REGION_RECTS(&pWin->clipList);
        nbox = REGION_NUM_RECTS(&pWin->clipList);
        plxBlankVideoWindow (pWin, pbox, nbox,plxWinPtr->wid);
        plxWinPtr->mapped=0;
    }
  }
    return (TRUE);
}

Bool
PlxDestroyWindow(pWin)
    WindowPtr pWin;
{
plxPrivWinPtr plxWinPtr;
plxGCPtr        privGC;
TV2Priv         *tv2_priv;
ScreenPtr pScreen = pWin->drawable.pScreen;
plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);



    plxFreeWindowWids(pWin); /* free any video wids associated with the window */
    if(pWin->devPrivates[plxWindowPrivateIndex].ptr)
    {
        plxWinPtr =(plxPrivWinPtr)pWin->devPrivates[plxWindowPrivateIndex].ptr;
        if(plxWinPtr->window_type == PLX_WINDOW_TYPE || 
           plxWinPtr->window_type == XV_WINDOW_TYPE)
        {
            if(plxWinPtr->hash >0)
                if(plxWinPtr->widptr) widDecref(plxWinPtr->widptr);
/*
 * The following was added to gracefully disconnect from RTV-server
 * when window is destroyed by abnormal methods. -ABW 10-25-95 ***
 */
	        if(plxWinPtr->rtv.handle != NULL)
	        {
#ifdef RTV_DEBUG
	          fprintf(stderr, "About to disconnect\n");
#endif
	          DisconnectRTV(&plxWinPtr->rtv); 
	          plxWinPtr->rtv.handle = NULL;
	        }

        }
        xfree(pWin->devPrivates[plxWindowPrivateIndex].ptr);
    }
    cfbDestroyWindow(pWin);
    return(TRUE); 
}
#ifdef REMOVE
plxSetPwinPriv(WindowPtr pWin,int *obj,int mode)
{
plxPrivWinPtr plxWinPtr;
      plxWinPtr = (plxPrivWinPtr )pWin->devPrivates[plxWindowPrivateIndex].ptr;

      switch(mode)
      {
      case VideoPriv:
           plxWinPtr->Video_Priv= (int *)obj;
           break;
      case WidPriv:
           plxWinPtr->widptr = (int *)obj;
           break;
      }
}
#endif
plxPrivWinPtr plxGetPwinPriv(WindowPtr pWin)
{
plxPrivWinPtr plxWinPtr;
     if(pWin->devPrivates == NULL)return(NULL);
      plxWinPtr = (plxPrivWinPtr )pWin->devPrivates[plxWindowPrivateIndex].ptr;
     return(plxWinPtr);
}

extern          WindowPtr *WindowTable;
int plxGetWindowType(WindowPtr pWin)
{
plxPrivWinPtr plxWinPtr;
WindowPtr pParent = pWin->parent;

  if(pWin->devPrivates == NULL)return(0);
  if (pWin->mapped && pParent!=NULL && pParent->realized) 
  {
      plxWinPtr = (plxPrivWinPtr )pWin->devPrivates[plxWindowPrivateIndex].ptr;
      return(plxWinPtr->window_type);
  }
  else
      return (0);
}



void plxSetWindowType(WindowPtr pWin,int type)
{
plxPrivWinPtr plxWinPtr;
DrawablePtr  pDraw;
ScreenPtr pScreen = pWin->drawable.pScreen;
plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);
  if(pWin->devPrivates == NULL)return;
  pDraw = (DrawablePtr)pWin;
  if (pDraw->type == DRAWABLE_WINDOW)
  {
       if(pWin->devPrivates[plxWindowPrivateIndex].ptr)
       {
           plxWinPtr = (plxPrivWinPtr )pWin->devPrivates[plxWindowPrivateIndex].ptr;
           plxWinPtr->window_type=type;
       }
  }
}

Bool
PlxCreateWindow(WindowPtr pWin)
{
  plxPrivWinPtr plxWinPtr;
  Bool ret;
  int wid;
  int flavor=0;
  ScreenPtr     pScreen = pWin->drawable.pScreen;
  int vid = WindowVisual(pWin);
  plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);

  if(cfbCreateWindow(pWin))
  {
        pWin->devPrivates[plxWindowPrivateIndex].ptr = 
		(pointer )xalloc(sizeof(plxWinRec));
        plxWinPtr = (plxPrivWinPtr)pWin->devPrivates[plxWindowPrivateIndex].ptr;
        switch ( pWin->drawable.depth )
        {
          case 8:
            if(pPlxPrivate->WidPtr8 == NULL)
            {
                pPlxPrivate->WidPtr8= widAllocate(pScreen,vid,1,FALSE,flavor);
            }
            widSetWindowWid(pWin, pPlxPrivate->WidPtr8, TRUE);
            wid=widGetValue(pPlxPrivate->WidPtr8);
            plxWinPtr->widptr = (int *)pPlxPrivate->WidPtr8;
            break;
          case 24:
            if ( vid == VIDs[2] )  /* TrueColor */
            {
                if(pPlxPrivate->WidPtrTrue24== NULL)
                {
                    pPlxPrivate->WidPtrTrue24 = widAllocate(pScreen,vid,1,FALSE,flavor);
                }
                widSetWindowWid(pWin, pPlxPrivate->WidPtrTrue24, TRUE);
                wid= widGetValue(pPlxPrivate->WidPtrTrue24);
                plxWinPtr->widptr = (int *)pPlxPrivate->WidPtrTrue24;
            }
            else		/* Direct Color */
            {
                if(pPlxPrivate->WidPtrDirect24== NULL)
                {
                    pPlxPrivate->WidPtrDirect24 = widAllocate(pScreen,vid,1,FALSE,flavor);
                }
                widSetWindowWid(pWin, pPlxPrivate->WidPtrDirect24, TRUE);
                wid= widGetValue(pPlxPrivate->WidPtrDirect24);
                plxWinPtr->widptr = (int *)pPlxPrivate->WidPtrDirect24;
            }
            break;
        }
        plxWinPtr->window_type=0;
        plxWinPtr->mapped=1;
        plxWinPtr->video_active=0;
        plxWinPtr->explicitPrepare = 0;
	    plxWinPtr->rtv_track = 0;
        InitializeRTV(&plxWinPtr->rtv); 
	    plxWinPtr->rtv.handle = NULL;
	    plxWinPtr->video_wid_set = 0;
        plxWinPtr->wid=wid;
        plxWinPtr->hash=0;
  }
  return(TRUE);
}

void
PlxWindowExposures(pWin, pReg, pOtherReg)
WindowPtr pWin;
RegionPtr pReg;
RegionPtr pOtherReg;
 
{
int vid;
plxPrivWinPtr plxWinPtr;
ScreenPtr pScreen = pWin->drawable.pScreen;
plxScreenPtr  pPlxPrivate =  GetPlxPrivate(pScreen);
 
  pScreen->WindowExposures = pPlxPrivate->WindowExposures;
  plxWinPtr = (plxPrivWinPtr )pWin->devPrivates[plxWindowPrivateIndex].ptr;
  /*
   * Enable rtv tracking test when correct action to stop 
   * video display is determined.
   *
  if(plxWinPtr->rtv_track == RtvTrackPutCImage)
  {
  }
   */
 
  (* pScreen->WindowExposures)(pWin, pReg, pOtherReg);
 
  pScreen->WindowExposures = PlxWindowExposures;
  {
     WindowPtr pParent = pWin->parent;
 
     plxWinPtr = (plxPrivWinPtr )pWin->devPrivates[plxWindowPrivateIndex].ptr;
     if (pWin->mapped && pParent!=NULL && pParent->realized &&
         plxWinPtr->window_type)
     {
        register WindowPtr pVideo = NULL;
           switch(plxWinPtr->window_type)
           {
           case PLX_WINDOW_TYPE:
             pVideo = (WindowPtr)plxSearchVideoWindow (pWin);
             if (pVideo)
             {
                register BoxPtr pbox;
                register int nbox;
                 pbox = REGION_RECTS(&pVideo->clipList);
                 nbox = REGION_NUM_RECTS(&pVideo->clipList);
#ifdef DEBUG_VIDEO
                 vid = WindowVisual(pWin);
        fprintf(stderr,"window depth=%d type=%d vid=%d\n" ,
                pWin->drawable.depth,plxWinPtr->window_type,vid);
        fprintf(stderr," plxRestartVideoWindow\n");
#endif
                 plxRestartVideoWindow (pVideo, pbox, nbox);
		 /*
		 * Enable when other rtv tracking test is enabled 
		 * to allow video display.
		 *
		 */
                 if(plxWinPtr->video_active==0)
                 {
                      plxWinPtr->video_active=1;
                      if(pPlxPrivate->video_active<=3)
                      {
                          pPlxPrivate->video_active++;
                          video_active=pPlxPrivate->video_active;
                      }
                 }
             }
             break;
           case XV_WINDOW_TYPE:
             XvplxWindowExposures(pWin,pReg,pOtherReg);
             break;
          }
     }
  }
 
 
}
