/*
 *   Copyright (c) 1987, 88 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 */

/*
 * plxpointer.c
 */

/* $XConsortium: plxpointer.c,v 5.9 89/12/10 11:06:17 rws Exp $ */
static char *rcsid = "@(#)$Id: plxcursor.c,v 1.3 92/07/07 10:36:23 ruby Exp $";

/*
Copyright 1989 by the Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the software
without specific, written prior permission.  M.I.T. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.
*/

#ifdef sun
# define NEED_EVENTS
# include   "X.h"
# include   "Xmd.h"
# include   "Xproto.h"
# include   "misc.h"
# include   "windowstr.h"
# include   "pixmapstr.h"
# include   "mi.h"
# include   "scrnintstr.h"
# include   "mipointrst.h"
# include   "cursorstr.h"
# include   "dixstruct.h"
# include   "plx.h"
# include   "plxv.h"
# include   "plxInit.h"
# include   "sun.h"
# include   "xvideo.h"

extern int  miPointerScreenIndex;
extern unsigned long miPointerGeneration;
extern miPointerRec miPointer;
extern miPointerScreenFuncRec sunPointerScreenFuncs;

/*
 * until more than one pointer device exists.
 */

static Bool plxRealizeCursor (),	    plxUnrealizeCursor ();
static void plxSetCursor();
static void plxMoveCursor();
static void plxRecolorCursor();

extern void miRecolorCursor();
extern void ProcessInputEvents ();
extern void NewCurrentScreen ();
extern XV_struct *PlxGetContext();


extern int plxroptbl[];


typedef struct {
	unsigned char red;
	unsigned char green;
	unsigned char blue;
} plxv_color;

/*
typedef struct {
	CursorPtr  pCursor;
	int	x, y;
} plxPointerRec, *plxPointerPtr;
*/

static plxPointerRec plxPointer = { NULL, 0, 0};

extern miPointerScreenFuncRec sunPointerScreenFuncs;

miPointerSpriteFuncRec plxPointerSpriteFuncs = {
    plxRealizeCursor,
    plxUnrealizeCursor,
    plxSetCursor,
    plxMoveCursor,
};


Bool
plxPointerInitialize (pScreen)
    ScreenPtr		    pScreen;
{
    plxScreenPtr pScreenPriv;
    plxPointerPtr pPointer;
    pScreenPriv = GetPlxPrivate(pScreen);
    pPointer = (plxPointerPtr) xalloc(sizeof(plxPointerRec));
    pPointer->pCursor = NULL;
    pScreenPriv->plxPointer = pPointer;
    miPointerInitialize(pScreen, &plxPointerSpriteFuncs, &sunPointerScreenFuncs,
						TRUE);
    return TRUE;
}

/*
 * DIX/DDX interface routines
 */

static Bool
plxRealizeCursor (pScreen, pCursor)
    ScreenPtr	pScreen;
    CursorPtr	pCursor;
{
    if (pCursor->bits->refcnt <= 1)
	pCursor->bits->devPriv[pScreen->myNum] = (pointer)NULL;
    return TRUE;

}


/* places to save shadow contents */


static int M1ForCol, M1BakCol, M1RdMask;
static int TagCtl;
static int DrawRop, RopCtl;
static int TagClip;
static int DrawMask;
static int MMode;
static int MStart, MEnd, MOffset;
static int SolidCol;

static void save_from_shadow()
{

    XV_RSDW(M1ForCol, M1ForCol.l);
    XV_RSDW(M1BakCol, M1BakCol.l);
    XV_RSDW(M1RdMask, M1RdMask.l);
    /* tag */
    XV_RSDW(TagCtl, TagCtl.l);
    /* rop */
    XV_RSDW(DrawRop, DrawRop.l);
    XV_RSDW(RopCtl, RopCtl.l);
    /* stencil */
    XV_RSDW(TagClip, TagClip.l);
    /* mask */
    XV_RSDW(DrawMask, DrawMask.l);
    /* transp */
    XV_RSDW(MMode, MMode.l);
    /* map ctl */
    XV_RSDW(MStart, MStart.l);
    XV_RSDW(MEnd, MEnd.l);
    XV_RSDW(MOffset, MOffset.l);
    /* solid color */
    XV_RSDW(SolidCol, SolidCol.l);
    plxv_wf_done();
}

static void restore_to_shadow()
{
    plxv_wf_done();
    XV_WREG(M1ForCol.l, M1ForCol);
    XV_WREG(M1BakCol.l, M1BakCol);
    XV_WREG(M1RdMask.l, M1RdMask);
    /* tag */
    XV_WREG(TagCtl.l, TagCtl);
    /* rop */
    XV_WREG(DrawRop.l, DrawRop);
    XV_WREG(RopCtl.l, RopCtl);
    /* stencil */
    XV_WREG(TagClip.l, TagClip);
    /* mask */
    XV_WREG(DrawMask.l, DrawMask);
    /* transp */
    XV_WREG(MMode.l, MMode);
    /* map ctl */
    XV_WREG(MStart.l, MStart);
    XV_WREG(MEnd.l, MEnd);
    XV_WREG(MOffset.l, MOffset);
    /* solid color */
    XV_WREG(SolidCol.l, SolidCol);

/* restore vector, box, and blit start addresses */

    XV_RSDW(xv_wreg->SrcStartAdd.l,SrcStartAdd.l);
    XV_RSDW(xv_wreg->DstStartAdd.l,DstStartAdd.l);

}
void plxPointerRemoveCursor(pScreen)
    ScreenPtr	pScreen;
{
    int			sx, sy;
    XV_struct		*xv;
    plxPointerPtr	pPointer;
    plxScreenPtr	pPlxScreen;

    pPlxScreen = GetPlxPrivate(pScreen);
    pPointer = pPlxScreen->plxPointer;

    if(pPointer->pCursor == NULL)
	return;

#if 0
    xv = ((hwlibPrivPtr)(((PixmapPtr)(pScreen->devPrivate))->devPrivate.ptr))->xv;
#else
    xv = PlxGetContext(pScreen);
#endif

    plxv_switch_context(xv);

    save_from_shadow();

    plxv_color_24(0);
    plxv_wmask (0xc0000000);
    plxv_tag(0, 0);
    plxv_rop(plxroptbl[GXcopy]);

    if((sx = pPointer->x - pPointer->pCursor->bits->xhot) < 0)
	sx = 0;
    if((sy = pPointer->y - pPointer->pCursor->bits->yhot) < 0)
	sy = 0;
    plxv_box(sx, sy, pPointer->pCursor->bits->width,
	     pPointer->pCursor->bits->height);

    restore_to_shadow();
}

static Bool
plxUnrealizeCursor (pScreen, pCursor)
    ScreenPtr	pScreen;
    CursorPtr	pCursor;
{

    plxPointerPtr	pPointer;
    plxScreenPtr	pPlxScreen;

    pPlxScreen = GetPlxPrivate(pScreen);
    pPointer = pPlxScreen->plxPointer;

    if(pPointer->pCursor == pCursor)
    {
	plxPointerRemoveCursor(pScreen);
	pPointer->pCursor = NULL;
    }
    return(TRUE);
}

static Bool
plxPointerDisplayCursor (pScreen, pCursor)
    ScreenPtr	pScreen;
    CursorPtr	pCursor;
{
    register long *dadd, *sadd, w, h;
    long *dbase, *sbase, i;
    int curx, cury, dinc, sinc;
    int startx, starty, realwidth, realheight, shiftx, shifty;
    int nstart, nmiddle, endpart;
    plxv_color colors[2];
    XV_struct *xv;
    plxPointerPtr	pPointer;
    plxScreenPtr	pPlxScreen;

    pPlxScreen = GetPlxPrivate(pScreen);
    pPointer = pPlxScreen->plxPointer;

#if 0
    xv = ((hwlibPrivPtr)(((PixmapPtr)(pScreen->devPrivate))->devPrivate.ptr))->xv;
#else
    xv = PlxGetContext(pScreen);
#endif
    plxv_switch_context(xv);

    if (pPointer->pCursor != pCursor)
    {
	plxPointerRemoveCursor(pScreen);

	colors[1].red = pCursor->foreRed >> 8;
	colors[1].green = pCursor->foreGreen >> 8;
	colors[1].blue = pCursor->foreBlue >> 8;

	colors[0].red = pCursor->backRed >> 8;
	colors[0].green = pCursor->backGreen >> 8;
	colors[0].blue = pCursor->backBlue >> 8;

	plxv_load_cursor(colors);
    }

    pPointer->pCursor = pCursor;

#if 0
    dbase = ((XV_struct *)((hwlibPrivPtr)
		((PixmapPtr)(screenInfo.screens[pScreen->myNum]->devPrivate))->devPrivate.ptr)->xv)->m1base;
#else
    dbase = (long *)xv->m1base;
#endif

    nstart = shiftx = shifty = 0;
    realwidth = pCursor->bits->width;
    startx = pPointer->x - pCursor->bits->xhot;
    if(startx < 0)
    {
	realwidth += startx;
	shiftx = -startx;
	startx = 0;
	nstart = (realwidth > 32 ) ? 32 - shiftx : realwidth;
    }
    if((startx + realwidth) > 1152)
	realwidth = 1152 - startx;

    realwidth -= nstart;

    nmiddle = (realwidth + 31) >> 5;

    if((nmiddle == 1) || (realwidth && nmiddle))
    {
	--nmiddle;
	if(realwidth > 32)
	    endpart = realwidth & 31;
	else
	    endpart = realwidth;
    }
    else
	endpart = 0;

    realheight = pCursor->bits->height;
    starty = pPointer->y - pCursor->bits->yhot;
    if(starty < 0)
    {
	realheight += starty;
	shifty = -starty;
	starty = 0;
    }
    if((starty + realheight) > 900)
	realheight = 900 - starty;
   
    dinc = (xv->main.linebytes >> 5);
    sinc = (((int)(pCursor->bits->width)) + 31) >> 5;

    save_from_shadow();

    plxv_colors_1(0xffffffff, 0, 0xc0000000);
    plxv_transp_off();
    plxv_stencil(0, 0);
    plxv_tag(0, 0);
    plxv_rop(plxroptbl[GXcopy]);

    for(i = 2; i--;)
    {
	if(i) /* doing data */
	{
	    sbase = (long *) pCursor->bits->source;
	    plxv_wmask(0x40000000);
	}
	else /* doing mask */
	{
	    sbase = (long *) pCursor->bits->mask;
	    plxv_wmask(0x80000000);
	}
	cury = starty;
	sadd = sbase + (shifty * sinc);
	for(h = realheight; h--; ++cury)
	{
	    curx = startx;
	    dadd = dbase + (cury * dinc) + (curx >> 5);
	    if(nstart)
	    {
		plxv_ctl_1(0, nstart);
		*dadd++ = *sadd++ << shiftx;
		curx += nstart;
	    }
	    if(w = nmiddle)
	    {
	      plxv_ctl_1(curx & 31, 32);
	      while(w--)
		*dadd++ = *sadd++;
	    }
	    if(endpart)
	    {
	      plxv_ctl_1(curx & 31, endpart);
	      *dadd++ = *sadd++;
	    }
	}
    }
    restore_to_shadow();
    return TRUE;
}

#if 0
static void plxRecolorCursor(pScreen, pCursor, displayed)
ScreenPtr       pScreen;
CursorPtr       pCursor;
int             displayed;
{
    XV_struct *xv;
    plxv_color colors[2];

    if(!displayed)
	return;

    xv = PlxGetContext(pScreen);
    plxv_switch_context(xv);

    colors[1].red = pCursor->foreRed >> 8;
    colors[1].green = pCursor->foreGreen >> 8;
    colors[1].blue = pCursor->foreBlue >> 8;

    colors[0].red = pCursor->backRed >> 8;
    colors[0].green = pCursor->backGreen >> 8;
    colors[0].blue = pCursor->backBlue >> 8;

    plxv_load_cursor(colors);
}
#endif


/*
 * plxPointerSetCursor.  The pointer has moved to x,y on screen pScreen
 */

static void
plxSetCursor (pScreen, pCursor, x, y)
    ScreenPtr	pScreen;
    CursorPtr	pCursor;
    int		x, y;
{
    plxPointerPtr	pPointer;
    plxScreenPtr	pPlxScreen;

    pPlxScreen = GetPlxPrivate(pScreen);
    pPointer = pPlxScreen->plxPointer;

    if(!pCursor)
    {
	plxPointerRemoveCursor(pScreen);
	return;
    }

    if ((pPointer->x == x) && (pPointer->y == y) &&
	(pPointer->pCursor == pCursor))
	return;

    plxPointerRemoveCursor(pScreen);

    pPointer->x = x;
    pPointer->y = y;

    /*
     * avoid problems when this routine recurses
     */
/*
    if (pPointer->pCursor)
*/
	plxPointerDisplayCursor (pScreen, pCursor);
}

static void plxMoveCursor(pScreen, x, y)
    ScreenPtr   pScreen;
    int         x, y;

{
    plxPointerPtr pPointer;
    plxScreenPtr	pPlxScreen;

    pPlxScreen = GetPlxPrivate(pScreen);
    pPointer = pPlxScreen->plxPointer;
    plxSetCursor(pScreen, pPointer->pCursor, x, y);
}
#endif
