/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: plxv.h,v $
 * Revision 1.1  1995/11/27  22:46:59  dist
 * Initial revision
 *
 * Revision 1.1  1995/10/30  17:27:33  kevin
 * Initial revision
 *
 * Revision 1.1  1995/10/13  21:35:04  kevin
 * Initial revision
 *
 * Revision 1.1  1995/03/30  19:44:56  kevin
 * Initial revision
 *
 * Revision 1.11  93/09/30  02:16:34  rocky
 * SQUASH, 7192A
 * 
 * Revision 1.10  92/10/01  16:03:11  rocky
 * temp version for SONYRGB
 * 
 * Revision 1.9  92/09/16  13:06:14  rocky
 * new option modes for SONY camera
 * 
 * Revision 1.8  91/11/13  15:23:36  eric
 * PLXV_*_PIXEL_ATTR needs to be 3f
 * 
 * Revision 1.7  91/11/12  14:34:14  eric
 * changed from 28 bit mode to 32 bit mode
 * 
 * Revision 1.6  91/09/30  16:37:47  mears
 * some additions
 * 
 * Revision 1.5  91/08/14  12:25:28  mears
 * blanking info and TmrInit in nvram
 * 
 * Revision 1.4  91/08/13  13:50:52  mears
 * added input_status bit definitions
 * 
 * Revision 1.3  91/08/09  16:52:37  mears
 * new nvram structure
 * 
 * Revision 1.2  91/07/26  19:24:16  eric
 * new from bill
 * 
 * Revision 1.1  91/06/12  16:18:18  eric
 * Initial revision
 * 
 *
 */

#ifdef H_ID
#ifndef lint
static char *rcsid_plxv_h = "@(#)$Id: plxv.h,v 1.1 1995/11/27 22:46:59 dist Exp $ Parallax Graphics Inc";
#endif
#endif

/* plxv.h: the only stuff user programs should have to deal with */

#ifndef __PLXV__

#define __PLXV__

/*REVISION CONTROL FOR NVRAM COMPATABILITY 
  ---- MUST CHANGE WHEN NV STRUCTURE CHANGES -----
--- note: parameters above the POWER STATS MUST NOT CHANGE ******
*/

#define HLIB_REV 0x8008

#define PLXV_ADDR_REG(x,y)          ( (int)xv_ap->reg[(y)]  + (x))
#define PLXV_ADDR_24(x,y) (int *)  ( (int)xv_ap->m24[(y)] + ((x)<<2))
#define PLXV_ADDR_8(x,y) (char *) ( (int)xv_ap->m8[(y)]  + (x))
#define PLXV_ADDR_1(x,y) (int *) ( (int)xv_ap->m1[(y)]  + (((x)>>5)<<2))
#define PLXV_OFFS_1(x) ((x) & 0x1f )

#define NV_POSITION(board,ptr) \
	 ((int)(&(xv_cp->board.ptr)) - (int)(&(xv_cp->board)))
/*rop names */
#define PLXV_ROP_CLEAR		0
#define PLXV_ROP_AND		1
#define PLXV_ROP_ANDREVERSE	4
#define PLXV_ROP_COPY		5
#define PLXV_ROP_ANDINVERTED	2
#define PLXV_ROP_NOOP		3
#define PLXV_ROP_XOR		6
#define PLXV_ROP_OR		7
#define PLXV_ROP_NOR		8
#define PLXV_ROP_EQUIV		9
#define PLXV_ROP_INVERT		0xc
#define PLXV_ROP_ORREVERSE	0xb
#define PLXV_ROP_COPYINVERTED	0xa
#define PLXV_ROP_ORINVERTED	0xd
#define PLXV_ROP_NAND		0xe
#define PLXV_ROP_SET		0xf

/* TAG DEFINITIONS */

#define PLXV_TAG_PSEUDO_COLOR	0x01
#define PLXV_TAG_TRUE_COLOR	0x02

#define PLXV_TAG_VIDEO_0	0x20
#define PLXV_TAG_VIDEO_LEN	0x20

/* there are PLXV_TAG_VIDEO_LEN video tag values, beginning at
 * PLXV_TAG_VIDEO_0, ending at PLXV_TAG_VIDEO_0+PLXV_TAG_VIDEO_LEN-1
 */

#define PLXV_TAG_DISPLAY_ATTR	0x30
#define PLXV_TAG_CURSOR_MAP	0x40
#define PLXV_TAG_CURSOR_ENAB	0x80
#define PLXV_TAG_CURSOR_ALL	0xc0
#define PLXV_TAG_PIXEL_ATTR	0x3f
#define PLXV_TAG_ALL		0xff

/* WMASK VALUES */
#define PLXV_WMASK_24		0x00ffffff
#define PLXV_WMASK_ALL		0xffffffff
#define PLXV_WMASK_PIXEL_ALL	0x3fffffff
#define PLXV_WMASK_DISPLAY_ATTR	0x3f000000
#define PLXV_WMASK_CURSOR_MAP	0x40000000
#define PLXV_WMASK_CURSOR_ENAB	0x80000000
#define PLXV_WMASK_CURSOR_ALL	0xc0000000
#define PLXV_WMASK_PIXEL_ATTR	0x3f000000

/* define the board codes for the XVideo boards */
#define SBUS_1 4	/* 66 Hz */
#define TCHAN_1 5
#define SBUS_2 6	/* 76 Hz */
#define SBUS_3 7	/* 60 Hz */
#define SBUS_4 8	/* SQUASH */
#define SBUS_5 9	/* PURVIS */
#define OPT_1  10	/* VIO */
#define OPT_2  11	/* RGB */
#define OPT_3  12	/* SONYRGB */
#define OPT_4  13	/* SONYRGB2 */

/* defines for the revs of the component chip (sets) being used */
#define GAREV_1 1	/* BIC: rev 1  CTC: rev 1 PPC: rev 1 */
#define GAREV_2 2	/* BIC: rev 2  CTC: rev 2 PPC: rev 1 */
#define DMSDREV_1 1	/* proto chip w/faulty vsync */
#define DMSDREV_2 2	/* supposed to be better     */
#define C3REV_1 1

/* misc. flags for component revs */
#define SAA7192A 1

#define GA_REV GAREV_2

/* defines for the "flags" field of the io_port sub-structure */
#define IO_CHAN_TYPE 0x3f
#define IO_DMSD	     01
#define IO_RGB_IN    02
#define IO_GEN_IN    03
#define IO_SONYRGB_IN 04
#define IO_OUTPUT    0x20
#define IO_COMP_OUT  0x21
#define IO_RGB_OUT   0x22
#define IO_GEN_OUT   0x23

/* redback status bit defines for plxv_input_status */
#define CHROMA_LOCK 1
#define VERT_60HZ   32
#define SYNC_LOCK   64

/* defines for the various clt's being used on XVideo */
#define BT463 1
#define BT462 2
#define BT473 3

typedef struct {
        unsigned char red;
        unsigned char green;
        unsigned char blue;
        } XV_color;

typedef struct {
	short active_pixels;	/* per line */
	short active_lines;	/* per frame */
	short blank_lines;	/* per frame */
	short reset_line;	/* in a field */
	short start_line;	/* in a field */
	short unused;
        } XV_video_format;

typedef struct {
	unsigned short disp;
	unsigned char  fp;
	unsigned char  sy;
	unsigned char  bp;
	unsigned char  hsync_ser;		/* disp param for serration  */
	unsigned short hsync_nser;		/* disp param for serration  */
	} XV_disp_format;
	
typedef struct {
	unsigned char  bright;
	unsigned char  contrast;
	unsigned char  saturation;
	unsigned char  hue;
	} XV_knob_rec;

typedef struct {
	unsigned char	rev;		/* rev of the dmsd chipset      */
	unsigned char	unit;		/* which "unit" number	        */
	unsigned char val[26];		/* location 0:22 are 7191       */
	} XV_dmsd_config;		/* locations 23:25 unused       */


typedef struct {
	unsigned char	command[4];
	unsigned short	fgate_start;
	unsigned short	fgate_stop;
	unsigned char	ngate_start;
	unsigned char	ngate_stop;
	unsigned char   hsync_start;
	unsigned char	clamp_start;
	unsigned char	clamp_stop;
	unsigned char	unused[3];
	} XV_bt261_config;
	
typedef struct {
	unsigned short	hcount;
	unsigned short  hactive;
	unsigned char	zero_stop;
	unsigned char	unused[3];
	} XV_bt261_init;

typedef struct {
	unsigned char	val[6];
	unsigned char	unused[2];
	} XV_bt253_config;

/* data structure to define the format of the RGB_IN interface */
/* this includes the Xpoint config_bits need to set up the hardware */
typedef struct {
	unsigned long	xpoint_bits;		/* Xpoint config value       */
	XV_bt261_config timing;
	XV_bt261_init	format[2];
	XV_bt253_config	cal[2];
	} XV_rgbin_config;



/* data structure to define the format of a general interface */
/* this includes the Xpoint config_bits need to set up the hardware */
typedef struct {
	unsigned long	xpoint_bits;		/* Xpoint config value       */
	unsigned char   val[28];
	} XV_gen_config;

/* structure to define general interface for A and B ports */
/* port can be either DMSD, or general purpose		   */
typedef struct {
	unsigned long	flags;			/* see IO_XXXX constants     */
	XV_knob_rec	factory,u1,u2;		/* 3 sets of users adjusts */
	XV_video_format	format[2];
	union  {
		    XV_gen_config	gen;
		    XV_dmsd_config	dmsd;
		    XV_rgbin_config	rgbin;
	        } config;
	} XV_io_port;

/* the full data structure for the CONTROLLER NVRAM			     */

typedef struct {
	unsigned char	board_code;		/* the PARALLAX HARDWARE NUM */
	unsigned char	ga_rev;			/* a code for which chip set */
	unsigned char	c3_rev;			/* a code for CL550 revision */
	unsigned char	clt_type;		/* what type of output stage */
	unsigned long	serial_number;
	unsigned short	hlib_rev;
	unsigned char   unused0[2];
	unsigned long	power_hours;		/* hours of operation	     */
	unsigned short	power_cycles;		/* number of power ups	     */
	unsigned short	xsize;			/* Pixels in a line	     */
	unsigned short	ysize;			/* lines on display	     */
	unsigned short  Attr;			/* another startup value     */
	unsigned short  DispKludge;		/* a startup value	     */
	unsigned short	DispFlgs;		/* Stuff value at power up   */
	unsigned long	StartUp;		/* Stuff value at power up   */
	unsigned short	TmrInit;		/* Stuff value at power up   */
	unsigned short  RasMode;		/* Stuff value at power up   */
	unsigned char	OLDI2C;			/* Stuff value at power up   */
	unsigned char   unused_1[3];
	XV_disp_format	h,v;			/* general display timing     */
	XV_io_port	d;			/* DMSD video adjustments    */
	unsigned long	icd_clock;
	unsigned short	linebytes;
	unsigned char	misc_flags;		/* misc component rev info   */
	unsigned char	misc_flags2;
	unsigned char	unused_2[4];
	} XV_controller_nvram;
/* the full data structure for the OPTION NVRAM				     */

typedef struct {
	unsigned char	board_code;		/* the PARALLAX HARDWARE NUM */
	unsigned char	board_rev;		/* board revision code	     */
	unsigned char	clt_type;		/* what type of output stage */
	unsigned char	unused_1[1];
	unsigned long	serial_number;
	unsigned short	hlib_rev;
	unsigned char	unused0[2];
	unsigned long	power_hours;		/* hours of operation	     */
	unsigned short	power_cycles;		/* number of power ups	     */
	unsigned char	unused_2[2];
	XV_io_port	a,b;
	unsigned char	misc_flags;
	unsigned char	misc_flags2;
	unsigned char	unused[8];
	} XV_option_nvram;

typedef struct {
	int			*m24[1024];
	char			*m8[1024];
	int			*m1[1024];
	int			reg[1024];
	} XV_addr_maps;


typedef struct {
	XV_controller_nvram	main;
	XV_option_nvram		opt;
	int			addr_wrap;
	int			*eprombase;
	int			*regbase;
	int			*c3base;
	int			*m24base;
	char			*m8base;
	int			*m1base;
	int			*shadow;
	XV_addr_maps		*maps;
	} XV_struct;
	
extern XV_struct *xv_cp,*plxv_init_context();
extern XV_addr_maps *xv_ap;
extern int *xv_m24base,*xv_m1base,*xv_eprombase,*xv_c3base,*xv_regbase;
extern char *xv_m8base;

#endif /* __PLXV__ */

