/*
 *   Copyright (c) 1987, 1988, 1989, 1990 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *
 * $Log: plxvideo.c,v $
 * Revision 1.1  1995/11/27  22:46:59  dist
 * Initial revision
 *
 * Revision 1.1  1995/10/13  21:35:04  kevin
 * Initial revision
 *
 * Revision 1.1  1995/03/30  19:42:32  kevin
 * Initial revision
 *
 * Revision 1.1  92/02/18  10:35:18  dave
 * Initial revision
 * 
 * Revision 1.1  91/10/24  16:29:03  schen
 * Initial revision
 * 
 * Revision 1.1  91/10/19  14:20:35  schen
 * Initial revision
 * 
 */

#ifndef lint
static char *rcsid = "@(#)$Id: plxvideo.c,v 1.1 1995/11/27 22:46:59 dist Exp $ Parallax Graphics Inc";
#endif

#include <stdio.h>

#include "X.h"
#include "Xos.h"
#include "Xproto.h"
#include "misc.h"
#include "os.h"
#include "pixmapstr.h"
#include "gcstruct.h"
#include "extnsionst.h"
#include "scrnintstr.h"
#include "dixstruct.h"
#include "resource.h"
#include "opaque.h"
#define _XSHM_SERVER_
#include "plxvideo.h"

#define PLX_WINDOW_TYPE 1

int PlxVideoReqCode = 0;

int ProcPlxVideoDispatch(), SProcPlxVideoDispatch();
void PlxVideoResetProc();
void PlxVideoValidateGC(), PlxVideoDestroyGC(), PlxVideoDeleteState();

extern void ValidateGC();
extern ExtensionEntry *AddExtension();

char *xv_opstrings[] = {
"X_VideoSet",
"X_VideoLive",
"X_VideoStill",
"X_VideoScale",
"X_VideoStop",
"X_VideoPriority",
"X_VideoFrameMode",
"X_VideoFrameStart",
"X_VideoDitherControl",
"X_VideoInput",
"X_Plx_zoom_on",
"X_Plx_zoom_off",
"X_Plx_Debug",
"X_VideoValueFactory",
"X_VideoValueSet",
"X_VideoSqueezeLive",
"X_VideoSqueezeStill",
"X_VideoFlipLive",
"X_VideoFlipStill",
"X_VideoFlipScale",
"X_VideoFlipSqueezeLive",
"X_VideoFlipSqueezeStill"
};

char *xvp_opstrings[] = {
"X_VideoOutput",
"X_VideoScaleOutput",
"X_VideoTag",
"X_VideoInputSelect",
"X_VideoOutputSelect",
"X_VideoValueLoad",
"X_VideoValueQuery",
"X_VideoValueSave",
"X_VideoValueRecall",
"X_VideoDirection",
"X_VideoQueryConfig",
"X_VideoQueryVideo",
"X_Plx_Pan",
"X_Plx_ScaleCopyArea",
"X_Plx_Command",
"X_Plx_ImageLoad",
"X_PlxPutImage",
"X_PlxGetImage",
"X_PlxPutCImage",
"X_PlxGetCImage",
"X_PlxPutQTable",
"X_Plx_SPString",
"X_Plx_GPString",
"X_PlxShmPutCImage",
"X_PlxShmGetCImage"
};
/*
 * PlxVideoExtensionInit
 *
 * Called from InitExtensions in main() or from QueryExtension() if the
 * extension is dynamically loaded.
 *
 * VIDEO has no events or errors (other than the core errors)
 */

void
PlxVideoExtensionInit()
{
	register ExtensionEntry *extEntry;
	extern GCPtr CreateScratchGC();

	extEntry = AddExtension(VIDEONAME, 0, 0,
				ProcPlxVideoDispatch,
				SProcPlxVideoDispatch,
				PlxVideoResetProc
#ifdef notforXNeWS
				, StandardMinorOpcode
#endif
				);
	if (extEntry) {
		PlxVideoReqCode = extEntry->base;
		(void)MakeAtom(VIDEONAME, strlen(VIDEONAME), TRUE);
	} else {
		FatalError("PlxVideoExtensionInit: AddExtensions failed\n");
	}
}

void
PlxVideoResetProc()
{
/*
	fprintf(stderr, "PlxVideoResetProc() called\n");
*/
}

/*
 * ProcPlxVideoDispatch
 */

int
ProcPlxVideoDispatch(client)
register ClientPtr client;
{
	REQUEST(xReq);
#ifdef DEBUG
	if((int)stuff->data <24 )
          ErrorF("%s\n",xv_opstrings[(int)(stuff->data)-11]);
        else
	if((int)stuff->data >55 )
          ErrorF("%s\n",xvp_opstrings[(int)(stuff->data)-100]);
	else
          ErrorF("Ext code %d\n",stuff->data);
#endif
	switch (stuff->data) {
	case X_VideoSet:
	case X_VideoLive:
	case X_VideoFlipLive:
	case X_VideoStill:
	case X_VideoFlipStill:
	case X_VideoScale:
	case X_VideoFlipScale:
	case X_VideoStop:
	case X_VideoFrameMode:
	case X_VideoFrameStart:
	case X_VideoDitherControl:
	case X_VideoPriority:
	case X_VideoInput:
	case X_Plx_zoom_on:
	case X_Plx_zoom_off:
	case X_Plx_Debug:
	case X_VideoValueFactory:
	case X_VideoValueSet:
	case X_VideoSqueezeLive:
	case X_VideoFlipSqueezeLive:
	case X_VideoSqueezeStill:
	case X_VideoFlipSqueezeStill:

/* new functions defined in rev 4.0 */

	case X_VideoOutput:	
	case X_VideoScaleOutput:	
	case X_VideoTag:	
	case X_VideoInputSelect:	
	case X_VideoOutputSelect:	
	case X_VideoValueLoad:	
	case X_VideoValueQuery:	
	case X_VideoValueSave:	
	case X_VideoValueRecall:	
	case X_VideoDirection:	
	case X_VideoQueryConfig:	
	case X_VideoQueryVideo:	
	case X_Plx_Pan:	
	case X_Plx_ScaleCopyArea:
	case X_Plx_ImageLoad:	
	case X_Plx_Command:	

/* this is really an image operator, but uses a video request structure */
/* string handling functions */
	case X_Plx_SPString:
	case X_Plx_GPString:
		return(ProcPlxVideo(client));

/* more newer functions */

	case X_PlxPutQTable:
	case X_PlxPutImage:
	case X_PlxGetImage:
	case X_PlxPutCImage:
	case X_PlxGetCImage:
	case X_PlxShmPutCImage:
	case X_PlxShmGetCImage:
	case X_PlxRtvGetCImage:
	case X_PlxRtvPutCImage:
	case X_PlxRtvConnect:
	case X_PlxRtvDisconnect:
		return(ProcPlxVideoImage(client));
	case X_PlxControl:
		return(ProcPlxControl(client));

		/* NOT REACHED */
	default:
		SendErrorToClient(client, PlxVideoReqCode, stuff->data, 0, BadRequest);
		return(BadRequest);
	}
}

int
SProcPlxVideoDispatch(client)
register ClientPtr client;
{
	REQUEST(xReq);

	switch (stuff->data) {
	case X_VideoSet:
	case X_VideoLive:
	case X_VideoFlipLive:
	case X_VideoStill:
	case X_VideoFlipStill:
	case X_VideoScale:
	case X_VideoFlipScale:
	case X_VideoStop:
	case X_VideoFrameMode:
	case X_VideoFrameStart:
	case X_VideoDitherControl:
	case X_VideoPriority:
	case X_VideoInput:
	case X_Plx_zoom_on:
	case X_Plx_zoom_off:
	case X_Plx_Debug:
	case X_VideoValueFactory:
	case X_VideoValueSet:
	case X_VideoSqueezeLive:
	case X_VideoFlipSqueezeLive:
	case X_VideoSqueezeStill:
	case X_VideoFlipSqueezeStill:

/* new functions defined in rev 4.0 */

	case X_VideoOutput:	
	case X_VideoScaleOutput:	
	case X_VideoTag:	
	case X_VideoInputSelect:	
	case X_VideoOutputSelect:	
	case X_VideoValueLoad:	
	case X_VideoValueQuery:	
	case X_VideoValueSave:	
	case X_VideoValueRecall:	
	case X_VideoDirection:	
	case X_VideoQueryConfig:	
	case X_VideoQueryVideo:	
	case X_Plx_Pan:	
	case X_Plx_ScaleCopyArea:
	case X_Plx_ImageLoad:	
	case X_Plx_Command:	

/* this is really an image operator, but uses a video request structure */

/* string handling functions */
	case X_Plx_SPString:
	case X_Plx_GPString:

		return(SProcPlxVideo(client));

/* more newer functions */

	case X_PlxPutQTable:
	case X_PlxPutImage:
	case X_PlxGetImage:
	case X_PlxPutCImage:
	case X_PlxGetCImage:
	case X_PlxShmPutCImage:
	case X_PlxShmGetCImage:
	case X_PlxRtvGetCImage:
	case X_PlxRtvPutCImage:
	case X_PlxRtvConnect:
	case X_PlxRtvDisconnect:
		return(SProcPlxVideoImage(client));
	case X_PlxControl:
		return(SProcPlxControl(client));

		/* NOT REACHED */
	default:
		SendErrorToClient(client, PlxVideoReqCode, stuff->data, 0, BadRequest);
		return(BadRequest);
	}
}

/* 
 * Macros needed for byte-swapping, copied from swapreq.c.
 * Really should be in a header file somewhere.
 */
#ifdef Xnews
#define	LengthRestS(stuff)	((stuff->length << 1)  - (sizeof(*stuff) >> 1))

#define	SwapRestS(stuff)	SwapShorts(stuff + 1, LengthRestS(stuff))
#endif

int
SProcPlxVideo(client)
register ClientPtr client;
{
	int reqtype;
	register char n;
	register xCVideoArgs *xcvp;
	Drawable temp;

	REQUEST(xVideoReq);

	reqtype = stuff->videoReqType;

	swaps(&stuff->length, n);
	swapl(&stuff->drawable, n);
	swapl(&stuff->gc, n);
	if(reqtype == X_VideoTag)
	{
	    swapl(&stuff[1], n);
	}
	else if (reqtype == X_Plx_ScaleCopyArea)
	{
	    ++stuff;
	    xcvp = (xCVideoArgs *) stuff;
	    --stuff;
	    temp = xcvp->drawable;
#ifdef DEBUGGING_ITTTT
	    printf("drawable in = %x ", temp);
#endif
	    SwapShorts(xcvp, 8);
	    swapl(&temp, n);
#ifdef DEBUGGING_ITTTT
	    printf("drawable out = %x\n", temp);
#endif
	    xcvp->drawable = temp;
	}
	else if (reqtype == X_PlxPutQTable)
		; /* empty */
	else
	    SwapRestS(stuff);
	return (ProcPlxVideo(client));
}

/*
 * ProcPlxVideo
 */

static int
ProcPlxVideo(client)
register ClientPtr client;
{
	register GCPtr pGC;
	register DrawablePtr pDraw;

	REQUEST(xVideoReq);

	REQUEST_AT_LEAST_SIZE(xVideoReq);
	
	GetGCAndDrawableAndValidate(stuff->gc, pGC, stuff->drawable, pDraw, client);

	plxSetWindowType(pDraw,PLX_WINDOW_TYPE);
	PlxVideoProc(pDraw, pGC, stuff->videoReqType, &stuff[1], client);
	return (Success);
}

static
SProcPlxControl(client)
register ClientPtr client;
{
	register char n;

	REQUEST(xPlxControlReq);

	swaps(&stuff->length, n);
	swapl(&stuff->operation, n);
	return ProcPlxControl(client);
}

static int
ProcPlxControl(client)
register ClientPtr client;
{
	register GCPtr pGC;
	register DrawablePtr pDraw;

	REQUEST(xPlxControlReq);

	REQUEST_AT_LEAST_SIZE(xPlxImageReq);
	return PlxControl(client, stuff->operation, stuff+1);
}

static
SProcPlxVideoImage(client)
register ClientPtr client;
{
	register char n;

	REQUEST(xPlxImageReq);

	swaps(&stuff->length, n);
	swapl(&stuff->drawable, n);
	swapl(&stuff->gc, n);
	swaps(&stuff->src_x, n);
	swaps(&stuff->src_y, n);
	swaps(&stuff->src_w, n);
	swaps(&stuff->src_h, n);
	swaps(&stuff->dst_x, n);
	swaps(&stuff->dst_y, n);
	swaps(&stuff->dst_w, n);
	swaps(&stuff->dst_h, n);
	swapl(&stuff->planeMask, n);
	swapl(&stuff->shmseg, n);
	swapl(&stuff->offset, n);
	return (ProcPlxVideoImage(client));
}

static int
ProcPlxVideoImage(client)
register ClientPtr client;
{
	register GCPtr pGC;
	register DrawablePtr pDraw;

	REQUEST(xPlxImageReq);

	REQUEST_AT_LEAST_SIZE(xPlxImageReq);
	GetGCAndDrawableAndValidate(stuff->gc, pGC, stuff->drawable, pDraw, client);

	plxSetWindowType(pDraw,PLX_WINDOW_TYPE);
	PlxVideoImageProc(pDraw, pGC, stuff, client);
	return (Success);
}
