/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: vidlib.c,v $
 * Revision 1.1  1995/11/27  22:46:59  dist
 * Initial revision
 *
 * Revision 1.1  1995/10/30  17:27:33  kevin
 * Initial revision
 *
 * Revision 1.1  1995/10/13  21:35:04  kevin
 * Initial revision
 *
 * Revision 1.2  1995/04/04  20:36:50  kevin
 * Fixes for plxv_flash_v_off_now, plxv_flash_w_off_now
 *
 * Revision 1.18  93/09/30  02:40:04  rocky
 * SQUASH
 * 
 * Revision 1.17  92/08/21  16:17:04  rocky
 * added missing break in switch statement
 * 
 * Revision 1.16  92/05/05  11:05:29  kau
 * fix bottom first pixel replication on output
 * 
 * Revision 1.15  91/11/26  13:57:02  kau
 * wait for video_added but not yet working!!!
 * 
 * Revision 1.14  91/10/23  09:56:01  mears
 * new rev
 * 
 * 
 * Revision 1.13  91/10/04  12:47:36  mears
 * ifdef DRIVER
 * 
 * Revision 1.12  91/09/30  16:32:09  mears
 * changes in stopping digitization
 * 
 * Revision 1.11  91/08/20  20:37:06  mears
 * added loopback format
 * 
 * Revision 1.10  91/08/15  19:36:23  eric
 * debugging prints
 * 
 * Revision 1.9  91/08/15  18:20:45  mears
 * use standard numbers for digitization start location
 * 
 * Revision 1.8  91/08/14  12:24:20  mears
 * blanking info in nvram
 * 
 * Revision 1.7  91/08/13  14:35:20  mears
 * right fix for starline
 * 
 * Revision 1.6  91/08/13  14:22:38  eric
 * need to set startline anyway
 * 
 * Revision 1.5  91/08/13  13:45:28  mears
 * disable output when w used for input
 * 
 * Revision 1.4  91/08/06  10:38:11  eric
 * turn output on and off
 * 
 * Revision 1.3  91/07/27  14:05:52  eric
 * less debugging
 * 
 * Revision 1.2  91/07/26  19:07:01  eric
 * new from bill
 * 
 * Revision 1.1  91/06/12  16:06:34  eric
 * Initial revision
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: vidlib.c,v 1.1 1995/11/27 22:46:59 dist Exp $ Parallax Graphics Inc";
#endif

#include <stdio.h>
#include "xvideo.h"
#include "plxv.h"
#include "plxv_xpoint.h"

#define NULL 0
#define INPUT 0
#define OUTPUT 1

#define WAIT_FOR_V 0
#define WAIT_FOR_W 1
#define WAIT_FOR_FIRST 2
#define WAIT_FOR_BOTH 3

#ifndef DRIVER
extern int plxv_opt_cntl_reg;
extern int is_28_now;
static int Vaddr = 0;

static int gdsy_v=0,gdsy_w=0,output_flag=0;
static int waddr = 0;

extern XV_video_format *plxv_io_format[4];
static XV_video_format **format_v_ptr = &(plxv_io_format[LOOPBACK]);
static XV_video_format **format_w_ptr = &(plxv_io_format[LOOPBACK]);
static w_last_funct = OUTPUT;
#endif

int no_ccube=0;		/* global flag for the presence of c3 */

/* initialize the video input hardware and crosspoint switch.  Set both
   V and W channels to recieve the onboard D channel.  Set DMSD for NTSC
   mode, and turn off flashing NOW					 */
plxv_init_video()
{
/* MultiVideo */
    if(xv_cp->main.c3_rev)
	no_ccube = 0;
    else
	no_ccube = 1;
/* squash */
    if(xv_cp->main.board_code == SBUS_4)
    {
	xv_wreg->VFormat.l = 0;
	xv_wreg->WFormat.l = 0;
    }
    else
    {
	xv_wreg->VFormat.l = SEL_DATA_INPUT_D | SEL_CTL_INPUT_D |
			 SEL_CLK_INPUT_D | SEL_CLK_HIGH;
	xv_wreg->WFormat.l = SEL_DATA_INPUT_D | SEL_CTL_INPUT_D |
			 SEL_CLK_INPUT_D | SEL_CLK_HIGH;
    }

    /* stop flashing on both ports NOW */
    XV_WREG(VCtl.b.now,1);
    XV_WREG(WCtl.b.now,1);
    XV_WREG(VCtl.b.single,0);
    XV_WREG(WCtl.b.single,0);
    XV_WREG(VCtl.b.cont,0);
    XV_WREG(WCtl.b.cont,0);

    plxv_flash_v_off();
    plxv_flash_w_off();

    /* new stuff hacked in !!! */
    xv_wreg->VStart.l = 4;
    xv_wreg->VStop.l  = 260;
    xv_wreg->WStart.l = 4;
    xv_wreg->WStop.l  = 260;

#ifndef DRIVER
    plxv_init_attr();
#endif
}

/****************************  WRITE CONTROL STUFF  *****************/

#ifndef DRIVER

/* set up the stencil control for the V channel.  each pixel of destination
   is read for TAG value.  if (pixel's tag & mask) = value, then write the
   video pxiel to memory						   */
plxv_video_v_stencil(mask,compare)
int mask,compare;
{
    /* draw video v only when (tagplanes & mask) == compare */
    if ( is_28_now)
    {
	 mask = ((mask & 0xf) << 4);
	 compare  = ((compare  & 0xf) << 4);
    }
    XV_WREG(VTag.b.val, compare);
    XV_WREG(VTag.b.mask, mask);
}

/* setup the write mask for the V channel. Note: you can't write to the
   TAG planes from the video inputs					  */
plxv_video_v_wmask(mask)
int mask;
{
    /* mask is a 24-bit value since tag planes are not affedted */
    XV_WREG(VMask.l, mask);
}

#endif /* NOT DRIVER */

/* TURN OFF the FLASH on V... but wait until the current field is done	  */
plxv_flash_v_off()
{
    XV_WREG(VCtl.l, 0);
}

#ifndef DRIVER

/* TURN OFF the FLASH on V... NOW */
plxv_flash_v_off_now()
{
    XV_WREG(VCtl.l, 0x80808);

    XV_WREG(VSqzX.l, 0);
    XV_WREG(VSqzY.l, 0);
}

/* set up the stencil control for the W channel.  each pixel of destination
   is read for TAG value.  if (pixel's tag & mask) = value, then write the
   video pxiel to memory						   */
plxv_video_w_stencil(mask,compare)
int mask,compare;
{
    /* draw video w only when (tagplanes & mask) == compare */
    if ( is_28_now)
    {
	 mask = ((mask & 0xf) << 4);
	 compare  = ((compare  & 0xf) << 4);
    }
    XV_WREG(WTag.b.val, compare);
    XV_WREG(WTag.b.mask, mask);
}

/* setup the write mask for the W channel. Note: you can't write to the
   TAG planes from the video inputs					  */
plxv_video_w_wmask(mask)
int mask;
{
    /* mask is a 24-bit value since tag planes are not affedted */
    XV_WREG(WMask.l, mask);
}

#endif

/* TURN OFF the FLASH on W... but wait until the current field is done	  */
plxv_flash_w_off()
{
    int i;

#ifndef DRIVER
    /* turn off the option cards display */
    /* in case it has been gernerating an output */
    if (xv_cp->opt.board_code)
    {
	    plxv_opt_cntl_reg &= ~0x8;
	    XV_WREG(Ext.reg2,plxv_opt_cntl_reg);
    }
#endif

    /* don't clear the direction bit */
    XV_RSDW(i,WCtl.l);
    i &= ~0x60606;
    XV_WREG(WCtl.l, i);

}

#ifndef DRIVER
/* TURN OFF the FLASH on W... NOW !! (don't hit the direction bits   */
plxv_flash_w_off_now()
{
    int i;
    /* turn off the option cards display */
    /* in case it has been gernerating an output */
    if (xv_cp->opt.board_code)
    {
	    plxv_opt_cntl_reg &= ~0x8;
	    XV_WREG(Ext.reg2,plxv_opt_cntl_reg);
    }

    /* don't clear the direction bit */
    XV_RSDW(i,WCtl.l);
    i &= ~0x60606;
    i |= 0x80808;
    XV_WREG(WCtl.l, i);

    XV_WREG(WSqzX.l, 0);
    XV_WREG(WSqzY.l, 0);
}
/****************************   FLASH COMMANDS   *******************/

/* digitize on the V channel an unsqueezed image */
/* user is responsible for setting up tag/wm and clipping */
plxv_flash_v(dx,dy)
int dx,dy;
{
	 plxv_flash_v_squeeze(-4,44,640,480,(dx),(dy),640,480,0,0);
}
/* digitize on the W channel an unsqueezed image */
/* user is responsible for setting up tag/wm and clipping */
plxv_flash_w(dx,dy)
int dx,dy;
{
	 plxv_flash_w_squeeze(-4,44,640,480,(dx),(dy),640,480,0,0);
}

/*  flash squeezed  vx,vy are positions in input space		 */
/*		    vsy,vsy are sizes in pixels from input space */
/*		    dx,dy are frame buffer coordiantges		 */
/*		    dsx,dsy are sizes in pixels on display	 */
/*		    noninterlace is a zero for an interlaced img */
/*		    "single" starts flash, but doesn't wait until done */
/*	flashing image will spill outside region of display	 */
/*	clipping is required to control actual region of flashing */
/*	programmer is responsible for correctly clipping with tags */

plxv_flash_v_squeeze(vx,vy,vsx,vsy,dx,dy,dsx,dsy,noninterlace,single)
int vx,vy,vsx,vsy,dx,dy,dsx,dsy,noninterlace;
{

    int i,k,sqzx,sqzy;
    int ddx,ddy,instr;
    int startline,stopline,dead_lines;
    int overflow = 0;

gdsy_v = dsy;
    /* use the vstart and vstop registers to position the vertical */
    if (*format_v_ptr == NULL)
    {
	printf("plxv_flash_v: attempt to flash from null format\n");
	format_v_ptr = &(plxv_io_format[LOOPBACK]);
    }
    dead_lines = (*format_v_ptr)->reset_line;
    startline  = ( noninterlace ?  vy : vy>>1) - dead_lines;
    if (startline < 1 )
    {	/* need to draw a black box where we can't digitize */
	overflow = 1-startline;
	startline = 1;
    }
    vy -= (noninterlace ? 1:2 ) * (dead_lines - overflow);
	
    stopline = startline -overflow + (noninterlace ? vsy  : ((vsy +1)>>1) );
    xv_wreg->VStart.l = startline;
    xv_wreg->VStop.l = stopline;

    if ((sqzx = plxv_calc_squeeze(vsx,dsx)) < 0) return(-1);
    if ((sqzy = plxv_calc_squeeze(vsy,dsy)) < 0) return(-1);

    if (dsx < 0 ) i=1; else i=0;
    if (dsy < 0 ) k=0; else k=1;

    ddx = (vx * (sqzx + 1))>>12;
    ddy = (vy * (sqzy + 1))>>12;
    Vaddr = PLXV_ADDR_REG(dx,dy) - (ddy * xv_cp->main.linebytes) - ddx;

    if (Vaddr < 0) Vaddr += xv_cp->addr_wrap;

    XV_WREG(VSqzY.b.factor, sqzy);
    XV_WREG(VSqzY.b.inter, noninterlace);
    XV_WREG(VSqzY.b.ltor, i);
    XV_WREG(VSqzY.b.ttob, k);

    
    XV_WREG(VSqzX.b.factor, sqzx);
    XV_WREG(VSqzX.b.ltor, i);
    xv_wreg->VStartAdd.l = Vaddr;

    if (single)
    {
	XV_WREG4(VCtl.l, 2);
    }
    else XV_WREG4(VCtl.l, 4);
}

plxv_flash_w_squeeze(vx,vy,vsx,vsy,dx,dy,dsx,dsy,noninterlace,single)
int vx,vy,vsx,vsy,dx,dy,dsx,dsy,noninterlace,single;
{
    int a,i,k,addr,sqzx,sqzy;
    int ddx,ddy;
    int startline,stopline,dead_lines;
    int overflow = 0;

output_flag = 0;
gdsy_w = dsy;
    if (w_last_funct == OUTPUT)
    {
	plxv_flash_w_off_now();
	w_last_funct = INPUT;

        /* turn off the option cards display */
        /* in case it has been gernerating an output */
        if (xv_cp->opt.board_code)
        {
	    plxv_opt_cntl_reg &= ~0x8;
	    XV_WREG(Ext.reg2,plxv_opt_cntl_reg);
        }
    }

    /* use the vstart and vstop registers to position the vertical */
    if (*format_w_ptr == NULL)
    {
	printf("plxv_flash_w: attempt to flash from null format\n");
	format_w_ptr = &(plxv_io_format[LOOPBACK]);
    }

    dead_lines = (*format_w_ptr)->reset_line;
    startline  = ( noninterlace ?  vy : vy>>1) - dead_lines;
    if (startline < 1 )
    {	/* need to draw a black box where we can't digitize */
	overflow = 1-startline;
	startline = 1;
    }
    vy -= (noninterlace ? 1:2 ) * (dead_lines - overflow);
	
    stopline = startline - overflow + (noninterlace ? vsy  : ((vsy +1)>>1) );
    xv_wreg->WStart.l = startline;
    xv_wreg->WStop.l  = stopline;

    if ((sqzx = plxv_calc_squeeze(vsx,dsx)) < 0) return(-1);
    if ((sqzy = plxv_calc_squeeze(vsy,dsy)) < 0) return(-1);

    if (dsx < 0 ) i=1; else i=0;
    if (dsy < 0 ) k=0; else k=1;

    ddx = (vx * (sqzx + 1))>>12;
    ddy = (vy * (sqzy + 1))>>12;
    addr = PLXV_ADDR_REG(dx,dy) - (ddy * xv_cp->main.linebytes) - ddx;
    if (addr < 0) addr += xv_cp->addr_wrap;

    /* turn off the option cards display */
    /* in case it has been gernerating an output */
    if (xv_cp->opt.board_code)
    {
	    plxv_opt_cntl_reg &= ~0x8;
	    XV_WREG(Ext.reg2,plxv_opt_cntl_reg);
    }

    XV_WREG(WSqzY.b.factor, sqzy);
    XV_WREG(WSqzY.b.inter, noninterlace);
    XV_WREG(WSqzY.b.ltor, i);
    XV_WREG(WSqzY.b.ttob, k);

    
    XV_WREG(WSqzX.b.factor, sqzx);
    XV_WREG(WSqzX.b.ltor, i);

    XV_WREG(WStartAdd.l,addr);
waddr = addr;
    xv_wreg->VStartAdd.l = Vaddr;		/* fixed l.to.r bug */

    if (single)
    {
	XV_WREG4(WCtl.l, 2);
    }
    else XV_WREG4(WCtl.l,4);

}
/* generate output stream on w channel */
/* sx,sy are the source coordinates in the frame buffer */
/* address pointers reset/advance on Vsync/Hsync respectively */
/* ssx & ssy are frame buffer window size in pixels, negative */
/* sizes are for left going and upgoing .  vx & vy refer to the */
/* video destination coordinates Y is relative to vsync in hsynces */
/* and X is relative to unblanked video.  vsx and vsy are */
/* sizes in pixels  for expand factors only. If they don't match */
/* the video output, then the data you get is accurate only to */
/* the expand factor */

plxv_output_w(sx,sy,ssx,ssy,vx,vy,vsx,vsy,noninterlace,single)
int sx,sy,ssx,ssy,vx,vy,vsx,vsy,noninterlace,single;
{
    int a,i,k,addr,sqzx,sqzy;
    int ddx,ddy;

    int startline,stopline,dead_lines,stop_offset;
    int overflow = 0;

output_flag = 1;
gdsy_w = ssy;
    if (w_last_funct == INPUT)
    {
	plxv_flash_w_off_now();
	w_last_funct = OUTPUT;
    }

    /* use the vstart and vstop registers to position the vertical */
    if (*format_w_ptr == NULL)
    {
	printf("plxv_output_w: attempt to output to null format\n");
	format_w_ptr = &(plxv_io_format[LOOPBACK]);
    }
    dead_lines = (*format_w_ptr)->reset_line;
    switch (xv_cp->opt.board_rev)
    {
	default:
	    stop_offset = 3;
	    break;
	case 0: 
	    dead_lines -= 4;
	    stop_offset = 0;
	    break;
	case 1: 
	    dead_lines -= 3;
	    stop_offset = 3;
	    break;
    }
    startline  = ( noninterlace ?  vy : vy>>1) - dead_lines;
    if (startline < 1 )
    {
	overflow = 1-startline;
	startline = 1;
    }
    vy -= (noninterlace ? 1:2 ) * (dead_lines - overflow);
	
    stopline = startline -overflow + (noninterlace ? vsy  : ((vsy +1)>>1))
		+ stop_offset;
    xv_wreg->WStart.l = startline;
    xv_wreg->WStop.l  = stopline;

    if ((sqzx = plxv_calc_squeeze(vsx,ssx)) < 0) return(-1);
    if ((sqzy = plxv_calc_squeeze(vsy,ssy)) < 0) return(-1);

    if (ssx < 0 ) i=1; else i=0;
    if (ssy < 0 ) k=0; else k=1;

    ddx = (vx * (sqzx + 1))>>12;
    ddy = (vy * (sqzy + 1))>>12;
    addr = PLXV_ADDR_REG(sx,sy) - (ddy * xv_cp->main.linebytes) - ddx;
    if (addr < 0) addr += xv_cp->addr_wrap;

    XV_WREG(WSqzY.b.factor, sqzy);
    XV_WREG(WSqzY.b.inter, noninterlace);
    XV_WREG(WSqzY.b.ltor, i);
    XV_WREG(WSqzY.b.ttob, k);

    
    XV_WREG(WSqzX.b.factor, sqzx);
    XV_WREG(WSqzX.b.ltor, i);

    xv_wreg->WStartAdd.l = addr;
    xv_wreg->VStartAdd.l = Vaddr;		/* fixed l.to.r bug */

    if (single)
    {
	XV_WREG4(WCtl.l, 3);
    }
    else XV_WREG4(WCtl.l,5);
}

int plxv_wf_video(chan,line)
int chan,line;
{
    int iv_curadd,iw_curadd;
    int vsingle,wsingle;
    int vstart_flag,wstart_flag;
    int i=0,j=0;

    XV_RSDW(vsingle,VCtl.b.single);
    XV_RSDW(wsingle,WCtl.b.single);

    switch (chan)
    {
	case WAIT_FOR_V:
    	    iv_curadd = uncalc_v(line);
	    if (vsingle)
	        while (compare_video_curadd_v(iv_curadd));
	    else
	    {
		while (~compare_video_curadd_v(iv_curadd)); /* wait for above */
		while (compare_video_curadd_v(iv_curadd)); /* wait for done */
	    }
	    return(WAIT_FOR_V);
	    break;
	case WAIT_FOR_W:
    	    iw_curadd = uncalc_w(line);
	    if (wsingle)
	        while (compare_video_curadd_w(iw_curadd));
	    else
	    {
		while (~compare_video_curadd_w(iw_curadd)); /* wait for above */
		while (compare_video_curadd_w(iw_curadd)); /* wait for done */
	    }
	    return(WAIT_FOR_W);
	    break;
	case WAIT_FOR_FIRST:
    	    iv_curadd = uncalc_v(line);
    	    iw_curadd = uncalc_w(line);
	    vstart_flag = 1;
	    wstart_flag = 1;
	    {
		while (1)
		{
		    {
		        if (vsingle)
		        {
			    if (compare_video_curadd_v(iv_curadd))
				return(WAIT_FOR_V);
			}
		        else	
			{
		            if (vstart_flag) 
			        vstart_flag = compare_video_curadd_v(iv_curadd);
		            else if (compare_video_curadd_v(iv_curadd))
			        return(WAIT_FOR_V);
			}
		        if (wsingle)
		        {
		            if (compare_video_curadd_w(iw_curadd))
			        return(WAIT_FOR_W);
			}
			else
			{
		            if (wstart_flag) 
			        wstart_flag = compare_video_curadd_w(iw_curadd);
		            else if (compare_video_curadd_w(iw_curadd))
			        return(WAIT_FOR_W);
			}
		    }
		}
	    }
	    break;
	case WAIT_FOR_BOTH:
    	    iv_curadd = uncalc_v(line);
    	    iw_curadd = uncalc_w(line);
	    {
		while ((i & j) == 0)
		{
		    if (i == 0)
		    {
			if (vsingle)
		            i = compare_video_curadd_v(iv_curadd);
		        else	
			{
		            if (vstart_flag) 
			        vstart_flag = compare_video_curadd_v(iv_curadd);
		            else 
				i = compare_video_curadd_v(iv_curadd);
			}
		    }
		    if (j == 0)
		    {
			if (wsingle)
			    j = compare_video_curadd_w(iw_curadd);
			else
			{
		            if (wstart_flag) 
			        wstart_flag = compare_video_curadd_w(iw_curadd);
		            else if (compare_video_curadd_w(iw_curadd))
			        return(WAIT_FOR_W);
			}
		    }
		}
		return(WAIT_FOR_BOTH);
	    }
	    break;
		
	default:
	    printf("invalid wait_for_video function call\n");
	    break;
    }
}

int uncalc_v(line)
int line;
{
    int i,xsize,ttob;

    XV_RSDW(ttob,VSqzY.b.ttob);
    xsize = xv_cp->main.linebytes;
    
    if (ttob)
    {
        if (line < 0)
	    i = Vaddr + (gdsy_v + line - 1) * xsize/4;
        else
	    i = Vaddr + line * xsize/4;
    }
    else
    {
	if (line < 0)
	    i = Vaddr + line * xsize/4;
	else
	    i = Vaddr + (gdsy_v + line - 1) * xsize/4;
    }
    i &= 0x3ffff;
    return(i);
}

int uncalc_w(line)
int line;
{
    int i,xsize,ttob;

    XV_RSDW(ttob,WSqzY.b.ttob);
    xsize = xv_cp->main.linebytes;
    
    if (ttob)
    {
        if (line < 0)
	    i = waddr + (gdsy_w + line - 1) * xsize/4;
        else
	    i = waddr + line * xsize/4;
    }
    else
    {
	if (line < 0)
	    i = Vaddr + line * xsize/4;
	else
	    i = Vaddr + (gdsy_w + line - 1) * xsize/4;
    }
    i &= 0x3ffff;
    return(i);
}

compare_video_curadd_v(curadd)
int curadd;
{
    int i,j;
    int ttob,factor,odd;

    XV_RSDW(ttob,VSqzY.b.ttob);
    XV_RSDW(factor,VSqzY.b.factor);

    XV_RREG(i,VCurAdd.l);
    XV_RREG(j,IntStat.l);
    odd = (j >> 8) & 1;

    if ((factor > 0x7ff) && odd)	/* 1 <= squeeze_factor < 2 */
	return(0);	
    i &= 0x3ffff;
    curadd &= 0x3ffff;
    if (ttob)
    {
        if (i >= curadd) 
	{
	    return(-1);
	}
    }
    else
    {
	if (i <= curadd)
	return(-1);
    }
    return(0);
}

compare_video_curadd_w(curadd)
int curadd;
{
    int i;
    int ttob,factor,odd;

    XV_RSDW(ttob,WSqzY.b.ttob);
    XV_RSDW(factor,WSqzY.b.factor);

    XV_RREG(i,WCurAdd.l);
    XV_RREG(odd,IntStat.b.wodd);

    if ((factor > 0x7ff) && (~(odd & 1)))	/* 1 <= squeeze_factor < 2 */
	return(0);	
    i &= 0x3ffff;
    curadd &= 0x3ffff;
    if (ttob)
    {
        if (i >= curadd) 
	    return(-1);
    }
    else
    {
	if (i <= curadd)
	return(-1);
    }
    return(0);
}

plxv_calc_squeeze(a,b)
int a,b;
{
    int i,j,k,l;
    if (a<0) a = -a;
    if (b<0) b = -b;
    if (b>a) 
    {
	printf("can only squeeze video !!\n");
	return(-1);
    }
    i = ((b<<12) / a) -1 ;
    if ( i & ~(0xfff) )
    {
	printf("weird error\n");
	return(-1);
    }
    return(i);
}


/**********************    CROSS POINT SWITCH STUFF  ******************/
plxv_xpoint_v(sel,clk_polarity)
int sel,clk_polarity;
{
    int bits;
    switch(sel)
    {
	case INPUT_A:
		format_v_ptr = &(plxv_io_format[PORT_A]);
		bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case INPUT_B:
		format_v_ptr = &(plxv_io_format[PORT_B]);
		bits = SEL_DATA_INPUT_B | SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	case INPUT_C:
		format_v_ptr = &(plxv_io_format[PORT_C]);
		bits = SEL_DATA_INPUT_C | SEL_CTL_INPUT_C | SEL_CLK_INPUT_C;
		break;
	case INPUT_D:
		format_v_ptr = &(plxv_io_format[PORT_D]);
/* squash */
		if(xv_cp->main.board_code == SBUS_4)
		{
		  bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		}
		else
		{
		  bits = SEL_DATA_INPUT_D | SEL_CTL_INPUT_D | SEL_CLK_INPUT_D;
		}
		break;
	case OUTPUT_A:
	case OUTPUT_B:
	case OUTPUT_LOOPBACK_A:
	case OUTPUT_LOOPBACK_B:
		printf("error - can't output from V channel\n");
		bits = 0;
		break;
	case INPUT_LOOPBACK_A:
		format_v_ptr = &(plxv_io_format[LOOPBACK]);
		bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case INPUT_LOOPBACK_B:
		format_v_ptr = &(plxv_io_format[LOOPBACK]);
		bits = SEL_DATA_INPUT_B | SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	default:
		printf("plxv_xpoint_v: invalid channel select: %d\n",sel);
    }
    if (clk_polarity) bits |= SEL_CLK_HIGH;
    xv_wreg->VFormat.l = bits;
}

plxv_xpoint_w(sel,clk_polarity)
int sel,clk_polarity;
{
    int bits;
    switch(sel)
    {
	case INPUT_A:
		format_w_ptr = &(plxv_io_format[PORT_A]);
		bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case INPUT_B:
		format_w_ptr = &(plxv_io_format[PORT_B]);
		bits = SEL_DATA_INPUT_B | SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	case INPUT_C:
		format_w_ptr = &(plxv_io_format[PORT_C]);
		bits = SEL_DATA_INPUT_C | SEL_CTL_INPUT_C | SEL_CLK_INPUT_C;
		break;
	case INPUT_D:
		format_w_ptr = &(plxv_io_format[PORT_D]);
/* squash */
		if(xv_cp->main.board_code == SBUS_4)
		{
		  bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		}
		else
		{
		  bits = SEL_DATA_INPUT_D | SEL_CTL_INPUT_D | SEL_CLK_INPUT_D;
		}
		break;
	case OUTPUT_A:
		format_w_ptr = &(plxv_io_format[PORT_A]);
		bits =			  SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case OUTPUT_B:
		format_w_ptr = &(plxv_io_format[PORT_B]);
		bits =			  SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	case OUTPUT_C:
		format_w_ptr = &(plxv_io_format[PORT_C]);
		bits = 			  SEL_CTL_INPUT_C | SEL_CLK_INPUT_C;
		break;
	case OUTPUT_LOOPBACK_A:
		format_w_ptr = &(plxv_io_format[LOOPBACK]);
		bits =			  SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case INPUT_LOOPBACK_A:
		format_w_ptr = &(plxv_io_format[LOOPBACK]);
		bits = SEL_DATA_INPUT_A | SEL_CTL_INPUT_A | SEL_CLK_INPUT_A;
		break;
	case OUTPUT_LOOPBACK_B:
		format_w_ptr = &(plxv_io_format[LOOPBACK]);
		bits =			  SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	case INPUT_LOOPBACK_B:
		format_w_ptr = &(plxv_io_format[LOOPBACK]);
		bits = SEL_DATA_INPUT_B | SEL_CTL_INPUT_B | SEL_CLK_INPUT_B;
		break;
	default:
		printf("plxv_xpoint_w: invalid channel select: %d\n",sel);
    }
    if (clk_polarity) bits |= SEL_CLK_HIGH;
    XV_WREG(WFormat.l,bits);
}

/* numbers for config val should be created by oring bit field constant
   found in plxv_xpoint.h */
plxv_xpoint_a(config_val)
int config_val;
{
    xv_wreg->AFormat.l = config_val;	
}

plxv_xpoint_b(config_val)
int config_val;
{
    xv_wreg->BFormat.l = config_val;	
}

plxv_xpoint_c(config_val)
int config_val;
{
    xv_wreg->CFormat.l = config_val;	
}

plxv_xpoint_d(config_val)
int config_val;
{
    xv_wreg->DFormat.l = config_val;
}

plxv_init_attr()
{
    int i,j;
    /* 2-bit values of attr as interpreted by the option card:
	0 -- pseudo
	1 -- 24-bit true
	2 -- overlay color 1 (cursor 1)
	3 -- overlay color 2 (cursor 2)
    */

    XV_WREG(WAttrL.b.value0,0);		
    XV_WREG(WAttrL.b.value1,1);	
    XV_WREG(WAttrL.b.value2,1);
    XV_WREG(WAttrL.b.value3,1);

    XV_WREG(WAttrL.b.value4,0);
    XV_WREG(WAttrL.b.value5,1);
    XV_WREG(WAttrL.b.value6,1);
    XV_WREG(WAttrL.b.value7,1);

    XV_WREG(WAttrH.b.value8,2);
    XV_WREG(WAttrH.b.value9,2);
    XV_WREG(WAttrH.b.value10,2);
    XV_WREG(WAttrH.b.value11,2);

    XV_WREG(WAttrH.b.value12,3);
    XV_WREG(WAttrH.b.value13,3);
    XV_WREG(WAttrH.b.value14,3);
    XV_WREG(WAttrH.b.value15,3);

    XV_WREG(Attr.b.attr0,0);
}
#endif /*NOT DRIVER*/
