#pragma ident "@(#)wid.h	1.4 94/01/05 SMI"
 
/*
 * Interface definitions for window id interface
 */

#ifndef WID_H
#define WID_H

typedef struct _WidObj *WidPtr;
    
typedef WidPtr (*WidAllocFunc)(ScreenPtr pScreen, VisualID visual,
			       int numContig, Bool Unique, CARD32 flavor);

typedef void	(*WidFreeFunc)(WidPtr pWid);

typedef void	(*WidSetColorLutFunc)(WidPtr  pWid, CARD32 clutId);

/* Function prototypes for window id package */

Bool		widScreenInit(ScreenPtr pScreen, WidAllocFunc allocFunc,
	            WidFreeFunc freeFunc,  WidSetColorLutFunc setClutFunc);
WidPtr		widAllocate(ScreenPtr pScreen, VisualID visual, int count,
		    Bool unique, CARD32 flavor);
void		widSetColorLut(WidPtr pWid, CARD32 clutId);
void		widScreenClose(ScreenPtr pScreen);
CARD32	    	widGetColorLut(WidPtr pWid);
WidPtr		widAllocObj();
void	    	widFreeObj(WidPtr pWid);
void		widIncref(WidPtr pWid);
void		widDecref(WidPtr pWid);
ScreenPtr	widGetScreen(WidPtr pWid);
VisualID	widGetVisual(WidPtr pWid);
unsigned long	widGetValue(WidPtr pWid);
unsigned long	widWinGetValue(WindowPtr pWin);
void		widSetValue(WidPtr pWid, unsigned long value);
unsigned int	widGetNumber(WidPtr pWid);
Bool		widGetUnique(WidPtr pWid);
CARD32		widGetFlavor(WidPtr pWid);
pointer		widGetDevData(WidPtr pWid);
void		widSetDevData(WidPtr pWid, pointer devData);
void		widSetWindowWid(WindowPtr pWin, WidPtr pWid, Bool prepare);
WidPtr		widGetWindowWid(WindowPtr pWin);
VisualID    	widGetVisual(WidPtr pWid);

#endif	/* WID_H */

